<?php
/**
 * Created by PhpStorm.
 * User: matheussilva
 * Date: 20/08/14
 * Time: 17:58
 */

namespace Folha\Logic\ValesBeneficios\CalculoValeTransporte;

use Folha\Entities\FpaTipomoviment;
use \Folha\Entities\GpeVinculom;

use \Folha\Entities\GpeVinculoh;

use \Folha\Entities\GpeAlteescala;

use \Folha\Entities\GpeEscalatrabh;

use Folha\Entities\VabHistvalevinc;

use Folha\Entities\VabIntegtransph;

use \Folha\Repositories\FpaFerias;

use \Folha\Entities\FpaParamsindicato;

use \Folha\Entities\GpeAltesitufunc;

use Folha\Entities\FpaValorreferenciam;

use \Geral\Repositories\Estruturah;

use \Folha\Repositories\GpeSitufunch;

use \Folha\Repositories\VabLinhavinc;

use \Folha\Repositories\GpeEscalatrabm;

use \Folha\Entities\GpeHorarioturno;

use \Folha\Repositories\FpaCalculofolha;

use HCM\Geral\Entity\GpemovimentacaoEntity;

use Geral\Util\Ambiente;

use \HCM\Util\DateUtil;

use Geral\Util\NovoCodigo;

use HCM\Util\HCMParameters;
use HCM\Util\Messages;
use HCM\Util\FPA;

use HCM\Util\MsgCalculo;
use \Setforms2\Shared\ORM\DateTime;

class ValeVinculo
{

    //CONSTANTES
    const SABADO = 6;
    const DOMINGO = 7;
    const SABDOM = 67;
    const SEGUNDA = 1;
    const TERCA = 2;
    const QUARTA = 3;
    const QUINTA = 4;
    const SEXTA = 5;

    //INFORMAÇÃO SOBRE O VÍNCULO
    private $objvinculo;
    private $objvinculoh;
    private $nrdiascomposicaomensal;
    private $nrdiasobrigacaosindicato;
    private $nrestrutlegal;

    private $nrtpjornada;
    private $nrturno;
    
    private $nrafastamento;
    private $nrfalta;
    private $nrdiasaviso;
    private $nrdiasferias;
    private $nrdiasnuteis;

    private $geraBenefFeriado;
    
    private $dsdiadescansosemanal;

    private $nrtipolinhavinc;

    private $idnaogeravale;

    private $diaInicialAupr;
    private $diaFinalAupr;
    
    private $idcalccomplementar;
    private $idcalccredindev;
    
    private $datasEntreAtestadoOuAfast;
    private $datasDsrAnt;
    private $datasFeriadosAnt;
    private $datasEntreFerias;
    private $dsrEntreFerias;
    private $feriadoEntreFerias;
    private $datasAposRescisao;
    private $datasFaltas;
    
    //INFORMAÇÕES SOBRE A LINHA
    private $passagens;
    private $vrtotal;
    private $vrrestante;

    //INFORMAÇÕES SOBRE O MÊS
    private $nrdiasproxmes;
    private $diastotaisconsideracao;
    private $datasDesconsideradas;
    private $datasEntre;
    private $qtdiasvalefixo;

    //INFORMAÇÕES DO SISTEMA
    private $nrorg;
    private $dtmescompetencia;
    private $dtiniperiodocalculo;
    private $dtfimperiodocalculo;
    private $dtiniperiodovale;
    private $dtfimperiodovale;
    private $dtiniciocredindev;
    private $dtfinalcredindev;
    
    //PARAMETRO DO VALE TRANSPORTE
    private $paramVale;
    private $dataIniApurSemMOD;
    private $dataFimApurSemMOD;
    
    public $valorAnteriorCartao = array();

    /**
     * @var HCMParameters
     */
    private $hcmParameters;
    private $nrturnoRetroc;
    private $escalaTrabVinc;
    private $historico;
    public $messages;
    
    protected $_movimentosVinculo;
    
    private $cacheAnalisaDiaFeriadoNaoTrabalhado = [];
    private $cacheQtdeDiasFolgaVincDia = [];

    //CONSTRUTOR
    /**
     * Construtor da Classe
     * @param GpeVinculom $objvinculo
     * @param int $nrorg
     * @param \DateTime $dtiniapuracao
     * @param \DateTime $dtfimapuracao
     * @param int $nrtipolinhavinc
     */
    public function __construct($objvinculo, $nrorg, \DateTime $dtiniapuracao, \DateTime $dtfimapuracao, $nrtipolinhavinc, $hcmParameters, $paramVale = null, $qtdiasvalefixo = null, $idcalccomplementar = 'N', $idcalccredindev = 'N', $dtinicredindev = null, $dtfimcredindev = null)
    {
        try {
            $this->rescindido = false;
            $this->idnaogeravale = false;
        
            $this->objvinculo = $objvinculo;
            $this->dtmescompetencia = $dtiniapuracao->format('01/m/Y');
            $this->nrorg = $nrorg;

            $dtiniperiodo = clone $dtiniapuracao;
            $dtfimperiodo = clone $dtfimapuracao;
            
            $this->dtiniciocredindev = DateUtil::getDataDeString($dtinicredindev, DateUtil::FORMATO_BRASILEIRO, true);
            $this->dtfinalcredindev = DateUtil::getDataDeString($dtfimcredindev, DateUtil::FORMATO_BRASILEIRO, true);
            
            $this->_movimentosVinculo = new GpemovimentacaoEntity(\Setforms2\Shared\Registry::getEntityManager(), $hcmParameters);

//        //ÁREA CRIADA PARA A COMPENSAÇÃO DA NÃO UTILIZAÇÃO DE PERÍODO INICIAL E FINAL
//        //Para utilização de período, remova a variável $periodo e suas utilizações.
//        $periodo = DateUtil::getDataDeString($dtmescompetencia);
//        $periodo->add(new \DateInterval('P1M'));
//
//        $this->dtiniperiodovale = $dtiniperiodo = $periodo->format('d/m/Y');
//        $this->dtfimperiodovale = $dtfimperiodo = $periodo->format('t/m/Y');
//
//        //FINAL DE COMPENSAÇÃO
			
			if($dtiniperiodo <= $objvinculo->getDtadmissaovinc()){
                $dtiniperiodo = $objvinculo->getDtadmissaovinc();
            }
            
            if(!empty($objvinculo->getDtrescisaovinc()) && $objvinculo->getDtrescisaovinc() < $dtiniperiodo){
                $this->rescindido = true;
            }
            
            $this->deveAnalisarDescontoMinimizadores = false;
            $this->deveAnalisarDescontoMinimizadores = $this->buscaValorDeReferenciaAnalisaDescontoMinimizadores($nrorg);
            
            $this->deveRecalcularMinimizadoresVT = false;
            $this->deveRecalcularMinimizadoresVT = $this->buscaValorDeReferenciaRecalcularMinimizadoresVT($nrorg);
            
            //Não aplicar sub diretamente nesta propriedade!!
            $this->dataIniApurSemMOD = clone $dtiniperiodo;
            $this->dataFimApurSemMOD = clone $dtfimapuracao;
            
            $this->backupDtIni = clone $dtiniperiodo;
            $this->backupDtFim = clone $dtfimapuracao;
			
            $this->paramVale = $paramVale;
            
            $this->idcalccomplementar = $idcalccomplementar;
            $this->idcalccredindev = $idcalccredindev;
            
            $this->dtiniperiodovale = clone $dtiniperiodo;
            $this->dtfimperiodovale = clone $dtfimperiodo;

            $this->dtiniperiodocalculo = clone $dtiniperiodo;
            $this->dtfimperiodocalculo = clone $dtfimperiodo;

            /*$dtintervalo = $this->dtiniperiodocalculo->diff($this->dtfimperiodocalculo);
            $dtintervalo->d++;

            $this->dtiniperiodocalculo->sub($dtintervalo);
            $this->dtfimperiodocalculo->sub($dtintervalo);*/
            // felipesantos 08/07/2015 - Alteração para pegar o mês anterior às datas de apuração do vale
            $this->dtiniperiodocalculo->sub(new \DateInterval('P1M'));
            $this->dtfimperiodocalculo->sub(new \DateInterval('P1M'));
            
            $this->nrtipolinhavinc = $nrtipolinhavinc;
            
            $this->datasDesconsideradas = [];
            $this->datasAposRescisao = [];
            $this->datasEntreFerias = [];
            $this->dsrEntreFerias = [];
            $this->feriadoEntreFerias = [];
            $this->datasDsrAnt = []; 
            $this->datasFeriadosAnt = [];
            $this->datasFaltas = array();
            $this->datasEntreAtestadoOuAfast = [];
            $this->qtdiasvalefixo = $qtdiasvalefixo;
            $this->hcmParameters = $hcmParameters;
            $this->objvinculoh = $this->setVinculoh();
            $this->nrestrutlegal = $this->setNrestrutlegal();
            $this->nrdiascomposicaomensal = $this->setDiasComposicaoMensal();
            $this->nrdiasobrigacaosindicato = $this->setNrDiasObrigacaoSindicato();
            $this->setDecansoSemanal();
            
            if($this->deveRecalcularMinimizadoresVT == false){
                $this->datasEntre = DateUtil::getDatasEntre($this->dtiniperiodovale, $this->dtfimperiodovale);
                $this->nrafastamento = $this->setNrAfastamento();
                $this->nrfalta = $this->setNrFalta();
                $this->nrdiasferias = $this->setNrDiasFerias($this->dtiniperiodovale, $this->dtfimperiodovale);
                $this->nrdiasproxmes = $this->setNrDiasCalculo($this->dtiniperiodovale, $this->dtfimperiodovale);
                $this->nrdiasaviso = $this->setNrDiasAviso($this->dtiniperiodovale, $this->dtfimperiodovale);
            
                $params = array(
                    "P_REFERENCIA"     => 0,
                    "P_NRORG"          => $nrorg,
                    "P_DTMESCOMPETENC" => $this->dtmescompetencia,
                    "P_DSREFERENCIA"   => 'DESCONTA_FALTA_VALE');
    
                $sql = "select * from FPA_VALORREFERENCIAM
                          JOIN FPA_VALORREFERENCIAH
                            ON FPA_VALORREFERENCIAH.NRVALORREFERENCIAM = FPA_VALORREFERENCIAM.NRVALORREFERENCIAM
                           AND FPA_VALORREFERENCIAH.VRREFERENCIA = :P_REFERENCIA
                           AND FPA_VALORREFERENCIAH.DTMESCOMPETENC =
                                                                 (SELECT MAX(DTMESCOMPETENC)
                                                                    FROM FPA_VALORREFERENCIAH
                                                                   WHERE FPA_VALORREFERENCIAH.NRVALORREFERENCIAM       = FPA_VALORREFERENCIAM.NRVALORREFERENCIAM
                                                                     AND FPA_VALORREFERENCIAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))
    
                        WHERE FPA_VALORREFERENCIAM.NRORG = :P_NRORG
                        AND FPA_VALORREFERENCIAM.DSREFERENCIA = :P_DSREFERENCIA";
    
                $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
                
                MemoriaVT::getInstance()->setDiasConsPeriodo($this->nrdiasproxmes);
                MemoriaVT::getInstance()->setDiasComposicaoMensal($this->nrdiascomposicaomensal);
                MemoriaVT::getInstance()->setDiasObrigacaoSindicato($this->nrdiasobrigacaosindicato);
                MemoriaVT::getInstance()->setDiasAfastAtest($this->nrafastamento);
                MemoriaVT::getInstance()->setFaltas($this->nrfalta);
                MemoriaVT::getInstance()->setFerias($this->nrdiasferias);
                MemoriaVT::getInstance()->setDiasAviso($this->nrdiasaviso);
    
                if (empty($retorno)) {
                    MemoriaVT::getInstance()->setReferencia(false);
                    if($this->idcalccomplementar == 'S'){
                        $this->diastotaisconsideracao = (int)$this->nrdiascomposicaomensal;
                    } elseif ($this->nrdiascomposicaomensal) {
                        $this->diastotaisconsideracao = (int)$this->nrdiascomposicaomensal - (int)$this->nrdiasferias - (int)$this->nrfalta - (int)$this->nrafastamento;
                    } elseif ($this->nrdiasobrigacaosindicato) {
                        $this->diastotaisconsideracao = (int)$this->nrdiasobrigacaosindicato - (int)$this->nrdiasferias - (int)$this->nrfalta - (int)$this->nrafastamento;
                    } elseif ($this->nrdiasaviso) {
                        $this->diastotaisconsideracao = (int)$this->nrdiasaviso - (int)$this->nrdiasferias - (int)$this->nrfalta - (int)$this->nrafastamento;
                    } else {
                        $this->diastotaisconsideracao = (int)$this->nrdiasproxmes - (int)$this->nrdiasferias - (int)$this->nrfalta - (int)$this->nrafastamento;
                    }
                }else{
                    MemoriaVT::getInstance()->setReferencia(true);
                    if ($this->nrdiascomposicaomensal) {
                        $this->diastotaisconsideracao = (int)$this->nrdiascomposicaomensal;
                    } elseif ($this->nrdiasobrigacaosindicato) {
                        $this->diastotaisconsideracao = (int)$this->nrdiasobrigacaosindicato;
                    } elseif ($this->nrdiasaviso) {
                        $this->diastotaisconsideracao = (int)$this->nrdiasaviso;
                    } else {
                        $this->diastotaisconsideracao = (int)$this->nrdiasproxmes;
                    }
                }
                
                if ($this->idnaogeravale) {
                    MemoriaVT::getInstance()->setIdNaoGeraCalc($this->idnaogeravale);
                    $this->diastotaisconsideracao = 0;
                }
    
                MemoriaVT::getInstance()->setResultadoTotal($this->diastotaisconsideracao);
            }

            $this->setPassagens();

        }catch (\Exception $e){
            throw $e;
        }
    }

    /** 
     * Função que modifica os minimizadores que descontam Faltas, Afastamentos, Atestados
     * - Se não houve pagamento na epoca de analise do minimizador não havera desconto para o minimizador.
     * @param $minimizadores
     * @param $linhaVinculo
     * @return array
     */
    private function avaliarDescontoMinimizadores($minimizadores, $linhaVinculo){
        $minimizadoresParaAvaliar = ['IDCONSFALTAVALE', 'IDCONSAFASTVALE', 'IDCONSATESTVALE'];
        $this->avaliaMinimizadores($minimizadores, $minimizadoresParaAvaliar, $linhaVinculo['NRVINCULOM'], $linhaVinculo['NRLINHATRANSP']);
        return $minimizadores;
    }

    private function avaliaMinimizadores(&$minimizadores, $minimizadoresParaAvaliar, $nrvinculom, $nrlinhavinc){
        if(empty($minimizadores)){
            return;
        }
        
        foreach($minimizadores as $nomeMinimizador => $minimizador){
            if (in_array($nomeMinimizador, $minimizadoresParaAvaliar) && $minimizador == 'S') {
                $nomeQtMinimizador = $this->retornaQtMinimizador($nomeMinimizador);
                $minimizador = $this->avaliaMinimizador($minimizador, $minimizadores[$nomeQtMinimizador], $nrvinculom, $nrlinhavinc);
                $minimizadores[$nomeMinimizador] = $minimizador;
            }
        }
    }

    private function retornaQtMinimizador($nomeMinimizador){
        switch($nomeMinimizador){
            case 'IDCONSFALTAVALE':
                return 'QTMESESFALTAVALE';
                break;
            case 'IDCONSAFASTVALE':
                return 'QTMESESAFASTVALE';
                break;
            case 'IDCONSATESTVALE':
                return 'QTMESESATESTVALE';
                break;
        }
    }

    private function avaliaMinimizador($minimizador, $retrocedeQtsMeses, $nrvinculom, $nrlinhavinc){
        $eMesAtual = $retrocedeQtsMeses == 0;
        if($eMesAtual){
            return $minimizador;
        }

        $minimizador = $this->modificaMinimizador($minimizador, $retrocedeQtsMeses, $nrvinculom, $nrlinhavinc);
        return $minimizador;
    }

    private function modificaMinimizador($minimizador, $retrocedeQtsMeses, $nrvinculom, $nrlinhavinc){
        $dtinicio = clone $this->dataIniApurSemMOD;
        $dtinicio = clone DateUtil::getDataDeString($dtinicio, DateUtil::FORMATO_BRASILEIRO, true)->sub(new \DateInterval('P'.$retrocedeQtsMeses.'M'));
        $dtFim = clone $this->dataFimApurSemMOD;
        $dtFim = clone DateUtil::getDataDeString($dtFim, DateUtil::FORMATO_BRASILEIRO, true)->sub(new \DateInterval('P'.$retrocedeQtsMeses.'M'));
        
        $dtmescompetenc = DateUtil::getDataDeString($dtinicio, DateUtil::FORMATO_BRASILEIRO, true)->format('01/m/Y');
        $formIni = $dtinicio->format('d/m/Y');
        $formFim = $dtFim->format('d/m/Y');
        $nrorg = $this->hcmParameters->getNrorgTrabalho();
        
        //Fazer a verificação se existe vabhistvalevinc para aquele VT.
        $hists = VabHistvalevinc::getObjectsByWhere(
            "NRORG =  $nrorg AND
             TRUNC(DTMESCOMPAPVALE, 'DD') = '$dtmescompetenc' AND
             DTINIAPURVALE <= '$formFim' AND DTFINAPURVALE >= '$formIni' AND
             NRVINCULOM IN (SELECT NRVINCULOM FROM GPE_VINCULOM WHERE NRORG =  $nrorg AND NRVINCULOM = $nrvinculom) AND
             NRLINHATRANSP = '$nrlinhavinc' AND
             QTDIASVALE > 0");
        
        //Se não houve pagamento na epoca de analise do minimizador não havera desconto para o minimizador.
        if(empty($hists)){
            $minimizador = 'N';
        }
        
        return $minimizador;
    }
    
    private function buscaValorDeReferenciaAnalisaDescontoMinimizadores($nrorg){
        $params = array(
            "P_REFERENCIA"     => 1,
            "P_NRORG"          => $nrorg,
            "P_DTMESCOMPETENC" => $this->dtmescompetencia,
            "P_DSREFERENCIA"   => 'ANALISA_DESCONTO_MINIMIZADORES');

        $sql = "select * from FPA_VALORREFERENCIAM
                  JOIN FPA_VALORREFERENCIAH
                    ON FPA_VALORREFERENCIAH.NRVALORREFERENCIAM = FPA_VALORREFERENCIAM.NRVALORREFERENCIAM
                   AND FPA_VALORREFERENCIAH.VRREFERENCIA = :P_REFERENCIA
                   AND FPA_VALORREFERENCIAH.DTMESCOMPETENC =
                                                         (SELECT MAX(DTMESCOMPETENC)
                                                            FROM FPA_VALORREFERENCIAH
                                                           WHERE FPA_VALORREFERENCIAH.NRVALORREFERENCIAM       = FPA_VALORREFERENCIAM.NRVALORREFERENCIAM
                                                             AND FPA_VALORREFERENCIAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))

                WHERE FPA_VALORREFERENCIAM.NRORG = :P_NRORG
                AND FPA_VALORREFERENCIAM.DSREFERENCIA = :P_DSREFERENCIA";

        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        
        if(!empty($retorno)){
            return true;
        }
        
        return false;
    }
    
    private function buscaValorDeReferenciaRecalcularMinimizadoresVT($nrorg){
        $params = array(
            "P_REFERENCIA"     => 1,
            "P_NRORG"          => $nrorg,
            "P_DTMESCOMPETENC" => $this->dtmescompetencia,
            "P_DSREFERENCIA"   => 'RECALCULA_MINIMIZADORES_VT');

        $sql = "select * from FPA_VALORREFERENCIAM
                  JOIN FPA_VALORREFERENCIAH
                    ON FPA_VALORREFERENCIAH.NRVALORREFERENCIAM = FPA_VALORREFERENCIAM.NRVALORREFERENCIAM
                   AND FPA_VALORREFERENCIAH.VRREFERENCIA = :P_REFERENCIA
                   AND FPA_VALORREFERENCIAH.DTMESCOMPETENC =
                                                         (SELECT MAX(DTMESCOMPETENC)
                                                            FROM FPA_VALORREFERENCIAH
                                                           WHERE FPA_VALORREFERENCIAH.NRVALORREFERENCIAM       = FPA_VALORREFERENCIAM.NRVALORREFERENCIAM
                                                             AND FPA_VALORREFERENCIAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))

                WHERE FPA_VALORREFERENCIAM.NRORG = :P_NRORG
                AND FPA_VALORREFERENCIAM.DSREFERENCIA = :P_DSREFERENCIA";

        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        
        if(!empty($retorno)){
            return true;
        }
        
        return false;
    }
    
    private function recalculaSituacoesDoVinculo($nrorg, $dtinilinhavinc){
        $this->nrafastamento = $this->setNrAfastamento($dtinilinhavinc, $this->backupDtIni, $this->backupDtFim);
        $this->nrfalta = $this->setNrFalta($dtinilinhavinc, $this->backupDtIni, $this->backupDtFim);
       
        $params = array(
            "P_REFERENCIA"     => 0,
            "P_NRORG"          => $nrorg,
            "P_DTMESCOMPETENC" => $this->dtmescompetencia,
            "P_DSREFERENCIA"   => 'DESCONTA_FALTA_VALE');

        $sql = "select * from FPA_VALORREFERENCIAM
                  JOIN FPA_VALORREFERENCIAH
                    ON FPA_VALORREFERENCIAH.NRVALORREFERENCIAM = FPA_VALORREFERENCIAM.NRVALORREFERENCIAM
                   AND FPA_VALORREFERENCIAH.VRREFERENCIA = :P_REFERENCIA
                   AND FPA_VALORREFERENCIAH.DTMESCOMPETENC =
                                                         (SELECT MAX(DTMESCOMPETENC)
                                                            FROM FPA_VALORREFERENCIAH
                                                           WHERE FPA_VALORREFERENCIAH.NRVALORREFERENCIAM       = FPA_VALORREFERENCIAM.NRVALORREFERENCIAM
                                                             AND FPA_VALORREFERENCIAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))

                WHERE FPA_VALORREFERENCIAM.NRORG = :P_NRORG
                AND FPA_VALORREFERENCIAM.DSREFERENCIA = :P_DSREFERENCIA";

        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        
        MemoriaVT::getInstance()->setDiasConsPeriodo($this->nrdiasproxmes);
        MemoriaVT::getInstance()->setDiasComposicaoMensal($this->nrdiascomposicaomensal);
        MemoriaVT::getInstance()->setDiasObrigacaoSindicato($this->nrdiasobrigacaosindicato);
        MemoriaVT::getInstance()->setDiasAfastAtest($this->nrafastamento);
        MemoriaVT::getInstance()->setFaltas($this->nrfalta);
        MemoriaVT::getInstance()->setFerias($this->nrdiasferias);
        MemoriaVT::getInstance()->setDiasAviso($this->nrdiasaviso);

        if (empty($retorno)) {
            MemoriaVT::getInstance()->setReferencia(false);
            if($this->idcalccomplementar == 'S'){
                $this->diastotaisconsideracao = (int)$this->nrdiascomposicaomensal;
            } elseif ($this->nrdiascomposicaomensal) {
                $this->diastotaisconsideracao = (int)$this->nrdiascomposicaomensal - (int)$this->nrdiasferias - (int)$this->nrfalta - (int)$this->nrafastamento;
            } elseif ($this->nrdiasobrigacaosindicato) {
                $this->diastotaisconsideracao = (int)$this->nrdiasobrigacaosindicato - (int)$this->nrdiasferias - (int)$this->nrfalta - (int)$this->nrafastamento;
            } elseif ($this->nrdiasaviso) {
                $this->diastotaisconsideracao = (int)$this->nrdiasaviso - (int)$this->nrdiasferias - (int)$this->nrfalta - (int)$this->nrafastamento;
            } else {
                $this->diastotaisconsideracao = (int)$this->nrdiasproxmes - (int)$this->nrdiasferias - (int)$this->nrfalta - (int)$this->nrafastamento;
            }
        }else{
            MemoriaVT::getInstance()->setReferencia(true);
            if ($this->nrdiascomposicaomensal) {
                $this->diastotaisconsideracao = (int)$this->nrdiascomposicaomensal;
            } elseif ($this->nrdiasobrigacaosindicato) {
                $this->diastotaisconsideracao = (int)$this->nrdiasobrigacaosindicato;
            } elseif ($this->nrdiasaviso) {
                $this->diastotaisconsideracao = (int)$this->nrdiasaviso;
            } else {
                $this->diastotaisconsideracao = (int)$this->nrdiasproxmes;
            }
        }
        
        if ($this->idnaogeravale) {
            MemoriaVT::getInstance()->setIdNaoGeraCalc($this->idnaogeravale);
            $this->diastotaisconsideracao = 0;
        }
        
        MemoriaVT::getInstance()->setResultadoTotal($this->diastotaisconsideracao);
    }
    
    private function recalculaSituacoesGeraisDoVinculoUtilizandoDatasModificadas($nrorg){
        $this->datasEntre = DateUtil::getDatasEntre($this->dtiniperiodovale, $this->dtfimperiodovale);
        $this->nrafastamento = $this->setNrAfastamento(null, $this->backupDtIni, $this->backupDtFim);
        $this->nrfalta = $this->setNrFalta(null, $this->backupDtIni, $this->backupDtFim);
        $this->nrdiasferias = $this->setNrDiasFerias($this->dtiniperiodovale, $this->dtfimperiodovale);
        $this->nrdiasproxmes = $this->setNrDiasCalculo($this->dtiniperiodovale, $this->dtfimperiodovale);
        $this->nrdiasaviso = $this->setNrDiasAviso($this->dtiniperiodovale, $this->dtfimperiodovale);
       
        $params = array(
            "P_REFERENCIA"     => 0,
            "P_NRORG"          => $nrorg,
            "P_DTMESCOMPETENC" => $this->dtmescompetencia,
            "P_DSREFERENCIA"   => 'DESCONTA_FALTA_VALE');

        $sql = "select * from FPA_VALORREFERENCIAM
                  JOIN FPA_VALORREFERENCIAH
                    ON FPA_VALORREFERENCIAH.NRVALORREFERENCIAM = FPA_VALORREFERENCIAM.NRVALORREFERENCIAM
                   AND FPA_VALORREFERENCIAH.VRREFERENCIA = :P_REFERENCIA
                   AND FPA_VALORREFERENCIAH.DTMESCOMPETENC =
                                                         (SELECT MAX(DTMESCOMPETENC)
                                                            FROM FPA_VALORREFERENCIAH
                                                           WHERE FPA_VALORREFERENCIAH.NRVALORREFERENCIAM       = FPA_VALORREFERENCIAM.NRVALORREFERENCIAM
                                                             AND FPA_VALORREFERENCIAH.DTMESCOMPETENC <= TO_DATE(:P_DTMESCOMPETENC, 'DD/MM/YYYY'))

                WHERE FPA_VALORREFERENCIAM.NRORG = :P_NRORG
                AND FPA_VALORREFERENCIAM.DSREFERENCIA = :P_DSREFERENCIA";

        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        
        MemoriaVT::getInstance()->setDiasConsPeriodo($this->nrdiasproxmes);
        MemoriaVT::getInstance()->setDiasComposicaoMensal($this->nrdiascomposicaomensal);
        MemoriaVT::getInstance()->setDiasObrigacaoSindicato($this->nrdiasobrigacaosindicato);
        MemoriaVT::getInstance()->setDiasAfastAtest($this->nrafastamento);
        MemoriaVT::getInstance()->setFaltas($this->nrfalta);
        MemoriaVT::getInstance()->setFerias($this->nrdiasferias);
        MemoriaVT::getInstance()->setDiasAviso($this->nrdiasaviso);

        if (empty($retorno)) {
            MemoriaVT::getInstance()->setReferencia(false);
            if($this->idcalccomplementar == 'S'){
                $this->diastotaisconsideracao = (int)$this->nrdiascomposicaomensal;
            } elseif ($this->nrdiascomposicaomensal) {
                $this->diastotaisconsideracao = (int)$this->nrdiascomposicaomensal - (int)$this->nrdiasferias - (int)$this->nrfalta - (int)$this->nrafastamento;
            } elseif ($this->nrdiasobrigacaosindicato) {
                $this->diastotaisconsideracao = (int)$this->nrdiasobrigacaosindicato - (int)$this->nrdiasferias - (int)$this->nrfalta - (int)$this->nrafastamento;
            } elseif ($this->nrdiasaviso) {
                $this->diastotaisconsideracao = (int)$this->nrdiasaviso - (int)$this->nrdiasferias - (int)$this->nrfalta - (int)$this->nrafastamento;
            } else {
                $this->diastotaisconsideracao = (int)$this->nrdiasproxmes - (int)$this->nrdiasferias - (int)$this->nrfalta - (int)$this->nrafastamento;
            }
        }else{
            MemoriaVT::getInstance()->setReferencia(true);
            if ($this->nrdiascomposicaomensal) {
                $this->diastotaisconsideracao = (int)$this->nrdiascomposicaomensal;
            } elseif ($this->nrdiasobrigacaosindicato) {
                $this->diastotaisconsideracao = (int)$this->nrdiasobrigacaosindicato;
            } elseif ($this->nrdiasaviso) {
                $this->diastotaisconsideracao = (int)$this->nrdiasaviso;
            } else {
                $this->diastotaisconsideracao = (int)$this->nrdiasproxmes;
            }
        }
        
        if ($this->idnaogeravale) {
            MemoriaVT::getInstance()->setIdNaoGeraCalc($this->idnaogeravale);
            $this->diastotaisconsideracao = 0;
        }
        
        MemoriaVT::getInstance()->setResultadoTotal($this->diastotaisconsideracao);
    }
    
    public function getMessages(){
        return $this->messages;
    }

    //INFORMAÇÃO SOBRE O VÍNCULO
    /**
     * VERIFICA A QUANTIDADE DE DIAS DA COMPOSIÇÃO MENSAL DO VÍNCULO
     * Verifica a quantidade de dias da composição mensal de cada vínculo. Criado para tratar excessões, quando
     * vínculos tem uma excessão no pagamento de seus vales transporte
     */
    private function setDiasComposicaoMensal()
    {
        empty($this->qtdiasvalefixo) ? $nrDiasApurVale = $this->objvinculo->getNrdiasapurvales() : $nrDiasApurVale = $this->qtdiasvalefixo;
        return (int) $nrDiasApurVale;
    }

    /**
     * VERIFICA A QUANTIDADE DE DIAS OBRIGATÓRIOS POR ACORDO COM O SINDICATO
     * Opção feita quando se há uma quantidade de vales a ser depositado por algum acordo entre o sindicato patronal e
     * o sindicato operário.
     */
    private function setNrDiasObrigacaoSindicato()
    {
        $dtmescompetencia = $this->dtmescompetencia;
        $nrDiasApurVale = null;

        if ($this->objvinculoh->getNrestrutsind()) {
            $params = array(
                'P_NRESTRUTURAM' => $this->objvinculoh->getNrestrutsind(),
                'P_NRORG' => $this->nrorg
            );
            $where = "NRESTRUTURAM = :P_NRESTRUTURAM AND NRORG = :P_NRORG AND DTINICIOVIGENCIA <= '$dtmescompetencia' AND (DTFIMVIGENCIA >= '$dtmescompetencia' OR DTFIMVIGENCIA IS NULL)";
            $sindicato = FpaParamsindicato::getObjectByWhere($where, $params);

            if($sindicato) $nrDiasApurVale = (int)$sindicato->getNrdiasapurvales();
        }
        
        return $nrDiasApurVale;
    }
    
    private function getHistoricoEscalaRetroc($competencia, $iniperiodoAnaliseRetroc, $fimperiodoAnaliseRetroc){
        $this->nrturnoRetroc = null;
        $competencia = $competencia;
        $iniperiodo = $iniperiodoAnaliseRetroc;
        $fimperiodo = $fimperiodoAnaliseRetroc;
        
        try {
             /**
             * @var GpeEscalatrabh $escalaTrab
             * @var GpeAlteescala $escalaTrabVinc
             */
            $params = array(    
                            'P_NRORG' => $this->nrorg,
                            'P_NRVINCULOM' => $this->objvinculo->getNrvinculom(),
                            'P_INIPERIODO' => $iniperiodoAnaliseRetroc,
                            'P_FIMPERIODO' => $fimperiodoAnaliseRetroc,
                            'P_COMPETENCIA' => $competencia,
                           );
                           
            $where = "e.NRVINCULOM = :P_NRVINCULOM 
                        AND e.NRORG = :P_NRORG 
                        AND e.DTINIESCALA = (SELECT MAX(DTINIESCALA) DTINIESCALA 
                                                FROM GPE_ALTEESCALA MAX_ALTEESCALA 
                                                WHERE MAX_ALTEESCALA.DTINIESCALA <= LAST_DAY(:P_COMPETENCIA)
                                                AND MAX_ALTEESCALA.NRORG = e.NRORG 
                                                AND MAX_ALTEESCALA.NRVINCULOM = e.NRVINCULOM
                                           )";
            $escalaTrabVinc = GpeAlteescala::getObjectByWhere($where, $params);
            
            $this->nrturnoRetroc = isset($escalaTrabVinc) && !empty($escalaTrabVinc) ? $escalaTrabVinc->getNrturno() : null; // Caso haja turno a contagem de dias deverá olhar apenas para o turno
            
            if (!empty($escalaTrabVinc)) {
                $params = array(
                    'P_NRORG' => $this->nrorg,
                    'P_NRESCALATRABM' => $escalaTrabVinc->getNrescalatrabm(), 
                    'P_DTMESCOMPETENC' => $competencia, 
                );
                $where = "NRORG = :P_NRORG 
                            AND e.NRESCALATRABM = :P_NRESCALATRABM 
                            AND e.DTMESCOMPETENC = (SELECT MAX(MAX_ESCALATRABH.DTMESCOMPETENC) 
                                                    FROM GPE_ESCALATRABH MAX_ESCALATRABH 
                                                    WHERE MAX_ESCALATRABH.DTMESCOMPETENC <= :P_DTMESCOMPETENC 
                                                    AND MAX_ESCALATRABH.NRESCALATRABM = e.NRESCALATRABM 
                                                    AND MAX_ESCALATRABH.NRORG = e.NRORG
                                                  )";
                $escalatrabalho = GpeEscalatrabh::getObjectByWhere($where, $params);
                
                if(empty($escalatrabalho)){
                    $this->messages[] = "Atenção: Vínculo ".$this->objvinculo->getNrvinculom()." - ".$this->objvinculo->getNmvinculom().". Escala: ".$escalaTrabVinc->getNrescalatrabm()." não possui histórico na competência: ".$competencia.".";
                    return;
                }
                
                // histórico é carregado novamente apenas para acessar os valores 'IDGERBENFER' e 'IDUTAPURATESTBENEF' 
                $historico = GpeEscalatrabm::_retornaHistórico(
                    $escalatrabalho->getNrescalatrabh(), 
                    $this->hcmParameters->getNrorgTrabalho()
                );
                
                return $historico;
            }
        }catch (\Exception $e){
            throw $e;
        }
    }

    /**
     * VERIFICA A QUANTIDADE DE DIAS QUE SERÁ DEPOSITADO DE ACORDO COM A ESCALA DE TRABALHO.
     * Opção feita para aquelas pessoas que trabalham com uma escala de trabalho onde é difícil se definir quando será
     * seus dias de descanso remunerado
     */
    private function setDecansoSemanal()
    {
        $this->dsdiadescansosemanal = self::SABDOM;
        
        $competencia = $this->dtmescompetencia;
        $iniperiodo = clone $this->dtiniperiodovale;
        $fimperiodo = clone $this->dtfimperiodovale;

        try {
            /**
             * @var GpeEscalatrabh $escalaTrab
             * @var GpeAlteescala $escalaTrabVinc
             */
            $params = array(    
                            'P_NRORG' => $this->nrorg,
                            'P_NRVINCULOM' => $this->objvinculo->getNrvinculom(),
                            'P_INIPERIODO' => $iniperiodo->format('d/m/Y'),
                            'P_FIMPERIODO' => $fimperiodo->format('d/m/Y'),
                            'P_COMPETENCIA' => $competencia,
                           );
            $where = "e.NRVINCULOM = :P_NRVINCULOM 
                        AND e.NRORG = :P_NRORG
                        AND e.DTINIESCALA = (SELECT MAX(DTINIESCALA) DTINIESCALA 
                                                FROM GPE_ALTEESCALA MAX_ALTEESCALA 
                                                WHERE MAX_ALTEESCALA.DTINIESCALA <= LAST_DAY(:P_COMPETENCIA) 
                                                AND MAX_ALTEESCALA.NRORG = e.NRORG 
                                                AND MAX_ALTEESCALA.NRVINCULOM = e.NRVINCULOM
                                           )";
            
            $this->escalaTrabVinc = $escalaTrabVinc = GpeAlteescala::getObjectByWhere($where, $params);
            
            $this->nrturno = isset($escalaTrabVinc) && !empty($escalaTrabVinc) ? $escalaTrabVinc->getNrturno() : null; // Caso haja turno a contagem de dias deverá olhar apenas para o turno
            
            if ($escalaTrabVinc) {
                $params = array(
                    'P_NRORG' => $this->nrorg,
                    'P_NRESCALATRABM' => $escalaTrabVinc->getNrescalatrabm(), 
                    'P_DTMESCOMPETENC' => $competencia, 
                );
                $where = "NRORG = :P_NRORG 
                            AND e.NRESCALATRABM = :P_NRESCALATRABM 
                            AND e.DTMESCOMPETENC = (SELECT MAX(MAX_ESCALATRABH.DTMESCOMPETENC) 
                                                    FROM GPE_ESCALATRABH MAX_ESCALATRABH 
                                                    WHERE MAX_ESCALATRABH.DTMESCOMPETENC <= :P_DTMESCOMPETENC 
                                                    AND MAX_ESCALATRABH.NRESCALATRABM = e.NRESCALATRABM 
                                                    AND MAX_ESCALATRABH.NRORG = e.NRORG
                                                  )";
                                                  
                $escalatrabalho = GpeEscalatrabh::getObjectByWhere($where, $params);
                // histórico é carregado novamente apenas para acessar os valores 'IDGERBENFER' e 'IDUTAPURATESTBENEF' 
                $this->historico = $historico = GpeEscalatrabm::_retornaHistórico(
                    $escalatrabalho->getNrescalatrabh(), 
                    $this->hcmParameters->getNrorgTrabalho()
                );
                
                $this->geraBenefFeriado = isset($escalatrabalho) && $escalatrabalho->getIdgerbenfer() ? $escalatrabalho->getIdgerbenfer() : null;
                
                $this->geraBenefFeriado = isset($historico) && !empty($historico) ? $historico['IDGERBENFER'] : null;
                
                if(isset($historico['IDUTAPURATESTBENEF']) && !empty($historico['IDUTAPURATESTBENEF']) && ($historico['IDUTAPURATESTBENEF'] == 'S' || $historico['IDUTAPURATESTBENEF'] == 'Y')){
                    $this->diaInicialAupr = $escalatrabalho->getNrdiainiapur();
                    $this->diaFinalAupr = $escalatrabalho->getNrdiafinapur();
                }                
                
                // $this->nrtpjornada = isset($escalatrabalho) && !empty($escalatrabalho) ? $escalatrabalho->getNrtpjornada() : null;

                $dsdescansosemanal = $escalatrabalho->getDescansosemanal();
                switch ($dsdescansosemanal) {
                    case('SABADO'): {
                        $this->dsdiadescansosemanal = self::SABADO;
                        break;
                    }
                    case('SAB/DOM'): {
                        $this->dsdiadescansosemanal = self::SABDOM;
                        break;
                    }
                    case('DOMINGO'): {
                        $this->dsdiadescansosemanal = self::DOMINGO;
                        break;
                    }
                    case('SEGUNDA'): {
                        $this->dsdiadescansosemanal = self::SEGUNDA;
                        break;
                    }
                    case('TERCA'): {
                        $this->dsdiadescansosemanal = self::TERCA;
                        break;
                    }
                    case('QUARTA'): {
                        $this->dsdiadescansosemanal = self::QUARTA;
                        break;
                    }
                    case('QUINTA'): {
                        $this->dsdiadescansosemanal = self::QUINTA;
                        break;
                    }
                    case('SEXTA'): {
                        $this->dsdiadescansosemanal = self::SEXTA;
                        break;
                    }
                    case('6 X 1'): {
                        $this->dsdiadescansosemanal = self::DOMINGO;
                        break;
                    }
                    case('ESCALA'): {
                        $this->dsdiadescansosemanal = self::DOMINGO;
                        break;
                    }
                }
                
            }
            else {
                //throw new \Exception('Vínculo '.$this->objvinculo->getNrvinculom().' - '.$this->objvinculo->getNmvinculom().' não possui escala.');
            }
        }catch (\Exception $e){
            throw $e;
        }
    }

    /**
     * NÚMERO DE AFASTAMENTOS QUE O VÍNCULO OBTEVE DURANTE DO PERÍODO
     * Considera-se o número de dias em que o vínculo de afastou da empresa e tais afastamentos não geraram vales
     * transporte, tais como atestados médicos, afastamento por acidente (de trabalho ou não), afastamento por gravidez,
     * afastamentos por serviços sociais (militares ou parecidos).
     */
    private function setNrAfastamento($dtinilinhavinc = null, $dtiniperiodocalculo = null, $dtfimperiodocalculo = null)
    {
        //felipesantos - 09/06/2015 : Alterações para considerar o período de apuração do vale e caso as datas de afastamento não estejam compreendidas dentro do período
        //                            considerar as datas do período de apuração.
        //felipesantos - 05/10/2015 : Alterado para considerar os afastamentos voltando dois períodos de apuração do vale, pois é o período que se encontra totalmente fechado.
        //                            Por exemplo: para apuração de 16/09 a 15/10, considerar os afastamentos em 16/07 a 15/08.
        $dtiniperiodo    = !empty($dtiniperiodocalculo) ? clone $dtiniperiodocalculo : clone $this->dtiniperiodocalculo;
        $dtfimperiodo    = !empty($dtfimperiodocalculo) ? clone $dtfimperiodocalculo : clone $this->dtfimperiodocalculo;
        $dtiniperiodoAnt = !empty($dtiniperiodocalculo) ? clone $dtiniperiodocalculo : clone $this->dtiniperiodocalculo;
        $dtfimperiodoAnt = !empty($dtfimperiodocalculo) ? clone $dtfimperiodocalculo : clone $this->dtfimperiodocalculo;
        $dtiniperiodoAnt = $dtiniperiodoAnt->sub(new \DateInterval('P1M'));
        $dtfimperiodoAnt = $dtfimperiodoAnt->sub(new \DateInterval('P1M'));
        $total = 0;
        $nrsitufuncm = GpeSitufunch::getAfastamentoIncideVale($this->dtmescompetencia);
        $nrsitufuncm = implode(', ', $nrsitufuncm);
        
        $nrsitufuncmAgileAtestados = [100063, 100064, 100065, 100066, 100067, 100068, 100069, 100074, 100075];
        $nrsitufuncmAgileAtestados = implode(', ', $nrsitufuncmAgileAtestados);
        
        // Caso seja para contar dias de Atestado e na escala do vínculo tenha período pré-definido e id 'Utiliza para Atestados' preenchido,
        // função abaixo adequará perído de consideração de atestado segundo o informado no histórico da Escala do vínculo
        if($this->diaInicialAupr && $this->diaFinalAupr) $this->setPeriodoApuracaoPelaEscala($dtiniperiodoAnt, $dtfimperiodoAnt);
        
        $where = "NRORG = :P_NRORG AND
                      NRVINCULOM = :P_NRVINCULOM AND
                      (
                           /*AFASTAMENTO*/ (DTINISITUFUNC <= '$dtfimperiodo' AND DTFIMSITUFUNC >= '$dtiniperiodo' AND NRSITUFUNCM NOT IN (12, 15, 16, 13, 100072, $nrsitufuncmAgileAtestados)) OR
                           /*AFASTAMENTO*/ (DTINISITUFUNC BETWEEN '$dtiniperiodo' AND '$dtfimperiodo' AND NRSITUFUNCM NOT IN (12, 15, 16, 13, 100072, $nrsitufuncmAgileAtestados)) OR
                           /*AFASTAMENTO*/ (DTFIMSITUFUNC BETWEEN '$dtiniperiodo' AND '$dtfimperiodo' AND NRSITUFUNCM NOT IN (12, 15, 16, 13, 100072, $nrsitufuncmAgileAtestados)) OR
                           /*ATESTADO*/    (DTINISITUFUNC <= '$dtfimperiodoAnt' AND DTFIMSITUFUNC >= '$dtiniperiodoAnt' AND NRSITUFUNCM IN (12, 15, 16, $nrsitufuncmAgileAtestados)) OR
                           /*ATESTADO*/    (DTINISITUFUNC BETWEEN '$dtiniperiodoAnt' AND '$dtfimperiodoAnt' AND NRSITUFUNCM IN (12, 15, 16, $nrsitufuncmAgileAtestados)) OR
                           /*ATESTADO*/    (DTFIMSITUFUNC BETWEEN '$dtiniperiodoAnt' AND '$dtfimperiodoAnt' AND NRSITUFUNCM IN (12, 15, 16, $nrsitufuncmAgileAtestados)) OR
                                           (DTFIMSITUFUNC IS NULL AND NRSITUFUNCM IN (12, 15, 16, $nrsitufuncmAgileAtestados)) OR
                           /*AFASTAMENTO*/ (DTINISITUFUNC = (SELECT MAX(DTINISITUFUNC)
                                                                    FROM GPE_ALTESITUFUNC MAX_ALTESITUFUNC
                                                                    WHERE MAX_ALTESITUFUNC.NRORG = e.NRORG
                                                                    AND MAX_ALTESITUFUNC.NRVINCULOM = e.NRVINCULOM) AND NRSITUFUNCM NOT IN (12, 13, 15, 16, 100072, $nrsitufuncmAgileAtestados)
                                            )
                       ) AND NRSITUFUNCM IN ($nrsitufuncm)";

        //Verifica se existe parametro de vale transporte para a organização...
        if(!empty($this->paramVale)){
            //Atestado
            if($this->paramVale['IDCONSATESTVALE'] == 'S'){
                $dataFormularioIsUltimoDiaMes = false;
                $dtiniperiodoAnt = clone $dtiniperiodo;
                $dtfimperiodoAnt = clone $dtfimperiodo;
                
                if($dtfimperiodoAnt->format('d/m/Y') == $dtfimperiodoAnt->format('t/m/Y')){
                    $dataFormularioIsUltimoDiaMes = true;
                }
                
                //Aplica a quantidade de meses a ser retrocedido dependendo do parametro informado.
                $dtiniperiodoAnt = DateUtil::truncateData($dtiniperiodoAnt)->sub(new \DateInterval("P". $this->paramVale['QTMESESATESTVALE'] ."M"));
                $dtfimperiodoAnt = DateUtil::truncateData($dtfimperiodoAnt)->sub(new \DateInterval("P". $this->paramVale['QTMESESATESTVALE'] ."M"));
                
                while($dtfimperiodoAnt->format('m') == $this->backupDtFim->format('m') && $this->paramVale['QTMESESATESTVALE'] != 0){
                    $dtfimperiodoAnt = $dtfimperiodoAnt->sub(new \DateInterval('P1D'));
                }
                
                #if($dtiniperiodoAnt->format('m') == 2){
                    while(($dtfimperiodoAnt->format('m') > $dtiniperiodoAnt->format('m')) && $this->paramVale['QTMESESATESTVALE'] != 0){
                        $dtfimperiodoAnt = $dtfimperiodoAnt->sub(new \DateInterval('P1D'));
                    }
                #}
                
                if(($dtfimperiodoAnt->format('d/m/Y') != $dtfimperiodoAnt->format('t/m/Y')) && $dataFormularioIsUltimoDiaMes == true){
                    $dtfimperiodoAnt = DateUtil::getDataDeString($dtfimperiodoAnt->format('t/m/Y'), DateUtil::FORMATO_BRASILEIRO, true);
                }
                
                $condAtestado = true;
            } else {
                $condAtestado = '';
            }
            
            //Afastamento
            if($this->paramVale['IDCONSAFASTVALE'] == 'S'){
                $dataFormularioIsUltimoDiaMes = false;
                $dtiniperiodo = clone $dtiniperiodo;
                $dtfimperiodo = clone $dtfimperiodo;
                
                if($dtfimperiodo->format('d/m/Y') == $dtfimperiodo->format('t/m/Y')){
                    $dataFormularioIsUltimoDiaMes = true;
                }
                
                //Aplica a quantidade de meses a ser retrocedido dependendo do parametro informado.
                $dtiniperiodo = DateUtil::truncateData($dtiniperiodo)->sub(new \DateInterval("P". $this->paramVale['QTMESESAFASTVALE'] ."M"));
                $dtfimperiodo = DateUtil::truncateData($dtfimperiodo)->sub(new \DateInterval("P". $this->paramVale['QTMESESAFASTVALE'] ."M"));
                
                while($dtfimperiodo->format('m') == $this->backupDtFim->format('m') && $this->paramVale['QTMESESAFASTVALE'] != 0){
                    $dtfimperiodo = $dtfimperiodo->sub(new \DateInterval('P1D'));
                }
                
                #if($dtiniperiodo->format('m') == 2){
                    while(($dtfimperiodo->format('m') > $dtiniperiodo->format('m')) && $this->paramVale['QTMESESAFASTVALE'] != 0){
                        $dtfimperiodo = $dtfimperiodo->sub(new \DateInterval('P1D'));
                    }
                #}
                
                if(($dtfimperiodo->format('d/m/Y') != $dtfimperiodo->format('t/m/Y')) && $dataFormularioIsUltimoDiaMes == true){
                    $dtfimperiodo = DateUtil::getDataDeString($dtfimperiodo->format('t/m/Y'), DateUtil::FORMATO_BRASILEIRO, true);
                }
                
                $condAfastamento = true;
            } else {
                $condAfastamento = '';
            }
            
            if($this->paramVale['IDCONSAFASTVALE'] == 'N' && $this->paramVale['IDCONSATESTVALE'] == 'N'){
                return $total;
            }
            
            if(!empty($condAfastamento) && !empty($condAtestado)){
                $where = "NRORG = :P_NRORG AND
                          NRVINCULOM = :P_NRVINCULOM AND
                          (
                               /*AFASTAMENTO*/ (DTINISITUFUNC <= '$dtfimperiodo' AND DTFIMSITUFUNC >= '$dtiniperiodo' AND NRSITUFUNCM NOT IN (12, 15, 16, 13, 100072, $nrsitufuncmAgileAtestados)) OR
                               /*AFASTAMENTO*/ (DTINISITUFUNC BETWEEN '$dtiniperiodo' AND '$dtfimperiodo' AND NRSITUFUNCM NOT IN (12, 15, 16, 13, 100072, $nrsitufuncmAgileAtestados)) OR
                               /*AFASTAMENTO*/ (DTFIMSITUFUNC BETWEEN '$dtiniperiodo' AND '$dtfimperiodo' AND NRSITUFUNCM NOT IN (12, 15, 16, 13, 100072, $nrsitufuncmAgileAtestados)) OR
                               /*ATESTADO*/    (DTINISITUFUNC <= '$dtfimperiodoAnt' AND DTFIMSITUFUNC >= '$dtiniperiodoAnt' AND ((DTINISITUFUNC >= :P_DTINILINHAVINC OR DTFIMSITUFUNC >= :P_DTINILINHAVINC) OR :P_DTINILINHAVINC IS NULL) AND NRSITUFUNCM IN (12, 15, 16, $nrsitufuncmAgileAtestados)) OR
                               /*ATESTADO*/    (DTINISITUFUNC BETWEEN '$dtiniperiodoAnt' AND '$dtfimperiodoAnt' AND ((DTINISITUFUNC >= :P_DTINILINHAVINC OR DTFIMSITUFUNC >= :P_DTINILINHAVINC) OR :P_DTINILINHAVINC IS NULL) AND NRSITUFUNCM IN (12, 15, 16, $nrsitufuncmAgileAtestados)) OR
                               /*ATESTADO*/    (DTFIMSITUFUNC BETWEEN '$dtiniperiodoAnt' AND '$dtfimperiodoAnt' AND ((DTINISITUFUNC >= :P_DTINILINHAVINC OR DTFIMSITUFUNC >= :P_DTINILINHAVINC) OR :P_DTINILINHAVINC IS NULL) AND NRSITUFUNCM IN (12, 15, 16, $nrsitufuncmAgileAtestados)) OR
                                               (DTFIMSITUFUNC IS NULL AND NRSITUFUNCM IN (12, 15, 16, $nrsitufuncmAgileAtestados)) OR
                               /*AFASTAMENTO*/ (DTINISITUFUNC = (SELECT MAX(DTINISITUFUNC)
                                                                        FROM GPE_ALTESITUFUNC MAX_ALTESITUFUNC
                                                                        WHERE MAX_ALTESITUFUNC.NRORG = e.NRORG
                                                                        AND MAX_ALTESITUFUNC.NRVINCULOM = e.NRVINCULOM) AND NRSITUFUNCM NOT IN (12, 13, 15, 16, 100072, $nrsitufuncmAgileAtestados)
                                                )
                           ) AND NRSITUFUNCM IN ($nrsitufuncm)"; 
            } else if(!empty($condAtestado) && empty($condAfastamento)){
                $where = "NRORG = :P_NRORG AND
                          NRVINCULOM = :P_NRVINCULOM AND
                          (
                               /*ATESTADO*/    (DTINISITUFUNC <= '$dtfimperiodoAnt' AND DTFIMSITUFUNC >= '$dtiniperiodoAnt' AND ((DTINISITUFUNC >= :P_DTINILINHAVINC OR DTFIMSITUFUNC >= :P_DTINILINHAVINC) OR :P_DTINILINHAVINC IS NULL) AND NRSITUFUNCM IN (12, 15, 16, $nrsitufuncmAgileAtestados)) OR
                               /*ATESTADO*/    (DTINISITUFUNC BETWEEN '$dtiniperiodoAnt' AND '$dtfimperiodoAnt' AND ((DTINISITUFUNC >= :P_DTINILINHAVINC OR DTFIMSITUFUNC >= :P_DTINILINHAVINC) OR :P_DTINILINHAVINC IS NULL) AND NRSITUFUNCM IN (12, 15, 16, $nrsitufuncmAgileAtestados)) OR
                               /*ATESTADO*/    (DTFIMSITUFUNC BETWEEN '$dtiniperiodoAnt' AND '$dtfimperiodoAnt' AND ((DTINISITUFUNC >= :P_DTINILINHAVINC OR DTFIMSITUFUNC >= :P_DTINILINHAVINC) OR :P_DTINILINHAVINC IS NULL) AND NRSITUFUNCM IN (12, 15, 16, $nrsitufuncmAgileAtestados)) OR
                                               (DTFIMSITUFUNC IS NULL AND NRSITUFUNCM IN (12, 15, 16, $nrsitufuncmAgileAtestados))
                           ) AND NRSITUFUNCM IN ($nrsitufuncm)";  
            } else if(!empty($condAfastamento) && empty($condAtestado)){
                $where = "NRORG = :P_NRORG AND
                          NRVINCULOM = :P_NRVINCULOM AND
                          (
                               /*AFASTAMENTO*/ (DTINISITUFUNC <= '$dtfimperiodo' AND DTFIMSITUFUNC >= '$dtiniperiodo' AND NRSITUFUNCM NOT IN (12, 15, 16, 13, 100072, $nrsitufuncmAgileAtestados)) OR
                               /*AFASTAMENTO*/ (DTINISITUFUNC BETWEEN '$dtiniperiodo' AND '$dtfimperiodo' AND NRSITUFUNCM NOT IN (12, 15, 16, 13, 100072, $nrsitufuncmAgileAtestados)) OR
                               /*AFASTAMENTO*/ (DTFIMSITUFUNC BETWEEN '$dtiniperiodo' AND '$dtfimperiodo' AND NRSITUFUNCM NOT IN (12, 15, 16, 13, 100072, $nrsitufuncmAgileAtestados)) OR
                               /*AFASTAMENTO*/ (DTINISITUFUNC = (SELECT MAX(DTINISITUFUNC)
                                                                        FROM GPE_ALTESITUFUNC MAX_ALTESITUFUNC
                                                                        WHERE MAX_ALTESITUFUNC.NRORG = e.NRORG
                                                                        AND MAX_ALTESITUFUNC.NRVINCULOM = e.NRVINCULOM) AND NRSITUFUNCM NOT IN (12, 13, 15, 16, 100072, $nrsitufuncmAgileAtestados)
                                                )
                           ) AND NRSITUFUNCM IN ($nrsitufuncm)"; 
            }
        }

        $param = array(
            'P_NRORG' => $this->nrorg,
            'P_NRVINCULOM' => $this->objvinculo->getNrvinculom(),
            'P_DTINILINHAVINC' => $dtinilinhavinc);
        
        $altesitfuncs = GpeAltesitufunc::getObjectsByWhere($where, $param);
        
        foreach($altesitfuncs as $altesitfunc){
			if (($altesitfunc->getNrsitufuncm() == 12) or ($altesitfunc->getNrsitufuncm() == 15) or ($altesitfunc->getNrsitufuncm() == 16) or ($altesitfunc->getNrsitufuncm() == 100063) or ($altesitfunc->getNrsitufuncm() == 100064) or ($altesitfunc->getNrsitufuncm() == 100065) or  ($altesitfunc->getNrsitufuncm() == 100066) or ($altesitfunc->getNrsitufuncm() == 100067) or ($altesitfunc->getNrsitufuncm() == 100068) or ($altesitfunc->getNrsitufuncm() == 100069) or ($altesitfunc->getNrsitufuncm() == 100074) or ($altesitfunc->getNrsitufuncm() == 100075)) {
				if ($altesitfunc->getDtinisitufunc() < $dtiniperiodoAnt) {
					$dtiniafastamento = $dtiniperiodoAnt;
				} else {
					$dtiniafastamento = $altesitfunc->getDtinisitufunc();
				}
				if (!$altesitfunc->getDtfimsitufunc()) {
					//Caso a situação funcional não possual data final, considera o dia anterior da data inicial da próxima situação que gera vale
					$dtinisitufunc = $altesitfunc->getDtinisitufunc();
					$where = "NRORG = :P_NRORG AND
							  NRVINCULOM = :P_NRVINCULOM AND
							  DTINISITUFUNC > '$dtinisitufunc' AND
							  DTINISITUFUNC <= '$dtfimperiodoAnt' AND
							  NRSITUFUNCM NOT IN ($nrsitufuncm)";
					$param = array(
						'P_NRORG' => $this->nrorg,
						'P_NRVINCULOM' => $this->objvinculo->getNrvinculom());
					$prox_altesitufunc = GpeAltesitufunc::getObjectsByWhere($where, $param);

					if ($prox_altesitufunc) {
						//Dia anterior da próxima situação geradora de vale
						$dtfimafastamento = end($prox_altesitufunc)->getDtinisitufunc()->sub(new \DateInterval('P1D'));
						//Caso o afastamento não esteja no período de apuração, é desconsiderado
						if ($dtfimafastamento < $dtiniafastamento) {
							continue;
						}
					} else {
						//Caso não tenha próxima situação que gera vale considera a data final do periodo de apuração
						$dtfimafastamento = clone DateUtil::getDataDeString($altesitfunc->getDtinisitufunc()->format('t/m/Y'), DateUtil::FORMATO_BRASILEIRO, true);
					}

				} else {
					if ($altesitfunc->getDtfimsitufunc() > $dtfimperiodoAnt) {
						$dtfimafastamento = $dtfimperiodoAnt;
					} else {
						$dtfimafastamento = $altesitfunc->getDtfimsitufunc();
					}
				}

                if ((($dtiniafastamento == $dtiniperiodoAnt) and ($dtfimafastamento == $dtfimperiodoAnt)) && ($this->hcmParameters->getNrorgTrabalho() != 1410) ) {
                    $this->idnaogeravale = true;
                }
			} else {
			    //  03/12/2023                           01/02/2024
				if ($altesitfunc->getDtinisitufunc() < $dtiniperiodo) {
					$dtiniafastamento = $dtiniperiodo;
				} else {
					$dtiniafastamento = $altesitfunc->getDtinisitufunc();
				}
				if (!$altesitfunc->getDtfimsitufunc()) {
					//Caso a situação funcional não possual data final, considera o dia anterior da data inicial da próxima situação que gera vale
					$dtinisitufunc = $altesitfunc->getDtinisitufunc();
					$where = "NRORG = :P_NRORG AND
							  NRVINCULOM = :P_NRVINCULOM AND
							  DTINISITUFUNC > '$dtinisitufunc' AND
							  DTINISITUFUNC <= '$dtfimperiodo' AND
							  NRSITUFUNCM NOT IN ($nrsitufuncm)";
					$param = array(
						'P_NRORG' => $this->nrorg,
						'P_NRVINCULOM' => $this->objvinculo->getNrvinculom());
					$prox_altesitufunc = GpeAltesitufunc::getObjectsByWhere($where, $param);

					if ($prox_altesitufunc) {
						//Dia anterior da próxima situação geradora de vale
						$dtfimafastamento = end($prox_altesitufunc)->getDtinisitufunc()->sub(new \DateInterval('P1D'));
						//Caso o afastamento não esteja no período de apuração, é desconsiderado
						if ($dtfimafastamento < $dtiniafastamento) {
							continue;
						}
					} else {
						//Caso não tenha próxima situação que gera vale considera a data final do periodo de apuração
						$dtfimafastamento = clone $dtfimperiodo;
					}

				} else {
					if ($altesitfunc->getDtfimsitufunc() > $dtfimperiodo) {
						$dtfimafastamento = $dtfimperiodo;
					} else {
						$dtfimafastamento = $altesitfunc->getDtfimsitufunc();
					}
				}

                if (($dtiniafastamento == $dtiniperiodo) and ($dtfimafastamento == $dtfimperiodo)) {
                    $this->idnaogeravale = true;
				}
			}
		    
            if ($dtfimafastamento >= $dtiniafastamento) {
				$qnt = $dtiniafastamento->diff($dtfimafastamento, true);
			
			    $diasEntreAtestado = DateUtil::getDatasEntre($dtiniafastamento, $dtfimafastamento);
			    if($diasEntreAtestado){
			        foreach($diasEntreAtestado as $dia){
			            array_push($this->datasEntreAtestadoOuAfast, $dia->format('d/m/Y'));
			        }   
			    }

				//Datas em string 
			    $arFeriados = $this->seekFeriado($dtiniafastamento, $dtfimafastamento);
				
                $diasTotaisAtestOuAfast = ($qnt->d + $qnt->m*30 + $qnt->y*365 + 1);
                
                $historico = $this->getHistoricoEscalaRetroc($dtiniafastamento->format('t/m/Y'), $dtiniafastamento->format('d/m/Y'), $dtfimafastamento->format('d/m/Y'));
            
                //Se o Vinculo tiver um tipo de joranda 12x36 não ira descontar feriados.
                if((!empty($historico) && isset($historico)) && $historico['NRTPJORNADA'] == 2){
                    $arFeriados = array();
                }
                
    			$feriados = count($arFeriados);
    			
    			if($feriados){
    			    foreach($arFeriados as $feriado){
    			       array_push($this->datasFeriadosAnt, $feriado[0]);
    			    }
    			}
                
                if( isset($this->nrturnoRetroc) ){
                    $arrayDiasFolgaVinc = array();
                    $datasEntreSitufunc = Dateutil::getDatasEntre($dtiniafastamento, $dtfimafastamento);
                    
                    //Para cada dia de situação funcional de afastamento/Atestado, é verificado se o vinculo trabalhou naquele dia para descontar a falta (verificando dia a dia a escala do vinculo e turno).
                    foreach($datasEntreSitufunc as $diaSitufunc){
                        $qntDia = $diaSitufunc->diff($diaSitufunc, true);
                        $descansoArray = $this->calcularQtdeDiasFolgaVincDia($diaSitufunc, $qntDia, $this->objvinculo->getNrvinculom(), $diaSitufunc->format('d/m/Y'));
                        
                        if(!empty($descansoArray)){
                            array_push($this->datasDsrAnt, $descansoArray[0]);
                            $arrayDiasFolgaVinc[] = $descansoArray[0];
                        }
                    }
                    
                    $diasFolga = count($arrayDiasFolgaVinc);
                    $intersecaoFolgaFeriado = count(array_intersect($arrayDiasFolgaVinc, $arFeriados)); //quantidade de dias que coincidem Atestado/Afastamento e Feriados
                
                    $total += $resultado = $diasTotaisAtestOuAfast - $feriados - $diasFolga + $intersecaoFolgaFeriado;
                    
                    MemoriaVT::getInstance()->detalharDiasAfastAtest(
                        array(
                            'tipo' => 'turno',
                            'dtInicial' => $dtiniafastamento->format('d/m/Y'),
                            'dtFinal' => $dtfimafastamento->format('d/m/Y'),
                            "formula" => "resultado = diasTotaisAtestOuAfast - feriados - diasFolga + intersecaoFolgaFeriado",
                            "expressao" => $resultado.' = '.$diasTotaisAtestOuAfast.' - '.$feriados.' - '.$diasFolga.' + '.$intersecaoFolgaFeriado,  
                            "resultado" => $resultado,
                            "diasTotaisAtestOuAfast" => $diasTotaisAtestOuAfast,
                            "feriados" => $feriados,
                            "diasFolga" => $diasFolga,
                            "intersecaoFolgaFeriado" => $intersecaoFolgaFeriado,
                        )
                    );
                }else{
    				$arDsr      = $this->seekDsr($dtiniafastamento->format('d/m/Y'), $dtfimafastamento->format('d/m/Y'), $this->dsdiadescansosemanal); 
    				
    				if($arDsr){
        			    foreach($arDsr as $dsr){
        			       $this->datasFeriadosAnt[] = $dsr[0];
        			    }
        			}
        			
    				$dsr      = count($arDsr);
    				$intersecaoDsrFeriado = count(array_intersect($arDsr, $arFeriados)); //quantidade de dias que coincidem DSR e Feriados
    				$total += $resultado = $diasTotaisAtestOuAfast - $feriados - $dsr + $intersecaoDsrFeriado;
                    
                    MemoriaVT::getInstance()->detalharDiasAfastAtest(
                        array(
                            'tipo' => 'dsr', 
                            'dtInicial' => $dtiniafastamento->format('d/m/Y'),
                            'dtFinal' => $dtfimafastamento->format('d/m/Y'),
                            "formula" => "resultado = diasTotaisAtestOuAfast - feriados - dsr + intersecaoDsrFeriado",
                            "expressao" => $resultado.' = '.$diasTotaisAtestOuAfast.' - '.$feriados.' - '.$dsr.' + '.$intersecaoDsrFeriado,  
                            "resultado" => $resultado,
                            "diasTotaisAtestOuAfast" => $diasTotaisAtestOuAfast,
                            "feriados" => $feriados,
                            "dsr" => $dsr,
                            "intersecaoDsrFeriado" => $intersecaoDsrFeriado,
                        )
                    );
                }
			}
        }

        return $total;
    }

    private function setPeriodoApuracaoPelaEscala(&$dtiniperiodoAnt, &$dtfimperiodoAnt){ 
        $competenciaReferencia = DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true);

        // Subtrari dois meses da competência para operar de acordo com a data final evidente na tela de escala
        $competenciaReferencia = $competenciaReferencia->sub(new \DateInterval('P2M')); 
        $dtfimperiodoAnt = clone $competenciaReferencia;
        $dtfimperiodoAnt = $dtfimperiodoAnt->add(new \DateInterval('P'. ($this->diaFinalAupr-1).'D'));
        
        // Subtrai mais um mes para operar de acordo com a data inicial evidente na tela de escala
        $competenciaReferencia = $competenciaReferencia->sub(new \DateInterval('P1M')); 
        $dtiniperiodoAnt = clone $competenciaReferencia;
        $dtiniperiodoAnt = $dtiniperiodoAnt->add(new \DateInterval('P'. ($this->diaInicialAupr-1).'D'));
    }
    
    public function retornaArraySituFuncFaltas($nrsitufuncm, $dtInicio, $dtFim){
        $arraySituFuncFaltas = [];

        $where = "NRORG = :P_NRORG AND
                  NRVINCULOM = :P_NRVINCULOM AND
                  DTINISITUFUNC <= '$dtFim' AND (DTFIMSITUFUNC >= '$dtInicio' OR DTFIMSITUFUNC IS NULL) AND NRSITUFUNCM = :P_NRSITUFUNCM";
                       
        $param = array(
            'P_NRORG' => $this->nrorg,
            'P_NRVINCULOM' => $this->objvinculo->getNrvinculom(),
            'P_NRSITUFUNCM' => $nrsitufuncm);
            
        $altesitfuncs = GpeAltesitufunc::getObjectsByWhere($where, $param);
        
        foreach($altesitfuncs as $altesitfunc){
            array_push($arraySituFuncFaltas, $altesitfunc);
        }
        
        return $arraySituFuncFaltas;
    }
    
    private function calculaFaltasSituFunc($iniSitufunc, $fimSitufunc){
        $faltasSituFunc = 0;
        
        //Verificar se a data fim e maior do q a data inicio
        if($fimSitufunc > $iniSitufunc){
            //Calcula a diferença de dias entre essas datas.
            $qntDiasFaltasSitu = $iniSitufunc->diff($fimSitufunc, true)->d+1;
            $faltasSituFunc = $faltasSituFunc + $qntDiasFaltasSitu;
        } else {
            //Se caso a data fim for igual a data inicio adiciona somente uma falta.
            $faltasSituFunc++;
        }
        
        return $faltasSituFunc;
    }
    
    private function getFaltasFrequencia($nrorg, $nrvinculom, $dtIni, $dtFim, $nrorgpadrao){
        $params = array(
            "P_NRORG"          => $nrorg,
            "P_NRVINCULOM"     => $nrvinculom,
            "P_DTINICIOAPUR"   => $dtIni,
            "P_DTFIMAPUR"      => $dtFim,
            "P_NRORG_PADRAO"   => $nrorgpadrao
            );

$sql = "SELECT
    resusitu.NRORG,
    resusitu.NRVINCULOM,
    resusitu.DTAPURACAOSITUFREQ,
    resusitu.QTREFAPURSITUFREQ,
    resusitu.NRSITUFREQUENCIA,
    situfreq.NRCALCULOSITUFREQ
FROM PTO_RESUMOSITUFREQ resusitu
JOIN PTO_ASSOCSITUFREQ situfreq
ON situfreq.NRSITUFREQUENCIA = resusitu.NRSITUFREQUENCIA
AND situfreq.NRORG = (
    SELECT NRORG
    FROM PTO_ASSOCSITUFREQ
    WHERE NRSITUFREQUENCIA = situfreq.NRSITUFREQUENCIA
        AND (NRORG = :P_NRORG OR NRORG = :P_NRORG_PADRAO)
    GROUP BY NRORG
    ORDER BY (
        CASE
            WHEN NRORG = :P_NRORG AND COUNT(NRORG) = 1 THEN -1
            ELSE NRORG
        END
    )
    FETCH FIRST ROW ONLY
)
AND situfreq.NRASSOCSITUFREQ = (
    SELECT MAX(NRASSOCSITUFREQ)
    FROM PTO_ASSOCSITUFREQ
    WHERE NRORG = situfreq.NRORG
        AND NRSITUFREQUENCIA = situfreq.NRSITUFREQUENCIA
)
AND situfreq.NRCALCULOSITUFREQ IN(10600, 10500)
WHERE resusitu.NRORG = :P_NRORG 
        AND resusitu.NRSITUFREQUENCIA = situfreq.NRSITUFREQUENCIA 
        AND resusitu.NRVINCULOM = :P_NRVINCULOM 
        AND resusitu.DTAPURACAOSITUFREQ BETWEEN :P_DTINICIOAPUR AND :P_DTFIMAPUR";

        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        
        return $retorno;
    }
    
    private function calculaFaltasFrequencia($arrayFaltasFreq){
        $dataFaltaAnterior = '';
        $qtdeFaltas = 0;

        for($indice = 0; $indice < count($arrayFaltasFreq); $indice++){
            /*Considerando que o retorno do array pode vir com 2 Posições com a mesma data, contamos somente uma (Pode acontecer de vir o numero 7 no campo ['QTREFAPURSITUFREQ']
            e logo apos com a mesma data, outro registro com o campo ['QTREFAPURSITUFREQ'] igual a 1, o que totaliza 8 horas de falta.)
            Segundo o proprio vinicius, foi dito que quando aparecer uma situação destas considera-se uma falta somente.*/
            if($arrayFaltasFreq[$indice]['DTAPURACAOSITUFREQ'] == $dataFaltaAnterior){
                continue;
            }
            
            $qtdeFaltas++;
            $dataFaltaAnterior = $arrayFaltasFreq[$indice]['DTAPURACAOSITUFREQ'];
        }

        return $qtdeFaltas;
    }

    /**
     * NÚMERO DE FALTAS
     * Considera-se faltas não justificadas durante o período avaliado.
     */
    private function setNrFalta($dtinilinhavinc = null, $dtiniperiodocalculo = null, $dtfimperiodocalculo = null)
    {
        $dtIniPeriodoFalta = !empty($dtiniperiodocalculo) ? clone $dtiniperiodocalculo : clone $this->dtiniperiodovale;
        $dtFimPeriodoFalta = !empty($dtfimperiodocalculo) ? clone $dtfimperiodocalculo : clone $this->dtfimperiodovale;
        $qtdeFaltas = 0;
        $nreventom = "490, 495, 1040, 1043";
        $nrtpmovimento = '1';
        
        if(!empty($this->paramVale)){
            if($this->paramVale['IDCONSFALTAVALE'] == 'S'){
                $dataFormularioIsUltimoDiaMes = false;
                
                if($dtFimPeriodoFalta->format('d/m/Y') == $dtFimPeriodoFalta->format('t/m/Y')){
                    $dataFormularioIsUltimoDiaMes = true;
                }
                
                $dataRetrocedidaIni = DateUtil::truncateData($dtIniPeriodoFalta)->sub(new \DateInterval("P". $this->paramVale['QTMESESFALTAVALE'] ."M"));
                $dataRetrocedidaFim = DateUtil::truncateData($dtFimPeriodoFalta)->sub(new \DateInterval("P". $this->paramVale['QTMESESFALTAVALE'] ."M"));
                
                $dataRetrocedidaComp = DateUtil::truncateData(DateUtil::getPrimeiroDiaDoMes($dtIniPeriodoFalta))->sub(new \DateInterval("P". $this->paramVale['QTMESESFALTAVALE'] ."M"));
                
                //Antes de buscar as datas das faltas do vinculo, precisamos verificar se a dataRetrocedidaFim e maior q o ultimo dia do mes da competencia retrocedida...
                $UltimoDiaDataRetrocedida = DateUtil::truncateData(DateUtil::getUltimoDiaDoMes($dataRetrocedidaComp));
                if($dataRetrocedidaFim > $UltimoDiaDataRetrocedida){
                    $dataRetrocedidaFim = $UltimoDiaDataRetrocedida;
                }
                
                if(($dataRetrocedidaFim->format('d/m/Y') != $dataRetrocedidaFim->format('t/m/Y')) && $dataFormularioIsUltimoDiaMes == true){
                    $dataRetrocedidaFim = DateUtil::getDataDeString($dataRetrocedidaFim->format('t/m/Y'), DateUtil::FORMATO_BRASILEIRO, true);
                }
                
                if(!empty($dtinilinhavinc)){
                    //Se o mes for igual verificamos se a data inicio da linha e maior que a data inicial de analise das faltas
                    if( $dtinilinhavinc->format('m/YYYY') === $dataRetrocedidaIni->format('m/YYYY') ){
                        //EXEMPLO: 20/08/2024   -   01/08/2024
                        if($dtinilinhavinc > $dataRetrocedidaIni){
                            $dataRetrocedidaIni = $dtinilinhavinc;
                        }
                    } else if($dtinilinhavinc > $dataRetrocedidaIni){
                        return 0;
                    }
                }
                
                $historico = $this->getHistoricoEscalaRetroc($UltimoDiaDataRetrocedida, $dataRetrocedidaIni, $dataRetrocedidaFim);
                
                switch($this->paramVale['IDORIGVALEFALTA']){
                    case "1":
                        //Calculo de VT Utilizando a origem de faltas pela folha usando os eventos 490,495,1040,1043 no mes da competencia retrocedida para o vinculo...
                        $qtdeFaltas = $this->calculaQtdeDiasFaltas($this->objvinculo->getNrvinculom(), $this->nrorg, $dataRetrocedidaComp, $dataRetrocedidaComp, $nreventom, $nrtpmovimento, $dataRetrocedidaComp);
                        
                        return $qtdeFaltas;
                        break;
                    case "2":
                        //Calculo de VT utilizando origem de faltas pela situação funcional falta(DIA) no periodo retrocedido.
                        $arraySituFuncFaltas = $this->retornaArraySituFuncFaltas(100072, $dataRetrocedidaIni, $dataRetrocedidaFim);
                        
                        $descansoRemuneradoEFeriado = array();
                        $descansos = array();
                        $feriados = array();
 
                        if(!empty($arraySituFuncFaltas)){
                            foreach($arraySituFuncFaltas as $arraySituFuncFalta){
                                
                                $dtFimSitufunc = $arraySituFuncFalta->getDtfimsitufunc();
                                $dtInicioSitufunc = $arraySituFuncFalta->getDtinisitufunc();
                                
                                if(is_null($dtFimSitufunc) or $dtFimSitufunc > $dataRetrocedidaFim){
                                    $dtFimSitufunc = $dataRetrocedidaFim;
                                }
                                
                                if($dtInicioSitufunc < $dataRetrocedidaIni){
                                    $dtInicioSitufunc = $dataRetrocedidaIni;
                                }
                                
                                if(!empty($this->nrturnoRetroc) && isset($this->nrturnoRetroc)){
                                    $datasEntreSitufunc = Dateutil::getDatasEntre($dtInicioSitufunc, $dtFimSitufunc);
                    
                                    //Para cada dia de situação funcional de falta, é verificado se o vinculo trabalhou naquele dia para descontar a falta (verificando dia a dia a escala do vinculo e turno).
                                    foreach($datasEntreSitufunc as $diaSitufunc){
                                        $qnt = $diaSitufunc->diff($diaSitufunc, true);
                                        $descansoArray = $this->calcularQtdeDiasFolgaVincDia($diaSitufunc, $qnt, $this->objvinculo->getNrvinculom(), $diaSitufunc->format('d/m/Y'));
                                        
                                        if(!empty($descansoArray)){
                                            $descansos[] = $descansoArray[0];
                                        }
                                    }
                                } else {
                                    $descansos = $this->seekDsr($dtInicioSitufunc, $dtFimSitufunc);
                                }
                                
                                if((!empty($historico) && isset($historico)) && $historico['NRTPJORNADA'] == 2){
                                    $feriados = array();
                                } else {
                                    $feriados = $this->seekFeriado($dtInicioSitufunc, $dtFimSitufunc);
                                }
                                
                                $datasEntrefaltas = DateUtil::getDatasEntre($dtInicioSitufunc, $dtFimSitufunc);
                                foreach($datasEntrefaltas as $falta){
                                    //Array de faltas para utilizar na rotina de vale com dia de semanas marcados.
                                    //Não coloca dentro do datasFaltas, os feriados e nem os DSR's somente as faltas do vinculo de fato.
                                    if(!in_array($falta->format('d/m/Y'), $descansos) && !in_array($falta->format('d/m/Y'), $feriados) && !in_array($falta->format('d/m/Y'), $this->datasFaltas)){
                                        $this->datasFaltas[] = $falta->format('d/m/Y');
                                    }
                                }
                                
                                if(!empty($descansos)){
                                    foreach($descansos as $descanso){
                                        if(!in_array($descanso, $descansoRemuneradoEFeriado)){
                                            $descansoRemuneradoEFeriado[] = $descanso;
                                        }
                                    }
                                }
                                
                                if(!empty($feriados)){
                                    foreach($feriados as $feriado){
                                        if(!in_array($feriado, $descansoRemuneradoEFeriado)){
                                            $descansoRemuneradoEFeriado[] = $feriado;
                                        }
                                    }
                                }
                                
                                $qtdeFaltas += $this->calculaFaltasSituFunc($dtInicioSitufunc, $dtFimSitufunc);
                            }
                        }
                        
                        //Pega a quantidade de DSRs do vinculo, no periodo da situação funcional das faltas e diminui da quantidade de faltas.
                        if($qtdeFaltas >= count($descansoRemuneradoEFeriado)){
                            $qtdeFaltas = $qtdeFaltas - count($descansoRemuneradoEFeriado);
                        } else {
                            //Se o vinculo tiver DSR's + Feriados maior do que faltas a quantidade de faltas devem ser 0.
                            $qtdeFaltas = 0;
                        }
                        
                        return $qtdeFaltas ;
                        break;
                    case "3":
                        //Calculo de VT utilizando origem de faltas pelo Modulo Frequencia.
                        $arrayFaltasFreq = $this->getFaltasFrequencia($this->nrorg, $this->objvinculo->getNrvinculom(), $dataRetrocedidaIni->format('d/m/Y'), $dataRetrocedidaFim->format('d/m/Y'), 0);

                        if(!empty($arrayFaltasFreq)){
                            foreach($arrayFaltasFreq as $faltaFreq){
                                if(!in_array(DateUtil::getDataDeString($faltaFreq['DTAPURACAOSITUFREQ'])->format('d/m/Y'), $this->datasFaltas)){
                                   $this->datasFaltas[] = DateUtil::getDataDeString($faltaFreq['DTAPURACAOSITUFREQ'])->format('d/m/Y'); 
                                }
                            }
                            
                            $qtdeFaltas = $this->calculaFaltasFrequencia($arrayFaltasFreq);
                        }
                        
                        return $qtdeFaltas;
                        break;
                    default: 
                        //Calculo de VT Utilizando o default origem de faltas pela folha usando os eventos 490,495,1040,1043 no mes da competencia retrocedida para o vinculo...
                        $qtdeFaltas = $this->calculaQtdeDiasFaltas($this->objvinculo->getNrvinculom(), $this->nrorg, $dataRetrocedidaComp, $dataRetrocedidaComp, $nreventom, $nrtpmovimento, $dataRetrocedidaComp);
                         
                        return $qtdeFaltas;
                        break;
                }
            } else {
                return $qtdeFaltas;
            }
            
        } else {
            $dtmescomp_falta = clone $this->dtiniperiodocalculo;
            $dtmescomp_falta = DateUtil::truncateData(DateUtil::getPrimeiroDiaDoMes($dtmescomp_falta));
            //Para a organização 1193-Russel ou 1024-Básica, para as faltas, são considerados dois meses anteriores à competencia atual*/
            if ($this->nrorg == 1193 || $this->nrorg == 1024) {
                $dtmescomp_falta = $dtmescomp_falta->sub(new \DateInterval('P1M'));
            }
            $qtdeFaltas = $this->calculaQtdeDiasFaltas($this->objvinculo->getNrvinculom(), $this->nrorg, $dtmescomp_falta, $dtmescomp_falta, $nreventom, $nrtpmovimento, $dtmescomp_falta);
            return $qtdeFaltas;
        }
        return $qtdeFaltas;
    }
    
    private function calculaQtdeDiasFaltas($objVinc, $nrorg, $dtIni, $dtFim, $nreventom, $nrtpmovimento, $dtmescompetencia){
        $faltas = FpaCalculofolha::getSomaItemCalculo($objVinc, $nrorg, $dtIni, $dtFim, $nreventom, $nrtpmovimento, $dtmescompetencia);
        $qtdeFaltas = (int)$faltas['VALOR'];
        
        return $qtdeFaltas;
    }

    /**
     * NÚMERO DE DIAS DE FÉRIAS
     * Considera-se dias que o vínculo ficou afastado por causa de férias.
     */
    private function setNrDiasFerias(\DateTime $dtinicio, \DateTime $dtfinal)
    {
        $diasFerias = 0;
        $dataInicio = clone($dtinicio);
        $dataFinal = clone($dtfinal);
        
        if(!empty($this->paramVale)){
            if($this->paramVale['IDCONSFERIASVALE'] == 'S'){
                $dataInicio = $dataInicio->sub(new \DateInterval('P' . $this->paramVale['QTMESESFERIASVALE'] . 'M'));
                $dataFinal = $dataFinal->sub(new \DateInterval('P' . $this->paramVale['QTMESESFERIASVALE'] . 'M'));
                
                while($dataFinal->format('m') == $this->dataFimApurSemMOD->format('m') && $this->paramVale['QTMESESFERIADOVALE'] != 0){
                    $dataFinal = $dataFinal->sub(new \DateInterval('P1D'));
                }
            } else {
                return $diasFerias;
            }
        }
        
        $diasFerias = $this->calculaQtdeDiasFerias($dataInicio, $dataFinal);
        return $diasFerias;
    }
    
    private function calculaQtdeDiasFerias($dtInicio, $dtFim){
        $ferias = FpaFerias::getPeriodoGozoFeriasVt($this->objvinculo->getNrvinculom(), $dtInicio, $dtFim, $this->nrorg);
        $diasFerias = 0;
        
        if ($ferias) {
            $inicio = DateUtil::retornaMaiorData(substr($ferias['DTINIGOZOFERIAS'], 0, 10),$dtInicio->format('d/m/Y'));
            $final  = DateUtil::retornaMenorData(substr($ferias['DTFIMGOZOFERIAS'], 0, 10),$dtFim->format('d/m/Y'));

            //Adiciona as datas entre o inicio e fim das ferias para o vinculo para ser utilizado na rotina de calculo de vt por dia de semana
            $this->datasEntreFerias = DateUtil::getDatasEntre(DateUtil::getDataDeString($inicio, DateUtil::FORMATO_BRASILEIRO, true), DateUtil::getDataDeString($final, DateUtil::FORMATO_BRASILEIRO, true));
            $this->dsrEntreFerias = $arFeriados = $this->seekFeriado(DateUtil::getDataDeString($inicio, DateUtil::FORMATO_BRASILEIRO, true), DateUtil::getDataDeString($final, DateUtil::FORMATO_BRASILEIRO, true));
		    $this->feriadoEntreFerias = $this->seekDsr(DateUtil::getDataDeString($inicio, DateUtil::FORMATO_BRASILEIRO, true), DateUtil::getDataDeString($final, DateUtil::FORMATO_BRASILEIRO, true), $this->dsdiadescansosemanal);
		    
		    //Filtra o array de ferias para deixar de conter os dias de dsr e os de feriados dentro do periodo de ferias
            $this->datasEntreFerias = array_filter($this->datasEntreFerias, function ($element) {
                $data = $element->format(DateUtil::FORMATO_DATA);
                
                if(!empty($this->feriadoEntreFerias) && !empty($this->dsrEntreFerias)){
                    return !in_array($data, $this->feriadoEntreFerias) && !in_array($data, $this->dsrEntreFerias);
                } else if(!empty($this->feriadoEntreFerias) && empty($this->dsrEntreFerias)) {
                    return !in_array($data, $this->feriadoEntreFerias);
                } else {
                    return !in_array($data, $this->dsrEntreFerias);
                }
            });
            
            $totalFerias = DateUtil::getDataDeString($inicio)->diff(DateUtil::getDataDeString($final));
            $feriados    = count($arFeriados);
    
            if( isset($this->nrturno) ){
                $arrayDiasFolgaVinc = $this->calcularQtdeDiasFolgaVinc(DateUtil::getDataDeString($inicio, DateUtil::FORMATO_BRASILEIRO, true), $totalFerias, $this->objvinculo->getNrvinculom(), $this->nrturno);
                $intersecao = count(array_intersect($arrayDiasFolgaVinc, $arFeriados)); //quantidade de dias que coincidem Folga e Feriados
                $diasFerias = ($totalFerias->d+1) - count($arrayDiasFolgaVinc) - $feriados + $intersecao;
                
                MemoriaVT::getInstance()->detalharFerias(
                    array(
                        'tipo' => 'turno', 
                        "formula" => "resultado = totalFerias - diasFolgaVinc - feriados + intersecaoFolgaFeriado",
                        "expressao" => $diasFerias.' = '.($totalFerias->d+1).' - '.count($arrayDiasFolgaVinc).' - '.$feriados.' + '.$intersecao,
                        "resultado" => $diasFerias,
                        "totalFerias" => ($totalFerias->d+1),
                        "diasFolgaVinc" => count($arrayDiasFolgaVinc),
                        "feriados" => $feriados,
                        "intersecaoFolgaFeriado" => $intersecao,
                    )
                );
            }else{
                $descRemunerado = $this->seekDsr($inicio, $final);
                //return (((int)$ferias['QUANTIDADE']) - count($descRemunerado));
                $intersecao = count(array_intersect($descRemunerado, $arFeriados)); //quantidade de dias que coincidem DSR e Feriados
                $diasFerias = ($totalFerias->d+1) - count($descRemunerado) - $feriados + $intersecao;

                MemoriaVT::getInstance()->detalharFerias(
                    array(
                        'tipo' => 'dsr', 
                        "formula" => "resultado = totalFerias - dsr - feriados + intersecaoDsrFeriado",
                        "expressao" => $diasFerias.' = '.($totalFerias->d+1).' - '.count($descRemunerado).' - '.$feriados.' + '.$intersecao,
                        "resultado" => $diasFerias,
                        "totalFerias" => ($totalFerias->d+1),
                        "dsr" => count($descRemunerado),
                        "feriados" => $feriados,
                        "intersecaoDsrFeriado" => $intersecao,
                    )
                );
            }
        }
        
        return $diasFerias;
    }

    /**
     * NÚMERO DE DIAS DE AVISO
     * Considera-se dias que o vínculo ficou trabalhando cumprindo aviso prévio.
     */
    private function setNrDiasAviso(\DateTime $dtinicio, \DateTime $dtfinal)
    {
        $diasAviso = null;
        
        if ($this->objvinculo->getDtrescisaovinc()) {
            
            $dtrescisao = $this->objvinculo->getDtrescisaovinc();
            
            if( !($this->objvinculo->getDtrescisaovinc() instanceof \DateTime) )
                $dtrescisao = DateUtil::getDataDeString($dtrescisao, DateUtil::FORMATO_BRASILEIRO, true);
        
            $iniperiodo = $dtinicio;
            $fimperiodo = $dtfinal;

            if ( ($this->objvinculo->getDtrescisaovinc() || $this->objvinculo->getDtavisoprevio()) and \HCM\Util\DateUtil::isBetween($dtrescisao->format('d/m/Y'), $iniperiodo->format('d/m/Y'), $fimperiodo->format('d/m/Y')) ) {
                $nrdiasaviso = DateUtil::getQtdeDiasEntre($iniperiodo, $dtrescisao) + 1;
                
                $nrdsr = $this->seekDsr($iniperiodo->format('d/m/Y'), $dtrescisao->format('d/m/Y'));
                $arFeriados = $this->seekFeriado($iniperiodo->format('d/m/Y'), $dtrescisao->format('d/m/Y'));
                $intersecaoDsrFeriado = count(array_intersect($nrdsr, $arFeriados)); //quantidade de dias que coincidem Dsr e Feriados
                
                $diasAviso = $nrdiasaviso - count($nrdsr) - count($arFeriados) - $intersecaoDsrFeriado;
            }
            
            if($dtrescisao < $iniperiodo){
                $this->datasAposRescisao = DateUtil::getDatasEntre(DateUtil::getDataDeString($iniperiodo), DateUtil::getDataDeString($fimperiodo));
            } else if($dtrescisao >= $iniperiodo && $dtrescisao <= $fimperiodo) {
                $this->datasAposRescisao = DateUtil::getDatasEntre(DateUtil::getDataDeString($dtrescisao), DateUtil::getDataDeString($fimperiodo));
            }

        }
        
        return $diasAviso;
    }
    
    /**
     * retorna datas desconsideradas na rotina de vale por dia de semana
     * 
     */
    private function retornaDataDesconsideradaParaS($datas, $idDiaSemana){
        $arrayDeDatasDescontadas = [];
        
        foreach($datas as $data){
            if (($data instanceof DateTime) === true) {
                $data = DateUtil::truncateData($data);
            } else {
                $data = DateUtil::truncateData(DateUtil::getDataDeString($data));
            }

            if(in_array($data, $arrayDeDatasDescontadas)){
                continue;
            }
            
            //Se for S sai da iteraçao
            $idDiaSemanaAtual = substr($idDiaSemana, (DateUtil::getDiaSemana($data) - 1), 1);
            if($idDiaSemanaAtual == 'N'){
                continue;
            }
            
            array_push($arrayDeDatasDescontadas, $data);
        }
        
        return $arrayDeDatasDescontadas;
    }
    
    /**
     * Adiciona datas desconsideradas na rotina de vale por dia de semana
     * 
     */
    private function adicionaDataDesconsideradaParaS($datas, $idDiaSemana){
        foreach($datas as $data){
            $data = DateUtil::truncateData(DateUtil::getDataDeString($data));

            if(in_array($data, $this->datasDesconsideradas)){
                continue;
            }
            
            //Se for S sai da iteraçao
            $idDiaSemanaAtual = substr($idDiaSemana, (DateUtil::getDiaSemana($data) - 1), 1);
            if($idDiaSemanaAtual == 'N'){
                continue;
            }
            
            array_push($this->datasDesconsideradas, $data);
        }
    }
    
    private function adicionaDataDesconsideradaParaN($datas, $idDiaSemana){
        foreach($datas as $data){
            if(in_array($data, $this->datasDesconsideradas)){
                continue;
            }
            
            //Se for N sai da iteraçao
            $idDiaSemanaAtual = substr($idDiaSemana, (DateUtil::getDiaSemana($data) - 1), 1);
            if($idDiaSemanaAtual == 'S'){
                continue;
            }

            array_push($this->datasDesconsideradas, $data);
        }
    }
    
    /**
     * @return array|bool
     */
    private function getInfoLinhaVinculoTarifa(\DateTime $dtinicio, \DateTime $dtfinal, $nrtipolinhavinc = null, $nrlinhatransp)
    {
        return VabLinhavinc::infoLinhaVinculoTarifaLinha($this->objvinculo->getNrvinculom(), $this->nrorg, $dtinicio, $dtfinal, $nrtipolinhavinc, $this->hcmParameters->getNrorgPadrao(), $nrlinhatransp);
    }
    
    private function carregaValorTarifaDaEpoca($nrorg, $nrtarifa){
        $params = array(
            "P_NRORG"          => $nrorg,
            "P_NRTARIFA" => $nrtarifa);
            
        $sql = "SELECT * FROM VAB_TARIFA WHERE NRORG = :P_NRORG AND NRTARIFA = :P_NRTARIFA";

        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        
        return $retorno;
    }
    
    private function getParametroValeTransporte($nrorg, $dtmescompecencia){
        $params = array(
            "P_NRORG"          => $nrorg,
            "P_DTMESCOMPETENC" => $dtmescompecencia);

$sql = "SELECT
    PARAMVALEH.*
FROM
         VAB_PARAMVALEM PARAMVALEM
    JOIN VAB_PARAMVALEH PARAMVALEH ON PARAMVALEH.NRORG = PARAMVALEM.NRORG
                                      AND PARAMVALEH.NRPARAMVALEM = PARAMVALEM.NRPARAMVALEM
                                      AND PARAMVALEH.DTMESCOMPETENC = (
        SELECT
            MAX(PH.DTMESCOMPETENC)
        FROM
            VAB_PARAMVALEH PH
        WHERE
                PH.NRORG = PARAMVALEH.NRORG
            AND PH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
    )
WHERE
    PARAMVALEM.NRORG = :P_NRORG
ORDER BY PARAMVALEH.DTMESCOMPETENC DESC";

        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        
        return $retorno;
    }
    
    private function rotinaDeCreditoIndevido($dtIniApur, $dtFimApur, $vinculo, $nrlinhatransp, $nrtipolinhavinc, $vrtarifa){
        $dtcompetenciaMod = DateUtil::truncateData(DateUtil::getPrimeiroDiaDoMes($dtIniApur));

        $valorCreditoIndevido = 0;
        $qtDiasCreditoIndevido = 0;
        $valorCreditoIndevidoTotal = 0;
        $qtDiasCreditoIndevidoTotal = 0;
        
        //Busca lançamentos de vale vínculo para aquela competência
        $params = array(
            'P_NRVINCULOM'        => $vinculo->getNrvinculom(),
            'P_DTMESCOMPAPVALE'   => $dtcompetenciaMod,
            'P_NRLINHATRANSP'     => $nrlinhatransp,
            'P_NRORG'             => $this->nrorg,
            'P_FORMINI'           => $dtIniApur->format('d/m/Y'),
            'P_FORMFIM'           => $dtFimApur->format('d/m/Y'));
        $where = "NRORG = :P_NRORG 
                    AND NRVINCULOM = :P_NRVINCULOM
                    AND TRUNC(DTMESCOMPAPVALE) = :P_DTMESCOMPAPVALE 
                    AND NRLINHATRANSP = :P_NRLINHATRANSP
                    AND DTINIAPURVALE <= :P_FORMFIM 
                    AND DTFINAPURVALE >= :P_FORMINI
                    AND IDCALCCOMPLEMENTAR <> 'S'";
                    
        //Pega os historicos que estão entre estas datas para recalcular credito indevido.
        $vabHistValeVincRetrocedidos = \Folha\Entities\VabHistvalevinc::getObjectsByWhere($where, $params);

        if($vabHistValeVincRetrocedidos){
            foreach($vabHistValeVincRetrocedidos as $vabHistValeVincRetrocedido){
                
                $diaApuradoHistValeVincRetrocedido = $vabHistValeVincRetrocedido->getQtdiasvale();
                $qtApuradoHistValeVincRetrocedido = $vabHistValeVincRetrocedido->getQtapurvale();
                $tarifaApuradoHistValeVincRetrocedido = $this->carregaValorTarifaDaEpoca($this->hcmParameters->getNrorgTrabalho(), $vabHistValeVincRetrocedido->getNrtarifa());
                if($tarifaApuradoHistValeVincRetrocedido && $tarifaApuradoHistValeVincRetrocedido[0]){
                   $tarifaApuradoHistValeVincRetrocedido = $tarifaApuradoHistValeVincRetrocedido[0]['VRTARIFA'];
                }
                
                $valorApuradoHistValeVincRetrocedido = $qtApuradoHistValeVincRetrocedido * $tarifaApuradoHistValeVincRetrocedido * $diaApuradoHistValeVincRetrocedido;

                //Pega o paramVale Da epoca
                $paramVale = $this->getParametroValeTransporte($this->nrorg, $dtcompetenciaMod->format('d/m/Y'))[0];
                 
                //Recalcula utilizando os mesmos parametros e retornando o valor do vale transporte.
                $diaApuradoRecalculoCreditoIndevidos = new CreditoIndevido($vinculo, $this->nrorg, $vabHistValeVincRetrocedido->getDtiniapurvale(), $vabHistValeVincRetrocedido->getDtfinapurvale(), $nrtipolinhavinc, $this->hcmParameters, $paramVale, null, 'N', $nrlinhatransp, $tarifaApuradoHistValeVincRetrocedido);
                
                foreach($diaApuradoRecalculoCreditoIndevidos->getValeTransporte() as $diaApuradoRecalculoCreditoIndevido){
                    if($diaApuradoRecalculoCreditoIndevido['NRLINHATRANSP'] == $nrlinhatransp){

                        $valorCreditoIndevido = 0;
                        $qtDiasCreditoIndevido = 0;
                        $diaApuradoCreditoIndevido = (float)$diaApuradoRecalculoCreditoIndevido['DIAS'];
                        
                        // 16 contra 20 do historico, ou seja deve ser descontado o valor de 4 dias.
                        if($diaApuradoCreditoIndevido > 0 && $diaApuradoCreditoIndevido < $diaApuradoHistValeVincRetrocedido){
                            $valorCreditoIndevido = $diaApuradoRecalculoCreditoIndevido['QTLINHATARIFA'] * $diaApuradoRecalculoCreditoIndevido['VRTARIFA'] * $diaApuradoCreditoIndevido;
                            $valorCreditoIndevido = $valorApuradoHistValeVincRetrocedido - $valorCreditoIndevido;
                            $qtDiasCreditoIndevido = $diaApuradoHistValeVincRetrocedido - $diaApuradoCreditoIndevido;
                            $valorCreditoIndevidoTotal += $valorCreditoIndevido;
                            $qtDiasCreditoIndevidoTotal += $qtDiasCreditoIndevido;
                            $this->messages[] = "Vínculo: ".$this->objvinculo->getNrvinculom()." - ".$this->objvinculo->getNmvinculom()." possui crédito indevido na linha de transporte: $nrlinhatransp, competência: ".$dtcompetenciaMod->format('d/m/Y')." periodo inicial: ".$vabHistValeVincRetrocedido->getDtiniapurvale()->format('d/m/Y')." periodo final: ".$vabHistValeVincRetrocedido->getDtfinapurvale()->format('d/m/Y').". Dias de Aviso: " . $diaApuradoRecalculoCreditoIndevido['INFOCREDINDEV']['aviso'].","." Dias de Férias: " . $diaApuradoRecalculoCreditoIndevido['INFOCREDINDEV']['ferias'].","." Dias de Faltas: " . $diaApuradoRecalculoCreditoIndevido['INFOCREDINDEV']['faltas'].","." Dias de Afastamento/testado: " . $diaApuradoRecalculoCreditoIndevido['INFOCREDINDEV']['afastamentos'].","." Dias não úteis: " . $diaApuradoRecalculoCreditoIndevido['INFOCREDINDEV']['dias nao uteis'].". Será descontado no vale transporte atual o valor de: R$$valorCreditoIndevido reais, quantidade de dias de crédito indevido: $qtDiasCreditoIndevido (DIAS).";
                        }
                    }
                }
            }
            $arrayRetorno = array('valor credito indevido' => $valorCreditoIndevidoTotal, 'dias credito indevido' => $qtDiasCreditoIndevidoTotal);
        }
        
        if($valorCreditoIndevidoTotal > 0){
            return $arrayRetorno;
        } else {
            return 0;
        }
    }

    //INFORMAÇÕES SOBRE A LINHA
    /**
     * QUANTIDADE DE PASSAGENS NECESSÁRIAS PARA CADA LINHA DE TRANSPORTE
     */
    private function setPassagens()
    {
        //IMPLEMENTAÇOES DO NOVO MODULO DE VALE
        //Dsrs dentro do periodo
        $periodoInicial = clone $this->dtiniperiodovale;
        $periodoFinal = clone $this->dtfimperiodovale;
        
        //Feriados dentro do periodo
        
        //Logica para calcular os ferias de acordo com o periodo da tela de Parametro de vale transporte
        if(!empty($this->paramVale)){
            if($this->paramVale['IDCONSFERIADOVALE'] == 'S'){
                $dtinicioSemMod = clone $this->dataIniApurSemMOD;
                $dtfimSemMod = clone $this->dataFimApurSemMOD;
                
                if($this->paramVale['QTMESESFERIADOVALE']){
                    $dtinicioSemMod = $dtinicioSemMod->sub(new \DateInterval('P' . $this->paramVale['QTMESESFERIADOVALE'] . 'M'));
                    $dtfimSemMod = $dtfimSemMod->sub(new \DateInterval('P' . $this->paramVale['QTMESESFERIADOVALE'] . 'M'));
                    
                    while($dtfimSemMod->format('m') == $this->dataFimApurSemMOD->format('m') && $this->paramVale['QTMESESFERIADOVALE'] != 0){
                        $dtfimSemMod = $dtfimSemMod->sub(new \DateInterval('P1D'));
                    }
                }
                
                $arrFeriados = $this->seekFeriado($dtinicioSemMod, $dtfimSemMod);
            } else {
                $arrFeriados = [];
            }

            //Logica para calcular os dsrs de acordo com o periodo da tela de Parametro de vale transporte
            if($this->paramVale['IDCONSDSRVALE'] == 'S'){
                $dtinicioSemMod = clone $this->dataIniApurSemMOD;
                $dtfimSemMod = clone $this->dataFimApurSemMOD;
                
                if($this->paramVale['QTMESESDSRVALE']){
                    $dtinicioSemMod = $dtinicioSemMod->sub(new \DateInterval('P' . $this->paramVale['QTMESESDSRVALE'] . 'M'));
                    $dtfimSemMod = $dtfimSemMod->sub(new \DateInterval('P' . $this->paramVale['QTMESESDSRVALE'] . 'M'));
                    
                    while($dtfimSemMod->format('m') == $this->dataFimApurSemMOD->format('m') && $this->paramVale['QTMESESDSRVALE'] != 0){
                        $dtfimSemMod = $dtfimSemMod->sub(new \DateInterval('P1D'));
                    }
                }
                
                $arrDsr = $this->seekDsr($dtinicioSemMod, $dtfimSemMod, $this->dsdiadescansosemanal);
            } else {
                $arrDsr = [];
            }
        } else {
            $arrFeriados = $this->seekFeriado($this->dtiniperiodovale, $this->dtfimperiodovale);
            $arrDsr = $this->seekDsr($periodoInicial, $periodoFinal, $this->dsdiadescansosemanal);
        }
        
        $intersecao = count(array_intersect($arrDsr, $arrFeriados));
        
        //Filtra o array de atestado/afastamento para deixar de conter os dias de dsr e os de feriados dentro do periodo do afastamento/atestado
        $this->datasEntreAtestadoOuAfast = array_filter($this->datasEntreAtestadoOuAfast, function ($element) {
            if($element instanceof DateTime){
                $data = $element->format(DateUtil::FORMATO_DATA);
            } else {
                $data = substr($element, 0, 10);
            }
            
            return !in_array($data, $this->datasDsrAnt) && !in_array($data, $this->datasFeriadosAnt);
        });
        
        //Se o campo dias apurados estiver preenchido da um merge nos arrays desconsiderando feriados e DSR's, ja que o dia util e fixado.
        if(!empty($this->qtdiasvalefixo)){
            $this->nrdiasnuteis = 0;
        } else {
            $this->nrdiasnuteis = count(array_merge($arrFeriados,$arrDsr)) - $intersecao;
        }
        
        //
        $linhasvinculo = $this->getPassagensNecessarias( $this->dtiniperiodovale, $this->dtfimperiodovale, $this->nrtipolinhavinc);
        
        if($linhasvinculo){
            $tarifa = array();
            
            foreach ($linhasvinculo as $linhavinculo) {
                //para cada linha reseta variaveis para o estado original (datas do formulario).
                $this->dtiniperiodovale = $this->backupDtIni;
                $this->dataIniApurSemMOD = $this->backupDtIni;
                $this->dtfimperiodovale = $this->backupDtFim;
                $this->dataFimApurSemMOD = $this->backupDtFim;
                
                $dtIniLinhaVinc = DateUtil::truncateData(DateUtil::getDataDeString(substr($linhavinculo['DTINILINHAVINC'], 0, 10)));
                
                $dtFimLinhaVinc = null;
                if(isset($linhavinculo['DTFIMLINHAVINC']) && !empty($linhavinculo['DTFIMLINHAVINC'])){
                    $dtFimLinhaVinc = DateUtil::truncateData(DateUtil::getDataDeString(substr($linhavinculo['DTFIMLINHAVINC'], 0, 10)));
                }
                
                //Modifica variaveis de data de formulario de calculo, dependendo do inicio e fim da vigencia da linha, se o valor de referencia for 1.
                if($this->deveRecalcularMinimizadoresVT == true){
                   //ANALISO SE A DATA INICIO ESTA DENTRO DO MES DE CALCULO.
                    if($dtIniLinhaVinc->format('m/Y') == $this->dtiniperiodovale->format('m/Y')){
                        //Verifica se esta dentro da intercesão.
                        if($dtIniLinhaVinc <= $this->dtfimperiodovale && $dtIniLinhaVinc >= $this->dtiniperiodovale){
                            //Modifica a data ini do periodo do vale para inicio da vigencia da linha do vinculo.
                            $this->dtiniperiodovale = $dtIniLinhaVinc;
                            $this->dataIniApurSemMOD = $dtIniLinhaVinc;
                        }
                    }
                    
                    //ANALISO SE A DATA FIM DE VIGENCIA ESTA DENTRO DO MES DE CALCULO.
                    if(!empty($dtFimLinhaVinc) && $dtFimLinhaVinc->format('m/Y') == $this->dtfimperiodovale->format('m/Y')){
                        //Verifica se esta dentro da intercesão.
                        if($dtFimLinhaVinc <= $this->dtfimperiodovale && $dtFimLinhaVinc >= $this->dtiniperiodovale){
                            //Modifica a data fim do periodo do vale para inicio da vigencia da linha do vinculo.
                            $this->dtfimperiodovale = $dtFimLinhaVinc;
                            $this->dataFimApurSemMOD = $dtFimLinhaVinc;
                        }
                    }
                    
                    //Recalcula as situações gerais do vinculo que dependem do ini e fim de periodo de calculo do Vale transporte.
                    $this->recalculaSituacoesGeraisDoVinculoUtilizandoDatasModificadas($this->hcmParameters->getNrorgTrabalho());
                }
                
                if($this->deveAnalisarDescontoMinimizadores && $this->deveAnalisarDescontoMinimizadores == true){ 
                    //Verifica se irá descontar minimizador.
                    $this->paramVale = $this->avaliarDescontoMinimizadores($this->paramVale, $linhavinculo);
                }
                
                //TODO VERIFICAR SE A DTINICIO DA LINHA DO VINCULO, (CADASTRAMENTO DO VINCULO NA LINHA) É MENOR OU IGUAL A DATA RETROCEDIDA PARA BUSCAR
                //FALTAS E AFASTAMENTOS/ATESTADOS -> ZERAR FALTAS OU AFASTAMENTOS.
                $this->recalculaSituacoesDoVinculo($this->hcmParameters->getNrorgTrabalho(), $dtIniLinhaVinc);
                
                //SE O VINCULO TIVER RESCINDIDO (DTRESCISAO < PERIODOINICALCULO)
                if($this->rescindido == true){
                    $this->diastotaisconsideracao = 0;
                }
                
                $difference = 0;

                //Formula nova para vales especificos para dias de semana
                //Verifica se a string tem S(ou seja se esta marcado)
                if(strpos($linhavinculo['IDDIASSEMANA'], 'S') !== false){
                    $this->datasFaltasRetornada = $this->retornaDataDesconsideradaParaS($this->datasFaltas, $linhavinculo['IDDIASSEMANA']);
                    $this->datasEntreAtestadoOuAfastRetornada = $this->retornaDataDesconsideradaParaS($this->datasEntreAtestadoOuAfast, $linhavinculo['IDDIASSEMANA']);
                    $this->datasAposRescisaoRetornada = $this->retornaDataDesconsideradaParaS($this->datasAposRescisao, $linhavinculo['IDDIASSEMANA']);
                    $this->datasEntreFeriasRetornada = $this->retornaDataDesconsideradaParaS($this->datasEntreFerias, $linhavinculo['IDDIASSEMANA']);
                    
                    //Se o campo dias apurados estiver preenchido da um merge nos arrays desconsiderando feriados e DSR's, ja que o dia util e fixado.
                    if(!empty($this->qtdiasvalefixo)){
                        //Merge nos arrays que vem das rotinas do calculo
                        $arrDatasDesconsideradasRotinas = array_merge(
                            $this->datasFaltasRetornada,                 $this->datasEntreAtestadoOuAfastRetornada,   $this->datasAposRescisaoRetornada,     $this->datasEntreFeriasRetornada
                        );
                        
                        $this->nrfaltaId = count($this->datasFaltasRetornada);
                        $this->nrdiasferiasId = count($this->datasEntreFeriasRetornada);
                        $this->nrafastamentoId = count($this->datasEntreAtestadoOuAfastRetornada);
                        $this->nrdiasavisoId = count($this->datasAposRescisaoRetornada);
                    } else {
                        $arrFeriadosRetornado = $this->retornaDataDesconsideradaParaS($arrFeriados, $linhavinculo['IDDIASSEMANA']);
                        $arrDsrRetornado = $this->retornaDataDesconsideradaParaS($arrDsr, $linhavinculo['IDDIASSEMANA']);
                        
                        //Merge nos arrays que vem das rotinas do calculo
                        $arrDatasDesconsideradasRotinas = array_merge(
                            $this->datasFaltasRetornada,                 $this->datasEntreAtestadoOuAfastRetornada,   $this->datasAposRescisaoRetornada,     $this->datasEntreFeriasRetornada,   
                            $arrFeriadosRetornado,                       $arrDsrRetornado
                        );
            
                        $this->datasFaltasRetornada ? $this->nrfaltaId = count($this->datasFaltasRetornada) : $this->nrfaltaId = count($this->datasFaltasRetornada);
                        $this->nrdiasferiasId = count($this->datasEntreFeriasRetornada);
                        $this->nrafastamentoId = count($this->datasEntreAtestadoOuAfastRetornada);
                        $this->nrdiasavisoId = count($this->datasAposRescisaoRetornada);
                    }
                    
                    //Itera dentro das datas desconsideradas do $arrMestre verificando se o dia esta marcado como S, se estiver ele deve desconsidera-lo.
                    $this->adicionaDataDesconsideradaParaS($arrDatasDesconsideradasRotinas, $linhavinculo['IDDIASSEMANA']);
                    
                    //Se o campo Dias apurados estiver preenchido não olha para as datas entre o inicio e fim do vale...
                    if(empty($this->qtdiasvalefixo)){
                        //Itera dentro das datas entre o inicio do periodo e o fim, passando pelos IDDIASSEMANA, verificando se os dias ja foram desconsiderados.
                        $this->adicionaDataDesconsideradaParaN($this->datasEntre, $linhavinculo['IDDIASSEMANA']);
                    }
                    
                    if($this->idcalccomplementar == 'S'){
                        //Se o idcalccomplementar for 'S' ele devera não descontar as datas desconsideradas.
                        $difference = $this->qtdiasvalefixo;
                    } else {
                        //calcula a quantidade de dias necessarios de vales
                        $difference = ((empty($this->qtdiasvalefixo) ? count($this->datasEntre) : $this->qtdiasvalefixo) - count($this->datasDesconsideradas));
                    }
                    
                    if($difference < 0){
                        $difference = 0;
                    }
                    
                    //SE O VINCULO TIVER RESCINDIDO (DTRESCISAO < PERIODOINICALCULO)
                    if($this->rescindido == true){
                        $difference = 0;
                    }
                    
                    $tarifa[] = array(  'NRLINHATRANSP' => $linhavinculo['NRLINHATRANSP'],
                                    'NRTARIFA' => $linhavinculo['NRTARIFA'],
                                    'NRVINCULOM' => $linhavinculo['NRVINCULOM'],
                                    'NRSENTIDOLINHA' => $linhavinculo['NRSENTIDOLINHA'],
                                    'NRTIPOLINHAVINC' => $linhavinculo['NRTIPOLINHAVINC'],
                                    'QTLINHATARIFA' => $linhavinculo['QTLINHATARIFA'],
                                    'IDDIASSEMANA' => $linhavinculo['IDDIASSEMANA'],
                                    //NEW
                                    'TPCALCVALE' => empty($this->qtdiasvalefixo) ? 'Dia P/ Semana' : 'Vale com dias úteis fixo pelo campo Dias Apurados',
                                    'DIASDESCONTADOS' => count($this->datasDesconsideradas),
                                    //END
                                    'VRTARIFA' => $linhavinculo['VRTARIFA'],
                                    'VALOR' => $linhavinculo['VRTARIFA'] * $linhavinculo['QTLINHATARIFA'] * $difference,
                                    'DIAS'  => $difference,
                                    'NRTURNO' => $this->nrturno,
                                    'DIAS_AFASTAMENTO' => $this->nrafastamentoId,
                                    'DIAS_FERIAS' => $this->nrdiasferiasId,
                                    'DIAS_FALTAS' => $this->nrfaltaId,
                                    'DIAS_AVISO' => $this->nrdiasavisoId,
                                    'DIAS_N_UTEIS' => $this->nrdiasnuteis,
                                    'DTINIAPURACAO' => $this->dtiniperiodovale,
                                    'DTFIMAPURACAO' => $this->dtfimperiodovale
                                );
                    
                    $this->vrtotal += $linhavinculo['VRTARIFA'] * $linhavinculo['QTLINHATARIFA'] * $difference;
                } else {
                    if($this->idcalccredindev && $this->idcalccredindev == 'S'){
                        //Utiliza a data informada no formulario (Campos de credito indevido) para retroceder de acordo com a data de incio e fim do periodo informado.
                        $valorCreditoIndevido = 0;
                        $diasCreditoIndevido = 0;
                        
                        $valorCreditoArray = $this->rotinaDeCreditoIndevido($this->dtiniciocredindev, $this->dtfinalcredindev, $this->objvinculo, $linhavinculo['NRLINHATRANSP'], $linhavinculo['NRTIPOLINHAVINC'], $linhavinculo['VRTARIFA']);
                        
                        if($valorCreditoArray > 0){
                            $valorCreditoIndevido = $valorCreditoArray['valor credito indevido'];
                            $diasCreditoIndevido = $valorCreditoArray['dias credito indevido'];
                            
                            $tarifa[] = array(  'NRLINHATRANSP' => $linhavinculo['NRLINHATRANSP'],
                                        'NRTARIFA' => $linhavinculo['NRTARIFA'],
                                        'NRVINCULOM' => $linhavinculo['NRVINCULOM'],
                                        'NRSENTIDOLINHA' => $linhavinculo['NRSENTIDOLINHA'],
                                        'NRTIPOLINHAVINC' => $linhavinculo['NRTIPOLINHAVINC'],
                                        'QTLINHATARIFA' => $linhavinculo['QTLINHATARIFA'],
                                        'IDDIASSEMANA' => $linhavinculo['IDDIASSEMANA'],
                                        'TPCALCVALE' => empty($this->qtdiasvalefixo) ? 'Mensal' : 'Vale com dias úteis pelo fixo campo Dias Apurados',
                                        'DIASDESCONTADOS' => null,
                                        'VRTARIFA' => $linhavinculo['VRTARIFA'],
                                        'VALOR' => ($linhavinculo['VRTARIFA'] * $linhavinculo['QTLINHATARIFA'] * $this->diastotaisconsideracao),
                                        'CRED_INDEVIDO' => $valorCreditoIndevido,
                                        'DIAS_CRED_INDEVIDO' => $diasCreditoIndevido,
                                        'DIAS'  => $this->diastotaisconsideracao,
                                        'NRTURNO' => $this->nrturno,
                                        'DIAS_AFASTAMENTO' => $this->nrafastamento,
                                        'DIAS_FERIAS' => $this->nrdiasferias,
                                        'DIAS_FALTAS' => $this->nrfalta,
                                        'DIAS_AVISO' => $this->nrdiasaviso,
                                        'DIAS_N_UTEIS' => $this->nrdiasnuteis,
                                        'DTINIAPURACAO' => $this->dtiniperiodovale,
                                        'DTFIMAPURACAO' => $this->dtfimperiodovale
                                    );
                            
                            $this->vrtotal += ($linhavinculo['VRTARIFA'] * $linhavinculo['QTLINHATARIFA'] * $this->diastotaisconsideracao) - $valorCreditoIndevido;
                            
                        } else {
                            $tarifa[] = array(  'NRLINHATRANSP' => $linhavinculo['NRLINHATRANSP'],
                                        'NRTARIFA' => $linhavinculo['NRTARIFA'],
                                        'NRVINCULOM' => $linhavinculo['NRVINCULOM'],
                                        'NRSENTIDOLINHA' => $linhavinculo['NRSENTIDOLINHA'],
                                        'NRTIPOLINHAVINC' => $linhavinculo['NRTIPOLINHAVINC'],
                                        'QTLINHATARIFA' => $linhavinculo['QTLINHATARIFA'],
                                        'IDDIASSEMANA' => $linhavinculo['IDDIASSEMANA'],
                                        'TPCALCVALE' => empty($this->qtdiasvalefixo) ? 'Mensal' : 'Vale com dias úteis pelo fixo campo Dias Apurados',
                                        'DIASDESCONTADOS' => null,
                                        'VRTARIFA' => $linhavinculo['VRTARIFA'],
                                        'VALOR' => $linhavinculo['VRTARIFA'] * $linhavinculo['QTLINHATARIFA'] * $this->diastotaisconsideracao,
                                        'DIAS'  => $this->diastotaisconsideracao,
                                        'NRTURNO' => $this->nrturno,
                                        'DIAS_AFASTAMENTO' => $this->nrafastamento,
                                        'DIAS_FERIAS' => $this->nrdiasferias,
                                        'DIAS_FALTAS' => $this->nrfalta,
                                        'DIAS_AVISO' => $this->nrdiasaviso,
                                        'DIAS_N_UTEIS' => $this->nrdiasnuteis,
                                        'DTINIAPURACAO' => $this->dtiniperiodovale,
                                        'DTFIMAPURACAO' => $this->dtfimperiodovale
                                    );
                                    
                            $this->vrtotal += $linhavinculo['VRTARIFA'] * $linhavinculo['QTLINHATARIFA'] * $this->diastotaisconsideracao;
                        }
                    } else {
                        $tarifa[] = array(  'NRLINHATRANSP' => $linhavinculo['NRLINHATRANSP'],
                                        'NRTARIFA' => $linhavinculo['NRTARIFA'],
                                        'NRVINCULOM' => $linhavinculo['NRVINCULOM'],
                                        'NRSENTIDOLINHA' => $linhavinculo['NRSENTIDOLINHA'],
                                        'NRTIPOLINHAVINC' => $linhavinculo['NRTIPOLINHAVINC'],
                                        'QTLINHATARIFA' => $linhavinculo['QTLINHATARIFA'],
                                        'IDDIASSEMANA' => $linhavinculo['IDDIASSEMANA'],
                                        'TPCALCVALE' => empty($this->qtdiasvalefixo) ? 'Mensal' : 'Vale com dias úteis pelo fixo campo Dias Apurados',
                                        'DIASDESCONTADOS' => null,
                                        'VRTARIFA' => $linhavinculo['VRTARIFA'],
                                        'VALOR' => $linhavinculo['VRTARIFA'] * $linhavinculo['QTLINHATARIFA'] * $this->diastotaisconsideracao,
                                        'DIAS'  => $this->diastotaisconsideracao,
                                        'NRTURNO' => $this->nrturno,
                                        'DIAS_AFASTAMENTO' => $this->nrafastamento,
                                        'DIAS_FERIAS' => $this->nrdiasferias,
                                        'DIAS_FALTAS' => $this->nrfalta,
                                        'DIAS_AVISO' => $this->nrdiasaviso,
                                        'DIAS_N_UTEIS' => $this->nrdiasnuteis,
                                        'DTINIAPURACAO' => $this->dtiniperiodovale,
                                        'DTFIMAPURACAO' => $this->dtfimperiodovale
                                    );
                        
                        $this->vrtotal += $linhavinculo['VRTARIFA'] * $linhavinculo['QTLINHATARIFA'] * $this->diastotaisconsideracao;
                    }
                    
                }
                $this->datasDesconsideradas = [];
            }
        }else{
            /*$this->messages[] = "Vínculo: ".$this->objvinculo->getNmvinculom()." não possui linha de vale transporte cadastrada!";
            
            $erro['STATUS'] = false;
            $erro['MOTIVO'] = "Vínculo não possui linha de vale transporte cadastrada!";
            MemoriaVT::getInstance()->setImpeditivosParaGerarVale($erro);*/
            
            $tarifa = 0;
            $this->vrtotal = 0;
        }
        
        $this->passagens = $tarifa;
    }

    //INFORMAÇÕES SOBRE O MÊS
    /**
     * COMPOSIÇÃO DO PRÓXIMO MÊS
     * considera-se quantos dias úteis haverão no próximo dia útil.
     *
     * @param \DateTime $dtiniciovale
     * @param \DateTime $dtfinalvale
     *
     * @return int
     *
     */
    private function setNrDiasCalculo(\DateTime $dtiniciovale, \DateTime $dtfinalvale, $dadosVinc = null)
    {
        $dtinicio = $dtfinal = $dias = $nrTurno = $nrVinculom = $qtdeDiasTrabalhados = $total = null;
        
        // $competencia = DateUtil::getDataDeString($this->dtmescompetencia);
        // $competencia = $competencia->add(new \DateInterval('P1M'));
        
        $dtinicio = clone $dtiniciovale;
        $dtfinal = clone $dtfinalvale;

        if(!($dtinicio instanceof \DateTime)) $dtinicio = DateUtil::getDataDeString($dtinicio, DateUtil::FORMATO_BRASILEIRO, true);
        
        if(!($dtfinal instanceof \DateTime)) $dtfinal = DateUtil::getDataDeString($dtfinal, DateUtil::FORMATO_BRASILEIRO, true);
        
        $dias = $dtinicio->diff($dtfinal, true);
        
        if(isset($dadosVinc)){ // $dadosVinc é o parâmetro passado na chamada dentro de getValorRestante
            $nrTurno = $dadosVinc['NRTURNO'];
            $nrVinculom  = $dadosVinc['NRVINCULOM'];
        }else{
            $nrTurno = $this->nrturno;
            $nrVinculom  = $this->objvinculo->getNrvinculom();
        }

        if(!empty($this->paramVale)){
            //Feriados
            if($this->paramVale['IDCONSFERIADOVALE'] == 'S'){
                $dtinicioSemMod = clone $this->dataIniApurSemMOD;
                $dtfimSemMod = clone $this->dataFimApurSemMOD;
                
                $dtinicioSemMod = $dtinicioSemMod->sub(new \DateInterval('P' . $this->paramVale['QTMESESFERIADOVALE'] . 'M'));
                $dtfimSemMod = $dtfimSemMod->sub(new \DateInterval('P' . $this->paramVale['QTMESESFERIADOVALE'] . 'M'));
                
                while($dtfimSemMod->format('m') == $this->dataFimApurSemMOD->format('m') && $this->paramVale['QTMESESFERIADOVALE'] != 0){
                    $dtfimSemMod = $dtfimSemMod->sub(new \DateInterval('P1D'));
                }

                $arFeriados = $this->seekFeriado($dtinicioSemMod->format('d/m/Y'), $dtfimSemMod->format('d/m/Y'));
            } else {
                $arFeriados = [];
            }
        } else {
            $arFeriados = $this->seekFeriado($dtinicio->format('d/m/Y'), $dtfinal->format('d/m/Y'));
        }
        
        $feriados        = count($arFeriados);
        
        if( isset($nrTurno) ){
            $qtdeDiasTrabalhados = GpeEscalatrabm::retornaQtdeDiasTrabalhoPorTurno( // dias totais do período menos dias de folga. Feriados são considerados como dias trabalhados
                $this->dtmescompetencia, 
                $dtinicio->format('d/m/Y'), 
                $dias->d, 
                $this->nrorg, 
                $nrTurno
            );
            
            if(!empty($this->paramVale)){
                //DSR
                if($this->paramVale['IDCONSDSRVALE'] == 'S'){
                    $dtinicioSemMod = clone $this->dataIniApurSemMOD;
                    $dtfimSemMod = clone $this->dataFimApurSemMOD;
                    
                    if($this->paramVale['QTMESESDSRVALE']){
                        $dtinicioSemMod = $dtinicioSemMod->sub(new \DateInterval('P' . $this->paramVale['QTMESESDSRVALE'] . 'M'));
                        $dtfimSemMod = $dtfimSemMod->sub(new \DateInterval('P' . $this->paramVale['QTMESESDSRVALE'] . 'M'));
                        
                        $dtcompetenciaMod = DateUtil::truncateData(DateUtil::getPrimeiroDiaDoMes($dtinicioSemMod))->format('d/m/Y');
                        
                        $qtdeDiasTrabalhados = GpeEscalatrabm::retornaQtdeDiasTrabalhoPorTurno( // dias totais do período menos dias de folga. Feriados são considerados como dias trabalhados
                            $dtcompetenciaMod, 
                            $dtinicio->format('d/m/Y'), 
                            $dias->d, 
                            $this->nrorg, 
                            $nrTurno
                        );
                    } else {
                        $qtdeDiasTrabalhados = GpeEscalatrabm::retornaQtdeDiasTrabalhoPorTurno( // dias totais do período menos dias de folga. Feriados são considerados como dias trabalhados
                            $this->dtmescompetencia, 
                            $dtinicio->format('d/m/Y'), 
                            $dias->d, 
                            $this->nrorg, 
                            $nrTurno
                        );
                    }
                } else {
                    $qtdeDiasTrabalhados = count(Dateutil::getDatasEntre($dtinicioSemMod, $dtfimSemMod));
                }
            }
            
            if($qtdeDiasTrabalhados == 0){
                $this->messages[] = "Vínculo: ".$this->objvinculo->getNrvinculom()." - ".$this->objvinculo->getNmvinculom()." possui escala com turno cadastrado mas o turno não possui horários, impossibilitando o cálculo da quantidade de dias trabalhados do vínculo!";
                
                $erro['STATUS'] = false;
                $erro['MOTIVO'] = "Vínculo possui escala com turno cadastrado mas o turno não possui horários, impossibilitando o cálculo da quantidade de dias trabalhados do vínculo!";
                MemoriaVT::getInstance()->setImpeditivosParaGerarVale($erro);
            }
        
            $arrayDiasFolgaVinc = $this->calcularQtdeDiasFolgaVinc($dtiniciovale, $dias, $nrVinculom, $nrTurno);
            $diasFolga = count($arrayDiasFolgaVinc);
            $intersecaoFolgaFeriado = count(array_intersect($arrayDiasFolgaVinc, $arFeriados)); //quantidade de dias que coincidem Folga e Feriados
            
            // Verifica se o turno possui algum horário do tipo TURNO, para entender que a escala é 12x36 e desconsiderar os feriados
            $params = array(
                'P_NRORG' => $this->nrorg,
                'P_NRTURNO' => $nrTurno,
                'P_DTMESCOMPETENC' => $dtinicio->format('d/m/Y'),
            );
            $where = "NRORG = :P_NRORG AND NRTURNO = :P_NRTURNO AND EXISTS (SELECT 1 FROM GPE_HORDIAH HH
                                                                            WHERE HH.NRHORDIAM = e.NRHORDIAM
                                                                              AND HH.NRORG = e.NRORG
                                                                              AND HH.IDTIPOHORARIO = 'T'
                                                                              AND HH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_HORDIAH
                                                                                                            WHERE GPE_HORDIAH.DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                                                                                              AND GPE_HORDIAH.NRHORDIAM = HH.NRHORDIAM
                                                                                                              AND GPE_HORDIAH.NRORG = HH.NRORG))";
            $gpeHorarioturno = GpeHorarioturno::getObjectByWhere($where,$params);
            if ($gpeHorarioturno) {
                // Zera feriados se tiver horário do tipo TURNO
                $feriados = 0;
                $intersecaoFolgaFeriado = 0;
            }
            
            $this->nrdiasnuteis = $feriados - $intersecaoFolgaFeriado;
            $total = $qtdeDiasTrabalhados - ($feriados - $intersecaoFolgaFeriado); // subtrair apenas feriados que não sejam em dias de folga
            
            if(!isset($dadosVinc)){
                MemoriaVT::getInstance()->detalharDiasConsPeriodo(
                    array(
                        'tipo' => 'turno', 
                        "formula" => "resultado = qtdeDiasTrabalhados - (feriados - intersecaoFolgaFeriado)",
                        "expressao" => $total.' = '.$qtdeDiasTrabalhados.' - ('.$feriados.' - '.$intersecaoFolgaFeriado.')',
                        "resultado" => $total,
                        "qtdeDiasTrabalhados" => $qtdeDiasTrabalhados,
                        "feriados" => $feriados,
                        "intersecaoFolgaFeriado" => $intersecaoFolgaFeriado,
                    )
                );
            }

        }else{
            $dias->d++;
    		$arDsr      = $this->seekDsr($dtinicio->format('d/m/Y'), $dtfinal->format('d/m/Y'), $this->dsdiadescansosemanal);
            if(!empty($this->paramVale)){
                //DSR
                if($this->paramVale['IDCONSDSRVALE'] == 'S'){
                    $dtinicioSemMod = clone $this->dataIniApurSemMOD;
                    $dtfimSemMod = clone $this->dataFimApurSemMOD;
                    
                    if($this->paramVale['QTMESESDSRVALE']){
                        $dtinicioSemMod = $dtinicioSemMod->sub(new \DateInterval('P' . $this->paramVale['QTMESESDSRVALE'] . 'M'));
                        $dtfimSemMod = $dtfimSemMod->sub(new \DateInterval('P' . $this->paramVale['QTMESESDSRVALE'] . 'M'));
                        
                        while($dtfimSemMod->format('m') == $this->dataFimApurSemMOD->format('m') && $this->paramVale['QTMESESDSRVALE'] != 0){
                            $dtfimSemMod = $dtfimSemMod->sub(new \DateInterval('P1D'));
                        }

                        $dtcompetenciaMod = DateUtil::truncateData(DateUtil::getPrimeiroDiaDoMes($dtinicioSemMod))->format('d/m/Y');
                        
                        $arDsr      = $this->seekDsr($dtinicioSemMod->format('d/m/Y'), $dtfimSemMod->format('d/m/Y'), $this->dsdiadescansosemanal);
                    }
                }
            }
            
            //quantidade de dias que coincidem DSR e Feriados
            $intersecao = count(array_intersect($arDsr, $arFeriados));
            $descansosemanal = count($arDsr);
            $this->nrdiasnuteis = ($descansosemanal - $feriados) + $intersecao;
            $total = $dias->d - $descansosemanal - $feriados + $intersecao;
            
            if(!isset($dadosVinc)){
                MemoriaVT::getInstance()->detalharDiasConsPeriodo(
                    array(
                        'tipo' => 'dsr', 
                        "formula" => "resultado = diasPeriodo - dsr - feriados + intercecaoDsrFeriado",
                        "expressao" => $total.' = '.$dias->d.' - '.$descansosemanal.' - '.$feriados.' + '.$intersecao,
                        "resultado" => $total,
                        "diasPeriodo" => $dias->d,
                        "dsr" => $descansosemanal,
                        "feriados" => $feriados,
                        "intersecaoDsrFeriado" => $intersecao,
                    )
                );
            }
            
        }
        
        return $total;

    }

    //FUNÇÕES DE SUPORTE
    /**
     * VERIFICA DSR
     * Verifica os quantos dias de descanso remunerado houveram em um determinado período.
     * @param string $dtiniperiodoapur (Formato 'dd/mm/yyyy')
     * @param string $dtfimperiodoapur (Formato 'dd/mm/yyyy')
     * @return array
     */

    private function seekDsr($dtiniperiodoapur, $dtfimperiodoapur)
    {
        
        $dtiniperiodoapur = clone DateUtil::getDataDeString($dtiniperiodoapur);
        $dtfimperiodoapur = clone DateUtil::getDataDeString($dtfimperiodoapur);
        
        $diasDsr = array();

        switch($this->dsdiadescansosemanal){
            case (self::SABADO):{
                while($dtiniperiodoapur->format('N') != 6){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
            case (self::DOMINGO):{
                while($dtiniperiodoapur->format('N') != 7){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
            case (self::SABDOM):{
                while($dtiniperiodoapur->format('N') != 7 and $dtiniperiodoapur->format('N') != 6){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                if($dtiniperiodoapur->format('N') == 7){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P6D'));
                }
                while($dtiniperiodoapur<$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P6D'));
                }
                if(($dtfimperiodoapur->format('N') == 6 or $dtfimperiodoapur->format('N') == 7) and ($dtiniperiodoapur<=$dtfimperiodoapur)){
                    $diasDsr[] = $dtfimperiodoapur->format('d/m/Y');
                }
                break;
            }
            case (self::SEGUNDA):{
                while($dtiniperiodoapur->format('N') != 1){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
            case (self::TERCA):{
                while($dtiniperiodoapur->format('N') != 1){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
            case (self::QUARTA):{
                while($dtiniperiodoapur->format('N') != 3){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
            case (self::QUINTA):{
                while($dtiniperiodoapur->format('N') != 4){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
            case (self::SEXTA):{
                while($dtiniperiodoapur->format('N') != 5){
                    $dtiniperiodoapur->add(new \DateInterval('P1D'));
                }
                while($dtiniperiodoapur<=$dtfimperiodoapur){
                    $diasDsr[] = $dtiniperiodoapur->format('d/m/Y');
                    $dtiniperiodoapur->add(new \DateInterval('P7D'));
                }
                break;
            }
        }
        return $diasDsr;
    }
    
    private function calcularQtdeDiasFolgaVincDia($dtInic, $dias, $nrVinculo, $competenciaForcada = null){
        $array = [];
        // Cria uma chave única para identificar a combinação de parâmetros
        $cacheKey = md5(serialize([$dtInic, $dias->d, $nrVinculo, $competenciaForcada]));
        
        // Verifica se o resultado já está no cache
        if (isset($this->cacheQtdeDiasFolgaVincDia[$cacheKey])) {
            return $this->cacheQtdeDiasFolgaVincDia[$cacheKey];
        }
        
        $diasDeFolgaNoPeriodo = GpeEscalatrabm::retornaDiasFolgaVincDia(
            !empty($competenciaForcada) ? $competenciaForcada : $this->hcmParameters->getDtCompetencia(), 
            $dtInic->format('d/m/Y'), 
            $dias->d, 
            $this->hcmParameters->getNrorgTrabalho(), 
            $nrVinculo
        );

        foreach($diasDeFolgaNoPeriodo as $value){
            if(!empty($value)){
                $array[] = $value['DTDATA'];  
            }
        } 
        
        // Armazena o resultado no cache
        $this->cacheQtdeDiasFolgaVincDia[$cacheKey] = $array;
        return $array;
    }
    
    /**
     * RETORNA QUANTIDADE DE FOLGAS
     * Retorn a quantidade de folgas do vínculo a partir de um período informado
     * @param data $dtInic
     * @param int $dias
     * @param int $nrvinculom
     * @return array 
     */ 
    private function calcularQtdeDiasFolgaVinc($dtInic, $dias, $nrVinculo, $nrTurno=null){
        $array = [];
        
        if (is_null($nrTurno)) {
            $diasDeFolgaNoPeriodo = GpeEscalatrabm::retornaDiasFolgaVinc(
                $this->hcmParameters->getDtCompetencia(), 
                $dtInic->format('d/m/Y'), 
                $dias->d, 
                $this->hcmParameters->getNrorgTrabalho(), 
                $nrVinculo
            );
        } else {
            $diasDeFolgaNoPeriodo = GpeEscalatrabm::retornaDiasFolgaTurno(
                $this->hcmParameters->getDtCompetencia(), 
                $dtInic->format('d/m/Y'), 
                $dias->d, 
                $this->hcmParameters->getNrorgTrabalho(), 
                $nrTurno
            );
        }

        foreach($diasDeFolgaNoPeriodo as $value) $array[] = $value['DTDATA'];
        
        return $array;
    }
 
    /**
     * BUSCAR FERIADOS
     * Verifica quantos feriados existem em um período de datas passadas por parâmetros.
     * @param string $dtiniperiodoapur
     * @param string $dtfimperiodoapur
     * @return array
     */
    private function seekFeriado($dtiniperiodoapur, $dtfimperiodoapur)
    {
        $result = array();
        
        if( $this->nrestrutlegal == null ){
            $instancia = MsgCalculo::getInstance();
            $instancia->setDados($this->hcmParameters->determinaNrCalculoFolha(FpaTipomoviment::TP_MOV_VALE_TRANSPORTE), $this->objvinculo->getNrvinculom(), $this->hcmParameters->getNrorgTrabalho(), "CALCULOVT");
            
            MsgCalculo::getInstance()->adicionaMensagem('O vínculo '.$this->objvinculo->getNrvinculom().' - '.$this->objvinculo->getNmvinculom().' não possui estrutura legal.', MsgCalculo::ALERTA);
            
            $instancia->salvaMensagens();
            $instancia->clear();
        } else {
            if($this->geraBenefFeriado == 'N'){
                
                $nrestrutlegal = $this->nrestrutlegal;
                    
                $paramOrg = FPA::getGpeParametrosOrganizacao();
            
                //Busca calendario da estrutra de movimentacao.
                if($paramOrg->getNrtpestrutcalend()){
                    
                    $movimentacoes = $this->_movimentosVinculo->carregaMovimentacaoRecentePorTipoEstrutura($this->objvinculo->getNrorg(), $this->objvinculo->getNrvinculom(), $this->hcmParameters->getUltimoDiaMes(), $paramOrg->getNrtpestrutcalend());

                    if($movimentacoes){
                        
                        foreach ($movimentacoes as $movimentacao){
                            
                            $nrestrutlegal = $movimentacao->getNrestruturam();
                        }
                    }
                }
                
                $feriados = Estruturah::getFeriados($dtiniperiodoapur, $dtfimperiodoapur, $nrestrutlegal, $this->dtmescompetencia, $this->nrorg);
                
        		foreach($feriados as $feriado){
        		    $isDiaFeriadoNaoTrabalhado = $this->analisaDiaFeriadoNaoTrabalhado(DateUtil::truncateData(DateUtil::getDataDeString($dtiniperiodoapur))->format('01/m/Y'), substr($feriado['DTCALENDARIO'], 0, 10), $this->objvinculo);
                    //02/10/2024 ANALISE EM CONJUNTO COM ERIJA.
                    //Se o vinculo trabalhou, o valor vem 0, o que configura um feriado que deve ser adicionado como feriado.
                    //Se o vinculo não trabalhou seja por folga, compensado e IDNGERABENEFDIARIO não deve-se descontar o feriado.
                    if($isDiaFeriadoNaoTrabalhado == false){
                        $result[] = substr($feriado['DTCALENDARIO'], 0, 10);
                    }
        		}
            }
        }
        return $result;
    }
    
    private function analisaDiaFeriadoNaoTrabalhado($dtcompetencia, $dataFeriadoString, $vinculo) {
        // Cria uma chave única para identificar a combinação de parâmetros
        $cacheKey = md5(serialize([$dtcompetencia, $dataFeriadoString, $vinculo->getNrvinculom()]));
    
        // Verifica se o resultado já está no cache
        if (isset($this->cacheAnalisaDiaFeriadoNaoTrabalhado[$cacheKey])) {
            return $this->cacheAnalisaDiaFeriadoNaoTrabalhado[$cacheKey];
        }
    
        // Código principal da função
        $isDiaFeriadoNaoTrabalhado = 0;
        $dias = DateUtil::truncateData(DateUtil::getDataDeString($dataFeriadoString))
            ->diff(DateUtil::truncateData(DateUtil::getDataDeString($dataFeriadoString)));
        // TODO: Verificar antes se o dia é um dia de trabalho
        $isDiaFeriadoNaoTrabalhado = GpeEscalatrabm::retornaDiaFeriadoNaoTrabalhado(
            $dtcompetencia,
            $dataFeriadoString,
            $dias->d,
            $this->hcmParameters->getNrorgTrabalho(),
            $vinculo->getNrvinculom()
        );
    
        $result = $isDiaFeriadoNaoTrabalhado == 1;
    
        // Armazena o resultado no cache
        $this->cacheAnalisaDiaFeriadoNaoTrabalhado[$cacheKey] = $result;
        return $result;
    }

    /**
     * BUSCAR OBJETO DE HISTÓRICO DO VÍNCULO ATUAL
     */
    private function setVinculoh()
    {
        $dtmescompetencia = $this->dtmescompetencia;

        try {
            $params = array(
                'P_NRORG' => $this->nrorg,
                'P_NRVINCULOM' => $this->objvinculo->getNrvinculom());
            $where = "NRORG = :P_NRORG AND NRVINCULOH = (SELECT NRVINCULOH FROM GPE_VINCULOH WHERE NRORG = :P_NRORG AND NRVINCULOM = :P_NRVINCULOM AND DTMESCOMPETENC = (SELECT * FROM (SELECT MAX_VINCULOH.DTMESCOMPETENC FROM GPE_VINCULOH MAX_VINCULOH WHERE MAX_VINCULOH.DTMESCOMPETENC <= '$dtmescompetencia' AND MAX_VINCULOH.NRVINCULOM = GPE_VINCULOH.NRVINCULOM AND MAX_VINCULOH.NRORG = GPE_VINCULOH.NRORG ORDER BY MAX_VINCULOH.DTMESCOMPETENC DESC) WHERE ROWNUM = 1))";
            $historico = GpeVinculoh::getObjectByWhere($where, $params);
            
            if ($historico) {
                return $historico;
            } else {
                throw new \Exception('Vinculo '.$this->objvinculo->getNrvinculom().' - '.$this->objvinculo->getNmvinculom().' não possui histórico.', Messages::ERROR_MESSAGE_CODE);
            }
        }catch (\Exception $e){
            throw $e;
        }
    }

    /**
     * BUSCA A ESTRUTURA LEGAL DO VÍNCULO ATUAL
     */
    private function setNrestrutlegal()
    {
        return $this->objvinculoh->getNrestrutlegal();
    }

    public function getValeTransporte()
    {
        return $this->passagens;
    }

    public function getTotalTarifas()
    {
        return array('VALOR'      => $this->vrtotal,
                     'REFERENCIA' => $this->diastotaisconsideracao);
    }

    /**
     * Adiciona os vínculos de líquido no histórico para os mesmos
     * @param array $info
     * @param int $vinculo
     * @return void
     */
    public function addHistorico($info, $vinculo, $dtpagamento)
    {   
        /**
         * @var VabHistvalevinc $hist
         */
        $dtiniapuravale = clone $this->dtiniperiodovale;
        $dtfimapuravale = clone $this->dtfimperiodovale;

        //$nrcalculo = tk_get_env_var('NRCALCULO_VAB');
        //if (is_null(tk_get_env_var('NRCALCULO_VAB'))) {
            $nrcalculo = $this->hcmParameters->determinaNrCalculoFolha(FpaTipomoviment::TP_MOV_VALE_TRANSPORTE);
        //}

        //Busca lançamentos de vale vínculo para aquela competência
        $params = array(
            'P_NRVINCULOM'        => $info['NRVINCULOM'],
            //'P_NRCALCULOFOLHA'    => tk_get_env_var('NRCALCULO_VAB'),
			'P_NRCALCULOFOLHA'    => $nrcalculo,
            'P_DTMESCOMPAPVALE'   => $this->dtmescompetencia,
            'P_NRLINHATRANSP'     => $info['NRLINHATRANSP'],
            'P_NRORG'             => $this->nrorg,
            'P_FORMINI'           => $dtiniapuravale->format('d/m/Y'),
            'P_FORMFIM'           => $dtfimapuravale->format('d/m/Y'),
            'DTPGTOVALE'          => $dtpagamento->format('d/m/Y'));
        $where = "NRORG = :P_NRORG 
                    AND NRVINCULOM = :P_NRVINCULOM 
                    AND NRCALCULOFOLHA = :P_NRCALCULOFOLHA 
                    AND TRUNC(DTMESCOMPAPVALE) = :P_DTMESCOMPAPVALE 
                    AND NRLINHATRANSP = :P_NRLINHATRANSP
                    AND DTPGTOVALE = :DTPGTOVALE
                    AND DTINIAPURVALE <= :P_FORMFIM 
                    AND DTFINAPURVALE >= :P_FORMINI";
        $obj = \Folha\Entities\VabHistvalevinc::getObjectByWhere($where, $params);

        $valorCartao = $this->getValorRestante($vinculo, $info);
        
        //A segunda condição nega a condição maxima de geração de lançamento de VT, se o parametro de vale transporte existir e tiver marcado como Sim
        //gerará VT para o vínculo mesmo com os DIAS zerados.
        if (!$obj and ($info['DIAS'] > 0 or ($this->paramVale and $this->paramVale['IDGERAHISTVALEZERADO'] == 'S'))) {
            $info['STATUS'] = true;
            $info['MOTIVO'] = "SUCESSO";
            MemoriaVT::getInstance()->setInfoValesVinc($info);

            $hist = new VabHistvalevinc();
            $hist->setNrhistvalevinc(NovoCodigo::geraCodigo($this->nrorg, 'VAB_HISTVALEVINC', 1, 22, true));
            $hist->setNrlinhatransp($info['NRLINHATRANSP']);
            $hist->setNrvinculom($vinculo);
            $hist->setNrtarifa($info['NRTARIFA']);
            $hist->setNrvinculom($info['NRVINCULOM']);
            $hist->setNrsentidolinha($info['NRSENTIDOLINHA']);
            $hist->setNrtipolinhavinc($info['NRTIPOLINHAVINC']);
            //$hist->setNrcalculofolha(tk_get_env_var('NRCALCULO_VAB'));
            $hist->setNrcalculofolha($nrcalculo);
            $hist->setNrorg($this->hcmParameters->getNrorgTrabalho());
            if($this->idcalccomplementar == 'S'){
                $hist->setDtmescompapvale(DateUtil::getDataDeString($this->hcmParameters->getDtCompetencia(), DateUtil::FORMATO_BRASILEIRO, true));
                $hist->setIdcalccomplementar($this->idcalccomplementar);
            } else {
                $hist->setDtmescompapvale(DateUtil::getDataDeString($this->dtmescompetencia, DateUtil::FORMATO_BRASILEIRO, true));
                $hist->setIdcalccomplementar('N');
            }
            $hist->setDtiniapurvale($info['DTINIAPURACAO']);
            $hist->setDtfinapurvale($info['DTFIMAPURACAO']);
            $hist->setQtapurvale($info['QTLINHATARIFA']);
            $hist->setIdativo('S');
            $hist->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
            $hist->setDtinclusao(DateUtil::getDataAtual());
            $hist->setCdoperinclusao($this->hcmParameters->getCdoperador());
            $hist->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
            $hist->setDtultatu(DateUtil::getDataAtual());
            $hist->setCdoperultatu($this->hcmParameters->getCdoperador());
            $hist->setQtdiasvale($info['DIAS'] > 0 ? $info['DIAS'] : 0);
            $hist->setVrdeducaovale($valorCartao);
            $hist->setDtpgtovale($dtpagamento);
            $hist->setIdajustemanual('N');
            $hist->setQtdiasfaltas(empty($info['DIAS_FALTAS']) ? 0 : $info['DIAS_FALTAS']);
            $hist->setQtdiasferias(empty($info['DIAS_FERIAS']) ? 0 : $info['DIAS_FERIAS']);
            $hist->setQtdiasaviso(empty($info['DIAS_AVISO']) ? 0 : $info['DIAS_AVISO']);
            $hist->setQtdiasafasta(empty($info['DIAS_AFASTAMENTO']) ? 0 : $info['DIAS_AFASTAMENTO']);
            $hist->setQtdiasnuteis(empty($info['DIAS_N_UTEIS']) ? 0 : $info['DIAS_N_UTEIS']);

            $hist->persist();
        }elseif( $obj && $info['DIAS'] > 0){
            $info['STATUS'] = false;
            $info['MOTIVO'] = "Lançamento já Calculado";
            MemoriaVT::getInstance()->setInfoValesVinc($info);
        }elseif( $obj && $info['DIAS'] <= 0){
            $info['STATUS'] = false;
            $info['MOTIVO'] = "Lançamento já calculado e sem dias de consideração";
            MemoriaVT::getInstance()->setInfoValesVinc($info);
        }

    }

    /**
    * Busca valor do restante no cartão cartão
    * @param int $nrvinculom
    * @return float
    */
    private function getValorRestante($nrvinculom, $info)
    {
        /**
         * Busca valor do cartão
         * @var VabIntegtransph $cartao
         */
        $params = array(
            'P_NRORG' => $this->nrorg,
            'P_NRVINCULOM' => $nrvinculom,
            'P_DTMESCOMPETENCIA' => $this->dtmescompetencia,
            'P_NRTIPOLINHAVINC' => $info['NRTIPOLINHAVINC'],
            'P_DTINILINHAVINC' => $this->dtiniperiodovale->format('d/m/Y'),
            'P_DTFIMLINHAVINC' => $this->dtfimperiodovale->format('d/m/Y'),
        );
        $orderBy = "DTMESCOMPINTEG DESC";
        $where = "NRORG = :P_NRORG AND NRTIPOLINHAVINC = :P_NRTIPOLINHAVINC AND NRINTEGTRANSPH IN ( SELECT VAB_INTEGTRANSPH.NRINTEGTRANSPH FROM VAB_INTEGTRANSPH LEFT JOIN VAB_LINHAVINC ON VAB_LINHAVINC.NRORG = VAB_INTEGTRANSPH.NRORG AND VAB_LINHAVINC.NRINTEGTRANSPM = VAB_INTEGTRANSPH.NRINTEGTRANSPM WHERE VAB_INTEGTRANSPH.NRORG = :P_NRORG AND VAB_LINHAVINC.NRVINCULOM = :P_NRVINCULOM AND VAB_LINHAVINC.NRTIPOLINHAVINC = VAB_INTEGTRANSPH.NRTIPOLINHAVINC AND ( VAB_LINHAVINC.DTINILINHAVINC <= :P_DTINILINHAVINC ) AND ( VAB_LINHAVINC.DTFIMLINHAVINC >= :P_DTFIMLINHAVINC OR VAB_LINHAVINC.DTFIMLINHAVINC IS NULL ) AND VAB_INTEGTRANSPH.DTMESCOMPINTEG = ( SELECT MAX(MAX_INTEGTRANSPH.DTMESCOMPINTEG) FROM VAB_INTEGTRANSPH MAX_INTEGTRANSPH WHERE VAB_INTEGTRANSPH.NRORG = MAX_INTEGTRANSPH.NRORG AND VAB_INTEGTRANSPH.NRINTEGTRANSPM = MAX_INTEGTRANSPH.NRINTEGTRANSPM AND MAX_INTEGTRANSPH.DTMESCOMPINTEG <= :P_DTMESCOMPETENCIA ) )";
        $cartao = VabIntegtransph::getObjectByWhere($where, $params, $orderBy);
        $credIndevido = empty($info['CRED_INDEVIDO']) ? 0 : $info['CRED_INDEVIDO'];
        
        if($cartao instanceof VabIntegtransph){
            $dthoje = DateUtil::getDataAtual(true);
            // $dthoje = DateUtil::getDataDeString('17/09/2018', DateUtil::FORMATO_BRASILEIRO, true);
            $dtfinal = clone $this->dtiniperiodovale;
            $dtfinal->sub(new \DateInterval('P1D'));
            $diasRestantes = $this->diastotaisconsideracao;
            
            $nrintegranspm = $cartao->getNrintegtranspm();
        
            $passagensNecessaria = $this->getPassagensNecessarias($dtfinal, $dtfinal, $cartao->getNrtipolinhavinc());
            
            $vrNecessario = 0;
            
            foreach ($passagensNecessaria as $passagemNecessaria) {
                if ($passagemNecessaria['NRTIPOLINHAVINC'] == $cartao->getNrtipolinhavinc() && $passagemNecessaria['NRLINHATRANSP'] == $info['NRLINHATRANSP']) {
                    $vrNecessario += $passagemNecessaria['VRTARIFA'] * $passagemNecessaria['QTLINHATARIFA'] * $diasRestantes;
                }
            }
            
            $valorCartaoSaldoAtual = $cartao->getVrsaldoultconsulta();
            
            if(!empty($this->valorAnteriorCartao) && is_array($this->valorAnteriorCartao)){
                foreach($this->valorAnteriorCartao as $valoresAnterioresCartao){
                    foreach($valoresAnterioresCartao as $key => $valorAnteriorCartao){
                        if($key == $nrintegranspm){
                            $valorCartaoSaldoAtual = $valorAnteriorCartao;
                        }
                    }
                }
            }
            
            if($valorCartaoSaldoAtual > $vrNecessario){
                $valorCartao = $vrNecessario;
            } else {
                $valorCartao = $valorCartaoSaldoAtual;
            }
            
            $novosElementos = [
                "$nrintegranspm" => ($cartao->getVrsaldoultconsulta() > $vrNecessario) ? $cartao->getVrsaldoultconsulta() - $vrNecessario : 0
            ];
                
            $this->valorAnteriorCartao[] = $novosElementos;
        }else{
            $valorCartao = 0;
        }

        return $valorCartao > 0 ? $valorCartao + $credIndevido : 0.00 + $credIndevido;
    }

    /**
     * @return array|bool
     */
    private function getPassagensNecessarias(\DateTime $dtinicio, \DateTime $dtfinal, $nrtipolinhavinc = null)
    {
        return VabLinhavinc::infoLinhaVinculoTarifa($this->objvinculo->getNrvinculom(), $this->nrorg, $dtinicio, $dtfinal, $nrtipolinhavinc, $this->hcmParameters->getNrorgPadrao());
    }
}