/*! 08-04-2025 */
function ZhPreferences(RepositoryFactory,requestEngine,requestFactory,ZHPromise,Query){var repositoryMap={};var userWidgetConfiguration={};this.registerRepository=function(name){var repositoryName=name.split("#").pop();repositoryMap[repositoryName]=RepositoryFactory.factory(name,"MEMORY")};this.savePreferences=function(preferenceType,preferences){return requestEngine.doRequest(requestFactory.factory({serviceName:"zh-preferences#/"+preferenceType+"/save",requestType:"dataSource",dataSource:preferences})).then(null,function(response){throw new Error(response.data.error)}).then(function(response){var returnedIds=response.dataset[preferenceType];return preferences.map(function(preference,index){preference.__is_new=false;preference.changed=false;preference.ID=returnedIds[index].ID;return preference})}).then(function(preferences){return repositoryMap[preferenceType].save(preferences)})};this.deletePreferences=function(preferenceType,preferences){return requestEngine.doRequest(requestFactory.factory({serviceName:"zh-preferences#/"+preferenceType+"/remove",requestType:"dataSource",dataSource:preferences})).then(null,function(response){throw new Error(response.data.error)}).then(function(response){var deletedIds=response.dataset[preferenceType].map(function(preference){return preference.ID});var query=Query.build().where("ID").in(deletedIds);return repositoryMap[preferenceType].remove(query)})};this.getPreferences=function(preferenceType,query){var filterRequest=requestFactory.factory({serviceName:"zh-preferences#/"+preferenceType,requestType:"filterData",filter:query.where()});return requestEngine.doRequest(filterRequest).then(function(response){var preferences=response.dataset[preferenceType];var removePreferences=repositoryMap[preferenceType].remove(query);var savePreferences=repositoryMap[preferenceType].save(preferences);return ZHPromise.all([removePreferences,savePreferences]).then(function(){return preferences})}).catch(function(response){throw new Error(response.data.error)})};this.getWidgetPreferences=function(preferenceType,widgetID){var query=Query.build().where("WIDGET_ID").equals(widgetID);return this.getPreferences(preferenceType,query)};this.getDefaultWidgetPreferences=function(widgetID){if(userWidgetConfiguration[widgetID]===undefined){var query=Query.build().where("WIDGET_ID").equals(widgetID);userWidgetConfiguration[widgetID]=requestEngine.doRequest(requestFactory.factory({serviceName:"zh-preferences#/default-preferences",requestType:"filterData",filter:query.where()})).then(function(response){var dataset=response.dataset;var preference=dataset.user_widget.pop()||{__is_new:true,ID:null,WIDGET_ID:widgetID,DEFAULT_FILTER:null,DEFAULT_LAYOUT:null,DEFAULT_VIEW:null,LAST_MODIFIED_DATE:null};if(dataset.defaultFilter&&dataset.defaultFilter.length){preference.defaultFilter=dataset.defaultFilter.pop();preference.defaultFilter.FILTER_ROW=JSON.parse(preference.defaultFilter.FILTER_ROW)}if(dataset.defaultLayout&&dataset.defaultLayout.length){preference.defaultLayout=dataset.defaultLayout.pop()}if(dataset.defaultView&&dataset.defaultView.length){preference.defaultView=dataset.defaultView.pop()}return preference})}return userWidgetConfiguration[widgetID]};this.changeDefaultPreferences=function(configWidget,property,preference){var widgetID=configWidget.listWidget.id;var preferenceID=preference[property]?preference.ID:null;userWidgetConfiguration[widgetID]=this.getDefaultWidgetPreferences(widgetID).then(function(defaultPreferences){defaultPreferences[property]=preferenceID;defaultPreferences.__is_new=defaultPreferences.__is_new||false;return ZHPromise.all([defaultPreferences,requestEngine.doRequest(requestFactory.factory({serviceName:"zh-preferences#/default-preferences/save",requestType:"dataSource",dataSource:[defaultPreferences]}))])}).then(function(args){var defaultPreferences=args[0];var response=args[1];defaultPreferences.ID=Util.getNestedProperty(response,["dataset","user_widget","0","ID"]);configWidget.dataSource.data.forEach(function(row){row.__is_new=false;row[property]=row.ID==defaultPreferences[property]});return defaultPreferences});return userWidgetConfiguration[widgetID]};function isMasterDetail(template){return template.indexOf("master_detail/grid.html")!==-1||template.indexOf("master_detail/list.html")!==-1||template.indexOf("master_detail/tree/grid.html")!==-1}function isMasterDetailView(widget){return isMasterDetail(widget.template)&&widget.mode==ViewMode.VIEW}this.validateWidget=function(widget){if(!widget.id){throw new Error('Widget\'s must have "id" to use Preferences. '+'Widget with name "'+widget.name+'" does not have an id.')}if(!widget.container.id){throw new Error('Container\'s must have "id" to use Preferences.')}return!isMasterDetailView(widget)};var userPromise=ZHPromise.defer();this.unsetUser=function(){userPromise=ZHPromise.defer();userWidgetConfiguration={};Object.keys(repositoryMap).forEach(function(repositoryName){repositoryMap[repositoryName].clearAll()})};this.setUserID=function(userID){userPromise.resolve(userID)};this.getUserID=function(){return userPromise.promise};this.downloadPreferenceFile=function(preference,fileName){var dataStr="data:text/json;charset=utf-8,"+encodeURIComponent(JSON.stringify(preference,false,4));var linkElement=document.createElement("a");linkElement.setAttribute("href",dataStr);linkElement.setAttribute("download",fileName);linkElement.click();linkElement.remove();return ZHPromise.when(preference)}}Configuration(function(ContextRegister){ContextRegister.register("ZhPreferences",ZhPreferences)});var ZeedhiDirectives=angular.module("ZeedhiDirectives");ZeedhiDirectives.directive("zhPreferenceFloatingControl",[zhPreferenceFloatingControl]);function zhPreferenceFloatingControl(){return{priority:10,link:function($scope){function checkFloatingCardOverflow(e){var actionElement=$(e.target).closest(".float-action");var floatingControl=actionElement.parents(".zh-floating-control");var widgetContainer=actionElement.closest(".container");var actionTop,actionBottom;var widgetTop,widgetBottom;if(!actionElement.hasClass("opened")){actionElement.removeClass("fix-position-top");actionElement.removeClass("fix-position-bottom");actionTop=actionElement.offset().top;widgetTop=widgetContainer.offset().top;widgetBottom=widgetTop+widgetContainer.height();if(floatingControl.hasClass("pos-top")){actionTop=actionTop-200+actionElement.height();if(actionTop<widgetTop){actionElement.addClass("fix-position-top")}}else{actionBottom=actionTop+200;if(actionBottom>widgetBottom){actionElement.addClass("fix-position-bottom")}}}}$scope.togglePreferencesCard=function(e){checkFloatingCardOverflow(e);$scope.toggleAction(e)}}}}(function(){window.metadataUrls=window.metadataUrls||[];window.serviceUrls=window.serviceUrls||[];var PACKAGE_NAME="zh-preferences";var hasMetaData=window.metadataUrls.some(function(metadataUrl){return metadataUrl.package===PACKAGE_NAME});var hasServiceUrl=window.serviceUrls.some(function(serviceUrl){return serviceUrl.package===PACKAGE_NAME});if(!hasMetaData){window.metadataUrls.push({package:PACKAGE_NAME,baseUrl:"bower_components/zh-preferences/dist/assets/"})}if(!hasServiceUrl){window.serviceUrls.push({package:PACKAGE_NAME,baseUrl:"../backend/service/index.php/zh-preferences"})}})();function ZhFilterBuilder(Query){var defaultOperators={"field/between-dates.html":Query.BETWEEN,"field/calendar.html":Query.EQ,"field/date.html":Query.EQ,"field/datetime.html":Query.EQ,"field/interval.html":{default:Query.BETWEEN,start:Query.GTE,end:Query.LTE},"field/number-edit.html":Query.EQ,"field/number-keyboard.html":Query.EQ,"field/number.html":Query.EQ,"field/radio.html":Query.EQ,"field/select.html":Query.EQ,"field/select-simple.html":Query.EQ,"field/select-native.html":Query.EQ,"field/select-autocomplete.html":Query.EQ,"field/select-multiple.html":Query.IN,default:Query.LIKE_INSENSITIVE};var buildFilterByTemplate={"field/select.html":buildSelectFilter,"field/select-autocomplete.html":buildSelectFilter,"field/select-native.html":buildSelectNativeFilter,"field/select-multiple.html":buildSelectMultipleFilter,"field/interval.html":buildIntervalFilter,default:buildDefaultFilter};this.setDefaultOperator=function(template,operator){defaultOperators[template]=operator};this.setBuildFilterByTemplate=function(template,callback){buildFilterByTemplate[template]=callback};function getFieldTemplate(field){return field.template.split("#").pop()}function getFilterBuilderByTemplate(template){if(!buildFilterByTemplate[template]){template="default"}return buildFilterByTemplate[template]}function clearFilters(filters){var clearedFilters=[];filters.forEach(function(filter){var repeated=clearedFilters.some(function(_filter){return _filter.name===filter.name});if(!repeated){clearedFilters.push(filter)}});return clearedFilters}this.buildFilter=function(fields,row){var query=Query.build();fields.forEach(function(field){if(!field.skipSearch){var template=getFieldTemplate(field);getFilterBuilderByTemplate(template)(query,field,row)}});return clearFilters(query.where())};var operatorFlow={BETWEEN:function(query,value){query.between([value.start,value.end])},"NOT BETWEEN":function(query,value){query.notBetween([value.start,value.end])},LIKE:function(query,value){query.like("%"+value+"%")},LIKE_I:function(query,value){query.likeInsensitive("%"+value+"%")},LIKE_BEGINNING:function(query,value){query.likeInsensitive(value+"%")},"NOT LIKE":function(query,value){query.notLike("%"+value+"%")},"LIKE ALL":function(query,value){query.likeAll("%"+value+"%")},"<>":function(query,value){query.notEquals(value)},"=":function(query,value){query.equals(value)},">":function(query,value){query.greater(value)},"<":function(query,value){query.lower(value)},">=":function(query,value){query.greaterOrEqual(value)},"<=":function(query,value){query.lowerOrEqual(value)},IN:function(query,value){query.in(value)},"NOT IN":function(query,value){query.notIn(value)}};function buildFilter(query,fieldName,operator,value){query.where(fieldName);operatorFlow[operator](query,value)}function isEmptyArrayOrObject(obj){var name;for(name in obj){return false}return true}function existValue(value){var isObject=typeof value=="object";return isObject?!isEmptyArrayOrObject(value):!Util.isEmptyOrBlank(value)}function buildDefaultFilter(query,field,currentRow){var fieldName=field.name;var value=currentRow[fieldName];if(existValue(value)){var operator=getFieldOperator(field);buildFilter(query,fieldName,operator,value)}}function buildIntervalFilter(query,field,currentRow){var fieldName=field.name;var value=currentRow[fieldName];value=existValue(value)?Util.clone(value):{};var existStartValue=!Util.isEmptyOrBlank(value.start);var existEndValue=!Util.isEmptyOrBlank(value.end);if(existStartValue||existEndValue){var operator=getFieldOperator(field);if(existStartValue&&existEndValue){operator=operator.default}else if(existStartValue){operator=operator.start;value=value.start}else{operator=operator.end;value=value.end}buildFilter(query,fieldName,operator,value)}}function buildSelectWithValueFieldFilter(query,field,currentRow,operator){var fieldName=field.valueField;var value=currentRow[fieldName];if(existValue(value)){buildFilter(query,fieldName,operator,value)}}function buildSelectWithValueFieldsFilter(query,field,currentRow,operator){var fieldName=field.name;var value=currentRow[fieldName];if(existValue(value)){buildFilter(query,fieldName,operator,value)}}function buildSelectWithOutDataFilter(query,field,currentRow,operator){var outData=field.outData;Object.keys(outData).forEach(function(outDataKey){var fieldName=outData[outDataKey];var value=currentRow[fieldName];if(existValue(value)){buildFilter(query,fieldName,operator,value)}})}function buildSelectFilter(query,field,currentRow){var operator=getFieldOperator(field);if(field.valueField){buildSelectWithValueFieldFilter(query,field,currentRow,operator)}else if(field.valueFields){buildSelectWithValueFieldsFilter(query,field,currentRow,operator)}else if(field.outData){buildSelectWithOutDataFilter(query,field,currentRow,operator)}else{throw new Error("Invalid select configuration on field "+field.name)}}function buildSelectNativeWithValueFieldFilter(query,field,currentRow,operator){var fieldName=field.name;var value=currentRow[fieldName];if(existValue(value)){buildFilter(query,fieldName,operator,value)}}function buildSelectNativeFilter(query,field,currentRow){var operator=getFieldOperator(field);if(field.valueField){buildSelectNativeWithValueFieldFilter(query,field,currentRow,operator)}else{throw new Error("Invalid select-native configuration on field "+field.name)}}function buildSelectMultipleWithValueFieldFilter(query,field,currentRow,operator){var fieldName=field.name;var value=currentRow[fieldName];if(currentRow[fieldName+"_EXCEPT"]){value=currentRow[fieldName+"_EXCEPT"];operator="NOT IN"}if(existValue(value)){buildFilter(query,fieldName,operator,value)}}function buildSelectMultipleWithValueFieldsFilter(query,field,currentRow,operator){throw new Error("Filter on field select-multiple with property valuesFields is not supported yet. "+'Field "'+field.name+'"')}function buildSelectMultipleFilter(query,field,currentRow){var operator=getFieldOperator(field);if(field.valueField){buildSelectMultipleWithValueFieldFilter(query,field,currentRow,operator)}else if(field.valueFields){buildSelectMultipleWithValueFieldsFilter(query,field,currentRow,operator)}else{throw new Error("Invalid select-multiple configuration on field "+field.name)}}function getFieldOperator(field){var template=getFieldTemplate(field);if(template==="field/interval.html"&&typeof field.operator==="string"){field.operator=defaultOperators[template]}return field.operator||defaultOperators[template]||defaultOperators["default"]}}Configuration(function(ContextRegister){ContextRegister.register("ZhFilterBuilder",ZhFilterBuilder)});function ZhFilterDescriptionBuilder(DecodeValueFieldService,ZhUtil,templateManager){this.buildFilterAppliedInfo=function(preferenceName){return[{label:"Filter",filterName:preferenceName}]};function getFilterWidget(id){return templateManager.container.factoredWidgets.filter(function(widget){return widget._filteredWidgetId==id})[0]}this.buildFilterInfo=function(fields,currentRow,searchCriteria,widget){var filterInfo=[];var filterWidget=getFilterWidget(widget&&widget.id);fields.forEach(function(field){buildDefaultFilterInfo(filterInfo,field,currentRow,filterWidget)});buildFilterInfoForSearchCriteria(fields,filterInfo,searchCriteria);return filterInfo};function buildFilterInfoForSearchCriteria(fields,filterInfo,searchCriteria){if(searchCriteria){Object.keys(searchCriteria).forEach(function(fieldName){if(searchCriteria[fieldName]!==""){var fieldLabel;if(fieldName=="_ALL_MAP"){fieldLabel="All fields"}else{fieldLabel=getFieldByName(fields,fieldName).label}filterInfo.push(buildFilterInfo(fieldLabel,searchCriteria[fieldName]))}})}}function getFieldByName(fields,fieldName){return fields.filter(function(field){return field.name===fieldName}).shift()}function buildFilterInfo(label,value){return{label:label,value:value}}function buildDefaultFilterInfo(filterInfo,field,currentRow,widget){var condition=!Util.isEmptyOrBlank(currentRow[field.name]);var filterField=widget&&widget.getField(field.name);var showInfo=filterField&&filterField.isVisible;if(condition&&showInfo){var value=filterField&&filterField.modelValue()||DecodeValueFieldService.model(field,currentRow[field.name]);value=ZhUtil.evaluate(value);filterInfo.push(buildFilterInfo(field.label,value))}}}Configuration(function(ContextRegister){ContextRegister.register("ZhFilterDescriptionBuilder",ZhFilterDescriptionBuilder)});function ZhFilterPreferences(ZhPreferences,ZhFilterBuilder,ZhFilterDescriptionBuilder,templateManager,eventAggregator,ZhUtil,eventEngine,metaDataFactory,ZHPromise,MessageService,ScreenService,ZhKeyboardService,ApplicationContext,$timeout){var self=this;var originalFilterRows={};var originalFilter={ID:"ORIGINAL",USER_ID:0,ORGANIZATION_ID:0,LABEL_TO_PREFERENCE:"Original"};function shouldShowFilterAction(widget){return Util.get(widget,["floatingControl","searchAction"])!==false||Util.get(widget,["floatingControl","customizationAction","filter"])!==false}eventAggregator.subscribe("beforeProjectStartup",function(){ZhPreferences.registerRepository("zh-filter-preferences#filter");templateManager.project.customFloatingActions.push({name:"Filter Action",label:"Search",type:"filter",order:20,icon:"search",template:"zh-filter-preferences#floating-filter-card.html",expandable:true,isVisible:shouldShowFilterAction})});eventEngine.registerEvent("FilterBeforeApply","beforeFilterApply");eventEngine.registerEvent("FilterAfterApply","afterFilterApply");var filterRegisteredDataSources={};this.registerFilterDataSource=function(widgetID,dataSource){if(widgetID){filterRegisteredDataSources[widgetID]=dataSource}return filterRegisteredDataSources};this.updateFilters=function(widgetID,dataSource){if(!dataSource){dataSource=filterRegisteredDataSources[widgetID]}return this.getWidgetFilters(widgetID).then(function(filters){return this.addIsDefaultFilterToFilters(filters,widgetID).then(function(filters){dataSource.data=filters})}.bind(this))};function addIsDefaultFilterToFilter(defaultFilter,filter){filter.DEFAULT_FILTER=filter.ID===defaultFilter;return filter}this.addIsDefaultFilterToFilters=function(filters,widgetID){return ZhPreferences.getDefaultWidgetPreferences(widgetID).then(function(defaultPreferences){var defaultFilter=defaultPreferences.DEFAULT_FILTER;return filters.map(addIsDefaultFilterToFilter.bind(this,defaultFilter))})};this.getWidgetFilters=function(widgetID){return ZhPreferences.getWidgetPreferences("filter",widgetID).then(function parseFilterRow(preferences){preferences.forEach(function(preference){preference.FILTER_ROW=JSON.parse(preference.FILTER_ROW)});return preferences})};this.getFilters=function(query){return ZhPreferences.getPreferences("filter",query)};this.saveFilters=function(filters){var cloneFilters=filters.map(function(filter){return ZhUtil.clearRow(filter)});return ZhPreferences.savePreferences("filter",cloneFilters).then(function(response){cloneFilters.forEach(function(clone,index){filters[index].ID=clone.ID;filters[index].__is_new=clone.__is_new;filters[index].changes=clone.changed});return ZHPromise.when(response)})};this.deleteFilters=function(filters){var cloneFilters=filters.map(function(filter){return ZhUtil.clearRow(filter)});return ZhPreferences.deletePreferences("filter",cloneFilters)};function applyOriginalFilterRow(widget,filter){filter.FILTER_ROW=Util.clone(originalFilterRows[widget.id]||{})}this.applyOriginalFilter=function(widget){applyOriginalFilterRow(widget,originalFilter);return this.applyFilter(widget,originalFilter)};this.setOriginalFilter=function(widgetId,filter){originalFilterRows[widgetId]=Util.clone(filter)};this.getOriginalFilter=function(widgetId,widget){var clearedFilter=ZhUtil.clearRow(originalFilterRows[widgetId]||{});var originalFilter={ID:"ORIGINAL",LABEL_TO_PREFERENCE:"Original",FILTER_ROW:Util.clone(clearedFilter)};return originalFilter};function getFilterConditions(filters){return filters.filter(function(filter){return filter.name.indexOf("SEARCHLIST_")===-1}).map(function(filter){filter.isCustomFilter=true;return filter})}function getSearchConditions(filters){var searchFields=Util.clone(filters);searchFields=searchFields.filter(function(filter){return~filter.name.indexOf("SEARCHLIST_")});return searchFields.map(function(filter){filter.name=filter.name.replace("SEARCHLIST_","");return filter})}function triggerBeforeFilterApplyEvent(widget,preference){if(widget.beforeFilterApply){return widget.beforeFilterApply({preference:preference})}}function triggerAfterFilterApplyEvent(widget,preference,filters){if(widget.afterFilterApply){widget.afterFilterApply({preference:preference,filters:filters})}}function prepareFilterRow(preference){var filterRow=preference.FILTER_ROW||{};filterRow=typeof preference.FILTER_ROW==="string"?JSON.parse(preference.FILTER_ROW):preference.FILTER_ROW;preference.FILTER_ROW=filterRow}function applyFilterInFilterPopup(widget,filterRow){self.createFilterWidget(widget,filterRow)}function mergeFilters(baseFilters,newFilters){var result=baseFilters.concat(newFilters).reduce(function(prev,current,index){var fieldName=current.name;if(fieldName in prev.keys){var replaceIndex=prev.keys[fieldName];prev.filters[replaceIndex]=current}else{prev.keys[fieldName]=index;prev.filters.push(current)}return prev},{filters:[],keys:{}});return result.filters}function buildDataSourceFilter(widget,filters){var filterConditions=getFilterConditions(filters);var originalFilters=getOriginalDataSourceFilters(widget.dataSourceFilter);return mergeFilters(originalFilters,filterConditions)}function applyFilterInDataSource(widget,filters){widget.dataSourceFilter=buildDataSourceFilter(widget,filters);var searchConditions=getSearchConditions(filters);if(widget.setSearchCriteria){widget.setSearchCriteria(searchConditions)}return searchConditions}function setAppliedFilter(widget,preference){widget.appliedFilter=preference}function applyFilterInWidget(widget,fields,filterRow,preference){self.updateFilterInfo(widget,fields,filterRow,preference,{});setAppliedFilter(widget,preference)}this.applyFilter=function(widget,preference,reloadWidget){reloadWidget=reloadWidget!==false;prepareFilterRow(preference);var event;if(reloadWidget){event=triggerBeforeFilterApplyEvent(widget,preference)}var filterRow=preference.CUSTOM_FILTER_ROW||preference.FILTER_ROW;var fields=self.factoryFields(null,widget.fields).filter(function removeInvisibleFields(field){return field.isVisible});var filters=ZhFilterBuilder.buildFilter(fields,filterRow);if(reloadWidget){if(!event||!event.isDefaultPrevented()){var searchConditions=applyFilterInDataSource(widget,filters);var searchCriteria=buildSearchCriteria(searchConditions);return widget.reload(ZhUtil.getLikeAllFilter(widget,searchCriteria)).then(function(){if(widget.dataSource){widget.dataSource.clearCheckedRows()}applyFilterInWidget(widget,fields,filterRow,preference);triggerAfterFilterApplyEvent(widget,preference,filters);applyFilterInFilterPopup(widget,preference.FILTER_ROW);return ZHPromise.when()}.bind(this))}else{return ZHPromise.reject()}}else{applyFilterInDataSource(widget,filters);applyFilterInWidget(widget,fields,filterRow,preference);applyFilterInFilterPopup(widget,preference.FILTER_ROW);return ZHPromise.when()}};this.updateFilterInfo=function(widget,fields,filterRow,preference,searchCriteria){var filterInfo;var filterName=preference.LABEL_TO_PREFERENCE;if((preference.ID==="ORIGINAL"||preference.ID==="EDITED")&&!filterName||preference.forceBuild){filterInfo=ZhFilterDescriptionBuilder.buildFilterInfo(fields,filterRow,searchCriteria,widget)}else{filterInfo=ZhFilterDescriptionBuilder.buildFilterAppliedInfo(filterName)}widget._filterInfo=filterInfo};function trimPercentageSymbol(value){if(value.charAt(0)==="%"){value=value.substr(1)}if(value.charAt(value.length-1)==="%"){value=value.substr(0,value.length-1)}return value}function buildSearchCriteria(conditions){var searchCriteria={};conditions.forEach(function(condition){searchCriteria[condition.name]=trimPercentageSymbol(condition.value)});return searchCriteria}function getOriginalDataSourceFilters(dataSourceFilter){return dataSourceFilter.filter(function(filter){return!filter.isCustomFilter})}function removeConflictingProperties(field){var conflictingProperties=["selectWidget","bindedEvents"];conflictingProperties.forEach(function(property){delete field[property]})}function factoryFields(gridFields,editing){var cloneField=function(field){var fieldClone=self.cloneObj(field);if(editing){fieldClone.fieldGroup="FILTER_FIELDS"}fieldClone.dataSource=field.dataSource;fieldClone.dataSourceFilter=field.dataSourceFilter;return fieldClone};return gridFields.filter(function(field){return!Util.isUndefined(field.template)}).map(cloneField)}function factorySearchFields(gridFields){var factoredFields=[{id:"SEARCHLIST__ALL_MAP",label:"All fields",name:"SEARCHLIST__ALL_MAP",class:12,template:"field/text-edit.html",isVisible:true,showOnList:true,descending:true,fieldGroup:"MORE_FIELDS"}];var buildSearchListField=function(field){var fieldClone=self.cloneObj(field);fieldClone.id="SEARCHLIST_"+fieldClone.id;fieldClone.name="SEARCHLIST_"+fieldClone.name;fieldClone.class=6;fieldClone.isVisible=true;fieldClone.readOnly=false;fieldClone.validations={};fieldClone.template="field/text-edit.html";fieldClone.fieldGroup="MORE_FIELDS";return fieldClone};return factoredFields.concat(gridFields.filter(function(field){return!field.skipSearch&&Util.isUndefined(field.template)}).map(buildSearchListField))}function mergeFieldNewProperties(field,filterProperties){var keys=Object.keys(filterProperties);keys.forEach(function(property){field[property]=filterProperties[property]});if(field.dataSource&&!(field.dataSource instanceof DataSource)){field.dataSource=metaDataFactory.factoryDataSource(field.dataSource,field.dataSourceFilter,field)}delete field.filterProperties;return field}function removeEventListener(field,eventName,eventIndex){eventIndex=eventEngine.bindEvent(field,eventName);eventEngine.unbindEvent(field,eventName,eventIndex);eventIndex--;eventEngine.unbindEvent(field,eventName,eventIndex)}this.factoryFields=function(parentWidget,gridFields,editing){var fields=factoryFields(gridFields,editing);var searchFields=factorySearchFields(gridFields);var buildFilterProperties=function(field){if(field.filterProperties){field=mergeFieldNewProperties(field,field.filterProperties)}removeConflictingProperties(field);removeEventListener(field,"FieldOnChange");return metaDataFactory.fieldFactory(field,parentWidget)};return fields.concat(searchFields).map(buildFilterProperties)};this.downloadPreferenceFile=function(filter){var fileName=filter.LABEL_TO_PREFERENCE.latinise().replace(/[^a-z,0-9 ]/gi,"").replace(/(?:^\w|[A-Z]|\b\w|\s+)/g,function(match,index){if(+match===0)return"";return index==0?match.toLowerCase():match.toUpperCase()})+".filter";var filterToExport={ID:filter.ID,LABEL_TO_PREFERENCE:filter.LABEL_TO_PREFERENCE,WIDGET_ID:filter.WIDGET_ID,FILTER_ROW:ZhUtil.clearRow(filter.FILTER_ROW),LAST_MODIFIED_DATE:filter.LAST_MODIFIED_DATE};return ZhPreferences.downloadPreferenceFile(filterToExport,fileName)};this.validateFilterImport=function(filter,configWidget,filterDataSource){filterDataSource=filterDataSource||configWidget.dataSource.data;if(configWidget.listWidget.id!=filter.WIDGET_ID){MessageService.showMessageByCode("zh-filter-preferences#import_error_widget_id");return false}var filtersWithSameId=filterDataSource.filter(function(row){return row.ID==filter.ID});if(filtersWithSameId.length>0){MessageService.showMessageByCode("zh-filter-preferences#import_error_id_violation");return false}var filtersWithSameLabel=filterDataSource.filter(function(row){return row.LABEL_TO_PREFERENCE==filter.LABEL_TO_PREFERENCE});if(filtersWithSameLabel.length>0){MessageService.showMessageByCode("zh-filter-preferences#import_error_name_violation");return false}return true};function openFilterWidget(widget,rowToBeSet){return createFilterWidget(widget,rowToBeSet).then(function(widgetToBeShown){widget.activate();ScreenService.openPopup(widgetToBeShown)})}this.openFilterWidget=openFilterWidget;var filterWidgets={};function forceSelectDataSourceToLoad(field,row){var data=Util.getNestedProperty(field,["dataSource","data","length"]);var fieldName=field.valueField||field.name;var currentRow;var template=field.template.split("#").pop();if(template==="field/select-autocomplete.html"){currentRow=row[fieldName]}else{currentRow=row[field.name]}if(field.dataSource&&!data&&currentRow){field.dataSource.load([{name:fieldName,value:currentRow,operator:"IN"}])}}function forceFieldDataSourceToLoad(widget){widget.fields.forEach(function(field){forceSelectDataSourceToLoad(field,widget.currentRow)})}function createFilterWidget(widget,rowToBeSet){return ApplicationContext.ZhFilterCreateFilterConditionsController.getCreateFilterConditionsWidgetForFilterPopup(widget).then(function(filterWidget){if(!widget.filterInitialized){filterWidget.listWidget=widget;widget.filterInitialized=true}filterWidget.label=ScreenService.i18n("Filter");var currentRow=rowToBeSet||widget.filterRowData;if(!currentRow){currentRow=widget.appliedFilter?widget.appliedFilter.FILTER_ROW:{}}filterWidget.currentRow=filterWidget.currentRow||{};Object.keys(currentRow).forEach(function(fieldName){filterWidget.currentRow[fieldName]=ZhUtil.evaluate(currentRow[fieldName])});if(rowToBeSet){if(!widget.appliedFilter){widget.appliedFilter={ID:"CREATED"}}widget.appliedFilter.FILTER_ROW=filterWidget.currentRow}forceFieldDataSourceToLoad(filterWidget);filterWidget.actions[0].isVisible=true;filterWidget.actions[1].isVisible=true;filterWidget.actions[2].isVisible=false;filterWidget.actions[3].isVisible=false;filterWidgets[widget.id]=filterWidget;return ZHPromise.when(filterWidget)}.bind(this))}this.createFilterWidget=createFilterWidget;function isCopiable(object){var isCopiable=Util.isUndefinedOrNull(object);if(!isCopiable){var constr=object.constructor;var types=[String,Number,Array,Object,Boolean];isCopiable=types.some(function(type){return type().constructor===constr})}return isCopiable}this.cloneObj=function(object){var clone={};Object.keys(object).forEach(function(property){if(isCopiable(object[property])){clone[property]=ZhUtil.clearRow(object[property])}});return clone};function hasPopupOpened(){var isMobiScrollOpen=$(".mbsc-mobiscroll").length>0;return!ScreenService.isSideMenuOpen()&&!isMobiScrollOpen&&!ScreenService.isAlertShown()}function isFilterPreferencesActive(widget){return Util.get(widget,["floatingControl","customizationAction","filter"])!==false}function isSearchActionActive(widget){return Util.get(widget,["floatingControl","searchAction"])!==false}function openWidgetFilter(){var activeWidget=templateManager.container.getActiveWidget();if(hasPopupOpened()&&isFilterPreferencesActive(activeWidget)&&ZhPreferences.validateWidget(activeWidget)){openFilterWidget(activeWidget)}return false}function openWidgetSearch(){var activeWidget=templateManager.container.getActiveWidget();var searchIsEnabled=isFilterPreferencesActive(activeWidget)||isSearchActionActive(activeWidget);if(searchIsEnabled&&hasPopupOpened()&&ZhPreferences.validateWidget(activeWidget)){activeWidget.openSearchAction()}return false}templateManager.projectPromise.then(function(){templateManager.project.shortcutKeys=templateManager.project.shortcutKeys||{};var openFilterKey=templateManager.project.shortcutKeys.openWidgetFilter||"mod+l";var openSearchKey=templateManager.project.shortcutKeys.openWidgetSearch||"mod+f";ZhKeyboardService.unbind(openFilterKey);ZhKeyboardService.unbind(openSearchKey);ZhKeyboardService.bind(openFilterKey,openWidgetFilter);ZhKeyboardService.bind(openSearchKey,openWidgetSearch)})}Configuration(function(ContextRegister){ContextRegister.register("ZhFilterPreferences",ZhFilterPreferences)});var ZhFilterWidgetsBuilder=function(restEngine,templateManager,metaDataFactory,ZhFilterPreferences){var widgetsJson={};function getWidgetJSON(widgetName){var widgetPath="zh-filter-preferences#json/widgets/"+widgetName+".json";if(!widgetsJson[widgetPath]){widgetsJson[widgetPath]=restEngine.requestMetaData(widgetPath).then(function(response){return response.data})}return widgetsJson[widgetPath]}this.factoryWidget=function(widgetName){return getWidgetJSON(widgetName).then(function(widget){widget=Util.clone(widget);return metaDataFactory.widgetFactory(widget,templateManager.container)})};this.factoryFilterConfigurationWidget=function(){return this.factoryWidget("config")};this.factoryCreateFilterWidget=function(){return this.factoryWidget("createFilter")};this.factoryImportFilterWidget=function(){return this.factoryWidget("importFilter")};function copyFieldGroups(fieldGroups){var copiedObj=(fieldGroups||[]).map(function(fieldGroup){return Util.clone(fieldGroup,["__proto__","rows","widget"])});return copiedObj}function buildFilterWidgetFieldGroups(filterWidget,widget){var fieldGroups=(filterWidget.fieldGroups||[]).concat(copyFieldGroups(widget.fieldGroups));var moreFieldsFieldGroup=[];fieldGroups=fieldGroups.filter(function(fieldGroup){var isMoreFieldFieldGroup=fieldGroup.name==="MORE_FIELDS";if(isMoreFieldFieldGroup){moreFieldsFieldGroup=fieldGroup;moreFieldsFieldGroup.isVisible=!widget.hideMoreFieldsOnFilter}return!isMoreFieldFieldGroup});filterWidget.fieldGroups=fieldGroups.concat(moreFieldsFieldGroup)}this.factoryBuildFiltersConditionsWidget=function(baseWidget){return getWidgetJSON("createFilterConditions").then(function(widgetJson){widgetJson=Util.clone(widgetJson);widgetJson.id=baseWidget.id+"_filter";widgetJson.actions.forEach(function(action){action.id=baseWidget.id+"_filter_action_"+action.name});buildFilterWidgetFieldGroups(widgetJson,baseWidget);var widget=metaDataFactory.widgetFactory(widgetJson,templateManager.container);widget.fields=widget.fields.concat(ZhFilterPreferences.factoryFields(widget,baseWidget.fields));widget._filteredWidgetId=baseWidget.id;return widget})}};ZeedhiController.controller("ZhFilterWidgetsBuilder",ZhFilterWidgetsBuilder);Configuration(function(ContextRegister){ContextRegister.register("ZhFilterWidgetsBuilder",ZhFilterWidgetsBuilder)});var ZhFilterCreateFilterConditionsController=function(ZhFilterPreferences,ZhFilterWidgetsBuilder,MessageService,ScreenService,ZHPromise,ZhUtil,templateManager,$timeout){var createFilterConditionsWidgetPromise={};this.clearCachedFilterConditionsWidget=function(widget){if(widget&&widget.id){widget.filterInitialized=false;delete createFilterConditionsWidgetPromise[widget.id]}};this.getCreateFilterConditionsWidget=function(widget){var widgetId=widget.id;if(!createFilterConditionsWidgetPromise[widgetId]){createFilterConditionsWidgetPromise[widgetId]=ZhFilterWidgetsBuilder.factoryBuildFiltersConditionsWidget(widget)}return createFilterConditionsWidgetPromise[widgetId]};function saveFilterFields(widget){var allowedFields=widget.fields.map(function(field){return ZhFilterPreferences.cloneObj(field)});widget.__originalFilterStatus=allowedFields;widget.__originalCurrentRow=ZhFilterPreferences.cloneObj(ZhUtil.clearRow(widget.currentRow))}this.getCreateFilterConditionsWidgetForFilterPopup=function(widget){return this.getCreateFilterConditionsWidget(widget).then(function(createFilterConditionsWidget){createFilterConditionsWidget.actions[0].isVisible=true;createFilterConditionsWidget.actions[1].isVisible=true;createFilterConditionsWidget.actions[2].isVisible=false;createFilterConditionsWidget.actions[3].isVisible=false;var labelField=createFilterConditionsWidget.getField("LABEL_TO_PREFERENCE");if(labelField){labelField.isVisible=false}saveFilterFields(createFilterConditionsWidget);return createFilterConditionsWidget})};this.getCreateFilterConditionsWidgetForEditPreference=function(widget){return this.getCreateFilterConditionsWidget(widget).then(function(createFilterConditionsWidget){createFilterConditionsWidget.actions[0].isVisible=false;createFilterConditionsWidget.actions[1].isVisible=false;createFilterConditionsWidget.actions[2].isVisible=true;createFilterConditionsWidget.actions[3].isVisible=true;var labelField=createFilterConditionsWidget.getField("LABEL_TO_PREFERENCE");if(labelField){labelField.isVisible=true}saveFilterFields(createFilterConditionsWidget);return createFilterConditionsWidget})};this.saveAndApplyFilter=function(createFilterConditionsWidget){var clearRequiredFieldErrors=function(invalidFields){invalidFields.shift();invalidFields.forEach(function(invalidField){var fieldName;invalidField=invalidField.filter(function(invalidItem){fieldName=invalidItem.fieldName;return invalidItem.errorMessage!="Required field"});if(!invalidField.length){delete createFilterConditionsWidget.currentRow.$error[fieldName]}})};if(createFilterConditionsWidget.isValid(clearRequiredFieldErrors)){var currentRow=createFilterConditionsWidget.currentRow;var filter=createFilterConditionsWidget.preference;filter.LABEL_TO_PREFERENCE=currentRow.LABEL_TO_PREFERENCE;filter.FILTER_ROW=ZhUtil.clearRow(currentRow);delete filter.FILTER_ROW.LABEL_TO_PREFERENCE;filter.FILTER_ROW=JSON.stringify(filter.FILTER_ROW);var configWidget=createFilterConditionsWidget.configWidget;var listWidget=configWidget.listWidget;return ZhFilterPreferences.saveFilters([filter]).then(function(){filter.FILTER_ROW=JSON.parse(filter.FILTER_ROW);MessageService.successNotificationByCode("zh-filter-preferences#save_success");ScreenService.closePopup(true);if(createFilterConditionsWidget.isValid()){filter.forceBuild=true;listWidget.filterRowData=currentRow;ZhFilterPreferences.applyFilter(listWidget,filter);listWidget.activate()}else{listWidget.openFilterWidget(createFilterConditionsWidget.currentRow)}ZhFilterPreferences.updateFilters(listWidget.id,configWidget.dataSource)}).catch(function(error){MessageService.showMessageByCode("zh-filter-preferences#save_error",{ERROR:error.message})})}else{return ZHPromise.reject("Invalid params")}};function getRowToApply(appliedFilter,currentRow){var appliedRow=appliedFilter&&appliedFilter.FILTER_ROW||{};var row=ZhUtil.clearRow(currentRow);Object.keys(appliedRow).forEach(function(key){if(Util.isString(appliedRow[key])&&appliedRow[key].indexOf("@")===0){row[key]=appliedRow[key]}});return row}this.clearFilter=function(widget){widget.fields.filter(function(field){return!field.readOnly}).forEach(function(field){var template=field.template||"";field.clearValue(field);if(template.indexOf("field/checkbox.html")!==-1){widget.currentRow[field.name]=field.valueToFalse;field.checked=false;templateManager.updateTemplate()}else if(template.indexOf("field/select-native.html")!==-1){$timeout(function(){if(field.element){var dropdown=field.element.next();dropdown.find(".selected").removeClass("selected");dropdown.find(".current").text("")}})}if(field.change){field.change()}})};this.applyFilter=function(createFilterConditionsWidget,filterName){if(createFilterConditionsWidget.isValid()){var currentRow=createFilterConditionsWidget.currentRow;var listWidget=createFilterConditionsWidget.listWidget;delete currentRow.LABEL_TO_PREFERENCE;var filter={ID:"EDITED",FILTER_ROW:getRowToApply(listWidget.appliedFilter,currentRow)};if(filterName){filter.LABEL_TO_PREFERENCE=filterName}var applyFilterPromise=ZhFilterPreferences.applyFilter(listWidget,filter).catch(function(){ScreenService.openPopup(createFilterConditionsWidget);return ZHPromise.reject()});if(ScreenService.getPopupOpen()==createFilterConditionsWidget){ScreenService.closePopup(true);listWidget.activate()}return applyFilterPromise}else{if(ScreenService.getPopupOpen()!=createFilterConditionsWidget){ScreenService.openPopup(createFilterConditionsWidget)}return ZHPromise.reject()}};function restoreFilterFields(widget){if(widget.__originalFilterStatus){widget.fields.forEach(function(field,index){var __field=widget.__originalFilterStatus.filter(function(fieldOriginal){return fieldOriginal.name===field.name})[0];Object.keys(__field).forEach(function(key){widget.fields[index][key]=__field[key]})});widget.currentRow=widget.__originalCurrentRow;delete widget.__originalCurrentRow;delete widget.__originalFilterStatus}}this.closePopup=function(widget){restoreFilterFields(widget);ScreenService.closePopup();widget.listWidget.activate()}};ZeedhiController.controller("ZhFilterCreateFilterConditionsController",ZhFilterCreateFilterConditionsController);Configuration(function(ContextRegister){ContextRegister.register("ZhFilterCreateFilterConditionsController",ZhFilterCreateFilterConditionsController)});var ZhFilterImportFilterController=function(MessageService,ZhFilterPreferences,ZhPreferences,ZhFilterWidgetsBuilder,ZHPromise,ScreenService){var importFilterWidgetPromise=null;this.getImportFilterWidget=function(){if(importFilterWidgetPromise===null){importFilterWidgetPromise=ZhFilterWidgetsBuilder.factoryImportFilterWidget()}return importFilterWidgetPromise};this.importPreference=function(importFilterWidget){if(!importFilterWidget.isValid()){return ZHPromise.reject({err:"WIDGET_INVALID"})}var filterFileData=importFilterWidget.fields[0].value()[0].b64File;filterFileData=filterFileData.split("base64,")[1];filterFileData=window.atob(filterFileData);filterFileData=decodeURIComponent(escape(filterFileData));var filter=JSON.parse(filterFileData);var configWidget=importFilterWidget.configWidget;var listWidget=configWidget.listWidget;if(!ZhFilterPreferences.validateFilterImport(filter,configWidget)){return ZHPromise.reject({err:"FILTER_FILE_INVALID"})}filter.__is_new=true;filter.__generate_id=false;filter.FILTER_ROW=JSON.stringify(filter.FILTER_ROW);return ZhPreferences.getUserID().then(function(userID){filter.USER_ID=userID;return ZhFilterPreferences.saveFilters([filter]).then(function(){filter.FILTER_ROW=JSON.parse(filter.FILTER_ROW);ScreenService.closePopup();ZhFilterPreferences.updateFilters(listWidget.id,configWidget.dataSource);configWidget.refreshWidget()}).catch(function(error){MessageService.showMessageByCode("zh-filter-preferences#save_error",{ERROR:error.message})})})}};ZeedhiController.controller("ZhFilterImportFilterController",ZhFilterImportFilterController);Configuration(function(ContextRegister){ContextRegister.register("ZhFilterImportFilterController",ZhFilterImportFilterController)});var ZhFilterConfigWidgetController=function(ZhPreferences,ZhFilterPreferences,ZhFilterWidgetsBuilder,ScreenService,MessageService,ZHPromise,ZhFilterCreateFilterConditionsController,ZhFilterImportFilterController){var configWidgetPromise=null;this.getConfigWidget=function(listWidget,dataSource){if(configWidgetPromise===null){configWidgetPromise=ZhFilterWidgetsBuilder.factoryFilterConfigurationWidget()}var userID=ZhPreferences.getUserID();return ZHPromise.all([userID,configWidgetPromise]).then(function(args){var userID=args[0];var configWidget=args[1];configWidget.listWidget=listWidget;configWidget.dataSourceFilter=[{name:"WIDGET_ID",operator:"=",value:listWidget.id}];dataSource.data.forEach(function(row){row.APPLIED=row.ID==(listWidget.appliedFilter?listWidget.appliedFilter.ID:"ORIGINAL")});configWidget.dataSource=dataSource;return configWidget})};var hideMoreFields=function(groups,hide){var moreFieldsFieldGroup=[];return groups.filter(function(fieldGroup){delete fieldGroup.rows;var isMoreFieldFieldGroup=fieldGroup.name==="MORE_FIELDS";if(isMoreFieldFieldGroup){moreFieldsFieldGroup=fieldGroup;moreFieldsFieldGroup.isVisible=!hide}return!isMoreFieldFieldGroup}).concat(moreFieldsFieldGroup)};this.openCreateFilterWidget=function(configWidget){var label=configWidget.currentRow.LABEL_TO_PREFERENCE;return ZhFilterCreateFilterConditionsController.getCreateFilterConditionsWidgetForEditPreference(configWidget.listWidget).then(function(createFilterConditionsWidget){var listWidget=configWidget.listWidget;createFilterConditionsWidget.label=ScreenService.i18n("Filter");createFilterConditionsWidget.configWidget=configWidget;if(!listWidget.filterInitialized){var fieldGroups=(createFilterConditionsWidget.fieldGroups||[]).concat(listWidget.fieldGroups||[]);createFilterConditionsWidget.fieldGroups=fieldGroups;listWidget.filterInitialized=true}createFilterConditionsWidget.fieldGroups=hideMoreFields(createFilterConditionsWidget.fieldGroups,listWidget.hideMoreFieldsOnFilter);return ZhPreferences.getUserID().then(function(userID){var preference={__is_new:true,ID:null,USER_ID:userID,LABEL_TO_PREFERENCE:label,WIDGET_ID:listWidget.id,LAST_MODIFIED_DATE:null};createFilterConditionsWidget.preference=preference;var labelField=createFilterConditionsWidget.getField("LABEL_TO_PREFERENCE");var fields=ZhFilterPreferences.factoryFields(createFilterConditionsWidget,listWidget.fields,true);createFilterConditionsWidget.fields=[labelField].concat(fields);labelField.isVisible=true;createFilterConditionsWidget.newRow();return ScreenService.openPopup(createFilterConditionsWidget)})})};this.editFilter=function(configWidget,filter){if(filter.TYPE==="F"){MessageService.alertNotificationByCode("zh-filter-preferences#cannot_edit_fixed_filter");return ZHPromise.when()}var listWidget=configWidget.listWidget;return ZhFilterCreateFilterConditionsController.getCreateFilterConditionsWidgetForEditPreference(configWidget.listWidget).then(function(createFilterConditionsWidget){createFilterConditionsWidget.preference=filter;createFilterConditionsWidget.label=ScreenService.i18n("Filter")+" - "+filter.LABEL_TO_PREFERENCE;createFilterConditionsWidget.configWidget=configWidget;createFilterConditionsWidget.fieldGroups=hideMoreFields(createFilterConditionsWidget.fieldGroups||[],listWidget.hideMoreFieldsOnFilter);var labelField=createFilterConditionsWidget.getField("LABEL_TO_PREFERENCE");var fields=ZhFilterPreferences.factoryFields(createFilterConditionsWidget,listWidget.fields,true);createFilterConditionsWidget.fields=[labelField].concat(fields);labelField.isVisible=true;createFilterConditionsWidget.currentRow=filter.FILTER_ROW;createFilterConditionsWidget.currentRow.LABEL_TO_PREFERENCE=filter.LABEL_TO_PREFERENCE;return ScreenService.openPopup(createFilterConditionsWidget)})};this.deleteFilters=function(configWidget){var filtersToDelete=configWidget.getCheckedRows();var defaultFilter=filtersToDelete.filter(function(filter){return filter.DEFAULT_FILTER});if(defaultFilter.length){MessageService.showMessageByCode("zh-filter-preferences#delete_error_default");return}return MessageService.confirmMessageByCode("zh-filter-preferences#delete",{NR_OF_FILTERS:filtersToDelete.length}).then(function(){return ZhFilterPreferences.deleteFilters(filtersToDelete).then(function(){configWidget.dataSource.clearCheckedRows();return ZhFilterPreferences.updateFilters(configWidget.listWidget.id,configWidget.dataSource)}).catch(function(error){return MessageService.getMessageByCode("zh-filter-preferences#"+error.message).then(function(errorMessage){return MessageService.showMessageByCode("zh-filter-preferences#delete_error",{ERROR:ScreenService.i18n(errorMessage)})})})})};this.updateDefaultFilter=function(configWidget,filter){return ZhPreferences.changeDefaultPreferences(configWidget,"DEFAULT_FILTER",filter)};this.updateAppliedFilter=function(configWidget,filter){var listWidget=configWidget.listWidget;return ZhFilterPreferences.applyFilter(listWidget,filter).then(function(){configWidget.dataSource.data.forEach(function(row){row.APPLIED=row.ID==filter.ID})})};this.downloadPreferenceFile=function(filter){return ZhFilterPreferences.downloadPreferenceFile(filter)};this.importPreferenceFile=function(configWidget){return ZhFilterImportFilterController.getImportFilterWidget().then(function(importFilterWidget){importFilterWidget.newRow();importFilterWidget.configWidget=configWidget;return ScreenService.openPopup(importFilterWidget)})}};ZeedhiController.controller("ZhFilterConfigWidgetController",ZhFilterConfigWidgetController);Configuration(function(ContextRegister){ContextRegister.register("ZhFilterConfigWidgetController",ZhFilterConfigWidgetController)});var ZhFilterFloatingCardController=function($scope,ApplicationContext,templateManager,metaDataFactory,ScreenService,Query,eventEngine,ZHPromise,ZhUtil){var widget=$scope.widget;var ZhFilterPreferences=ApplicationContext.ZhFilterPreferences;var ZhPreferences=ApplicationContext.ZhPreferences;var ZhFilterConfigWidgetController=ApplicationContext.ZhFilterConfigWidgetController;var ZhFilterCreateFilterConditionsController=ApplicationContext.ZhFilterCreateFilterConditionsController;var filterWidget;var dataSource=metaDataFactory.factoryDataSource({name:"zh-filter-preferences#/filter",localStorage:false,lazyLoad:true,rest:true,data:[]});dataSource.afterLoadDataSource(function(){return ZhFilterPreferences.addIsDefaultFilterToFilters(dataSource.data,widget.id).then(function(filters){dataSource.data=filters.map(function(filter){filter.FILTER_ROW=JSON.parse(filter.FILTER_ROW);return filter})})});$scope.customizationCard={label:"Filters",type:"filter",openFilterConfiguration:openFilterConfiguration,refreshFilters:refreshFilters,openFilterWidget:openFilterWidget,applyOriginalFilter:applyOriginalFilter,applyFilter:applyPreference,dataSource:dataSource};ZhFilterPreferences.registerFilterDataSource(widget.id,$scope.customizationCard.dataSource);widget.openFilterWidget=openFilterWidget;widget.refreshFilters=refreshFilters;function updateFilterRow(filterRow,searchCriteria){var changed=false;filterRow=filterRow||{};Object.keys(searchCriteria).forEach(function(key){var name="SEARCHLIST_"+key;var filterValue=filterRow[name];if(!Util.isEmptyOrBlank(filterValue)&&searchCriteria[key]!==filterValue){changed=true}filterRow[name]=searchCriteria[key]});filterRow.changed=changed;return filterRow}$scope.$watchCollection("widget.searchCriteria",function(searchCriteria){if(ZhPreferences.validateWidget(widget)){var filterRow=widget.appliedFilter&&widget.appliedFilter.FILTER_ROW;filterRow=updateFilterRow(filterRow,searchCriteria||{});if(filterRow.changed){widget.appliedFilter={ID:"EDITED",FILTER_ROW:filterRow}}delete filterRow.changed;if(widget.appliedFilter){ZhFilterPreferences.updateFilterInfo(widget,widget.fields,filterRow,widget.appliedFilter,searchCriteria)}}});function openFilterConfiguration(){var dataSource=$scope.customizationCard.dataSource;return ZhFilterConfigWidgetController.getConfigWidget(widget,dataSource).then(function(configWidget){return ScreenService.openPopup(configWidget)})}function refreshFilters(){return ZhPreferences.getUserID().then(function(){var query=Query.build().where("WIDGET_ID").equals(widget.id);return dataSource.load(query.where())})}function openFilterWidget(rowToBeSet){return ZhFilterPreferences.openFilterWidget(widget,rowToBeSet)}function applyOriginalFilter(){return ZhFilterPreferences.applyOriginalFilter(widget)}function applyPreference(filter,reloadWidget){ZhFilterPreferences.applyFilter(widget,filter,reloadWidget)}function applyDefaultFilter(){var isLazyLoad=Util.getNestedProperty(widget,["dataSource","lazyLoad"]);ZhPreferences.getDefaultWidgetPreferences(widget.id).then(function(defaultPreference){var filter=defaultPreference.defaultFilter||ZhFilterPreferences.getOriginalFilter(widget.id);applyPreference(filter,!isLazyLoad)})}function getDataSourceFilterRow(){var filterRow={};(widget.dataSourceFilter||[]).filter(function removeCustoms(filter){return!filter.isCustomFilter}).forEach(function parseToFilterRow(filter){filterRow[filter.name]=filter.value});return filterRow}function initOriginalFilter(){var widgetId=widget.id;var filter=ZhFilterPreferences.getOriginalFilter(widgetId);if(Util.isEmptyObject(filter.FILTER_ROW)){var filterRow=getDataSourceFilterRow();widget.fields.forEach(function(field){var hasFilterDefaultValue=field.filterProperties&&field.filterProperties.hasOwnProperty("defaultValue");var defaultValue=hasFilterDefaultValue?field.filterProperties.defaultValue:field.defaultValue;if(!Util.isUndefinedOrNull(defaultValue)){filterRow[field.name]=defaultValue}});ZhFilterPreferences.setOriginalFilter(widgetId,filterRow)}}function isFilterPreferencesActive(activeWidget){return Util.get(activeWidget||widget,["floatingControl","customizationAction","filter"])!==false}$scope.$on("$destroy",function(){delete widget.openFilterWidget;delete widget.refreshFilters;delete dataSource.afterLoadDataSourcelistener});(function initFilterPreferences(){var filterIsActive=isFilterPreferencesActive();if(filterIsActive&&ZhPreferences.validateWidget(widget)&&Util.isUndefinedOrNull(widget.appliedFilter)&&widget.filterInitialized!==true&&widget.preventDefaultFilter!==true){initOriginalFilter();applyDefaultFilter()}})()};ZeedhiController.controller("ZhFilterFloatingCardController",ZhFilterFloatingCardController);var ZeedhiDirectives=angular.module("ZeedhiDirectives");ZeedhiDirectives.directive("zhFloatingControl",["$timeout","templateManager",ZhSearchFloatingControl]);function ZhSearchFloatingControl($timeout,templateManager){return{priority:10,link:function($scope,element,attrs,controller){var widget=$scope.widget;if(widget.floatingControl===false){return}var isFilterApplied=function(){return widget&&widget.appliedFilter&&Object.keys(widget.appliedFilter.FILTER_ROW).length>0};var defaultOptions={searchAction:Util.isUndefined(element.parent().attr("data-hide-search"))&&Util.isUndefined(element.parent().attr("hide-search")),openSearch:false};widget.floatingControl=Util.extend(defaultOptions,widget.floatingControl);var isFilterAppliedWithoutOriginal=function(){return widget._filterInfo&&widget._filterInfo.length>0&&widget.appliedFilter&&widget.appliedFilter.ID!="ORIGINAL"};widget.floatingControl.addStatus({priority:20,classString:"searching",icon:"more",conditionFunction:function(){return isFilterAppliedWithoutOriginal()},infoTemplate:function(){var hideFilterValue=templateManager.project.hideFilterValue||widget.hideFilterValue;var filterInfoValue=hideFilterValue?"</b> {{info.filterName}}":":</b> {{info.value}}";if(isFilterApplied()){widget.floatingControl.statuses[1].icon="search";if(widget.floatingControl.customizationAction&&widget.floatingControl.customizationAction.filter){icon="filter";method="openFilter"}else{icon="close-x";method="clearFilter"}return'<div data-zh-touchstart="'+method+'()"> <div class="searching-control-info"><span data-zh-icon="'+icon+' no-border icon-white"></span><div class="searching-control-info-details"><span ng-repeat="info in widget._filterInfo"><b>{{info.label|i18n}}'+filterInfoValue+'</span></div></div><div class="searching-control-info-text" data-zh-bind-translate="\'Filter applied\'"></div></div>'}widget.floatingControl.statuses[1].icon="more"},scope:$scope});if(templateManager.project.showEmptyFilter){widget.floatingControl.addStatus({priority:30,classString:"emptyFilter",icon:"more",conditionFunction:function(){return!isFilterAppliedWithoutOriginal()},infoTemplate:'<div data-zh-touchstart="openFilter()"> <div class="searching-control-info"><span data-zh-icon="filter no-border icon-white"></span></div><div class="searching-control-info-text"></div></div>',scope:$scope})}$scope.inputInitialized=false;$scope.openSearchAction=function(){$timeout.cancel($scope._closeTimeout);if(!element.hasClass("opened")){$scope.toggleActionMenu()}$scope.closeOpenedActions();var searchAction=element.find(".search-action").closest(".float-action");if(searchAction&&searchAction.length>0){searchAction.find("span.search-action-icon").click();var searchInput=searchAction.find("input");setTimeout(function(){Util.selectElement(searchInput)},100);if(!$scope.inputInitialized){$scope.inputInitialized=true;searchInput.on("keydown",function(e){if(e.keyCode===9&&widget.focusElement){widget.focusElement();e.preventDefault()}})}}};widget.openSearchAction=$scope.openSearchAction;$scope.$on("$destroy",function(){delete widget.openSearchAction;widget.floatingControl.statuses=[]});$scope.openFilter=function(){$scope.widget.openFilterWidget()};$scope.clearFilter=function(){$scope.widget.searchCriteria={}};$scope.clearSearch=function(event,fieldName){var filterRow=widget.appliedFilter&&widget.appliedFilter.FILTER_ROW||{};if(!fieldName){widget.searchCriteria={}}else{delete filterRow["SEARCHLIST_"+fieldName];delete widget.searchCriteria[fieldName]}if(event){Util.selectElement($(event.target).closest(".floating-card-input").find("input"))}};$scope.toggleSearchFieldsList=function(event){if(!widget.floatingControl.customizationAction||!widget.floatingControl.customizationAction.filter){var el=$(event.target).closest(".floating-card").find(".floating-card-search-field-select");el.toggleClass("opened");if(el.hasClass("opened")){$(event.target).closest(".floating-card").find(".floating-card-select-field-options").removeClass("opened");$(event.target).closest(".floating-card").find(".zh-select-search-floating").removeClass("opened")}}};$scope.selectSearchField=function(field){$scope.searchField=field;element.find(".floating-card-search-field-select").removeClass("opened");element.find("input.zh-input-search-floating").focus()};$scope.filterFields=function(field){return field.aclIsVisible&&!field.skipSearch&&(field.isVisible&&field.showOnList||field.showOnFilter)};$scope.getFields=function(widget){return(widget.fields||[]).filter($scope.filterFields)};if(widget.floatingControl.defaultSearchField){$scope.searchField=widget.getField(widget.floatingControl.defaultSearchField)}if(widget.floatingControl.openSearch){$timeout(widget.openSearchAction,0,false)}}}}ZeedhiDirectives.directive("zhFilterFloatingControl",[ZhFilterFloatingControl]);function ZhFilterFloatingControl(){return{priority:10,link:function($scope){$scope.toggleFilterPreferencesCard=function(e){var actionElement=$(e.target).closest(".float-action");if(!actionElement.hasClass("opened")){$scope.widget.refreshFilters()}$scope.togglePreferencesCard(e)}}}}(function(){window.templateUrls=window.templateUrls||[];window.metadataUrls=window.metadataUrls||[];window.serviceUrls=window.serviceUrls||[];var PACKAGE_NAME="zh-filter-preferences";var hasTemplateUrl=Boolean(window.templateUrls.find(function(value){return value.package===PACKAGE_NAME}));var hasMetadataUrl=Boolean(window.metadataUrls.find(function(value){return value.package===PACKAGE_NAME}));var hasServiceUrl=Boolean(window.serviceUrls.find(function(value){return value.package===PACKAGE_NAME}));if(!hasTemplateUrl){window.templateUrls.push({package:PACKAGE_NAME,baseUrl:"bower_components/zh-filter-preferences/dist/templates/"})}if(!hasMetadataUrl){window.metadataUrls.push({package:PACKAGE_NAME,baseUrl:"bower_components/zh-filter-preferences/dist/assets/"})}if(!hasServiceUrl){window.serviceUrls.push({package:PACKAGE_NAME,baseUrl:"../backend/service/index.php/zh-preferences"})}})();var LayoutUtilities={};LayoutUtilities.createDiffDataStructure=function createDiffDataStructure(container,widget,clearFields){var containerDiff={};var createWidgetsDataStructure=function createWidgetsDataStructure(widgetID,widgets,containerDiff){containerDiff.widgets=[];createWidgetsObjects(containerDiff.widgets,widgets,widgetID);if(Util.isArray(widgets)&&widgets.length>0){widgets.forEach(function(eachWidget){createWidgetsDataStructure(widgetID,eachWidget.widgets,getWidgetObjectByID(containerDiff.widgets,eachWidget.id))})}};var createWidgetsObjects=function createWidgetsObjects(widgetsDiff,widgetsArray,widgetID){if(Util.isArray(widgetsArray)&&widgetsArray.length>0){widgetsArray.forEach(function(eachWidget){var properties={id:eachWidget.id};if(eachWidget.id==widgetID){properties.fields=clearFields?[]:eachWidget.fields}widgetsDiff.push(properties)})}};var getWidgetObjectByID=function getWidgetObjectByID(widgets,widgetId){return widgets.filter(function(eachWidgetObject){return eachWidgetObject.id==widgetId}).shift()};createWidgetsDataStructure(widget.id,container.widgets,containerDiff);return containerDiff};function ZhLayoutPreferences(ZhPreferences,templateManager,eventAggregator,containerMerger,ZHPromise,eventEngine,ZhUtil,MessageService){var defaultOriginalLayout={ID:"ORIGINAL",USER_ID:0,ORGANIZATION_ID:0,LAYOUT_CHANGES:"{}",LABEL_TO_PREFERENCE:"Original"};function shouldShowLayoutAction(widget){return Util.get(widget,["floatingControl","customizationAction","layout"])!==false}eventAggregator.subscribe("beforeProjectStartup",function(){ZhPreferences.registerRepository("zh-layout-preferences#layout");templateManager.project.customFloatingActions.push({name:"Layout Action",label:"Layout",type:"layout",order:20,icon:"layout",template:"zh-layout-preferences#floating-layout-card.html",expandable:true,isVisible:shouldShowLayoutAction})});eventEngine.registerEvent("LayoutBeforeApply","beforeLayoutApply");eventEngine.registerEvent("LayoutAfterApply","afterLayoutApply");var layoutRegisteredDataSources={};this.registerLayoutDataSource=function(widgetID,dataSource){if(widgetID){layoutRegisteredDataSources[widgetID]=dataSource}return layoutRegisteredDataSources};this.updateLayouts=function(widgetID,dataSource){if(!dataSource){dataSource=layoutRegisteredDataSources[widgetID]}return this.getWidgetLayouts(widgetID).then(function(layouts){return layouts}).then(function(layouts){return this.addIsDefaultLayoutToLayouts(layouts,widgetID).then(function(layouts){dataSource.data=layouts})}.bind(this))};this.addIsDefaultLayoutToLayouts=function(layouts,widgetID){return ZhPreferences.getDefaultWidgetPreferences(widgetID).then(function(defaultPreferences){var defaultLayout=defaultPreferences.DEFAULT_LAYOUT;return layouts.map(addIsDefaultLayoutToLayout.bind(this,defaultLayout))})};function addIsDefaultLayoutToLayout(defaultLayout,layout){layout.DEFAULT_LAYOUT=layout.ID===defaultLayout;return layout}this.getWidgetLayouts=function(widgetID){return ZhPreferences.getWidgetPreferences("layout",widgetID)};this.getLayouts=function(query){return ZhPreferences.getPreferences("layout",query)};this.saveLayouts=function(layouts){var cloneLayouts=layouts.map(function(layout){return ZhUtil.clearRow(layout)});return ZhPreferences.savePreferences("layout",cloneLayouts).then(function(response){cloneLayouts.forEach(function(clone,index){layouts[index].ID=clone.ID;layouts[index].__is_new=clone.__is_new;layouts[index].changes=clone.changed});return ZHPromise.when(response)})};this.deleteLayouts=function(layouts){var cloneLayouts=layouts.map(function(layout){return ZhUtil.clearRow(layout)});return ZhPreferences.deletePreferences("layout",cloneLayouts)};function triggerBeforeLayoutApplyEvent(widget,layout){if(widget.beforeLayoutApply){widget.beforeLayoutApply({layout:layout})}}function triggerAfterLayoutApplyEvent(widget,layout){if(widget.afterLayoutApply){widget.afterLayoutApply({layout:layout})}}var appliedPreference={ID:"ORIGINAL"};this.applyOriginalLayout=function(widget){triggerBeforeLayoutApplyEvent(widget,defaultOriginalLayout);containerMerger.restore(widget,"ORIGINAL");widget.redraw();widget.setAppliedLayout(defaultOriginalLayout);appliedPreference=defaultOriginalLayout;triggerAfterLayoutApplyEvent(widget,defaultOriginalLayout);return ZHPromise.when()};this.applyLayout=function(widget,preference){triggerBeforeLayoutApplyEvent(widget,preference);if(widget.backupPDFOrientation===undefined){widget.backupPDFOrientation=widget.reportOrientation||"PORTRAIT"}widget.reportOrientation=preference.PDF_REPORT_ORIENTATION;var layoutChanges=prepareLayout(JSON.parse(preference.LAYOUT_CHANGES));containerMerger.merge(templateManager.container,layoutChanges,appliedPreference.ID);widget.redraw(true);widget.setAppliedLayout(preference);appliedPreference=preference;triggerAfterLayoutApplyEvent(widget,preference);return ZHPromise.when()};var propertyToBeVerified={container:["widgets"],widget:["widgets","fields"]};function prepareLayout(objToBeMerged,baseObject){baseObject=baseObject||templateManager.container;var childProperties=[];if(baseObject instanceof Container){childProperties=propertyToBeVerified.container}else if(baseObject instanceof Widget){childProperties=propertyToBeVerified.widget}childProperties.forEach(function prepareChildLayout(propertyName){var childBaseObj=baseObject[propertyName];var childObjToBeMerged=objToBeMerged[propertyName];if(childObjToBeMerged){if(childBaseObj&&childBaseObj.length){var existentIds=childBaseObj.map(function returnObjId(obj){return obj.id});objToBeMerged[propertyName]=childObjToBeMerged.filter(function filterChilds(obj){var objIndex=existentIds.indexOf(obj.id);if(objIndex!=-1){prepareLayout(obj,childBaseObj[objIndex])}return~objIndex})}else{objToBeMerged[propertyName]=[]}}});return objToBeMerged}this.downloadPreferenceFile=function(layout){var fileName=layout.LABEL_TO_PREFERENCE.latinise().replace(/[^a-z,0-9 ]/gi,"").replace(/(?:^\w|[A-Z]|\b\w|\s+)/g,function(match,index){if(+match===0)return"";return index==0?match.toLowerCase():match.toUpperCase()})+".layout";var layoutToExport={ID:layout.ID,LABEL_TO_PREFERENCE:layout.LABEL_TO_PREFERENCE,WIDGET_ID:layout.WIDGET_ID,PDF_REPORT_ORIENTATION:layout.PDF_REPORT_ORIENTATION,LAYOUT_CHANGES:JSON.parse(layout.LAYOUT_CHANGES),LAST_MODIFIED_DATE:layout.LAST_MODIFIED_DATE};return ZhPreferences.downloadPreferenceFile(layoutToExport,fileName)};this.validateLayoutImport=function(layout,configWidget,layoutDataSource){layoutDataSource=layoutDataSource||configWidget.dataSource.data;if(configWidget.listWidget.id!=layout.WIDGET_ID){MessageService.showMessageByCode("zh-layout-preferences#import_error_widget_id");return false}var layoutsWithSameId=layoutDataSource.filter(function(row){return row.ID==layout.ID});if(layoutsWithSameId.length>0){MessageService.showMessageByCode("zh-layout-preferences#import_error_id_violation");return false}var layoutsWithSameLabel=layoutDataSource.filter(function(row){return row.LABEL_TO_PREFERENCE==layout.LABEL_TO_PREFERENCE});if(layoutsWithSameLabel.length>0){MessageService.showMessageByCode("zh-layout-preferences#import_error_name_violation");return false}return true}}Configuration(function(ContextRegister){ContextRegister.register("ZhLayoutPreferences",ZhLayoutPreferences)});var ZhLayoutWidgetsBuilder=function(restEngine,templateManager,metaDataFactory){function getWidgetJSON(widgetName){var widgetPath="zh-layout-preferences#json/widgets/"+widgetName+".json";return restEngine.requestMetaData(widgetPath).then(function(response){return response.data})}this.factoryWidget=function(widgetName){return getWidgetJSON(widgetName).then(function(widget){return metaDataFactory.widgetFactory(widget,templateManager.container)})};this.factoryLayoutConfigurationWidget=function(){return this.factoryWidget("config")};this.factoryCreateLayoutWidget=function(){return this.factoryWidget("createLayout")};this.factoryImportLayoutWidget=function(){return this.factoryWidget("importLayout")};this.factoryBuildLayoutOptionsWidget=function(){return this.factoryWidget("createLayoutOptions")};this.factoryBuildLayoutFieldOptionsWidget=function(){return this.factoryWidget("createLayoutFieldOptions")}};ZeedhiController.controller("ZhLayoutWidgetsBuilder",ZhLayoutWidgetsBuilder);Configuration(function(ContextRegister){ContextRegister.register("ZhLayoutWidgetsBuilder",ZhLayoutWidgetsBuilder)});var ZhLayoutCreateLayoutOptionsController=function(MessageService,ZhLayoutPreferences,ScreenService,ZhLayoutWidgetsBuilder,metaDataFactory,ZHPromise){var fieldDefaultProperties={isVisible:true,showOnList:true,visibility:true,grouped:false,fixed:false};var createLayoutOptionsWidgetPromise=null;function removeConflictingProperties(field){var conflictingProperties=["selectWidget","inlineEditable"];conflictingProperties.forEach(function(property){delete field[property]})}function factoryFields(parentWidget,gridFields){return gridFields.filter(function(field){return!field.skipLayout&&!!field.label}).map(function(field){var factoredField=metaDataFactory.fieldFactory(field,parentWidget);removeConflictingProperties(factoredField);return factoredField})}this.getCreateLayoutOptionsWidget=function(preference,configWidget){if(createLayoutOptionsWidgetPromise===null){createLayoutOptionsWidgetPromise=ZhLayoutWidgetsBuilder.factoryBuildLayoutOptionsWidget()}return createLayoutOptionsWidgetPromise.then(function(layoutOptionsWidget){var label=preference.LABEL_TO_PREFERENCE;var listWidget=configWidget.listWidget;layoutOptionsWidget.listWidget=listWidget;layoutOptionsWidget.preference=preference;layoutOptionsWidget.label=ScreenService.i18n("Layout");if(label){layoutOptionsWidget.label=layoutOptionsWidget.label+" - "+label}layoutOptionsWidget.layoutName=label;layoutOptionsWidget.reportTitle=listWidget.label;layoutOptionsWidget.reportOrientation=preference.PDF_REPORT_ORIENTATION;layoutOptionsWidget.dataSource.data=Util.clone(listWidget.dataSource.data.slice(0,2));layoutOptionsWidget.fields=factoryFields(layoutOptionsWidget,listWidget.fields);var layoutChanges=JSON.parse(preference.LAYOUT_CHANGES);var widgetDifferences=getEditingWidgetPath(layoutChanges.widgets,listWidget);layoutOptionsWidget.fields=layoutOptionsWidget.fields.map(function(field,index){delete field.__isSelected;delete field.__leftActions;delete field.__notSelectable;delete field.__rightActions;if(!Util.isEmptyOrBlank(widgetDifferences.fields)){var fieldPreference=filterObject(widgetDifferences.fields,field.id,"id");if(fieldPreference.obj&&Object.keys(fieldPreference.obj).length){return Util.extend(field,fieldPreference.obj)}}return Util.extend(fieldDefaultProperties,field,true)});return layoutOptionsWidget})};this.saveAndApplyLayout=function(createLayoutOptionsWidget){if(createLayoutOptionsWidget.gridConfigWidget.isValid()){var configWidget=createLayoutOptionsWidget.createNewLayoutWidget.configWidget;var listWidget=configWidget.listWidget;var fields=getFieldEditingWidgetAsDataSource(createLayoutOptionsWidget);var layout=createLayoutOptionsWidget.preference;var layoutChanges=JSON.parse(layout.LAYOUT_CHANGES);var editingWidget=getEditingWidgetPath(layoutChanges.widgets,listWidget);editingWidget.fields=fields;layout.PDF_REPORT_ORIENTATION=createLayoutOptionsWidget.reportOrientation;layout.LABEL_TO_PREFERENCE=createLayoutOptionsWidget.layoutName;layout.LAYOUT_CHANGES=JSON.stringify(layoutChanges);return ZhLayoutPreferences.saveLayouts([layout]).then(function(layouts){return ZhLayoutPreferences.applyLayout(listWidget,layouts[0])}).then(function(){ScreenService.closePopup(true);ZhLayoutPreferences.updateLayouts(listWidget.id,configWidget.dataSource);listWidget.activate()}).catch(function(error){MessageService.showMessageByCode("zh-layout-preferences#save_error",{ERROR:error.message})})}else{return ZHPromise.reject("Invalid params")}};this.updateFieldVisibility=function(field){field.isVisible=true;field.showOnList=field.isVisibleOnReport=field.visibility};function getFieldEditingWidgetAsDataSource(listWidget){return listWidget.fields.map(function(field){var data={id:field.id,name:field.name,label:field.label,labelOnReport:field.labelOnReport||null,expression:field.expression||null,align:field.align||null,isVisible:field.isVisible,showOnList:field.showOnList,minWidth:field.gridColumnSize||null,maxWidth:field.gridColumnSize||null,gridColumnSize:field.gridColumnSize||null,reportColumnSize:field.reportColumnSize||null,isVisibleOnReport:field.isVisibleOnReport,sequenceInList:field.sequenceInList,visibility:field.isVisible&&field.showOnList,grouped:field.grouped||false,groupOpened:field.groupOpened,fixed:field.fixed||false,skipLayout:field.skipLayout||false};return data}).filter(function(field){return!field.skipLayout})}function getEditingWidgetPath(widgetsArray,listWidget){var foundWidget=getWidgetObjectByID(widgetsArray,listWidget.id);if(!foundWidget){widgetsArray.some(function(eachWidget){foundWidget=getEditingWidgetPath(eachWidget.widgets,listWidget);return foundWidget})}return foundWidget}function filterObject(obj,value,key){var filtered=obj.filter(function(preference){return preference[key]==value});var toReturn={};toReturn.index=obj.indexOf(filtered[0]);toReturn.obj=filtered[0];return toReturn}function getWidgetObjectByID(widgets,widgetID){return widgets.filter(function(eachWidgetObject){return eachWidgetObject.id==widgetID}).shift()}};ZeedhiController.controller("ZhLayoutCreateLayoutOptionsController",ZhLayoutCreateLayoutOptionsController);Configuration(function(ContextRegister){ContextRegister.register("ZhLayoutCreateLayoutOptionsController",ZhLayoutCreateLayoutOptionsController)});var ZhLayoutImportLayoutController=function(MessageService,ZhLayoutPreferences,ZhPreferences,ZhLayoutWidgetsBuilder,ZHPromise,ScreenService){var importLayoutWidgetPromise=null;this.getImportLayoutWidget=function(){if(importLayoutWidgetPromise===null){importLayoutWidgetPromise=ZhLayoutWidgetsBuilder.factoryImportLayoutWidget()}return importLayoutWidgetPromise};this.importPreference=function(importLayoutWidget){if(!importLayoutWidget.isValid()){return ZHPromise.reject({err:"WIDGET_INVALID"})}var layoutFileData=importLayoutWidget.fields[0].value()[0].b64File;layoutFileData=layoutFileData.split("base64,")[1];layoutFileData=window.atob(layoutFileData);layoutFileData=decodeURIComponent(escape(layoutFileData));var layout=JSON.parse(layoutFileData);var configWidget=importLayoutWidget.configWidget;var listWidget=configWidget.listWidget;if(!ZhLayoutPreferences.validateLayoutImport(layout,configWidget)){return ZHPromise.reject({err:"LAYOUT_FILE_INVALID"})}layout.__is_new=true;layout.__generate_id=false;layout.LAYOUT_CHANGES=JSON.stringify(layout.LAYOUT_CHANGES);return ZhPreferences.getUserID().then(function(userID){layout.USER_ID=userID;return ZhLayoutPreferences.saveLayouts([layout]).then(function(){ScreenService.closePopup();ZhLayoutPreferences.updateLayouts(listWidget.id,configWidget.dataSource);configWidget.refreshWidget()}).catch(function(error){MessageService.showMessageByCode("zh-layout-preferences#save_error",{ERROR:error.message})})})}};ZeedhiController.controller("ZhLayoutImportLayoutController",ZhLayoutImportLayoutController);Configuration(function(ContextRegister){ContextRegister.register("ZhLayoutImportLayoutController",ZhLayoutImportLayoutController)});var ZhLayoutConfigController=function(ZhPreferences,ZhLayoutPreferences,ZhLayoutWidgetsBuilder,ScreenService,MessageService,ZHPromise,$timeout,ZhLayoutCreateLayoutOptionsController,ZhLayoutImportLayoutController){var configWidgetPromise=null;this.getConfigWidget=function(listWidget,dataSource){if(configWidgetPromise===null){configWidgetPromise=ZhLayoutWidgetsBuilder.factoryLayoutConfigurationWidget()}var userID=ZhPreferences.getUserID();return ZHPromise.all([userID,configWidgetPromise]).then(function(args){var configWidget=args[1];configWidget.listWidget=listWidget;configWidget.dataSourceFilter=[{name:"WIDGET_ID",operator:"=",value:listWidget.id}];dataSource.data.forEach(function(row){row.APPLIED=row.ID==(listWidget.appliedLayout?listWidget.appliedLayout.ID:"ORIGINAL")});configWidget.dataSource=dataSource;return configWidget})};this.openCreateLayoutWidget=function(configWidget){var listWidget=configWidget.listWidget;var pdfReportOrientation=listWidget.reportOrientation||"PORTRAIT";return ZhPreferences.getUserID().then(function(userID){return{__is_new:true,ID:null,WIDGET_ID:listWidget.id,USER_ID:userID,LAYOUT_CHANGES:JSON.stringify(LayoutUtilities.createDiffDataStructure(listWidget.container,listWidget,true)),PDF_REPORT_ORIENTATION:pdfReportOrientation,LAST_MODIFIED_DATE:null}}).then(function(preference){return ZhLayoutCreateLayoutOptionsController.getCreateLayoutOptionsWidget(preference,configWidget).then(function(createLayoutOptionsWidget){createLayoutOptionsWidget.createNewLayoutWidget={configWidget:configWidget};$timeout(function(){ScreenService.openPopup(createLayoutOptionsWidget)})})})};this.editLayout=function(configWidget,layout){if(layout.TYPE==="F"){MessageService.alertNotificationByCode("zh-layout-preferences#cannot_edit_fixed_layout");return ZHPromise.when()}return ZhLayoutCreateLayoutOptionsController.getCreateLayoutOptionsWidget(layout,configWidget).then(function(createLayoutOptionsWidget){createLayoutOptionsWidget.createNewLayoutWidget={configWidget:configWidget};$timeout(function(){ScreenService.openPopup(createLayoutOptionsWidget)})})};this.deleteLayouts=function(configWidget){var layoutsToDelete=configWidget.getCheckedRows();var defaultLayout=layoutsToDelete.filter(function(layout){return layout.DEFAULT_LAYOUT});if(defaultLayout.length){MessageService.showMessageByCode("zh-layout-preferences#delete_error_default");return}return MessageService.confirmMessageByCode("zh-layout-preferences#delete",{NR_OF_LAYOUTS:layoutsToDelete.length}).then(function(){return ZhLayoutPreferences.deleteLayouts(layoutsToDelete).then(function(){configWidget.dataSource.clearCheckedRows();return ZhLayoutPreferences.updateLayouts(configWidget.listWidget.id,configWidget.dataSource)}).catch(function(error){return MessageService.getMessageByCode("zh-layout-preferences#"+error.message).then(function(errorMessage){return MessageService.showMessageByCode("zh-layout-preferences#delete_error",{ERROR:ScreenService.i18n(errorMessage)})})})})};this.updateDefaultLayout=function(configWidget,layout){return ZhPreferences.changeDefaultPreferences(configWidget,"DEFAULT_LAYOUT",layout)};this.updateAppliedLayout=function(configWidget,layout){var listWidget=configWidget.listWidget;return ZhLayoutPreferences.applyLayout(listWidget,layout).then(function(){configWidget.dataSource.data.forEach(function(row){row.APPLIED=row.ID==layout.ID})})};this.downloadPreferenceFile=function(layout){return ZhLayoutPreferences.downloadPreferenceFile(layout)};this.importPreferenceFile=function(configWidget){return ZhLayoutImportLayoutController.getImportLayoutWidget().then(function(importLayoutWidget){importLayoutWidget.newRow();importLayoutWidget.configWidget=configWidget;return ScreenService.openPopup(importLayoutWidget)})}};ZeedhiController.controller("ZhLayoutConfigController",ZhLayoutConfigController);Configuration(function(ContextRegister){ContextRegister.register("ZhLayoutConfigController",ZhLayoutConfigController)});var ZhLayoutFloatingCardController=function($scope,ApplicationContext,Query,ScreenService,metaDataFactory){var widget=$scope.widget;$scope.appliedPreference=null;var ZhLayoutPreferences=ApplicationContext.ZhLayoutPreferences;var ZhPreferences=ApplicationContext.ZhPreferences;var ZhLayoutConfigController=ApplicationContext.ZhLayoutConfigController;var fieldDefaultProperties={isVisible:true,showOnList:true,visibility:true,grouped:false,fixed:false};var dataSource=metaDataFactory.factoryDataSource({name:"zh-layout-preferences#/layout",localStorage:false,lazyLoad:true,rest:true,data:[]});dataSource.afterLoadDataSource(function(){return ZhLayoutPreferences.addIsDefaultLayoutToLayouts(dataSource.data,widget.id).then(function(layouts){dataSource.data=layouts})});$scope.customizationCard={label:"Layouts",type:"layout",openLayoutConfiguration:openLayoutConfiguration,refreshLayouts:refreshLayouts,applyOriginalLayout:applyOriginalLayout,applyLayout:applyPreference,dataSource:dataSource};ZhLayoutPreferences.registerLayoutDataSource(widget.id,$scope.customizationCard.dataSource);widget.setAppliedLayout=setAppliedLayout;$scope.$on("$destroy",function(){delete dataSource.afterLoadDataSourcelistener});function setAppliedLayout(layout){$scope.appliedPreference=layout;widget.appliedLayout=layout}function openLayoutConfiguration(){var dataSource=$scope.customizationCard.dataSource;return ZhLayoutConfigController.getConfigWidget(widget,dataSource).then(function(configWidget){return ScreenService.openPopup(configWidget)})}function refreshLayouts(){return ZhPreferences.getUserID().then(function(){var query=Query.build().where("WIDGET_ID").equals(widget.id);return $scope.customizationCard.dataSource.load(query.where())})}function applyOriginalLayout(){return ZhLayoutPreferences.applyOriginalLayout(widget)}function applyPreference(layout){return ZhLayoutPreferences.applyLayout(widget,layout)}function applyDefaultLayout(){ZhPreferences.getDefaultWidgetPreferences(widget.id).then(function(defaultPreference){if(defaultPreference.defaultLayout){applyPreference(defaultPreference.defaultLayout)}else{applyOriginalLayout()}})}(function initLayoutPreferences(){if(ZhPreferences.validateWidget(widget)){if(Util.isUndefinedOrNull(widget.appliedLayout)){applyDefaultLayout()}else{applyPreference(widget.appliedLayout)}}})()};ZeedhiController.controller("ZhLayoutFloatingCardController",ZhLayoutFloatingCardController);var ZeedhiDirectives=angular.module("ZeedhiDirectives");ZeedhiDirectives.directive("zhLayoutFloatingControl",[ZhLayoutFloatingControl]);function ZhLayoutFloatingControl(){return{priority:10,link:function($scope){$scope.toggleLayoutPreferencesCard=function(e){var actionElement=$(e.target).closest(".float-action");if(!actionElement.hasClass("opened")){$scope.customizationCard.refreshLayouts()}$scope.togglePreferencesCard(e)}}}}(function(){window.templateUrls=window.templateUrls||[];window.metadataUrls=window.metadataUrls||[];window.serviceUrls=window.serviceUrls||[];var PACKAGE_NAME="zh-layout-preferences";var hasTemplateUrl=Boolean(window.templateUrls.find(function(value){return value.package===PACKAGE_NAME}));var hasMetadataUrl=Boolean(window.metadataUrls.find(function(value){return value.package===PACKAGE_NAME}));var hasServiceUrl=Boolean(window.serviceUrls.find(function(value){return value.package===PACKAGE_NAME}));if(!hasTemplateUrl){window.templateUrls.push({package:PACKAGE_NAME,baseUrl:"bower_components/zh-layout-preferences/dist/templates/"})}if(!hasMetadataUrl){window.metadataUrls.push({package:PACKAGE_NAME,baseUrl:"bower_components/zh-layout-preferences/dist/assets/"})}if(!hasServiceUrl){window.serviceUrls.push({package:PACKAGE_NAME,baseUrl:"../backend/service/index.php/zh-preferences"})}})();(function(global,factory){typeof exports==="object"&&typeof module!=="undefined"?module.exports=factory():typeof define==="function"&&define.amd?define(factory):(global=global||self,global.Sortable=factory())})(this,function(){"use strict";function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);if(enumerableOnly){symbols=symbols.filter(function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable})}keys.push.apply(keys,symbols)}return keys}function _objectSpread2(target){for(var i=1;i<arguments.length;i++){var source=arguments[i]!=null?arguments[i]:{};if(i%2){ownKeys(Object(source),true).forEach(function(key){_defineProperty(target,key,source[key])})}else if(Object.getOwnPropertyDescriptors){Object.defineProperties(target,Object.getOwnPropertyDescriptors(source))}else{ownKeys(Object(source)).forEach(function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key))})}}return target}function _typeof(obj){"@babel/helpers - typeof";if(typeof Symbol==="function"&&typeof Symbol.iterator==="symbol"){_typeof=function(obj){return typeof obj}}else{_typeof=function(obj){return obj&&typeof Symbol==="function"&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj}}return _typeof(obj)}function _defineProperty(obj,key,value){if(key in obj){Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true})}else{obj[key]=value}return obj}function _extends(){_extends=Object.assign||function(target){for(var i=1;i<arguments.length;i++){var source=arguments[i];for(var key in source){if(Object.prototype.hasOwnProperty.call(source,key)){target[key]=source[key]}}}return target};return _extends.apply(this,arguments)}function _objectWithoutPropertiesLoose(source,excluded){if(source==null)return{};var target={};var sourceKeys=Object.keys(source);var key,i;for(i=0;i<sourceKeys.length;i++){key=sourceKeys[i];if(excluded.indexOf(key)>=0)continue;target[key]=source[key]}return target}function _objectWithoutProperties(source,excluded){if(source==null)return{};var target=_objectWithoutPropertiesLoose(source,excluded);var key,i;if(Object.getOwnPropertySymbols){var sourceSymbolKeys=Object.getOwnPropertySymbols(source);for(i=0;i<sourceSymbolKeys.length;i++){key=sourceSymbolKeys[i];if(excluded.indexOf(key)>=0)continue;if(!Object.prototype.propertyIsEnumerable.call(source,key))continue;target[key]=source[key]}}return target}function _toConsumableArray(arr){return _arrayWithoutHoles(arr)||_iterableToArray(arr)||_unsupportedIterableToArray(arr)||_nonIterableSpread()}function _arrayWithoutHoles(arr){if(Array.isArray(arr))return _arrayLikeToArray(arr)}function _iterableToArray(iter){if(typeof Symbol!=="undefined"&&iter[Symbol.iterator]!=null||iter["@@iterator"]!=null)return Array.from(iter)}function _unsupportedIterableToArray(o,minLen){if(!o)return;if(typeof o==="string")return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);if(n==="Object"&&o.constructor)n=o.constructor.name;if(n==="Map"||n==="Set")return Array.from(o);if(n==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}function _arrayLikeToArray(arr,len){if(len==null||len>arr.length)len=arr.length;for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}function _nonIterableSpread(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var version="1.15.0";function userAgent(pattern){if(typeof window!=="undefined"&&window.navigator){return!!navigator.userAgent.match(pattern)}}var IE11OrLess=userAgent(/(?:Trident.*rv[ :]?11\.|msie|iemobile|Windows Phone)/i);var Edge=userAgent(/Edge/i);var FireFox=userAgent(/firefox/i);var Safari=userAgent(/safari/i)&&!userAgent(/chrome/i)&&!userAgent(/android/i);var IOS=userAgent(/iP(ad|od|hone)/i);var ChromeForAndroid=userAgent(/chrome/i)&&userAgent(/android/i);var captureMode={capture:false,passive:false};function on(el,event,fn){el.addEventListener(event,fn,!IE11OrLess&&captureMode)}function off(el,event,fn){el.removeEventListener(event,fn,!IE11OrLess&&captureMode)}function matches(el,selector){if(!selector)return;selector[0]===">"&&(selector=selector.substring(1));if(el){try{if(el.matches){return el.matches(selector)}else if(el.msMatchesSelector){return el.msMatchesSelector(selector)}else if(el.webkitMatchesSelector){return el.webkitMatchesSelector(selector)}}catch(_){return false}}return false}function getParentOrHost(el){return el.host&&el!==document&&el.host.nodeType?el.host:el.parentNode}function closest(el,selector,ctx,includeCTX){if(el){ctx=ctx||document;do{if(selector!=null&&(selector[0]===">"?el.parentNode===ctx&&matches(el,selector):matches(el,selector))||includeCTX&&el===ctx){return el}if(el===ctx)break}while(el=getParentOrHost(el))}return null}var R_SPACE=/\s+/g;function toggleClass(el,name,state){if(el&&name){if(el.classList){el.classList[state?"add":"remove"](name)}else{var className=(" "+el.className+" ").replace(R_SPACE," ").replace(" "+name+" "," ");el.className=(className+(state?" "+name:"")).replace(R_SPACE," ")}}}function css(el,prop,val){var style=el&&el.style;if(style){if(val===void 0){if(document.defaultView&&document.defaultView.getComputedStyle){val=document.defaultView.getComputedStyle(el,"")}else if(el.currentStyle){val=el.currentStyle}return prop===void 0?val:val[prop]}else{if(!(prop in style)&&prop.indexOf("webkit")===-1){prop="-webkit-"+prop}style[prop]=val+(typeof val==="string"?"":"px")}}}function matrix(el,selfOnly){var appliedTransforms="";if(typeof el==="string"){appliedTransforms=el}else{do{var transform=css(el,"transform");if(transform&&transform!=="none"){appliedTransforms=transform+" "+appliedTransforms}}while(!selfOnly&&(el=el.parentNode))}var matrixFn=window.DOMMatrix||window.WebKitCSSMatrix||window.CSSMatrix||window.MSCSSMatrix;return matrixFn&&new matrixFn(appliedTransforms)}function find(ctx,tagName,iterator){if(ctx){var list=ctx.getElementsByTagName(tagName),i=0,n=list.length;if(iterator){for(;i<n;i++){iterator(list[i],i)}}return list}return[]}function getWindowScrollingElement(){var scrollingElement=document.scrollingElement;if(scrollingElement){return scrollingElement}else{return document.documentElement}}function getRect(el,relativeToContainingBlock,relativeToNonStaticParent,undoScale,container){if(!el.getBoundingClientRect&&el!==window)return;var elRect,top,left,bottom,right,height,width;if(el!==window&&el.parentNode&&el!==getWindowScrollingElement()){elRect=el.getBoundingClientRect();top=elRect.top;left=elRect.left;bottom=elRect.bottom;right=elRect.right;height=elRect.height;width=elRect.width}else{top=0;left=0;bottom=window.innerHeight;right=window.innerWidth;height=window.innerHeight;width=window.innerWidth}if((relativeToContainingBlock||relativeToNonStaticParent)&&el!==window){container=container||el.parentNode;if(!IE11OrLess){do{if(container&&container.getBoundingClientRect&&(css(container,"transform")!=="none"||relativeToNonStaticParent&&css(container,"position")!=="static")){var containerRect=container.getBoundingClientRect();top-=containerRect.top+parseInt(css(container,"border-top-width"));left-=containerRect.left+parseInt(css(container,"border-left-width"));bottom=top+elRect.height;right=left+elRect.width;break}}while(container=container.parentNode)}}if(undoScale&&el!==window){var elMatrix=matrix(container||el),scaleX=elMatrix&&elMatrix.a,scaleY=elMatrix&&elMatrix.d;if(elMatrix){top/=scaleY;left/=scaleX;width/=scaleX;height/=scaleY;bottom=top+height;right=left+width}}return{top:top,left:left,bottom:bottom,right:right,width:width,height:height}}function isScrolledPast(el,elSide,parentSide){var parent=getParentAutoScrollElement(el,true),elSideVal=getRect(el)[elSide];while(parent){var parentSideVal=getRect(parent)[parentSide],visible=void 0;if(parentSide==="top"||parentSide==="left"){visible=elSideVal>=parentSideVal}else{visible=elSideVal<=parentSideVal}if(!visible)return parent;if(parent===getWindowScrollingElement())break;parent=getParentAutoScrollElement(parent,false)}return false}function getChild(el,childNum,options,includeDragEl){var currentChild=0,i=0,children=el.children;while(i<children.length){if(children[i].style.display!=="none"&&children[i]!==Sortable.ghost&&(includeDragEl||children[i]!==Sortable.dragged)&&closest(children[i],options.draggable,el,false)){if(currentChild===childNum){return children[i]}currentChild++}i++}return null}function lastChild(el,selector){var last=el.lastElementChild;while(last&&(last===Sortable.ghost||css(last,"display")==="none"||selector&&!matches(last,selector))){last=last.previousElementSibling}return last||null}function index(el,selector){var index=0;if(!el||!el.parentNode){return-1}while(el=el.previousElementSibling){if(el.nodeName.toUpperCase()!=="TEMPLATE"&&el!==Sortable.clone&&(!selector||matches(el,selector))){index++}}return index}function getRelativeScrollOffset(el){var offsetLeft=0,offsetTop=0,winScroller=getWindowScrollingElement();if(el){do{var elMatrix=matrix(el),scaleX=elMatrix.a,scaleY=elMatrix.d;offsetLeft+=el.scrollLeft*scaleX;offsetTop+=el.scrollTop*scaleY}while(el!==winScroller&&(el=el.parentNode))}return[offsetLeft,offsetTop]}function indexOfObject(arr,obj){for(var i in arr){if(!arr.hasOwnProperty(i))continue;for(var key in obj){if(obj.hasOwnProperty(key)&&obj[key]===arr[i][key])return Number(i)}}return-1}function getParentAutoScrollElement(el,includeSelf){if(!el||!el.getBoundingClientRect)return getWindowScrollingElement();var elem=el;var gotSelf=false;do{if(elem.clientWidth<elem.scrollWidth||elem.clientHeight<elem.scrollHeight){var elemCSS=css(elem);if(elem.clientWidth<elem.scrollWidth&&(elemCSS.overflowX=="auto"||elemCSS.overflowX=="scroll")||elem.clientHeight<elem.scrollHeight&&(elemCSS.overflowY=="auto"||elemCSS.overflowY=="scroll")){if(!elem.getBoundingClientRect||elem===document.body)return getWindowScrollingElement();if(gotSelf||includeSelf)return elem;gotSelf=true}}}while(elem=elem.parentNode);return getWindowScrollingElement()}function extend(dst,src){if(dst&&src){for(var key in src){if(src.hasOwnProperty(key)){dst[key]=src[key]}}}return dst}function isRectEqual(rect1,rect2){return Math.round(rect1.top)===Math.round(rect2.top)&&Math.round(rect1.left)===Math.round(rect2.left)&&Math.round(rect1.height)===Math.round(rect2.height)&&Math.round(rect1.width)===Math.round(rect2.width)}var _throttleTimeout;function throttle(callback,ms){return function(){if(!_throttleTimeout){var args=arguments,_this=this;if(args.length===1){callback.call(_this,args[0])}else{callback.apply(_this,args)}_throttleTimeout=setTimeout(function(){_throttleTimeout=void 0},ms)}}}function cancelThrottle(){clearTimeout(_throttleTimeout);_throttleTimeout=void 0}function scrollBy(el,x,y){el.scrollLeft+=x;el.scrollTop+=y}function clone(el){var Polymer=window.Polymer;var $=window.jQuery||window.Zepto;if(Polymer&&Polymer.dom){return Polymer.dom(el).cloneNode(true)}else if($){return $(el).clone(true)[0]}else{return el.cloneNode(true)}}function setRect(el,rect){css(el,"position","absolute");css(el,"top",rect.top);css(el,"left",rect.left);css(el,"width",rect.width);css(el,"height",rect.height)}function unsetRect(el){css(el,"position","");css(el,"top","");css(el,"left","");css(el,"width","");css(el,"height","")}var expando="Sortable"+(new Date).getTime();function AnimationStateManager(){var animationStates=[],animationCallbackId;return{captureAnimationState:function captureAnimationState(){animationStates=[];if(!this.options.animation)return;var children=[].slice.call(this.el.children);children.forEach(function(child){if(css(child,"display")==="none"||child===Sortable.ghost)return;animationStates.push({target:child,rect:getRect(child)});var fromRect=_objectSpread2({},animationStates[animationStates.length-1].rect);if(child.thisAnimationDuration){var childMatrix=matrix(child,true);if(childMatrix){fromRect.top-=childMatrix.f;fromRect.left-=childMatrix.e}}child.fromRect=fromRect})},addAnimationState:function addAnimationState(state){animationStates.push(state)},removeAnimationState:function removeAnimationState(target){animationStates.splice(indexOfObject(animationStates,{target:target}),1)},animateAll:function animateAll(callback){var _this=this;if(!this.options.animation){clearTimeout(animationCallbackId);if(typeof callback==="function")callback();return}var animating=false,animationTime=0;animationStates.forEach(function(state){var time=0,target=state.target,fromRect=target.fromRect,toRect=getRect(target),prevFromRect=target.prevFromRect,prevToRect=target.prevToRect,animatingRect=state.rect,targetMatrix=matrix(target,true);if(targetMatrix){toRect.top-=targetMatrix.f;toRect.left-=targetMatrix.e}target.toRect=toRect;if(target.thisAnimationDuration){if(isRectEqual(prevFromRect,toRect)&&!isRectEqual(fromRect,toRect)&&(animatingRect.top-toRect.top)/(animatingRect.left-toRect.left)===(fromRect.top-toRect.top)/(fromRect.left-toRect.left)){time=calculateRealTime(animatingRect,prevFromRect,prevToRect,_this.options)}}if(!isRectEqual(toRect,fromRect)){target.prevFromRect=fromRect;target.prevToRect=toRect;if(!time){time=_this.options.animation}_this.animate(target,animatingRect,toRect,time)}if(time){animating=true;animationTime=Math.max(animationTime,time);clearTimeout(target.animationResetTimer);target.animationResetTimer=setTimeout(function(){target.animationTime=0;target.prevFromRect=null;target.fromRect=null;target.prevToRect=null;target.thisAnimationDuration=null},time);target.thisAnimationDuration=time}});clearTimeout(animationCallbackId);if(!animating){if(typeof callback==="function")callback()}else{animationCallbackId=setTimeout(function(){if(typeof callback==="function")callback()},animationTime)}animationStates=[]},animate:function animate(target,currentRect,toRect,duration){if(duration){css(target,"transition","");css(target,"transform","");var elMatrix=matrix(this.el),scaleX=elMatrix&&elMatrix.a,scaleY=elMatrix&&elMatrix.d,translateX=(currentRect.left-toRect.left)/(scaleX||1),translateY=(currentRect.top-toRect.top)/(scaleY||1);target.animatingX=!!translateX;target.animatingY=!!translateY;css(target,"transform","translate3d("+translateX+"px,"+translateY+"px,0)");this.forRepaintDummy=repaint(target);css(target,"transition","transform "+duration+"ms"+(this.options.easing?" "+this.options.easing:""));css(target,"transform","translate3d(0,0,0)");typeof target.animated==="number"&&clearTimeout(target.animated);target.animated=setTimeout(function(){css(target,"transition","");css(target,"transform","");target.animated=false;target.animatingX=false;target.animatingY=false},duration)}}}}function repaint(target){return target.offsetWidth}function calculateRealTime(animatingRect,fromRect,toRect,options){return Math.sqrt(Math.pow(fromRect.top-animatingRect.top,2)+Math.pow(fromRect.left-animatingRect.left,2))/Math.sqrt(Math.pow(fromRect.top-toRect.top,2)+Math.pow(fromRect.left-toRect.left,2))*options.animation}var plugins=[];var defaults={initializeByDefault:true};var PluginManager={mount:function mount(plugin){for(var option in defaults){if(defaults.hasOwnProperty(option)&&!(option in plugin)){plugin[option]=defaults[option]}}plugins.forEach(function(p){if(p.pluginName===plugin.pluginName){throw"Sortable: Cannot mount plugin ".concat(plugin.pluginName," more than once")}});plugins.push(plugin)},pluginEvent:function pluginEvent(eventName,sortable,evt){var _this=this;this.eventCanceled=false;evt.cancel=function(){_this.eventCanceled=true};var eventNameGlobal=eventName+"Global";plugins.forEach(function(plugin){if(!sortable[plugin.pluginName])return;if(sortable[plugin.pluginName][eventNameGlobal]){sortable[plugin.pluginName][eventNameGlobal](_objectSpread2({sortable:sortable},evt))}if(sortable.options[plugin.pluginName]&&sortable[plugin.pluginName][eventName]){sortable[plugin.pluginName][eventName](_objectSpread2({sortable:sortable},evt))}})},initializePlugins:function initializePlugins(sortable,el,defaults,options){plugins.forEach(function(plugin){var pluginName=plugin.pluginName;if(!sortable.options[pluginName]&&!plugin.initializeByDefault)return;var initialized=new plugin(sortable,el,sortable.options);initialized.sortable=sortable;initialized.options=sortable.options;sortable[pluginName]=initialized;_extends(defaults,initialized.defaults)});for(var option in sortable.options){if(!sortable.options.hasOwnProperty(option))continue;var modified=this.modifyOption(sortable,option,sortable.options[option]);if(typeof modified!=="undefined"){sortable.options[option]=modified}}},getEventProperties:function getEventProperties(name,sortable){var eventProperties={};plugins.forEach(function(plugin){if(typeof plugin.eventProperties!=="function")return;_extends(eventProperties,plugin.eventProperties.call(sortable[plugin.pluginName],name))});return eventProperties},modifyOption:function modifyOption(sortable,name,value){var modifiedValue;plugins.forEach(function(plugin){if(!sortable[plugin.pluginName])return;if(plugin.optionListeners&&typeof plugin.optionListeners[name]==="function"){modifiedValue=plugin.optionListeners[name].call(sortable[plugin.pluginName],value)}});return modifiedValue}};function dispatchEvent(_ref){var sortable=_ref.sortable,rootEl=_ref.rootEl,name=_ref.name,targetEl=_ref.targetEl,cloneEl=_ref.cloneEl,toEl=_ref.toEl,fromEl=_ref.fromEl,oldIndex=_ref.oldIndex,newIndex=_ref.newIndex,oldDraggableIndex=_ref.oldDraggableIndex,newDraggableIndex=_ref.newDraggableIndex,originalEvent=_ref.originalEvent,putSortable=_ref.putSortable,extraEventProperties=_ref.extraEventProperties;sortable=sortable||rootEl&&rootEl[expando];if(!sortable)return;var evt,options=sortable.options,onName="on"+name.charAt(0).toUpperCase()+name.substr(1);if(window.CustomEvent&&!IE11OrLess&&!Edge){evt=new CustomEvent(name,{bubbles:true,cancelable:true})}else{evt=document.createEvent("Event");evt.initEvent(name,true,true)}evt.to=toEl||rootEl;evt.from=fromEl||rootEl;evt.item=targetEl||rootEl;evt.clone=cloneEl;evt.oldIndex=oldIndex;evt.newIndex=newIndex;evt.oldDraggableIndex=oldDraggableIndex;evt.newDraggableIndex=newDraggableIndex;evt.originalEvent=originalEvent;evt.pullMode=putSortable?putSortable.lastPutMode:undefined;var allEventProperties=_objectSpread2(_objectSpread2({},extraEventProperties),PluginManager.getEventProperties(name,sortable));for(var option in allEventProperties){evt[option]=allEventProperties[option]}if(rootEl){rootEl.dispatchEvent(evt)}if(options[onName]){options[onName].call(sortable,evt)}}var _excluded=["evt"];var pluginEvent=function pluginEvent(eventName,sortable){var _ref=arguments.length>2&&arguments[2]!==undefined?arguments[2]:{},originalEvent=_ref.evt,data=_objectWithoutProperties(_ref,_excluded);PluginManager.pluginEvent.bind(Sortable)(eventName,sortable,_objectSpread2({dragEl:dragEl,parentEl:parentEl,ghostEl:ghostEl,rootEl:rootEl,nextEl:nextEl,lastDownEl:lastDownEl,cloneEl:cloneEl,cloneHidden:cloneHidden,dragStarted:moved,putSortable:putSortable,activeSortable:Sortable.active,originalEvent:originalEvent,oldIndex:oldIndex,oldDraggableIndex:oldDraggableIndex,newIndex:newIndex,newDraggableIndex:newDraggableIndex,hideGhostForTarget:_hideGhostForTarget,unhideGhostForTarget:_unhideGhostForTarget,cloneNowHidden:function cloneNowHidden(){cloneHidden=true},cloneNowShown:function cloneNowShown(){cloneHidden=false},dispatchSortableEvent:function dispatchSortableEvent(name){_dispatchEvent({sortable:sortable,name:name,originalEvent:originalEvent})}},data))};function _dispatchEvent(info){dispatchEvent(_objectSpread2({putSortable:putSortable,cloneEl:cloneEl,targetEl:dragEl,rootEl:rootEl,oldIndex:oldIndex,oldDraggableIndex:oldDraggableIndex,newIndex:newIndex,newDraggableIndex:newDraggableIndex},info))}var dragEl,parentEl,ghostEl,rootEl,nextEl,lastDownEl,cloneEl,cloneHidden,oldIndex,newIndex,oldDraggableIndex,newDraggableIndex,activeGroup,putSortable,awaitingDragStarted=false,ignoreNextClick=false,sortables=[],tapEvt,touchEvt,lastDx,lastDy,tapDistanceLeft,tapDistanceTop,moved,lastTarget,lastDirection,pastFirstInvertThresh=false,isCircumstantialInvert=false,targetMoveDistance,ghostRelativeParent,ghostRelativeParentInitialScroll=[],_silent=false,savedInputChecked=[];var documentExists=typeof document!=="undefined",PositionGhostAbsolutely=IOS,CSSFloatProperty=Edge||IE11OrLess?"cssFloat":"float",supportDraggable=documentExists&&!ChromeForAndroid&&!IOS&&"draggable"in document.createElement("div"),supportCssPointerEvents=function(){if(!documentExists)return;if(IE11OrLess){return false}var el=document.createElement("x");el.style.cssText="pointer-events:auto";return el.style.pointerEvents==="auto"}(),_detectDirection=function _detectDirection(el,options){var elCSS=css(el),elWidth=parseInt(elCSS.width)-parseInt(elCSS.paddingLeft)-parseInt(elCSS.paddingRight)-parseInt(elCSS.borderLeftWidth)-parseInt(elCSS.borderRightWidth),child1=getChild(el,0,options),child2=getChild(el,1,options),firstChildCSS=child1&&css(child1),secondChildCSS=child2&&css(child2),firstChildWidth=firstChildCSS&&parseInt(firstChildCSS.marginLeft)+parseInt(firstChildCSS.marginRight)+getRect(child1).width,secondChildWidth=secondChildCSS&&parseInt(secondChildCSS.marginLeft)+parseInt(secondChildCSS.marginRight)+getRect(child2).width;if(elCSS.display==="flex"){return elCSS.flexDirection==="column"||elCSS.flexDirection==="column-reverse"?"vertical":"horizontal"}if(elCSS.display==="grid"){return elCSS.gridTemplateColumns.split(" ").length<=1?"vertical":"horizontal"}if(child1&&firstChildCSS["float"]&&firstChildCSS["float"]!=="none"){var touchingSideChild2=firstChildCSS["float"]==="left"?"left":"right";return child2&&(secondChildCSS.clear==="both"||secondChildCSS.clear===touchingSideChild2)?"vertical":"horizontal"}return child1&&(firstChildCSS.display==="block"||firstChildCSS.display==="flex"||firstChildCSS.display==="table"||firstChildCSS.display==="grid"||firstChildWidth>=elWidth&&elCSS[CSSFloatProperty]==="none"||child2&&elCSS[CSSFloatProperty]==="none"&&firstChildWidth+secondChildWidth>elWidth)?"vertical":"horizontal"},_dragElInRowColumn=function _dragElInRowColumn(dragRect,targetRect,vertical){var dragElS1Opp=vertical?dragRect.left:dragRect.top,dragElS2Opp=vertical?dragRect.right:dragRect.bottom,dragElOppLength=vertical?dragRect.width:dragRect.height,targetS1Opp=vertical?targetRect.left:targetRect.top,targetS2Opp=vertical?targetRect.right:targetRect.bottom,targetOppLength=vertical?targetRect.width:targetRect.height;return dragElS1Opp===targetS1Opp||dragElS2Opp===targetS2Opp||dragElS1Opp+dragElOppLength/2===targetS1Opp+targetOppLength/2},_detectNearestEmptySortable=function _detectNearestEmptySortable(x,y){var ret;sortables.some(function(sortable){var threshold=sortable[expando].options.emptyInsertThreshold;if(!threshold||lastChild(sortable))return;var rect=getRect(sortable),insideHorizontally=x>=rect.left-threshold&&x<=rect.right+threshold,insideVertically=y>=rect.top-threshold&&y<=rect.bottom+threshold;if(insideHorizontally&&insideVertically){return ret=sortable}});return ret},_prepareGroup=function _prepareGroup(options){function toFn(value,pull){return function(to,from,dragEl,evt){var sameGroup=to.options.group.name&&from.options.group.name&&to.options.group.name===from.options.group.name;if(value==null&&(pull||sameGroup)){return true}else if(value==null||value===false){return false}else if(pull&&value==="clone"){return value}else if(typeof value==="function"){return toFn(value(to,from,dragEl,evt),pull)(to,from,dragEl,evt)}else{var otherGroup=(pull?to:from).options.group.name;return value===true||typeof value==="string"&&value===otherGroup||value.join&&value.indexOf(otherGroup)>-1}}}var group={};var originalGroup=options.group;if(!originalGroup||_typeof(originalGroup)!="object"){originalGroup={name:originalGroup}}group.name=originalGroup.name;group.checkPull=toFn(originalGroup.pull,true);group.checkPut=toFn(originalGroup.put);group.revertClone=originalGroup.revertClone;options.group=group},_hideGhostForTarget=function _hideGhostForTarget(){if(!supportCssPointerEvents&&ghostEl){css(ghostEl,"display","none")}},_unhideGhostForTarget=function _unhideGhostForTarget(){if(!supportCssPointerEvents&&ghostEl){css(ghostEl,"display","")}};if(documentExists&&!ChromeForAndroid){document.addEventListener("click",function(evt){if(ignoreNextClick){evt.preventDefault();evt.stopPropagation&&evt.stopPropagation();evt.stopImmediatePropagation&&evt.stopImmediatePropagation();ignoreNextClick=false;return false}},true)}var nearestEmptyInsertDetectEvent=function nearestEmptyInsertDetectEvent(evt){if(dragEl){evt=evt.touches?evt.touches[0]:evt;var nearest=_detectNearestEmptySortable(evt.clientX,evt.clientY);if(nearest){var event={};for(var i in evt){if(evt.hasOwnProperty(i)){event[i]=evt[i]}}event.target=event.rootEl=nearest;event.preventDefault=void 0;event.stopPropagation=void 0;nearest[expando]._onDragOver(event)}}};var _checkOutsideTargetEl=function _checkOutsideTargetEl(evt){if(dragEl){dragEl.parentNode[expando]._isOutsideThisEl(evt.target)}};function Sortable(el,options){if(!(el&&el.nodeType&&el.nodeType===1)){throw"Sortable: `el` must be an HTMLElement, not ".concat({}.toString.call(el))}this.el=el;this.options=options=_extends({},options);el[expando]=this;var defaults={group:null,sort:true,disabled:false,store:null,handle:null,draggable:/^[uo]l$/i.test(el.nodeName)?">li":">*",swapThreshold:1,invertSwap:false,invertedSwapThreshold:null,removeCloneOnHide:true,direction:function direction(){return _detectDirection(el,this.options)},ghostClass:"sortable-ghost",chosenClass:"sortable-chosen",dragClass:"sortable-drag",ignore:"a, img",filter:null,preventOnFilter:true,animation:0,easing:null,setData:function setData(dataTransfer,dragEl){dataTransfer.setData("Text",dragEl.textContent)},dropBubble:false,dragoverBubble:false,dataIdAttr:"data-id",delay:0,delayOnTouchOnly:false,touchStartThreshold:(Number.parseInt?Number:window).parseInt(window.devicePixelRatio,10)||1,forceFallback:false,fallbackClass:"sortable-fallback",fallbackOnBody:false,fallbackTolerance:0,fallbackOffset:{x:0,y:0},supportPointer:Sortable.supportPointer!==false&&"PointerEvent"in window&&!Safari,emptyInsertThreshold:5};PluginManager.initializePlugins(this,el,defaults);for(var name in defaults){!(name in options)&&(options[name]=defaults[name])}_prepareGroup(options);for(var fn in this){if(fn.charAt(0)==="_"&&typeof this[fn]==="function"){this[fn]=this[fn].bind(this)}}this.nativeDraggable=options.forceFallback?false:supportDraggable;if(this.nativeDraggable){this.options.touchStartThreshold=1}if(options.supportPointer){on(el,"pointerdown",this._onTapStart)}else{on(el,"mousedown",this._onTapStart);on(el,"touchstart",this._onTapStart)}if(this.nativeDraggable){on(el,"dragover",this);on(el,"dragenter",this)}sortables.push(this.el);options.store&&options.store.get&&this.sort(options.store.get(this)||[]);_extends(this,AnimationStateManager())}Sortable.prototype={constructor:Sortable,_isOutsideThisEl:function _isOutsideThisEl(target){if(!this.el.contains(target)&&target!==this.el){lastTarget=null}},_getDirection:function _getDirection(evt,target){return typeof this.options.direction==="function"?this.options.direction.call(this,evt,target,dragEl):this.options.direction},_onTapStart:function _onTapStart(evt){if(!evt.cancelable)return;var _this=this,el=this.el,options=this.options,preventOnFilter=options.preventOnFilter,type=evt.type,touch=evt.touches&&evt.touches[0]||evt.pointerType&&evt.pointerType==="touch"&&evt,target=(touch||evt).target,originalTarget=evt.target.shadowRoot&&(evt.path&&evt.path[0]||evt.composedPath&&evt.composedPath()[0])||target,filter=options.filter;_saveInputCheckedState(el);if(dragEl){return}if(/mousedown|pointerdown/.test(type)&&evt.button!==0||options.disabled){return}if(originalTarget.isContentEditable){return}if(!this.nativeDraggable&&Safari&&target&&target.tagName.toUpperCase()==="SELECT"){return}target=closest(target,options.draggable,el,false);if(target&&target.animated){return}if(lastDownEl===target){return}oldIndex=index(target);oldDraggableIndex=index(target,options.draggable);if(typeof filter==="function"){if(filter.call(this,evt,target,this)){_dispatchEvent({sortable:_this,rootEl:originalTarget,name:"filter",targetEl:target,toEl:el,fromEl:el});pluginEvent("filter",_this,{evt:evt});preventOnFilter&&evt.cancelable&&evt.preventDefault();return}}else if(filter){filter=filter.split(",").some(function(criteria){criteria=closest(originalTarget,criteria.trim(),el,false);if(criteria){_dispatchEvent({sortable:_this,rootEl:criteria,name:"filter",targetEl:target,fromEl:el,toEl:el});pluginEvent("filter",_this,{evt:evt});return true}});if(filter){preventOnFilter&&evt.cancelable&&evt.preventDefault();return}}if(options.handle&&!closest(originalTarget,options.handle,el,false)){return}this._prepareDragStart(evt,touch,target)},_prepareDragStart:function _prepareDragStart(evt,touch,target){var _this=this,el=_this.el,options=_this.options,ownerDocument=el.ownerDocument,dragStartFn;if(target&&!dragEl&&target.parentNode===el){var dragRect=getRect(target);rootEl=el;dragEl=target;parentEl=dragEl.parentNode;nextEl=dragEl.nextSibling;lastDownEl=target;activeGroup=options.group;Sortable.dragged=dragEl;tapEvt={target:dragEl,clientX:(touch||evt).clientX,clientY:(touch||evt).clientY};tapDistanceLeft=tapEvt.clientX-dragRect.left;tapDistanceTop=tapEvt.clientY-dragRect.top;this._lastX=(touch||evt).clientX;this._lastY=(touch||evt).clientY;dragEl.style["will-change"]="all";dragStartFn=function dragStartFn(){pluginEvent("delayEnded",_this,{evt:evt});if(Sortable.eventCanceled){_this._onDrop();return}_this._disableDelayedDragEvents();if(!FireFox&&_this.nativeDraggable){dragEl.draggable=true}_this._triggerDragStart(evt,touch);_dispatchEvent({sortable:_this,name:"choose",originalEvent:evt});toggleClass(dragEl,options.chosenClass,true)};options.ignore.split(",").forEach(function(criteria){find(dragEl,criteria.trim(),_disableDraggable)});on(ownerDocument,"dragover",nearestEmptyInsertDetectEvent);on(ownerDocument,"mousemove",nearestEmptyInsertDetectEvent);on(ownerDocument,"touchmove",nearestEmptyInsertDetectEvent);on(ownerDocument,"mouseup",_this._onDrop);on(ownerDocument,"touchend",_this._onDrop);on(ownerDocument,"touchcancel",_this._onDrop);if(FireFox&&this.nativeDraggable){this.options.touchStartThreshold=4;dragEl.draggable=true}pluginEvent("delayStart",this,{evt:evt});if(options.delay&&(!options.delayOnTouchOnly||touch)&&(!this.nativeDraggable||!(Edge||IE11OrLess))){if(Sortable.eventCanceled){this._onDrop();return}on(ownerDocument,"mouseup",_this._disableDelayedDrag);on(ownerDocument,"touchend",_this._disableDelayedDrag);on(ownerDocument,"touchcancel",_this._disableDelayedDrag);on(ownerDocument,"mousemove",_this._delayedDragTouchMoveHandler);on(ownerDocument,"touchmove",_this._delayedDragTouchMoveHandler);options.supportPointer&&on(ownerDocument,"pointermove",_this._delayedDragTouchMoveHandler);_this._dragStartTimer=setTimeout(dragStartFn,options.delay)}else{dragStartFn()}}},_delayedDragTouchMoveHandler:function _delayedDragTouchMoveHandler(e){var touch=e.touches?e.touches[0]:e;if(Math.max(Math.abs(touch.clientX-this._lastX),Math.abs(touch.clientY-this._lastY))>=Math.floor(this.options.touchStartThreshold/(this.nativeDraggable&&window.devicePixelRatio||1))){this._disableDelayedDrag()}},_disableDelayedDrag:function _disableDelayedDrag(){dragEl&&_disableDraggable(dragEl);clearTimeout(this._dragStartTimer);this._disableDelayedDragEvents()},_disableDelayedDragEvents:function _disableDelayedDragEvents(){var ownerDocument=this.el.ownerDocument;off(ownerDocument,"mouseup",this._disableDelayedDrag);off(ownerDocument,"touchend",this._disableDelayedDrag);off(ownerDocument,"touchcancel",this._disableDelayedDrag);off(ownerDocument,"mousemove",this._delayedDragTouchMoveHandler);off(ownerDocument,"touchmove",this._delayedDragTouchMoveHandler);off(ownerDocument,"pointermove",this._delayedDragTouchMoveHandler)},_triggerDragStart:function _triggerDragStart(evt,touch){touch=touch||evt.pointerType=="touch"&&evt;if(!this.nativeDraggable||touch){if(this.options.supportPointer){on(document,"pointermove",this._onTouchMove)}else if(touch){on(document,"touchmove",this._onTouchMove)}else{on(document,"mousemove",this._onTouchMove)}}else{on(dragEl,"dragend",this);on(rootEl,"dragstart",this._onDragStart)}try{if(document.selection){_nextTick(function(){document.selection.empty()})}else{window.getSelection().removeAllRanges()}}catch(err){}},_dragStarted:function _dragStarted(fallback,evt){awaitingDragStarted=false;if(rootEl&&dragEl){pluginEvent("dragStarted",this,{evt:evt});if(this.nativeDraggable){on(document,"dragover",_checkOutsideTargetEl)}var options=this.options;!fallback&&toggleClass(dragEl,options.dragClass,false);toggleClass(dragEl,options.ghostClass,true);Sortable.active=this;fallback&&this._appendGhost();_dispatchEvent({sortable:this,name:"start",originalEvent:evt})}else{this._nulling()}},_emulateDragOver:function _emulateDragOver(){if(touchEvt){this._lastX=touchEvt.clientX;this._lastY=touchEvt.clientY;_hideGhostForTarget();var target=document.elementFromPoint(touchEvt.clientX,touchEvt.clientY);var parent=target;while(target&&target.shadowRoot){target=target.shadowRoot.elementFromPoint(touchEvt.clientX,touchEvt.clientY);if(target===parent)break;parent=target}dragEl.parentNode[expando]._isOutsideThisEl(target);if(parent){do{if(parent[expando]){var inserted=void 0;inserted=parent[expando]._onDragOver({clientX:touchEvt.clientX,clientY:touchEvt.clientY,target:target,rootEl:parent});if(inserted&&!this.options.dragoverBubble){break}}target=parent}while(parent=parent.parentNode)}_unhideGhostForTarget()}},_onTouchMove:function _onTouchMove(evt){if(tapEvt){var options=this.options,fallbackTolerance=options.fallbackTolerance,fallbackOffset=options.fallbackOffset,touch=evt.touches?evt.touches[0]:evt,ghostMatrix=ghostEl&&matrix(ghostEl,true),scaleX=ghostEl&&ghostMatrix&&ghostMatrix.a,scaleY=ghostEl&&ghostMatrix&&ghostMatrix.d,relativeScrollOffset=PositionGhostAbsolutely&&ghostRelativeParent&&getRelativeScrollOffset(ghostRelativeParent),dx=(touch.clientX-tapEvt.clientX+fallbackOffset.x)/(scaleX||1)+(relativeScrollOffset?relativeScrollOffset[0]-ghostRelativeParentInitialScroll[0]:0)/(scaleX||1),dy=(touch.clientY-tapEvt.clientY+fallbackOffset.y)/(scaleY||1)+(relativeScrollOffset?relativeScrollOffset[1]-ghostRelativeParentInitialScroll[1]:0)/(scaleY||1);if(!Sortable.active&&!awaitingDragStarted){if(fallbackTolerance&&Math.max(Math.abs(touch.clientX-this._lastX),Math.abs(touch.clientY-this._lastY))<fallbackTolerance){return}this._onDragStart(evt,true)}if(ghostEl){if(ghostMatrix){ghostMatrix.e+=dx-(lastDx||0);ghostMatrix.f+=dy-(lastDy||0)}else{ghostMatrix={a:1,b:0,c:0,d:1,e:dx,f:dy}}var cssMatrix="matrix(".concat(ghostMatrix.a,",").concat(ghostMatrix.b,",").concat(ghostMatrix.c,",").concat(ghostMatrix.d,",").concat(ghostMatrix.e,",").concat(ghostMatrix.f,")");css(ghostEl,"webkitTransform",cssMatrix);css(ghostEl,"mozTransform",cssMatrix);css(ghostEl,"msTransform",cssMatrix);css(ghostEl,"transform",cssMatrix);lastDx=dx;lastDy=dy;touchEvt=touch}evt.cancelable&&evt.preventDefault()}},_appendGhost:function _appendGhost(){if(!ghostEl){var container=this.options.fallbackOnBody?document.body:rootEl,rect=getRect(dragEl,true,PositionGhostAbsolutely,true,container),options=this.options;if(PositionGhostAbsolutely){ghostRelativeParent=container;while(css(ghostRelativeParent,"position")==="static"&&css(ghostRelativeParent,"transform")==="none"&&ghostRelativeParent!==document){ghostRelativeParent=ghostRelativeParent.parentNode}if(ghostRelativeParent!==document.body&&ghostRelativeParent!==document.documentElement){if(ghostRelativeParent===document)ghostRelativeParent=getWindowScrollingElement();rect.top+=ghostRelativeParent.scrollTop;rect.left+=ghostRelativeParent.scrollLeft}else{ghostRelativeParent=getWindowScrollingElement()}ghostRelativeParentInitialScroll=getRelativeScrollOffset(ghostRelativeParent)}ghostEl=dragEl.cloneNode(true);toggleClass(ghostEl,options.ghostClass,false);toggleClass(ghostEl,options.fallbackClass,true);toggleClass(ghostEl,options.dragClass,true);css(ghostEl,"transition","");css(ghostEl,"transform","");css(ghostEl,"box-sizing","border-box");css(ghostEl,"margin",0);css(ghostEl,"top",rect.top);css(ghostEl,"left",rect.left);css(ghostEl,"width",rect.width);css(ghostEl,"height",rect.height);css(ghostEl,"opacity","0.8");css(ghostEl,"position",PositionGhostAbsolutely?"absolute":"fixed");css(ghostEl,"zIndex","100000");css(ghostEl,"pointerEvents","none");Sortable.ghost=ghostEl;container.appendChild(ghostEl);css(ghostEl,"transform-origin",tapDistanceLeft/parseInt(ghostEl.style.width)*100+"% "+tapDistanceTop/parseInt(ghostEl.style.height)*100+"%")}},_onDragStart:function _onDragStart(evt,fallback){var _this=this;var dataTransfer=evt.dataTransfer;var options=_this.options;pluginEvent("dragStart",this,{evt:evt});if(Sortable.eventCanceled){this._onDrop();return}pluginEvent("setupClone",this);if(!Sortable.eventCanceled){cloneEl=clone(dragEl);cloneEl.removeAttribute("id");cloneEl.draggable=false;cloneEl.style["will-change"]="";this._hideClone();toggleClass(cloneEl,this.options.chosenClass,false);Sortable.clone=cloneEl}_this.cloneId=_nextTick(function(){pluginEvent("clone",_this);if(Sortable.eventCanceled)return;if(!_this.options.removeCloneOnHide){rootEl.insertBefore(cloneEl,dragEl)}_this._hideClone();_dispatchEvent({sortable:_this,name:"clone"})});!fallback&&toggleClass(dragEl,options.dragClass,true);if(fallback){ignoreNextClick=true;_this._loopId=setInterval(_this._emulateDragOver,50)}else{off(document,"mouseup",_this._onDrop);off(document,"touchend",_this._onDrop);off(document,"touchcancel",_this._onDrop);if(dataTransfer){dataTransfer.effectAllowed="move";options.setData&&options.setData.call(_this,dataTransfer,dragEl)}on(document,"drop",_this);css(dragEl,"transform","translateZ(0)")}awaitingDragStarted=true;_this._dragStartId=_nextTick(_this._dragStarted.bind(_this,fallback,evt));on(document,"selectstart",_this);moved=true;if(Safari){css(document.body,"user-select","none")}},_onDragOver:function _onDragOver(evt){var el=this.el,target=evt.target,dragRect,targetRect,revert,options=this.options,group=options.group,activeSortable=Sortable.active,isOwner=activeGroup===group,canSort=options.sort,fromSortable=putSortable||activeSortable,vertical,_this=this,completedFired=false;if(_silent)return;function dragOverEvent(name,extra){pluginEvent(name,_this,_objectSpread2({evt:evt,isOwner:isOwner,axis:vertical?"vertical":"horizontal",revert:revert,dragRect:dragRect,targetRect:targetRect,canSort:canSort,fromSortable:fromSortable,target:target,completed:completed,onMove:function onMove(target,after){return _onMove(rootEl,el,dragEl,dragRect,target,getRect(target),evt,after)},changed:changed},extra))}function capture(){dragOverEvent("dragOverAnimationCapture");_this.captureAnimationState();if(_this!==fromSortable){fromSortable.captureAnimationState()}}function completed(insertion){dragOverEvent("dragOverCompleted",{insertion:insertion});if(insertion){if(isOwner){activeSortable._hideClone()}else{activeSortable._showClone(_this)}if(_this!==fromSortable){toggleClass(dragEl,putSortable?putSortable.options.ghostClass:activeSortable.options.ghostClass,false);toggleClass(dragEl,options.ghostClass,true)}if(putSortable!==_this&&_this!==Sortable.active){putSortable=_this}else if(_this===Sortable.active&&putSortable){putSortable=null}if(fromSortable===_this){_this._ignoreWhileAnimating=target}_this.animateAll(function(){dragOverEvent("dragOverAnimationComplete");_this._ignoreWhileAnimating=null});if(_this!==fromSortable){fromSortable.animateAll();fromSortable._ignoreWhileAnimating=null}}if(target===dragEl&&!dragEl.animated||target===el&&!target.animated){lastTarget=null}if(!options.dragoverBubble&&!evt.rootEl&&target!==document){dragEl.parentNode[expando]._isOutsideThisEl(evt.target);!insertion&&nearestEmptyInsertDetectEvent(evt)}!options.dragoverBubble&&evt.stopPropagation&&evt.stopPropagation();return completedFired=true}function changed(){newIndex=index(dragEl);newDraggableIndex=index(dragEl,options.draggable);_dispatchEvent({sortable:_this,name:"change",toEl:el,newIndex:newIndex,newDraggableIndex:newDraggableIndex,originalEvent:evt})}if(evt.preventDefault!==void 0){evt.cancelable&&evt.preventDefault()}target=closest(target,options.draggable,el,true);dragOverEvent("dragOver");if(Sortable.eventCanceled)return completedFired;if(dragEl.contains(evt.target)||target.animated&&target.animatingX&&target.animatingY||_this._ignoreWhileAnimating===target){return completed(false)}ignoreNextClick=false;if(activeSortable&&!options.disabled&&(isOwner?canSort||(revert=parentEl!==rootEl):putSortable===this||(this.lastPutMode=activeGroup.checkPull(this,activeSortable,dragEl,evt))&&group.checkPut(this,activeSortable,dragEl,evt))){vertical=this._getDirection(evt,target)==="vertical";dragRect=getRect(dragEl);dragOverEvent("dragOverValid");if(Sortable.eventCanceled)return completedFired;if(revert){parentEl=rootEl;capture();this._hideClone();dragOverEvent("revert");if(!Sortable.eventCanceled){if(nextEl){rootEl.insertBefore(dragEl,nextEl)}else{rootEl.appendChild(dragEl)}}return completed(true)}var elLastChild=lastChild(el,options.draggable);if(!elLastChild||_ghostIsLast(evt,vertical,this)&&!elLastChild.animated){if(elLastChild===dragEl){return completed(false)}if(elLastChild&&el===evt.target){target=elLastChild}if(target){targetRect=getRect(target)}if(_onMove(rootEl,el,dragEl,dragRect,target,targetRect,evt,!!target)!==false){capture();if(elLastChild&&elLastChild.nextSibling){el.insertBefore(dragEl,elLastChild.nextSibling)}else{el.appendChild(dragEl)}parentEl=el;changed();return completed(true)}}else if(elLastChild&&_ghostIsFirst(evt,vertical,this)){var firstChild=getChild(el,0,options,true);if(firstChild===dragEl){return completed(false)}target=firstChild;targetRect=getRect(target);if(_onMove(rootEl,el,dragEl,dragRect,target,targetRect,evt,false)!==false){capture();el.insertBefore(dragEl,firstChild);parentEl=el;changed();return completed(true)}}else if(target.parentNode===el){targetRect=getRect(target);var direction=0,targetBeforeFirstSwap,differentLevel=dragEl.parentNode!==el,differentRowCol=!_dragElInRowColumn(dragEl.animated&&dragEl.toRect||dragRect,target.animated&&target.toRect||targetRect,vertical),side1=vertical?"top":"left",scrolledPastTop=isScrolledPast(target,"top","top")||isScrolledPast(dragEl,"top","top"),scrollBefore=scrolledPastTop?scrolledPastTop.scrollTop:void 0;if(lastTarget!==target){targetBeforeFirstSwap=targetRect[side1];pastFirstInvertThresh=false;isCircumstantialInvert=!differentRowCol&&options.invertSwap||differentLevel}direction=_getSwapDirection(evt,target,targetRect,vertical,differentRowCol?1:options.swapThreshold,options.invertedSwapThreshold==null?options.swapThreshold:options.invertedSwapThreshold,isCircumstantialInvert,lastTarget===target);var sibling;if(direction!==0){var dragIndex=index(dragEl);do{dragIndex-=direction;sibling=parentEl.children[dragIndex]}while(sibling&&(css(sibling,"display")==="none"||sibling===ghostEl))}if(direction===0||sibling===target){return completed(false)}lastTarget=target;lastDirection=direction;var nextSibling=target.nextElementSibling,after=false;after=direction===1;var moveVector=_onMove(rootEl,el,dragEl,dragRect,target,targetRect,evt,after);if(moveVector!==false){if(moveVector===1||moveVector===-1){after=moveVector===1}_silent=true;setTimeout(_unsilent,30);capture();if(after&&!nextSibling){el.appendChild(dragEl)}else{target.parentNode.insertBefore(dragEl,after?nextSibling:target)}if(scrolledPastTop){scrollBy(scrolledPastTop,0,scrollBefore-scrolledPastTop.scrollTop)}parentEl=dragEl.parentNode;if(targetBeforeFirstSwap!==undefined&&!isCircumstantialInvert){targetMoveDistance=Math.abs(targetBeforeFirstSwap-getRect(target)[side1])}changed();return completed(true)}}if(el.contains(dragEl)){return completed(false)}}return false},_ignoreWhileAnimating:null,_offMoveEvents:function _offMoveEvents(){off(document,"mousemove",this._onTouchMove);off(document,"touchmove",this._onTouchMove);off(document,"pointermove",this._onTouchMove);off(document,"dragover",nearestEmptyInsertDetectEvent);off(document,"mousemove",nearestEmptyInsertDetectEvent);off(document,"touchmove",nearestEmptyInsertDetectEvent)},_offUpEvents:function _offUpEvents(){var ownerDocument=this.el.ownerDocument;off(ownerDocument,"mouseup",this._onDrop);off(ownerDocument,"touchend",this._onDrop);off(ownerDocument,"pointerup",this._onDrop);off(ownerDocument,"touchcancel",this._onDrop);off(document,"selectstart",this)},_onDrop:function _onDrop(evt){var el=this.el,options=this.options;newIndex=index(dragEl);newDraggableIndex=index(dragEl,options.draggable);pluginEvent("drop",this,{evt:evt});parentEl=dragEl&&dragEl.parentNode;newIndex=index(dragEl);newDraggableIndex=index(dragEl,options.draggable);if(Sortable.eventCanceled){this._nulling();return}awaitingDragStarted=false;isCircumstantialInvert=false;pastFirstInvertThresh=false;clearInterval(this._loopId);clearTimeout(this._dragStartTimer);_cancelNextTick(this.cloneId);_cancelNextTick(this._dragStartId);if(this.nativeDraggable){off(document,"drop",this);off(el,"dragstart",this._onDragStart)}this._offMoveEvents();this._offUpEvents();if(Safari){css(document.body,"user-select","")}css(dragEl,"transform","");if(evt){if(moved){evt.cancelable&&evt.preventDefault();!options.dropBubble&&evt.stopPropagation()}ghostEl&&ghostEl.parentNode&&ghostEl.parentNode.removeChild(ghostEl);if(rootEl===parentEl||putSortable&&putSortable.lastPutMode!=="clone"){cloneEl&&cloneEl.parentNode&&cloneEl.parentNode.removeChild(cloneEl)}if(dragEl){if(this.nativeDraggable){off(dragEl,"dragend",this)}_disableDraggable(dragEl);dragEl.style["will-change"]="";if(moved&&!awaitingDragStarted){toggleClass(dragEl,putSortable?putSortable.options.ghostClass:this.options.ghostClass,false)}toggleClass(dragEl,this.options.chosenClass,false);_dispatchEvent({sortable:this,name:"unchoose",toEl:parentEl,newIndex:null,newDraggableIndex:null,originalEvent:evt});if(rootEl!==parentEl){if(newIndex>=0){_dispatchEvent({rootEl:parentEl,name:"add",toEl:parentEl,fromEl:rootEl,originalEvent:evt});_dispatchEvent({sortable:this,name:"remove",toEl:parentEl,originalEvent:evt});_dispatchEvent({rootEl:parentEl,name:"sort",toEl:parentEl,fromEl:rootEl,originalEvent:evt});_dispatchEvent({sortable:this,name:"sort",toEl:parentEl,originalEvent:evt})}putSortable&&putSortable.save()}else{if(newIndex!==oldIndex){if(newIndex>=0){_dispatchEvent({sortable:this,name:"update",toEl:parentEl,originalEvent:evt});_dispatchEvent({sortable:this,name:"sort",toEl:parentEl,originalEvent:evt})}}}if(Sortable.active){if(newIndex==null||newIndex===-1){newIndex=oldIndex;newDraggableIndex=oldDraggableIndex}_dispatchEvent({sortable:this,name:"end",toEl:parentEl,originalEvent:evt});this.save()}}}this._nulling()},_nulling:function _nulling(){pluginEvent("nulling",this);rootEl=dragEl=parentEl=ghostEl=nextEl=cloneEl=lastDownEl=cloneHidden=tapEvt=touchEvt=moved=newIndex=newDraggableIndex=oldIndex=oldDraggableIndex=lastTarget=lastDirection=putSortable=activeGroup=Sortable.dragged=Sortable.ghost=Sortable.clone=Sortable.active=null;savedInputChecked.forEach(function(el){el.checked=true});savedInputChecked.length=lastDx=lastDy=0},handleEvent:function handleEvent(evt){switch(evt.type){case"drop":case"dragend":this._onDrop(evt);break;case"dragenter":case"dragover":if(dragEl){this._onDragOver(evt);_globalDragOver(evt)}break;case"selectstart":evt.preventDefault();break}},toArray:function toArray(){var order=[],el,children=this.el.children,i=0,n=children.length,options=this.options;for(;i<n;i++){el=children[i];if(closest(el,options.draggable,this.el,false)){order.push(el.getAttribute(options.dataIdAttr)||_generateId(el))}}return order},sort:function sort(order,useAnimation){var items={},rootEl=this.el;this.toArray().forEach(function(id,i){var el=rootEl.children[i];if(closest(el,this.options.draggable,rootEl,false)){items[id]=el}},this);useAnimation&&this.captureAnimationState();order.forEach(function(id){if(items[id]){rootEl.removeChild(items[id]);rootEl.appendChild(items[id])}});useAnimation&&this.animateAll()},save:function save(){var store=this.options.store;store&&store.set&&store.set(this)},closest:function closest$1(el,selector){return closest(el,selector||this.options.draggable,this.el,false)},option:function option(name,value){var options=this.options;if(value===void 0){return options[name]}else{var modifiedValue=PluginManager.modifyOption(this,name,value);if(typeof modifiedValue!=="undefined"){options[name]=modifiedValue}else{options[name]=value}if(name==="group"){_prepareGroup(options)}}},destroy:function destroy(){pluginEvent("destroy",this);var el=this.el;el[expando]=null;off(el,"mousedown",this._onTapStart);off(el,"touchstart",this._onTapStart);off(el,"pointerdown",this._onTapStart);if(this.nativeDraggable){off(el,"dragover",this);off(el,"dragenter",this)}Array.prototype.forEach.call(el.querySelectorAll("[draggable]"),function(el){el.removeAttribute("draggable")});this._onDrop();this._disableDelayedDragEvents();sortables.splice(sortables.indexOf(this.el),1);this.el=el=null},_hideClone:function _hideClone(){if(!cloneHidden){pluginEvent("hideClone",this);if(Sortable.eventCanceled)return;css(cloneEl,"display","none");if(this.options.removeCloneOnHide&&cloneEl.parentNode){cloneEl.parentNode.removeChild(cloneEl)}cloneHidden=true}},_showClone:function _showClone(putSortable){if(putSortable.lastPutMode!=="clone"){this._hideClone();return}if(cloneHidden){pluginEvent("showClone",this);if(Sortable.eventCanceled)return;if(dragEl.parentNode==rootEl&&!this.options.group.revertClone){rootEl.insertBefore(cloneEl,dragEl)}else if(nextEl){rootEl.insertBefore(cloneEl,nextEl)}else{rootEl.appendChild(cloneEl)}if(this.options.group.revertClone){this.animate(dragEl,cloneEl)}css(cloneEl,"display","");cloneHidden=false}}};function _globalDragOver(evt){if(evt.dataTransfer){evt.dataTransfer.dropEffect="move"}evt.cancelable&&evt.preventDefault()}function _onMove(fromEl,toEl,dragEl,dragRect,targetEl,targetRect,originalEvent,willInsertAfter){var evt,sortable=fromEl[expando],onMoveFn=sortable.options.onMove,retVal;if(window.CustomEvent&&!IE11OrLess&&!Edge){evt=new CustomEvent("move",{bubbles:true,cancelable:true})}else{evt=document.createEvent("Event");evt.initEvent("move",true,true)}evt.to=toEl;evt.from=fromEl;evt.dragged=dragEl;evt.draggedRect=dragRect;evt.related=targetEl||toEl;evt.relatedRect=targetRect||getRect(toEl);evt.willInsertAfter=willInsertAfter;evt.originalEvent=originalEvent;fromEl.dispatchEvent(evt);if(onMoveFn){retVal=onMoveFn.call(sortable,evt,originalEvent)}return retVal}function _disableDraggable(el){el.draggable=false}function _unsilent(){_silent=false}function _ghostIsFirst(evt,vertical,sortable){var rect=getRect(getChild(sortable.el,0,sortable.options,true));var spacer=10;return vertical?evt.clientX<rect.left-spacer||evt.clientY<rect.top&&evt.clientX<rect.right:evt.clientY<rect.top-spacer||evt.clientY<rect.bottom&&evt.clientX<rect.left}function _ghostIsLast(evt,vertical,sortable){var rect=getRect(lastChild(sortable.el,sortable.options.draggable));var spacer=10;return vertical?evt.clientX>rect.right+spacer||evt.clientX<=rect.right&&evt.clientY>rect.bottom&&evt.clientX>=rect.left:evt.clientX>rect.right&&evt.clientY>rect.top||evt.clientX<=rect.right&&evt.clientY>rect.bottom+spacer}function _getSwapDirection(evt,target,targetRect,vertical,swapThreshold,invertedSwapThreshold,invertSwap,isLastTarget){var mouseOnAxis=vertical?evt.clientY:evt.clientX,targetLength=vertical?targetRect.height:targetRect.width,targetS1=vertical?targetRect.top:targetRect.left,targetS2=vertical?targetRect.bottom:targetRect.right,invert=false;if(!invertSwap){if(isLastTarget&&targetMoveDistance<targetLength*swapThreshold){if(!pastFirstInvertThresh&&(lastDirection===1?mouseOnAxis>targetS1+targetLength*invertedSwapThreshold/2:mouseOnAxis<targetS2-targetLength*invertedSwapThreshold/2)){pastFirstInvertThresh=true}if(!pastFirstInvertThresh){if(lastDirection===1?mouseOnAxis<targetS1+targetMoveDistance:mouseOnAxis>targetS2-targetMoveDistance){return-lastDirection}}else{invert=true}}else{if(mouseOnAxis>targetS1+targetLength*(1-swapThreshold)/2&&mouseOnAxis<targetS2-targetLength*(1-swapThreshold)/2){return _getInsertDirection(target)}}}invert=invert||invertSwap;if(invert){if(mouseOnAxis<targetS1+targetLength*invertedSwapThreshold/2||mouseOnAxis>targetS2-targetLength*invertedSwapThreshold/2){return mouseOnAxis>targetS1+targetLength/2?1:-1}}return 0}function _getInsertDirection(target){if(index(dragEl)<index(target)){return 1}else{return-1}}function _generateId(el){var str=el.tagName+el.className+el.src+el.href+el.textContent,i=str.length,sum=0;while(i--){sum+=str.charCodeAt(i)}return sum.toString(36)}function _saveInputCheckedState(root){savedInputChecked.length=0;var inputs=root.getElementsByTagName("input");var idx=inputs.length;while(idx--){var el=inputs[idx];el.checked&&savedInputChecked.push(el)}}function _nextTick(fn){return setTimeout(fn,0)}function _cancelNextTick(id){return clearTimeout(id)}if(documentExists){on(document,"touchmove",function(evt){if((Sortable.active||awaitingDragStarted)&&evt.cancelable){evt.preventDefault()}})}Sortable.utils={on:on,off:off,css:css,find:find,is:function is(el,selector){return!!closest(el,selector,el,false)},extend:extend,throttle:throttle,closest:closest,toggleClass:toggleClass,clone:clone,index:index,nextTick:_nextTick,cancelNextTick:_cancelNextTick,detectDirection:_detectDirection,getChild:getChild};Sortable.get=function(element){return element[expando]};Sortable.mount=function(){for(var _len=arguments.length,plugins=new Array(_len),_key=0;_key<_len;_key++){plugins[_key]=arguments[_key]}if(plugins[0].constructor===Array)plugins=plugins[0];plugins.forEach(function(plugin){if(!plugin.prototype||!plugin.prototype.constructor){throw"Sortable: Mounted plugin must be a constructor function, not ".concat({}.toString.call(plugin))}if(plugin.utils)Sortable.utils=_objectSpread2(_objectSpread2({},Sortable.utils),plugin.utils);PluginManager.mount(plugin)})};Sortable.create=function(el,options){return new Sortable(el,options)};Sortable.version=version;var autoScrolls=[],scrollEl,scrollRootEl,scrolling=false,lastAutoScrollX,lastAutoScrollY,touchEvt$1,pointerElemChangedInterval;function AutoScrollPlugin(){function AutoScroll(){this.defaults={scroll:true,forceAutoScrollFallback:false,scrollSensitivity:30,scrollSpeed:10,bubbleScroll:true};for(var fn in this){if(fn.charAt(0)==="_"&&typeof this[fn]==="function"){this[fn]=this[fn].bind(this)}}}AutoScroll.prototype={dragStarted:function dragStarted(_ref){var originalEvent=_ref.originalEvent;if(this.sortable.nativeDraggable){on(document,"dragover",this._handleAutoScroll)}else{if(this.options.supportPointer){on(document,"pointermove",this._handleFallbackAutoScroll)}else if(originalEvent.touches){on(document,"touchmove",this._handleFallbackAutoScroll)}else{on(document,"mousemove",this._handleFallbackAutoScroll)}}},dragOverCompleted:function dragOverCompleted(_ref2){var originalEvent=_ref2.originalEvent;if(!this.options.dragOverBubble&&!originalEvent.rootEl){this._handleAutoScroll(originalEvent)}},drop:function drop(){if(this.sortable.nativeDraggable){off(document,"dragover",this._handleAutoScroll)}else{off(document,"pointermove",this._handleFallbackAutoScroll);off(document,"touchmove",this._handleFallbackAutoScroll);off(document,"mousemove",this._handleFallbackAutoScroll)}clearPointerElemChangedInterval();clearAutoScrolls();cancelThrottle()},nulling:function nulling(){touchEvt$1=scrollRootEl=scrollEl=scrolling=pointerElemChangedInterval=lastAutoScrollX=lastAutoScrollY=null;autoScrolls.length=0},_handleFallbackAutoScroll:function _handleFallbackAutoScroll(evt){this._handleAutoScroll(evt,true)},_handleAutoScroll:function _handleAutoScroll(evt,fallback){var _this=this;var x=(evt.touches?evt.touches[0]:evt).clientX,y=(evt.touches?evt.touches[0]:evt).clientY,elem=document.elementFromPoint(x,y);touchEvt$1=evt;if(fallback||this.options.forceAutoScrollFallback||Edge||IE11OrLess||Safari){autoScroll(evt,this.options,elem,fallback);var ogElemScroller=getParentAutoScrollElement(elem,true);if(scrolling&&(!pointerElemChangedInterval||x!==lastAutoScrollX||y!==lastAutoScrollY)){pointerElemChangedInterval&&clearPointerElemChangedInterval();pointerElemChangedInterval=setInterval(function(){var newElem=getParentAutoScrollElement(document.elementFromPoint(x,y),true);if(newElem!==ogElemScroller){ogElemScroller=newElem;clearAutoScrolls()}autoScroll(evt,_this.options,newElem,fallback)},10);lastAutoScrollX=x;lastAutoScrollY=y}}else{if(!this.options.bubbleScroll||getParentAutoScrollElement(elem,true)===getWindowScrollingElement()){clearAutoScrolls();return}autoScroll(evt,this.options,getParentAutoScrollElement(elem,false),false)}}};return _extends(AutoScroll,{pluginName:"scroll",initializeByDefault:true})}function clearAutoScrolls(){autoScrolls.forEach(function(autoScroll){clearInterval(autoScroll.pid)});autoScrolls=[]}function clearPointerElemChangedInterval(){clearInterval(pointerElemChangedInterval)}var autoScroll=throttle(function(evt,options,rootEl,isFallback){if(!options.scroll)return;var x=(evt.touches?evt.touches[0]:evt).clientX,y=(evt.touches?evt.touches[0]:evt).clientY,sens=options.scrollSensitivity,speed=options.scrollSpeed,winScroller=getWindowScrollingElement();var scrollThisInstance=false,scrollCustomFn;if(scrollRootEl!==rootEl){scrollRootEl=rootEl;clearAutoScrolls();scrollEl=options.scroll;scrollCustomFn=options.scrollFn;if(scrollEl===true){scrollEl=getParentAutoScrollElement(rootEl,true)}}var layersOut=0;var currentParent=scrollEl;do{var el=currentParent,rect=getRect(el),top=rect.top,bottom=rect.bottom,left=rect.left,right=rect.right,width=rect.width,height=rect.height,canScrollX=void 0,canScrollY=void 0,scrollWidth=el.scrollWidth,scrollHeight=el.scrollHeight,elCSS=css(el),scrollPosX=el.scrollLeft,scrollPosY=el.scrollTop;if(el===winScroller){canScrollX=width<scrollWidth&&(elCSS.overflowX==="auto"||elCSS.overflowX==="scroll"||elCSS.overflowX==="visible");canScrollY=height<scrollHeight&&(elCSS.overflowY==="auto"||elCSS.overflowY==="scroll"||elCSS.overflowY==="visible")}else{canScrollX=width<scrollWidth&&(elCSS.overflowX==="auto"||elCSS.overflowX==="scroll");canScrollY=height<scrollHeight&&(elCSS.overflowY==="auto"||elCSS.overflowY==="scroll")}var vx=canScrollX&&(Math.abs(right-x)<=sens&&scrollPosX+width<scrollWidth)-(Math.abs(left-x)<=sens&&!!scrollPosX);var vy=canScrollY&&(Math.abs(bottom-y)<=sens&&scrollPosY+height<scrollHeight)-(Math.abs(top-y)<=sens&&!!scrollPosY);if(!autoScrolls[layersOut]){for(var i=0;i<=layersOut;i++){if(!autoScrolls[i]){autoScrolls[i]={}}}}if(autoScrolls[layersOut].vx!=vx||autoScrolls[layersOut].vy!=vy||autoScrolls[layersOut].el!==el){autoScrolls[layersOut].el=el;autoScrolls[layersOut].vx=vx;autoScrolls[layersOut].vy=vy;clearInterval(autoScrolls[layersOut].pid);if(vx!=0||vy!=0){scrollThisInstance=true;autoScrolls[layersOut].pid=setInterval(function(){if(isFallback&&this.layer===0){Sortable.active._onTouchMove(touchEvt$1)}var scrollOffsetY=autoScrolls[this.layer].vy?autoScrolls[this.layer].vy*speed:0;var scrollOffsetX=autoScrolls[this.layer].vx?autoScrolls[this.layer].vx*speed:0;if(typeof scrollCustomFn==="function"){if(scrollCustomFn.call(Sortable.dragged.parentNode[expando],scrollOffsetX,scrollOffsetY,evt,touchEvt$1,autoScrolls[this.layer].el)!=="continue"){return}}scrollBy(autoScrolls[this.layer].el,scrollOffsetX,scrollOffsetY)}.bind({layer:layersOut}),24)}}layersOut++}while(options.bubbleScroll&&currentParent!==winScroller&&(currentParent=getParentAutoScrollElement(currentParent,false)));scrolling=scrollThisInstance},30);var drop=function drop(_ref){var originalEvent=_ref.originalEvent,putSortable=_ref.putSortable,dragEl=_ref.dragEl,activeSortable=_ref.activeSortable,dispatchSortableEvent=_ref.dispatchSortableEvent,hideGhostForTarget=_ref.hideGhostForTarget,unhideGhostForTarget=_ref.unhideGhostForTarget;if(!originalEvent)return;var toSortable=putSortable||activeSortable;hideGhostForTarget();var touch=originalEvent.changedTouches&&originalEvent.changedTouches.length?originalEvent.changedTouches[0]:originalEvent;var target=document.elementFromPoint(touch.clientX,touch.clientY);unhideGhostForTarget();if(toSortable&&!toSortable.el.contains(target)){dispatchSortableEvent("spill");this.onSpill({dragEl:dragEl,putSortable:putSortable})}};function Revert(){}Revert.prototype={startIndex:null,dragStart:function dragStart(_ref2){var oldDraggableIndex=_ref2.oldDraggableIndex;this.startIndex=oldDraggableIndex},onSpill:function onSpill(_ref3){var dragEl=_ref3.dragEl,putSortable=_ref3.putSortable;this.sortable.captureAnimationState();if(putSortable){putSortable.captureAnimationState()}var nextSibling=getChild(this.sortable.el,this.startIndex,this.options);if(nextSibling){this.sortable.el.insertBefore(dragEl,nextSibling)}else{this.sortable.el.appendChild(dragEl)}this.sortable.animateAll();if(putSortable){putSortable.animateAll()}},drop:drop};_extends(Revert,{pluginName:"revertOnSpill"});function Remove(){}Remove.prototype={onSpill:function onSpill(_ref4){var dragEl=_ref4.dragEl,putSortable=_ref4.putSortable;var parentSortable=putSortable||this.sortable;parentSortable.captureAnimationState();dragEl.parentNode&&dragEl.parentNode.removeChild(dragEl);parentSortable.animateAll()},drop:drop};_extends(Remove,{pluginName:"removeOnSpill"});var lastSwapEl;function SwapPlugin(){function Swap(){this.defaults={swapClass:"sortable-swap-highlight"}}Swap.prototype={dragStart:function dragStart(_ref){var dragEl=_ref.dragEl;lastSwapEl=dragEl},dragOverValid:function dragOverValid(_ref2){var completed=_ref2.completed,target=_ref2.target,onMove=_ref2.onMove,activeSortable=_ref2.activeSortable,changed=_ref2.changed,cancel=_ref2.cancel;if(!activeSortable.options.swap)return;var el=this.sortable.el,options=this.options;if(target&&target!==el){var prevSwapEl=lastSwapEl;if(onMove(target)!==false){toggleClass(target,options.swapClass,true);lastSwapEl=target}else{lastSwapEl=null}if(prevSwapEl&&prevSwapEl!==lastSwapEl){toggleClass(prevSwapEl,options.swapClass,false)}}changed();completed(true);cancel()},drop:function drop(_ref3){var activeSortable=_ref3.activeSortable,putSortable=_ref3.putSortable,dragEl=_ref3.dragEl;var toSortable=putSortable||this.sortable;var options=this.options;lastSwapEl&&toggleClass(lastSwapEl,options.swapClass,false);if(lastSwapEl&&(options.swap||putSortable&&putSortable.options.swap)){if(dragEl!==lastSwapEl){toSortable.captureAnimationState();if(toSortable!==activeSortable)activeSortable.captureAnimationState();swapNodes(dragEl,lastSwapEl);toSortable.animateAll();if(toSortable!==activeSortable)activeSortable.animateAll()}}},nulling:function nulling(){lastSwapEl=null}};return _extends(Swap,{pluginName:"swap",eventProperties:function eventProperties(){return{swapItem:lastSwapEl}}})}function swapNodes(n1,n2){var p1=n1.parentNode,p2=n2.parentNode,i1,i2;if(!p1||!p2||p1.isEqualNode(n2)||p2.isEqualNode(n1))return;i1=index(n1);i2=index(n2);if(p1.isEqualNode(p2)&&i1<i2){i2++}p1.insertBefore(n2,p1.children[i1]);p2.insertBefore(n1,p2.children[i2])}var multiDragElements=[],multiDragClones=[],lastMultiDragSelect,multiDragSortable,initialFolding=false,folding=false,dragStarted=false,dragEl$1,clonesFromRect,clonesHidden;function MultiDragPlugin(){function MultiDrag(sortable){for(var fn in this){if(fn.charAt(0)==="_"&&typeof this[fn]==="function"){this[fn]=this[fn].bind(this)}}if(!sortable.options.avoidImplicitDeselect){if(sortable.options.supportPointer){on(document,"pointerup",this._deselectMultiDrag)}else{on(document,"mouseup",this._deselectMultiDrag);on(document,"touchend",this._deselectMultiDrag)}}on(document,"keydown",this._checkKeyDown);on(document,"keyup",this._checkKeyUp);this.defaults={selectedClass:"sortable-selected",multiDragKey:null,avoidImplicitDeselect:false,setData:function setData(dataTransfer,dragEl){var data="";if(multiDragElements.length&&multiDragSortable===sortable){multiDragElements.forEach(function(multiDragElement,i){data+=(!i?"":", ")+multiDragElement.textContent})}else{data=dragEl.textContent}dataTransfer.setData("Text",data)}}}MultiDrag.prototype={multiDragKeyDown:false,isMultiDrag:false,delayStartGlobal:function delayStartGlobal(_ref){var dragged=_ref.dragEl;dragEl$1=dragged},delayEnded:function delayEnded(){this.isMultiDrag=~multiDragElements.indexOf(dragEl$1)},setupClone:function setupClone(_ref2){var sortable=_ref2.sortable,cancel=_ref2.cancel;if(!this.isMultiDrag)return;for(var i=0;i<multiDragElements.length;i++){multiDragClones.push(clone(multiDragElements[i]));multiDragClones[i].sortableIndex=multiDragElements[i].sortableIndex;multiDragClones[i].draggable=false;multiDragClones[i].style["will-change"]="";toggleClass(multiDragClones[i],this.options.selectedClass,false);multiDragElements[i]===dragEl$1&&toggleClass(multiDragClones[i],this.options.chosenClass,false)}sortable._hideClone();cancel()},clone:function clone(_ref3){var sortable=_ref3.sortable,rootEl=_ref3.rootEl,dispatchSortableEvent=_ref3.dispatchSortableEvent,cancel=_ref3.cancel;if(!this.isMultiDrag)return;if(!this.options.removeCloneOnHide){if(multiDragElements.length&&multiDragSortable===sortable){insertMultiDragClones(true,rootEl);dispatchSortableEvent("clone");cancel()}}},showClone:function showClone(_ref4){var cloneNowShown=_ref4.cloneNowShown,rootEl=_ref4.rootEl,cancel=_ref4.cancel;if(!this.isMultiDrag)return;insertMultiDragClones(false,rootEl);multiDragClones.forEach(function(clone){css(clone,"display","")});cloneNowShown();clonesHidden=false;cancel()},hideClone:function hideClone(_ref5){var _this=this;var sortable=_ref5.sortable,cloneNowHidden=_ref5.cloneNowHidden,cancel=_ref5.cancel;if(!this.isMultiDrag)return;multiDragClones.forEach(function(clone){css(clone,"display","none");if(_this.options.removeCloneOnHide&&clone.parentNode){clone.parentNode.removeChild(clone)}});cloneNowHidden();clonesHidden=true;cancel()},dragStartGlobal:function dragStartGlobal(_ref6){var sortable=_ref6.sortable;if(!this.isMultiDrag&&multiDragSortable){multiDragSortable.multiDrag._deselectMultiDrag()}multiDragElements.forEach(function(multiDragElement){multiDragElement.sortableIndex=index(multiDragElement)});multiDragElements=multiDragElements.sort(function(a,b){return a.sortableIndex-b.sortableIndex});dragStarted=true},dragStarted:function dragStarted(_ref7){var _this2=this;var sortable=_ref7.sortable;if(!this.isMultiDrag)return;if(this.options.sort){sortable.captureAnimationState();if(this.options.animation){multiDragElements.forEach(function(multiDragElement){if(multiDragElement===dragEl$1)return;css(multiDragElement,"position","absolute")});var dragRect=getRect(dragEl$1,false,true,true);multiDragElements.forEach(function(multiDragElement){if(multiDragElement===dragEl$1)return;setRect(multiDragElement,dragRect)});folding=true;initialFolding=true}}sortable.animateAll(function(){folding=false;initialFolding=false;if(_this2.options.animation){multiDragElements.forEach(function(multiDragElement){unsetRect(multiDragElement)})}if(_this2.options.sort){removeMultiDragElements()}})},dragOver:function dragOver(_ref8){var target=_ref8.target,completed=_ref8.completed,cancel=_ref8.cancel;if(folding&&~multiDragElements.indexOf(target)){completed(false);cancel()}},revert:function revert(_ref9){var fromSortable=_ref9.fromSortable,rootEl=_ref9.rootEl,sortable=_ref9.sortable,dragRect=_ref9.dragRect;if(multiDragElements.length>1){multiDragElements.forEach(function(multiDragElement){sortable.addAnimationState({target:multiDragElement,rect:folding?getRect(multiDragElement):dragRect});unsetRect(multiDragElement);multiDragElement.fromRect=dragRect;fromSortable.removeAnimationState(multiDragElement)});folding=false;insertMultiDragElements(!this.options.removeCloneOnHide,rootEl)}},dragOverCompleted:function dragOverCompleted(_ref10){var sortable=_ref10.sortable,isOwner=_ref10.isOwner,insertion=_ref10.insertion,activeSortable=_ref10.activeSortable,parentEl=_ref10.parentEl,putSortable=_ref10.putSortable;var options=this.options;if(insertion){if(isOwner){activeSortable._hideClone()}initialFolding=false;if(options.animation&&multiDragElements.length>1&&(folding||!isOwner&&!activeSortable.options.sort&&!putSortable)){var dragRectAbsolute=getRect(dragEl$1,false,true,true);multiDragElements.forEach(function(multiDragElement){if(multiDragElement===dragEl$1)return;setRect(multiDragElement,dragRectAbsolute);parentEl.appendChild(multiDragElement)});folding=true}if(!isOwner){if(!folding){removeMultiDragElements()}if(multiDragElements.length>1){var clonesHiddenBefore=clonesHidden;activeSortable._showClone(sortable);if(activeSortable.options.animation&&!clonesHidden&&clonesHiddenBefore){multiDragClones.forEach(function(clone){activeSortable.addAnimationState({target:clone,rect:clonesFromRect});clone.fromRect=clonesFromRect;clone.thisAnimationDuration=null})}}else{activeSortable._showClone(sortable)}}}},dragOverAnimationCapture:function dragOverAnimationCapture(_ref11){var dragRect=_ref11.dragRect,isOwner=_ref11.isOwner,activeSortable=_ref11.activeSortable;multiDragElements.forEach(function(multiDragElement){multiDragElement.thisAnimationDuration=null});if(activeSortable.options.animation&&!isOwner&&activeSortable.multiDrag.isMultiDrag){clonesFromRect=_extends({},dragRect);var dragMatrix=matrix(dragEl$1,true);clonesFromRect.top-=dragMatrix.f;clonesFromRect.left-=dragMatrix.e}},dragOverAnimationComplete:function dragOverAnimationComplete(){if(folding){folding=false;removeMultiDragElements()}},drop:function drop(_ref12){var evt=_ref12.originalEvent,rootEl=_ref12.rootEl,parentEl=_ref12.parentEl,sortable=_ref12.sortable,dispatchSortableEvent=_ref12.dispatchSortableEvent,oldIndex=_ref12.oldIndex,putSortable=_ref12.putSortable;var toSortable=putSortable||this.sortable;if(!evt)return;var options=this.options,children=parentEl.children;if(!dragStarted){if(options.multiDragKey&&!this.multiDragKeyDown){this._deselectMultiDrag()}toggleClass(dragEl$1,options.selectedClass,!~multiDragElements.indexOf(dragEl$1));if(!~multiDragElements.indexOf(dragEl$1)){multiDragElements.push(dragEl$1);dispatchEvent({sortable:sortable,rootEl:rootEl,name:"select",targetEl:dragEl$1,originalEvent:evt});if(evt.shiftKey&&lastMultiDragSelect&&sortable.el.contains(lastMultiDragSelect)){var lastIndex=index(lastMultiDragSelect),currentIndex=index(dragEl$1);if(~lastIndex&&~currentIndex&&lastIndex!==currentIndex){var n,i;if(currentIndex>lastIndex){i=lastIndex;n=currentIndex}else{i=currentIndex;n=lastIndex+1}for(;i<n;i++){if(~multiDragElements.indexOf(children[i]))continue;toggleClass(children[i],options.selectedClass,true);multiDragElements.push(children[i]);dispatchEvent({sortable:sortable,rootEl:rootEl,name:"select",targetEl:children[i],originalEvent:evt})}}}else{lastMultiDragSelect=dragEl$1}multiDragSortable=toSortable}else{multiDragElements.splice(multiDragElements.indexOf(dragEl$1),1);lastMultiDragSelect=null;dispatchEvent({sortable:sortable,rootEl:rootEl,name:"deselect",targetEl:dragEl$1,originalEvent:evt})}}if(dragStarted&&this.isMultiDrag){folding=false;if((parentEl[expando].options.sort||parentEl!==rootEl)&&multiDragElements.length>1){var dragRect=getRect(dragEl$1),multiDragIndex=index(dragEl$1,":not(."+this.options.selectedClass+")");if(!initialFolding&&options.animation)dragEl$1.thisAnimationDuration=null;toSortable.captureAnimationState();if(!initialFolding){if(options.animation){dragEl$1.fromRect=dragRect;multiDragElements.forEach(function(multiDragElement){multiDragElement.thisAnimationDuration=null;if(multiDragElement!==dragEl$1){var rect=folding?getRect(multiDragElement):dragRect;multiDragElement.fromRect=rect;toSortable.addAnimationState({target:multiDragElement,rect:rect})}})}removeMultiDragElements();multiDragElements.forEach(function(multiDragElement){if(children[multiDragIndex]){parentEl.insertBefore(multiDragElement,children[multiDragIndex])}else{parentEl.appendChild(multiDragElement)}multiDragIndex++});if(oldIndex===index(dragEl$1)){var update=false;multiDragElements.forEach(function(multiDragElement){if(multiDragElement.sortableIndex!==index(multiDragElement)){update=true;return}});if(update){dispatchSortableEvent("update")}}}multiDragElements.forEach(function(multiDragElement){unsetRect(multiDragElement)});toSortable.animateAll()}multiDragSortable=toSortable}if(rootEl===parentEl||putSortable&&putSortable.lastPutMode!=="clone"){multiDragClones.forEach(function(clone){clone.parentNode&&clone.parentNode.removeChild(clone)})}},nullingGlobal:function nullingGlobal(){this.isMultiDrag=dragStarted=false;multiDragClones.length=0},destroyGlobal:function destroyGlobal(){this._deselectMultiDrag();off(document,"pointerup",this._deselectMultiDrag);off(document,"mouseup",this._deselectMultiDrag);off(document,"touchend",this._deselectMultiDrag);off(document,"keydown",this._checkKeyDown);off(document,"keyup",this._checkKeyUp)},_deselectMultiDrag:function _deselectMultiDrag(evt){if(typeof dragStarted!=="undefined"&&dragStarted)return;if(multiDragSortable!==this.sortable)return;if(evt&&closest(evt.target,this.options.draggable,this.sortable.el,false))return;if(evt&&evt.button!==0)return;while(multiDragElements.length){var el=multiDragElements[0];toggleClass(el,this.options.selectedClass,false);multiDragElements.shift();dispatchEvent({sortable:this.sortable,rootEl:this.sortable.el,name:"deselect",targetEl:el,originalEvent:evt})}},_checkKeyDown:function _checkKeyDown(evt){if(evt.key===this.options.multiDragKey){this.multiDragKeyDown=true}},_checkKeyUp:function _checkKeyUp(evt){if(evt.key===this.options.multiDragKey){this.multiDragKeyDown=false}}};return _extends(MultiDrag,{pluginName:"multiDrag",utils:{select:function select(el){var sortable=el.parentNode[expando];if(!sortable||!sortable.options.multiDrag||~multiDragElements.indexOf(el))return;if(multiDragSortable&&multiDragSortable!==sortable){multiDragSortable.multiDrag._deselectMultiDrag();multiDragSortable=sortable}toggleClass(el,sortable.options.selectedClass,true);multiDragElements.push(el)},deselect:function deselect(el){var sortable=el.parentNode[expando],index=multiDragElements.indexOf(el);if(!sortable||!sortable.options.multiDrag||!~index)return;toggleClass(el,sortable.options.selectedClass,false);multiDragElements.splice(index,1)}},eventProperties:function eventProperties(){var _this3=this;var oldIndicies=[],newIndicies=[];multiDragElements.forEach(function(multiDragElement){oldIndicies.push({multiDragElement:multiDragElement,index:multiDragElement.sortableIndex});var newIndex;if(folding&&multiDragElement!==dragEl$1){newIndex=-1}else if(folding){newIndex=index(multiDragElement,":not(."+_this3.options.selectedClass+")")}else{newIndex=index(multiDragElement)}newIndicies.push({multiDragElement:multiDragElement,index:newIndex})});return{items:_toConsumableArray(multiDragElements),clones:[].concat(multiDragClones),oldIndicies:oldIndicies,newIndicies:newIndicies}},optionListeners:{multiDragKey:function multiDragKey(key){key=key.toLowerCase();if(key==="ctrl"){key="Control"}else if(key.length>1){key=key.charAt(0).toUpperCase()+key.substr(1)}return key}}})}function insertMultiDragElements(clonesInserted,rootEl){multiDragElements.forEach(function(multiDragElement,i){var target=rootEl.children[multiDragElement.sortableIndex+(clonesInserted?Number(i):0)];if(target){rootEl.insertBefore(multiDragElement,target)}else{rootEl.appendChild(multiDragElement)}})}function insertMultiDragClones(elementsInserted,rootEl){multiDragClones.forEach(function(clone,i){var target=rootEl.children[clone.sortableIndex+(elementsInserted?Number(i):0)];if(target){rootEl.insertBefore(clone,target)}else{rootEl.appendChild(clone)}})}function removeMultiDragElements(){multiDragElements.forEach(function(multiDragElement){if(multiDragElement===dragEl$1)return;multiDragElement.parentNode&&multiDragElement.parentNode.removeChild(multiDragElement)})}Sortable.mount(new AutoScrollPlugin);Sortable.mount(Remove,Revert);Sortable.mount(new SwapPlugin);Sortable.mount(new MultiDragPlugin);return Sortable});(function(){window.templateUrls=window.templateUrls||[];var packageName="zh-grid-configuration";var hasPackageRegistered=window.templateUrls.some(function(templateUrl){return templateUrl.package===packageName});if(!hasPackageRegistered){window.templateUrls.push({package:packageName,baseUrl:"./bower_components/"+packageName+"/dist/templates/"})}})();var ZhGridConfigController=function($scope,$timeout,$filter,ApplicationContext,ScreenService,metaDataFactory,templateManager){var self=this;var widget=$scope.widget;var widgetShowCheckbox=widget.showCheckbox;var GRID_MODE="grid";var REPORT_MODE="report";widget.reportShowOnlyVisibleFields=false;widget._selectedColumn=undefined;self.configMode=GRID_MODE;self.inGridMode=function(){return self.configMode==GRID_MODE};$scope.inGridMode=self.inGridMode;self.inReportMode=function(){return self.configMode==REPORT_MODE};$scope.inReportMode=self.inReportMode;self.setConfigMode=function(mode){self.configMode=mode;widget.showCheckbox=self.inGridMode()&&widgetShowCheckbox;widget._selectedColumn=undefined;$timeout(function(){$scope.updateFields(false)})};$scope.getConfigMode=function(){return self.configMode};self.setReportOrientation=function(orientation){widget.reportOrientation=orientation;$timeout(function(){$scope.calcColumnSize();widget.resizeGridColumns(true)})};self.getPageInfo=function(){return ScreenService.i18n("Page")+": 1<br />"+(new Date).toLocaleString()};$scope.selectColumn=function(column){if(widget._selectedColumn==column){widget._selectedColumn=undefined}else{widget._selectedColumn=column;if(Util.isUndefined(column.fixed)){column.fixed=false}$scope.updateFieldDetailsData(column)}};$scope.updateFieldDetailsData=function(column){self.fieldDetailsWidget.dataSource.data[0]={LABEL:self.inReportMode()&&column.labelOnReport||column.label,ALIGNMENT:column.align,EXPRESSION:column.expression};self.fieldDetailsWidget.moveToFirst();self.fieldDetailsWidget.getField("FIXED").setValue(column.fixed);self.fieldDetailsWidget.getField("OPENED").setValue(Util.isUndefinedOrNull(column.groupOpened)?true:column.groupOpened);self.fieldDetailsWidget.getField("VISIBLE").setValue(self.inReportMode()?column.isVisibleOnReport:column.showOnList);if(self.inReportMode()){self.fieldDetailsWidget.getField("COLUMNSIZE").label="Column Width (%)";if(!Util.isUndefinedOrNull(column.reportColumnSize)){self.fieldDetailsWidget.getField("COLUMNSIZE").setValue(parseInt(column.reportColumnSize))}self.fieldDetailsWidget.getField("FIXED").isVisible=false}else{self.fieldDetailsWidget.getField("COLUMNSIZE").label="Column Width (px)";self.fieldDetailsWidget.getField("COLUMNSIZE").setValue(column.gridColumnSize);self.fieldDetailsWidget.getField("FIXED").isVisible=true}self.fieldDetailsWidget.getField("ALIGNMENT").isVisible=!column.grouped;self.fieldDetailsWidget.getField("EXPRESSION").isVisible=!column.grouped;self.fieldDetailsWidget.getField("COLUMNSIZE").isVisible=!column.grouped;self.fieldDetailsWidget.getField("FIXED").isVisible=!column.grouped;self.fieldDetailsWidget.getField("VISIBLE").isVisible=!column.grouped;self.fieldDetailsWidget.getField("OPENED").isVisible=column.grouped&&!self.inReportMode();self.fieldDetailsWidget.getField("LABEL").class=column.grouped&&!self.inReportMode()?10:12;templateManager.updateTemplate()};$scope.calcColumnSize=function(){var totalWidth=$scope.getTotalWidth();widget._filteredFields.forEach(function(field){field.minWidth=field.maxWidth=undefined;if(self.inReportMode()){if(field.reportColumnSize){field.minWidth=field.maxWidth=totalWidth*parseInt(field.reportColumnSize)/100}}else if(field.gridColumnSize){field.minWidth=field.maxWidth=field.gridColumnSize}})};$scope.calcColumnWidthProperties=function(){var totalWidth=$scope.getTotalWidth();widget._filteredFields.forEach(function(field){if(field.minWidth){if(self.inReportMode()){field.reportColumnSize=Math.round(field.minWidth*100/totalWidth)+"%"}else{field.gridColumnSize=field.minWidth}}})};$scope.updateFields=function(apply){function _updateFields(){widget.updateFilteredFields();self.updateGroupedColumns();self.updateNotVisibleColumns();$scope.calcColumnSize()}if(apply!==false){$scope.$apply(_updateFields)}else{_updateFields()}};widget.updateFilteredFields=function(){widget._filteredFields=$filter("orderBy")(widget.fields,$scope.fieldOrder);widget._filteredFields=widget._filteredFields.filter(function(field){var isVisible=false;if(self.inReportMode()){isVisible=field.isVisibleOnReport!==false&&(!widget.listWidget.reportShowOnlyVisibleFields||field.isVisible&&field.showOnList)}else{isVisible=field.isVisible&&field.showOnList}return isVisible&&field.aclIsVisible&&!field.grouped})};self._groupedColumns=[];self.updateGroupedColumns=function(){self._groupedColumns=$filter("orderBy")(widget.fields,$scope.fieldOrder);self._groupedColumns=self._groupedColumns.filter(function(field){return field.grouped&&field.aclIsVisible})};self._notVisibleColumns=[];self.updateNotVisibleColumns=function(){self._notVisibleColumns=$filter("orderBy")(widget.fields,$scope.fieldOrder);self._notVisibleColumns=self._notVisibleColumns.filter(function(field){return!~widget._filteredFields.indexOf(field)&&!~self._groupedColumns.indexOf(field)&&field.aclIsVisible})};$timeout(function(){$scope.updateFields(false)});self.layoutNameWidget=metaDataFactory.widgetFactory({id:"grid-config-layout-name",name:"grid-config-layout-name",template:"widget/form-structure.html",container:widget.container,isVisible:true,popupNoBlock:false,showDescriptionOrder:false,floatingControl:false,dataSource:{data:[]},actions:[],events:[],fields:[{label:"Layout name",name:"LABEL",class:"12",showOnForm:true,template:"field/text-edit.html",events:[],validations:{required:{}}}]});self.layoutNameWidget.dataSource.data.push({LABEL:widget.layoutName});self.layoutNameWidget.currentRow=self.layoutNameWidget.dataSource.data[0];$scope.$watch(function(){return self.layoutNameWidget.dataSource.data[0].LABEL},function(newValue){if(!Util.isUndefinedOrNull(newValue)){widget.layoutName=newValue}});self.fieldDetailsWidget=metaDataFactory.widgetFactory({id:"grid-config-field-details",name:"grid-config-field-details",label:"Field Details",template:"widget/form-structure.html",container:widget.container,isVisible:true,popupNoBlock:false,showDescriptionOrder:false,floatingControl:false,fieldGroups:[{name:"FIELDGROUP",opened:true,collapsible:false,label:"Column properties"}],fields:[{label:"Label",name:"LABEL",showLabel:true,showOnList:true,showOnForm:true,fieldGroup:"FIELDGROUP",class:12,template:"field/text-edit.html"},{label:"Alignment",name:"ALIGNMENT",showLabel:true,showOnList:true,showOnForm:true,fieldGroup:"FIELDGROUP",class:3,template:"field/select-native.html",dataSource:{data:[{value:"left"},{value:"center"},{value:"right"}]},valueField:"value",hideEmptyValue:true,descriptionField:"value"},{label:"Group expression",name:"EXPRESSION",showLabel:true,showOnList:true,showOnForm:true,fieldGroup:"FIELDGROUP",class:3,template:"field/select-native.html",dataSource:{data:[{value:"SUM"},{value:"AVG"},{value:"COUNT"},{value:"MAX"},{value:"MIN"}]},valueField:"value",hideEmptyValue:false,descriptionField:"value"},{label:"Column Width (%)",name:"COLUMNSIZE",showLabel:true,showOnList:true,showOnForm:true,fieldGroup:"FIELDGROUP",class:3,template:"field/number.html",spin:true},{label:"Fixed",name:"FIXED",showLabel:true,showOnList:true,showOnForm:true,fieldGroup:"FIELDGROUP",class:1,template:"field/checkbox.html",valueToTrue:true,valueToFalse:false},{label:"Visible",name:"VISIBLE",showLabel:true,showOnList:true,showOnForm:true,fieldGroup:"FIELDGROUP",class:2,template:"field/checkbox.html",valueToTrue:true,valueToFalse:false},{label:"Opened",name:"OPENED",showLabel:true,showOnList:true,showOnForm:true,fieldGroup:"FIELDGROUP",class:2,template:"field/checkbox.html",valueToTrue:true,valueToFalse:false}],dataSource:{data:[]},actions:[],events:[]});var lastSelectedColumn;$scope.$watch(function(){return self.fieldDetailsWidget.dataSource.data[0]},function(newValue){if(newValue&&widget._selectedColumn&&lastSelectedColumn==widget._selectedColumn){var forceResize=false;if(self.inReportMode()){widget._selectedColumn.labelOnReport=newValue.LABEL;widget._selectedColumn.reportColumnSize=undefined;if(!Util.isUndefinedOrNull(newValue.COLUMNSIZE)&&widget._selectedColumn.reportColumnSize!=newValue.COLUMNSIZE+"%"){widget._selectedColumn.reportColumnSize=newValue.COLUMNSIZE+"%";$scope.calcColumnSize();$scope.setFieldWidthFromElementWidth();$scope.calcColumnWidthProperties();forceResize=true}if(widget._selectedColumn.isVisibleOnReport!=newValue.VISIBLE){widget._selectedColumn.isVisibleOnReport=newValue.VISIBLE;widget._selectedColumn=undefined;widget.updateFilteredFields();self.updateNotVisibleColumns();$scope.removeInvisibleColumns();forceResize=true}}else{widget._selectedColumn.label=newValue.LABEL;widget._selectedColumn.gridColumnSize=undefined;if(!Util.isUndefinedOrNull(newValue.COLUMNSIZE)&&widget._selectedColumn.gridColumnSize!=newValue.COLUMNSIZE){widget._selectedColumn.gridColumnSize=newValue.COLUMNSIZE;$scope.calcColumnSize();$scope.setFieldWidthFromElementWidth();$scope.calcColumnWidthProperties();forceResize=true}if(widget._selectedColumn.showOnList!=newValue.VISIBLE){widget._selectedColumn.showOnList=newValue.VISIBLE;widget._selectedColumn=undefined;widget.updateFilteredFields();self.updateNotVisibleColumns();$scope.removeInvisibleColumns();forceResize=true}}if(widget._selectedColumn){widget._selectedColumn.align=newValue.ALIGNMENT;widget._selectedColumn.expression=newValue.EXPRESSION;widget._selectedColumn.groupOpened=newValue.OPENED;if(widget._selectedColumn.fixed!=newValue.FIXED){widget._selectedColumn.fixed=newValue.FIXED;widget.updateFilteredFields();var fixed=true;widget._filteredFields.forEach(function(field,idx){field.sequenceInList=idx;fixed=fixed&&field.fixed;field.fixed=fixed});forceResize=true}}if(forceResize){widget.resizeGridColumns(true)}}lastSelectedColumn=widget._selectedColumn},true);self.previewPDF=function(){widget.reportShowOnlyVisibleFields=widget.listWidget.reportShowOnlyVisibleFields;ApplicationContext.ZhReports.openReport(undefined,widget,undefined,undefined,"PDF").then(function(){widget.reportShowOnlyVisibleFields=false})};self.openSearch=function(){self.searchOpened=!self.searchOpened;if(self.searchOpened){$("#zh-grid-config-not-visible-search input").focus()}};self.clearSearch=function(){delete self.notVisibleSearch};self.getNotVisibleColumns=function(){return self._notVisibleColumns.filter(function(item){return!self.notVisibleSearch||item.label.indexOfLatin(self.notVisibleSearch)>-1}).sort(function(a,b){a.label=a.label||"";b.label=b.label||"";var labelA=a.label.toUpperCase();var labelB=b.label.toUpperCase();if(labelA<labelB){return-1}if(labelA>labelB){return 1}return 0})};widget.gridConfigWidget=self.layoutNameWidget};ZeedhiController.controller("ZhGridConfigController",ZhGridConfigController);(function(){var ZeedhiDirectives=angular.module("ZeedhiDirectives");ZeedhiDirectives.directive("zhGridConfig",zhGridConfig);function zhGridConfig(ApplicationContext){return{restrict:"A",link:function($scope,element){var widget=$scope.widget;if(Util.isUndefinedOrNull(ApplicationContext.ZhReports)){element.find("span.config-buttons").hide()}$scope.getTotalWidth=function(){return element.find(".header-content").outerWidth()-(element.find(".header-content .th.grid-checkbox-column").outerWidth()||0)-10};element.find(".body-content").off("mousewheel wheel DOMMouseScroll");var groupedColumns=element.find(".zh-grid-config-groups .sortable-columns")[0];var visibleColumns=element.find(".zh-grid-container .sortable-columns")[0];var notVisibleColumns=element.find(".zh-grid-config-not-visible .sortable-columns")[0];$scope.onStartSortable=function(evt){var el=$(evt.item);var fieldName=el.attr("data-zh-field-name");var field=widget.getField(fieldName);if(field==widget._selectedColumn){delete widget._selectedColumn}};$scope.onAddSortable=function(evt){var fieldName=$(evt.item).attr("data-zh-field-name");var field=widget.getField(fieldName);if(field){if($(evt.to).parent().hasClass("zh-grid-config-groups")){field.showOnList=false;field.grouped=true;field.groupOpened=Util.isUndefinedOrNull(field.groupOpened)?true:field.groupOpened}else if($(evt.to).parent().hasClass("zh-grid-config-not-visible")){if($scope.inReportMode()){field.isVisibleOnReport=false}else{field.showOnList=false}field.grouped=false}else{if($scope.inReportMode()){field.isVisibleOnReport=true}else{field.showOnList=true}field.isVisible=true;field.grouped=false}}$scope.onUpdateSortable(evt)};$scope.onUpdateSortable=function(evt){var fixed=true;$(evt.to).parent().find(".th").each(function(idx,item){var fieldName=$(item).attr("data-zh-field-name");var field=widget.getField(fieldName);if(field){if(!$(evt.to).parent().hasClass("zh-grid-config-not-visible")){field.sequenceInList=idx}if($(evt.to).parent().hasClass("tr")){fixed=fixed&&field.fixed;field.fixed=fixed}}});if(evt.type=="add"){$(evt.item).remove()}$scope.updateFields()};var sortableOptions={group:"sortableList",onUpdate:$scope.onUpdateSortable,onAdd:$scope.onAddSortable,onStart:$scope.onStartSortable,animation:100,handle:".label-text",scroll:element.find(".body-scroll-control")[0]};var sortableItems=[];[groupedColumns,visibleColumns,notVisibleColumns].forEach(function(el){sortableItems.push(Sortable.create(el,sortableOptions))});$scope.$on("$destroy",function(){sortableItems.forEach(function(item){item.destroy()});sortableItems=[];delete $scope.onUpdateSortable;delete $scope.onAddSortable;delete $scope.onStartSortable});element.on("touchend touchcancel mouseup pointercancel",function(){delete element[0]._tapEvt});$scope.setFieldWidthFromElementWidth=function(force){element.find(".header-content .sortable-columns .th").each(function(idx,item){item=$(item);var itemField=widget.getField(item.attr("data-zh-field-name"));if(Util.isUndefinedOrNull(itemField.minWidth)||force){itemField.minWidth=item.width();itemField.maxWidth=item.outerWidth()}})};element.on("touchmove mousemove",function(evt){if(element[0]._tapEvt){var tapElement=$(element[0]._tapEvt.target);var thElement=tapElement.closest(".th");var deltaX=evt.clientX-element[0]._tapEvt.clientX;if(deltaX===0){return}if(thElement.offset().left+thElement.outerWidth()+deltaX>thElement.offsetParent().offset().left+thElement.offsetParent().outerWidth()){return}var field=widget.getField(thElement.attr("data-zh-field-name"));var width=thElement.width();var outerWidth=thElement.outerWidth();$scope.setFieldWidthFromElementWidth(true);if(tapElement.hasClass("resize-handle-left")){if(thElement.prev().length){thElement.width(width-deltaX);if(field){field.minWidth=field.maxWidth=outerWidth-deltaX}var prevElement=thElement.prev();if(prevElement){var prevWidth=prevElement.width();var prevOuterWidth=prevElement.outerWidth();prevElement.width(prevWidth+deltaX);var prevField=widget.getField(prevElement.attr("data-zh-field-name"));if(prevField){prevField.minWidth=prevField.maxWidth=prevOuterWidth+deltaX}}}}else{thElement.width(width+deltaX);if(field){field.minWidth=width+deltaX;field.maxWidth=outerWidth+deltaX}}element[0]._tapEvt.clientX+=deltaX;$scope.calcColumnWidthProperties();$scope.updateFieldDetailsData(field);widget.resizeGridColumns(true)}});$scope.removeInvisibleColumns=function(){var thItems=element.find(".header-content .sortable-columns .th");thItems.each(function(idx,th){th=$(th);var fieldName=th.attr("data-zh-field-name");var field=widget.getField(fieldName);if(!field||widget._filteredFields.indexOf(field)==-1){th.remove()}})}}}}ZeedhiDirectives.directive("zhGridConfigResizeHandle",zhGridConfigResizeHandle);function zhGridConfigResizeHandle(){return{restrict:"A",link:function($scope,element){var widget=$scope.widget;element.on("touchStart mousedown",function(evt){element.closest(".zh-grid-config-container")[0]._tapEvt=evt});element.on("touchend touchcancel mouseup pointercancel",function(evt){delete element.closest(".zh-grid-config-container")[0]._tapEvt})}}}})();function ZhViewPreferences(ZhPreferences,ZhFilterPreferences,ZhLayoutPreferences,templateManager,eventAggregator,ZHPromise,Query,eventEngine,ZhUtil,MessageService){var originalView={ID:"ORIGINAL",LABEL_TO_PREFERENCE:"Original",FILTER_ID:"ORIGINAL",LAYOUT_ID:"ORIGINAL"};function shouldShowViewAction(widget){return Util.get(widget,["floatingControl","customizationAction","view"])!==false}eventAggregator.subscribe("beforeProjectStartup",function(){ZhPreferences.registerRepository("zh-view-preferences#view");templateManager.project.customFloatingActions.push({name:"View Action",label:"View",type:"view",order:30,icon:"view",template:"zh-view-preferences#floating-view-card.html",expandable:true,isVisible:shouldShowViewAction})});eventEngine.registerEvent("ViewBeforeApply","beforeViewApply");eventEngine.registerEvent("ViewAfterApply","afterViewApply");this.updateViews=function(widgetID,dataSource){return this.getWidgetViews(widgetID).then(function(views){return views}).then(function(views){return this.addIsDefaultViewToViews(views,widgetID).then(function(views){dataSource.data=views})}.bind(this))};this.addIsDefaultViewToViews=function(views,widgetID){return ZhPreferences.getDefaultWidgetPreferences(widgetID).then(function(defaultPreferences){var defaultView=defaultPreferences.DEFAULT_VIEW;return views.map(addIsDefaultViewToView.bind(this,defaultView))})};function addIsDefaultViewToView(defaultView,view){view.DEFAULT_VIEW=view.ID===defaultView;return view}this.getWidgetViews=function(widgetID){return ZhPreferences.getWidgetPreferences("view",widgetID)};this.saveViews=function(views){var cloneViews=views.map(function(view){return ZhUtil.clearRow(view)});return ZhPreferences.savePreferences("view",cloneViews).then(function(response){cloneViews.forEach(function(clone,index){views[index].ID=clone.ID;views[index].__is_new=clone.__is_new;views[index].changes=clone.changed});return ZHPromise.when(response)})};this.deleteViews=function(views){var cloneViews=views.map(function(view){return ZhUtil.clearRow(view)});return ZhPreferences.deletePreferences("view",cloneViews)};function triggerBeforeViewApplyEvent(widget,view){if(widget.beforeViewApply){widget.beforeViewApply({view:view})}}function triggerAfterViewApplyEvent(widget,view){if(widget.afterViewApply){widget.afterViewApply({view:view})}}this.applyOriginalView=function(widget){var filter=ZhFilterPreferences.applyOriginalFilter(widget);var layout=ZhLayoutPreferences.applyOriginalLayout(widget);triggerBeforeViewApplyEvent(widget,originalView);return ZHPromise.all([filter,layout]).then(function(){widget.setAppliedView(originalView);triggerAfterViewApplyEvent(widget,originalView)})};function getFilterObject(widget,preference){var filter;if(preference.FILTER_OBJ){filter=[preference.FILTER_OBJ]}else{var filterQuery=Query.build().where("ID").equals(preference.FILTER_ID).where("WIDGET_ID").equals(widget.id);filter=ZhFilterPreferences.getFilters(filterQuery)}return filter}function getLayoutObject(widget,preference){var layout;if(preference.LAYOUT_OBJ){layout=[preference.LAYOUT_OBJ]}else{var layoutQuery=Query.build().where("ID").equals(preference.LAYOUT_ID).where("WIDGET_ID").equals(widget.id);layout=ZhLayoutPreferences.getLayouts(layoutQuery)}return layout}this.applyView=function(widget,preference,reloadWidget){reloadWidget=reloadWidget!==false;var filter=getFilterObject(widget,preference);var layout=getLayoutObject(widget,preference);triggerBeforeViewApplyEvent(widget,preference);return ZHPromise.all([filter,layout]).then(function(args){var filter=args[0].pop();var layout=args[1].pop();var filterStatus=ZhFilterPreferences.applyFilter(widget,filter,reloadWidget);var layoutStatus=ZhLayoutPreferences.applyLayout(widget,layout);return ZHPromise.all([filterStatus,layoutStatus])}).then(function(){widget.setAppliedView(preference);triggerAfterViewApplyEvent(widget,preference)})};this.downloadPreferenceFile=function(view){var fileName=view.LABEL_TO_PREFERENCE.latinise().replace(/[^a-z,0-9 ]/gi,"").replace(/(?:^\w|[A-Z]|\b\w|\s+)/g,function(match,index){if(+match===0)return"";return index==0?match.toLowerCase():match.toUpperCase()})+".view";var viewToExport={ID:view.ID,LABEL_TO_PREFERENCE:view.LABEL_TO_PREFERENCE,WIDGET_ID:view.WIDGET_ID,FILTER_ID:view.FILTER_ID,LAYOUT_ID:view.LAYOUT_ID,LAST_MODIFIED_DATE:view.LAST_MODIFIED_DATE};return ZhPreferences.downloadPreferenceFile(viewToExport,fileName)};function getObjectFromBase64(b64){b64=b64.split("base64,")[1];b64=window.atob(b64);b64=decodeURIComponent(escape(b64));return JSON.parse(b64)}this.validateViewImport=function(view,importViewWidget,layouts,filters,viewDataSource){var configWidget=importViewWidget.configWidget;viewDataSource=viewDataSource||configWidget.dataSource.data;var layoutFileField=importViewWidget.getField("layoutFile");var filterFileField=importViewWidget.getField("filterFile");var layoutFileFieldGroup=importViewWidget.fieldGroups[1];var filterFileFieldGroup=importViewWidget.fieldGroups[2];if(configWidget.listWidget.id!=view.WIDGET_ID){MessageService.showMessageByCode("zh-view-preferences#import_error_widget_id");return false}var viewsWithSameId=viewDataSource.filter(function(row){return row.ID==view.ID});if(viewsWithSameId.length>0){MessageService.showMessageByCode("zh-view-preferences#import_error_id_violation");return false}var viewsWithSameLabel=viewDataSource.filter(function(row){return row.LABEL_TO_PREFERENCE==view.LABEL_TO_PREFERENCE});if(viewsWithSameLabel.length>0){MessageService.showMessageByCode("zh-view-preferences#import_error_name_violation");return false}var selectedLayout=layouts.filter(function(layout){return layout.ID==view.LAYOUT_ID});if(selectedLayout.length==0&&layoutFileField.value().length==0){MessageService.showMessageByCode("zh-view-preferences#import_error_layout_dependency");layoutFileFieldGroup.opened=true;return false}if(layoutFileField.value().length>0){var layout=getObjectFromBase64(layoutFileField.value()[0].b64File);if(layout.ID!=view.LAYOUT_ID){MessageService.showMessageByCode("zh-view-preferences#import_error_layout_dependency2");return false}}var selectedFilter=filters.filter(function(filter){return filter.ID==view.FILTER_ID});if(selectedFilter.length==0&&filterFileField.value().length==0){MessageService.showMessageByCode("zh-view-preferences#import_error_filter_dependency");filterFileFieldGroup.opened=true;return false}if(filterFileField.value().length>0){var filter=getObjectFromBase64(filterFileField.value()[0].b64File);if(filter.ID!=view.FILTER_ID){MessageService.showMessageByCode("zh-view-preferences#import_error_filter_dependency2");return false}}return true}}Configuration(function(ContextRegister){ContextRegister.register("ZhViewPreferences",ZhViewPreferences)});var ZhViewWidgetsBuilder=function(restEngine,templateManager,metaDataFactory){function getWidgetJSON(widgetName){var widgetPath="zh-view-preferences#json/widgets/"+widgetName+".json";return restEngine.requestMetaData(widgetPath).then(function(response){return response.data})}this.factoryWidget=function(widgetName){return getWidgetJSON(widgetName).then(function(widget){return metaDataFactory.widgetFactory(widget,templateManager.container)})};this.factoryViewConfigurationWidget=function(methods){return this.factoryWidget("config")};this.factoryCreateViewWidget=function(methods){return this.factoryWidget("create-view")};this.factoryImportViewWidget=function(){return this.factoryWidget("importView")}};ZeedhiController.controller("ZhViewWidgetsBuilder",ZhViewWidgetsBuilder);Configuration(function(ContextRegister){ContextRegister.register("ZhViewWidgetsBuilder",ZhViewWidgetsBuilder)});var ZhViewCreateViewController=function(ZhViewPreferences,ZhFilterPreferences,ZhLayoutPreferences,ZhViewWidgetsBuilder,ScreenService,MessageService,ZHPromise,ZhUtil){var createViewWidgetPromise=null;this.getCreateViewWidget=function(configWidget){if(createViewWidgetPromise===null){createViewWidgetPromise=ZhViewWidgetsBuilder.factoryCreateViewWidget()}var listWidget=configWidget.listWidget;var filters=ZhFilterPreferences.getWidgetFilters(listWidget.id);var layouts=ZhLayoutPreferences.getWidgetLayouts(listWidget.id);return ZHPromise.all([createViewWidgetPromise,filters,layouts]).then(function(args){var createViewWidget=args[0];var filters=args[1];var layouts=args[2];createViewWidget.configWidget=configWidget;createViewWidget.getField("FILTER_ID").dataSource.data=filters;createViewWidget.getField("LAYOUT_ID").dataSource.data=layouts;return createViewWidget})};this.cancelCreateView=function(createViewWidget){var configWidget=createViewWidget.configWidget;Util.extend(configWidget.currentRow,configWidget.backupRow);return ScreenService.closePopup()};this.saveAndApplyView=function(createViewWidget){if(createViewWidget.isValid()){var view=ZhUtil.clearRow(createViewWidget.currentRow);var configWidget=createViewWidget.configWidget;var listWidget=configWidget.listWidget;return ZhViewPreferences.saveViews([view]).then(function(){return ZhViewPreferences.applyView(listWidget,view)}).then(function(){ZhViewPreferences.updateViews(listWidget.id,configWidget.dataSource);ScreenService.closePopup(true);return listWidget.activate()}).catch(function(error){return MessageService.getMessageByCode("zh-view-preferences#"+error.message).then(function(errorMessage){return MessageService.showMessageByCode("zh-view-preferences#save_error",{ERROR:ScreenService.i18n(errorMessage)})})})}else{return ZHPromise.when()}}};ZeedhiController.controller("ZhViewCreateViewController",ZhViewCreateViewController);Configuration(function(ContextRegister){ContextRegister.register("ZhViewCreateViewController",ZhViewCreateViewController)});var ZhViewImportViewController=function(MessageService,ZhViewPreferences,ZhPreferences,ZhFilterPreferences,ZhLayoutPreferences,ZhViewWidgetsBuilder,ZHPromise,ScreenService,$timeout){var importViewWidgetPromise=null;this.getImportViewWidget=function(){if(importViewWidgetPromise===null){importViewWidgetPromise=ZhViewWidgetsBuilder.factoryImportViewWidget()}return importViewWidgetPromise};function getObjectFromBase64(b64){b64=b64.split("base64,")[1];b64=window.atob(b64);b64=decodeURIComponent(escape(b64));return JSON.parse(b64)}function buildImportPromises(importViewWidget,userID,layouts,filters){var layoutFileField=importViewWidget.getField("layoutFile");var filterFileField=importViewWidget.getField("filterFile");var promises=[];if(layoutFileField.value().length>0){var layout=getObjectFromBase64(layoutFileField.value()[0].b64File);if(!ZhLayoutPreferences.validateLayoutImport(layout,importViewWidget.configWidget,layouts)){return[ZHPromise.reject()]}promises.push(function(){layout.__is_new=true;layout.__generate_id=false;layout.USER_ID=userID;layout.LAYOUT_CHANGES=JSON.stringify(layout.LAYOUT_CHANGES);return ZhLayoutPreferences.saveLayouts([layout]).then(function(){ZhLayoutPreferences.updateLayouts(importViewWidget.configWidget.listWidget.id)}).catch(function(error){MessageService.showMessageByCode("zh-layout-preferences#save_error",{ERROR:error.message});return ZHPromise.reject()})}())}if(filterFileField.value().length>0){var filter=getObjectFromBase64(filterFileField.value()[0].b64File);if(!ZhFilterPreferences.validateFilterImport(filter,importViewWidget.configWidget,filters)){return[ZHPromise.reject()]}promises.push(function(){filter.__is_new=true;filter.__generate_id=false;filter.USER_ID=userID;filter.FILTER_ROW=JSON.stringify(filter.FILTER_ROW);return ZhFilterPreferences.saveFilters([filter]).then(function(){ZhFilterPreferences.updateFilters(importViewWidget.configWidget.listWidget.id)}).catch(function(error){MessageService.showMessageByCode("zh-filter-preferences#save_error",{ERROR:error.message});return ZHPromise.reject()})}())}return promises}this.importPreference=function(importViewWidget){if(!importViewWidget.isValid()){return ZHPromise.reject({err:"WIDGET_INVALID"})}var viewFileField=importViewWidget.getField("viewFile");var view=getObjectFromBase64(viewFileField.value()[0].b64File);var configWidget=importViewWidget.configWidget;var listWidget=configWidget.listWidget;var filters=ZhFilterPreferences.getWidgetFilters(listWidget.id);var layouts=ZhLayoutPreferences.getWidgetLayouts(listWidget.id);return ZHPromise.all([filters,layouts]).then(function(args){filters=args[0];layouts=args[1];if(!ZhViewPreferences.validateViewImport(view,importViewWidget,layouts,filters)){return ZHPromise.reject({err:"VIEW_FILE_INVALID"})}return ZhPreferences.getUserID().then(function(userID){view.USER_ID=userID;view.__is_new=true;view.__generate_id=false;var importPromises=buildImportPromises(importViewWidget,userID,layouts,filters);return ZHPromise.all(importPromises).then(function(){return ZhViewPreferences.saveViews([view]).then(function(){ScreenService.closePopup();ZhViewPreferences.updateViews(listWidget.id,configWidget.dataSource);configWidget.refreshWidget()}).catch(function(error){MessageService.showMessageByCode("zh-view-preferences#save_error",{ERROR:error.message})})})})})}};ZeedhiController.controller("ZhViewImportViewController",ZhViewImportViewController);Configuration(function(ContextRegister){ContextRegister.register("ZhViewImportViewController",ZhViewImportViewController)});var ZhViewConfigController=function(ZhPreferences,ZhViewPreferences,ZhViewWidgetsBuilder,ScreenService,MessageService,ZHPromise,ZhViewCreateViewController,ZhViewImportViewController){var configWidgetPromise=null;this.getConfigWidget=function(listWidget,dataSource){if(configWidgetPromise===null){configWidgetPromise=ZhViewWidgetsBuilder.factoryViewConfigurationWidget()}var userID=ZhPreferences.getUserID();return ZHPromise.all([userID,configWidgetPromise]).then(function(args){var userID=args[0];var configWidget=args[1];configWidget.listWidget=listWidget;configWidget.dataSourceFilter=[{name:"WIDGET_ID",operator:"=",value:listWidget.id}];dataSource.data.forEach(function(row){row.APPLIED=row.ID==(listWidget.appliedView?listWidget.appliedView.ID:"ORIGINAL")});configWidget.dataSource=dataSource;return configWidget})};this.openCreateViewWidget=function(configWidget){var createViewWidget=ZhViewCreateViewController.getCreateViewWidget(configWidget);var userID=ZhPreferences.getUserID();var listWidget=configWidget.listWidget;return ZHPromise.all([createViewWidget,userID]).then(function(args){var createViewWidget=args[0];var userID=args[1];createViewWidget.newRow();createViewWidget.currentRow.ID=null;createViewWidget.currentRow.USER_ID=userID;createViewWidget.currentRow.WIDGET_ID=listWidget.id;createViewWidget.currentRow.LAST_MODIFIED_DATE=null;createViewWidget.label=ScreenService.i18n("View");return ScreenService.openPopup(createViewWidget)})};this.editView=function(configWidget,view){if(view.TYPE==="F"){MessageService.alertNotificationByCode("zh-view-preferences#cannot_edit_fixed_view");return ZHPromise.when()}return ZhViewCreateViewController.getCreateViewWidget(configWidget).then(function(createViewWidget){configWidget.backupRow=Util.clone(view,["__rightActions","__leftActions"]);createViewWidget.currentRow=view;createViewWidget.label=ScreenService.i18n("View")+" - "+view.LABEL_TO_PREFERENCE;return ScreenService.openPopup(createViewWidget)})};this.deleteViews=function(configWidget){var viewsToDelete=configWidget.getCheckedRows();var defaultView=viewsToDelete.filter(function(view){return view.DEFAULT_VIEW});if(defaultView.length){MessageService.showMessageByCode("zh-view-preferences#delete_error_default");return}return MessageService.confirmMessageByCode("zh-view-preferences#delete",{NR_OF_VIEWS:viewsToDelete.length}).then(function(){return ZhViewPreferences.deleteViews(viewsToDelete).then(function(){configWidget.dataSource.clearCheckedRows();ZhViewPreferences.updateViews(configWidget.listWidget.id,configWidget.dataSource)}).catch(function(error){MessageService.showMessageByCode("zh-view-preferences#delete_error",{ERROR:error.message})})})};this.updateDefaultView=function(configWidget,view){return ZhPreferences.changeDefaultPreferences(configWidget,"DEFAULT_VIEW",view)};this.updateAppliedView=function(configWidget,view){var listWidget=configWidget.listWidget;return ZhViewPreferences.applyView(listWidget,view).then(function(){configWidget.dataSource.data.forEach(function(row){row.APPLIED=row.ID==view.ID})})};this.downloadPreferenceFile=function(view){return ZhViewPreferences.downloadPreferenceFile(view)};this.importPreferenceFile=function(configWidget){return ZhViewImportViewController.getImportViewWidget().then(function(importViewWidget){importViewWidget.newRow();importViewWidget.configWidget=configWidget;return ScreenService.openPopup(importViewWidget)})}};ZeedhiController.controller("ZhViewConfigController",ZhViewConfigController);Configuration(function(ContextRegister){ContextRegister.register("ZhViewConfigController",ZhViewConfigController)});var ZhViewFloatingCardController=function($scope,ApplicationContext,ScreenService,eventEngine,Query,metaDataFactory){var widget=$scope.widget;$scope.appliedPreference=null;var ZhViewConfigController=ApplicationContext.ZhViewConfigController;var ZhViewPreferences=ApplicationContext.ZhViewPreferences;var ZhPreferences=ApplicationContext.ZhPreferences;var dataSource=metaDataFactory.factoryDataSource({name:"zh-view-preferences#/view",localStorage:false,lazyLoad:true,rest:true,data:[]});dataSource.afterLoadDataSource(function(){return ZhViewPreferences.addIsDefaultViewToViews(dataSource.data,widget.id).then(function(views){dataSource.data=views})});$scope.customizationCard={label:"Views",type:"view",openViewConfiguration:openViewConfiguration,refreshViews:refreshViews,applyOriginalView:applyOriginalView,applyView:applyPreference,dataSource:dataSource};var filterApplyEventIndex=eventEngine.bindEvent(widget,"FilterAfterApply",function(){$scope.appliedPreference=null;widget.appliedView=null;if(widget.reportCustomData){delete widget.reportCustomData.name}});var layoutApplyEventIndex=eventEngine.bindEvent(widget,"LayoutAfterApply",function(){$scope.appliedPreference=null;widget.appliedView=null;if(widget.reportCustomData){delete widget.reportCustomData.name}});widget.setAppliedView=setAppliedView;$scope.$on("$destroy",function(){delete widget.setAppliedView;eventEngine.unbindEvent(widget,"FilterAfterApply",filterApplyEventIndex);eventEngine.unbindEvent(widget,"LayoutAfterApply",layoutApplyEventIndex);delete dataSource.afterLoadDataSourcelistener});function setAppliedView(view){$scope.appliedPreference=view;widget.appliedView=view;if(view.LABEL_TO_PREFERENCE){sessionStorage.setItem("view_"+widget.id,view.LABEL_TO_PREFERENCE)}widget.reportCustomData=widget.reportCustomData||{};if(view.ID!="ORIGINAL"){widget.reportCustomData.name=view.LABEL_TO_PREFERENCE}else{delete widget.reportCustomData.name}}function openViewConfiguration(){return ZhViewConfigController.getConfigWidget(widget,dataSource).then(function(configWidget){return ScreenService.openPopup(configWidget)})}function refreshViews(){return ZhPreferences.getUserID().then(function(userID){var query=Query.build().where("WIDGET_ID").equals(widget.id);return $scope.customizationCard.dataSource.load(query.where())})}function applyOriginalView(){return ZhViewPreferences.applyOriginalView(widget)}function applyPreference(preference,reloadWidget){return ZhViewPreferences.applyView(widget,preference,reloadWidget)}function applyDefaultView(){ZhPreferences.getDefaultWidgetPreferences(widget.id).then(function(defaultPreference){var view=defaultPreference.defaultView;if(view){var filterIsLazyLoad=Util.getNestedProperty(widget,["dataSource","lazyLoad"]);applyPreference(view,!filterIsLazyLoad)}})}(function initViewPreferences(){if(ZhPreferences.validateWidget(widget)){if(Util.isUndefinedOrNull(widget.appliedView)){applyDefaultView()}else{applyPreference(widget.appliedView)}}})()};ZeedhiController.controller("ZhViewFloatingCardController",ZhViewFloatingCardController);var ZeedhiDirectives=angular.module("ZeedhiDirectives");ZeedhiDirectives.directive("zhViewFloatingControl",[ZhViewFloatingControl]);function ZhViewFloatingControl(){return{priority:10,link:function($scope){$scope.toggleViewPreferencesCard=function(e){var actionElement=$(e.target).closest(".float-action");if(!actionElement.hasClass("opened")){$scope.customizationCard.refreshViews()}$scope.togglePreferencesCard(e)}}}}(function(){window.templateUrls=window.templateUrls||[];window.metadataUrls=window.metadataUrls||[];window.serviceUrls=window.serviceUrls||[];var PACKAGE_NAME="zh-view-preferences";var hasTemplateUrl=Boolean(window.templateUrls.find(function(value){return value.package===PACKAGE_NAME}));var hasMetadataUrl=Boolean(window.metadataUrls.find(function(value){return value.package===PACKAGE_NAME}));var hasServiceUrl=Boolean(window.serviceUrls.find(function(value){return value.package===PACKAGE_NAME}));if(!hasTemplateUrl){window.templateUrls.push({package:PACKAGE_NAME,baseUrl:"bower_components/zh-view-preferences/dist/templates/"})}if(!hasMetadataUrl){window.metadataUrls.push({package:PACKAGE_NAME,baseUrl:"bower_components/zh-view-preferences/dist/assets/"})}if(!hasServiceUrl){window.serviceUrls.push({package:PACKAGE_NAME,baseUrl:"../backend/service/index.php/zh-preferences"})}})();var FloatingReportCardController=function($scope,$rootScope,ScreenService,templateManager,ApplicationContext,restEngine,ZHPromise,eventAggregator){var editingWidget=$scope.$parent.widget;function checkFloatingCardOverflow(e){var actionElement=$(e.target).closest(".float-action");var floatingControl=actionElement.parents(".zh-floating-control");var widgetContainer=actionElement.closest(".container");var actionTop,actionBottom;var widgetTop,widgetBottom;if(!actionElement.hasClass("opened")){actionElement.removeClass("fix-position-top");actionElement.removeClass("fix-position-bottom");actionTop=actionElement.offset().top;widgetTop=widgetContainer.offset().top;widgetBottom=widgetTop+widgetContainer.height();if(floatingControl.hasClass("pos-top")){actionTop=actionTop-200+actionElement.height();if(actionTop<widgetTop){actionElement.addClass("fix-position-top")}}else{actionBottom=actionTop+200;if(actionBottom>widgetBottom){actionElement.addClass("fix-position-bottom")}}}}$scope.toggleFloatReportCard=function(e){checkFloatingCardOverflow(e);$scope.toggleAction(e)};editingWidget.toggleFloatReportCard=$scope.toggleFloatReportCard;$scope.setOrientation=function(e,orientation){$scope.widget.reportOrientation=orientation;e.stopPropagation()};$scope.getVisibilityActionXlsReport=function(widget,format){var isvisible=false;if(widget&&widget.floatingControl&&widget.floatingControl.xlsAction!==false){if((!widget.floatingControl.xlsAction||widget.floatingControl.xlsAction.runAt!=="local")&&widget.template.endsWith("widget/grid.html")){if(format==="origin"){isvisible=false}else{isvisible=!widget.floatingControl.xlsAction||widget.floatingControl.xlsAction[format]!==false}}else if(format==="origin"){isvisible=true}}return isvisible}};ZeedhiController.controller("FloatingReportCardController",FloatingReportCardController);function ZhReportsXLS(){var expressionZeedhiToXls={AVG:"AVERAGE",COUNT:"COUNTA",MAX:"MAX",MIN:"MIN",SUM:"SUM"};var expressionZeedhiToXlsIFS={AVG:"AVERAGEIFS",COUNT:"COUNTIFS",MAX:"MAXIFS",MIN:"MINIFS",SUM:"SUMIFS"};this.labelByFormat={F1:"XLS (all columns - with group)",F2:"XLS (grid mirror - with group)",F3:"XLS (all columns - no group)"};var isFormat2=function(format){return format==="F2"};var isFormat3=function(format){return format==="F3"||format==="ERROR_LOAD"};this.isFormat3=isFormat3;var colunmXLS="ABCDEFGHIJKLMNOPQRSTUVWXYZ";var getColumnsNameFormat2=function(columns,metaData){var columnsNameGroup=metaData.groups.map(function(row){return row.field});var columnsName=[];Object.entries(columns).forEach(function(row){var columnName=row[0];if(columnsNameGroup.indexOf(columnName)===-1){var index=row[1].sequence;columnsName[index]=columnName}});columnsName=columnsName.filter(function(columnName){return typeof columnName==="string"});return columnsName};var getColumnsNameFormat3=function(metaData){var columns=metaData.columns;var columnsNameGroup=metaData.groups.map(function(row){return row.field});var arrayColumns=Object.entries(columns);var maxSequence=0;arrayColumns.forEach(function(row){if(row[1].sequence>maxSequence){maxSequence=row[1].sequence}});arrayColumns.forEach(function(row){var columnName=row[0];if(columnsNameGroup.indexOf(columnName)!==-1){row[1].sequence=row[1].sequence+maxSequence+1}})};var getColumnsName=function(columns,metaData,lengthGroup){var columnsNameGroup=metaData.groups.map(function(row){return row.field});var columnsName=[];Object.entries(columns).forEach(function(row){var columnName=row[0];var auxIndex=row[1].sequence;index=columnsNameGroup.indexOf(columnName)===-1?auxIndex+lengthGroup:auxIndex;if(columnsName[index]){while(columnsName[index]!=null){index++}}columnsName[index]=columnName});columnsName=columnsName.filter(function(columnName){return typeof columnName==="string"});return columnsName};var initVars=function(metaData){metaData.xlsMergedCell=[];var columns=metaData.columns;var lengthGroup=metaData.groups.length;var indexLastGroup=lengthGroup-1;var columnsName=[];if(isFormat2(metaData.formatXLS)){columnsName=getColumnsNameFormat2(columns,metaData)}else{columnsName=getColumnsName(columns,metaData,lengthGroup)}var rowValues=[];var formatedDataSet=[];var groups=[];groups.groupEnd={};groups.groupEnd.letter={};return[columns,indexLastGroup,columnsName,rowValues,formatedDataSet,groups]};function setRowGroupFormat2(row,rowValues,groups,metaData,formatedDataSet,columnsName,columns,indexLastGroup){var label=row.__groupLabel+":"+row.__groupValue;var index=row.__groupIndex;if(row.__groupHeader){rowValues[index]=label;groups[index]={init:null,end:null};formatedDataSet.push(rowValues);rowValues=[]}else if(row.__groupFooter){if(row.__groupLabel===undefined){rowValues.push("Total")}else{rowValues.push("Total ("+label+")")}formatedDataSet.push(rowValues);rowValues=[];var funcXls=null;var funcXlsIFS=null;var labelRange=null;var valueRange=null;columnsName.forEach(function(column,columnIndex){if((row[column]||row[column]==0)&&index!==undefined){var letter=colunmXLS[rowValues.length];funcXls=expressionZeedhiToXls[columns[column].expression];var cellsfunc=letter+groups[index].init+":"+letter+groups[index].end;var expression="";if(indexLastGroup==index){expression="="+funcXls+"("+cellsfunc+")"}else{funcXlsIFS=expressionZeedhiToXlsIFS[columns[column].expression];labelRange="A"+(groups[index].init-1)+":A"+(groups[index].end-1);valueRange=letter+groups[index].init+":"+letter+groups[index].end;if(funcXlsIFS!=="COUNTIFS"){expression="="+funcXlsIFS+"("+valueRange+","+labelRange+',"<>Total (*")'}else{expression="="+funcXlsIFS+"("+valueRange+',"<>",'+labelRange+',"<>Total (*")'}if(index===0){if(!groups.groupEnd.init||groups.groupEnd.init>groups[index].init)groups.groupEnd.init=groups[index].init;if(!groups.groupEnd.end||groups.groupEnd.end<groups[index].end)groups.groupEnd.end=groups[index].end;groups.groupEnd.letter[column]=letter}}rowValues.push(expression)}else{var cell=row[column];if(row.__groupSummary){var columnLetter=groups.groupEnd.letter[column];if(columnLetter){funcXlsIFS=expressionZeedhiToXlsIFS[columns[column].expression];labelRange="A"+(groups.groupEnd.init-1)+":A"+(groups.groupEnd.end-1);valueRange=columnLetter+groups.groupEnd.init+":"+columnLetter+groups.groupEnd.end;if(funcXlsIFS!=="COUNTIFS"){cell="="+funcXlsIFS+"("+valueRange+","+labelRange+',"<>Total (*")'}else{cell="="+funcXlsIFS+"("+valueRange+',"<>",'+labelRange+',"<>Total (*")'}}}rowValues.push(cell)}})}return rowValues}function setRowGroup(row,rowValues,groups,metaData,formatedDataSet,columnsName,columns,indexLastGroup){var label=row.__groupLabel+":"+row.__groupValue;var index=row.__groupIndex;if(row.__groupHeader){rowValues[index]=label;groups[index]={init:null,end:null}}else if(row.__groupFooter){if(row.__groupLabel===undefined){rowValues.push("Total")}else{rowValues.push("Total ("+label+")")}var funcXls=null;var funcXlsIFS=null;var labelRange=null;var valueRange=null;if(groups[index]){metaData.xlsMergedCell.push({start_row:groups[index].init,start_col:colunmXLS[index],end_row:formatedDataSet.length+2,end_col:colunmXLS[index]})}columnsName.forEach(function(column,columnIndex){if(!(row.__groupFooter&&columnIndex===0)){if((row[column]||row[column]==0)&&index!==undefined){var letter=colunmXLS[rowValues.length];funcXls=expressionZeedhiToXls[columns[column].expression];var cellsfunc=letter+groups[index].init+":"+letter+groups[index].end;var expression="";if(indexLastGroup==index){expression="="+funcXls+"("+cellsfunc+")"}else{funcXlsIFS=expressionZeedhiToXlsIFS[columns[column].expression];labelRange="A"+groups[index].init+":A"+groups[index].end;valueRange=letter+groups[index].init+":"+letter+groups[index].end;if(funcXlsIFS!=="COUNTIFS"){expression="="+funcXlsIFS+"("+valueRange+","+labelRange+',"<>Total (*")'}else{expression="="+funcXlsIFS+"("+valueRange+',"<>",'+labelRange+',"<>Total (*")'}if(index===0){if(!groups.groupEnd.init||groups.groupEnd.init>groups[index].init)groups.groupEnd.init=groups[index].init;if(!groups.groupEnd.end||groups.groupEnd.end<groups[index].end)groups.groupEnd.end=groups[index].end;groups.groupEnd.letter[column]=letter}}rowValues.push(expression)}else{var cell=row[column];if(row.__groupSummary){var columnLetter=groups.groupEnd.letter[column];if(columnLetter){funcXlsIFS=expressionZeedhiToXlsIFS[columns[column].expression];labelRange="A"+groups.groupEnd.init+":A"+groups.groupEnd.end;valueRange=columnLetter+groups.groupEnd.init+":"+columnLetter+groups.groupEnd.end;if(funcXlsIFS!=="COUNTIFS"){cell="="+funcXlsIFS+"("+valueRange+","+labelRange+',"<>Total (*")'}else{cell="="+funcXlsIFS+"("+valueRange+',"<>",'+labelRange+',"<>Total (*")'}}}rowValues.push(cell)}}})}return rowValues}function setIndexGroups(groups,formatedDataSet){groups.forEach(function(group){if(!group.init){group.init=formatedDataSet.length+2}group.end=formatedDataSet.length+2})}function setRowNormal(columnsName,rowValues,row){columnsName.forEach(function(column){rowValues.push(row[column])})}this.getFormatDataSet=function(metaData,dataSetFormat,dataSet){if(isFormat3(metaData.formatXLS)){metaData.reportXLS=false;getColumnsNameFormat3(metaData);return dataSet}else{return this.formatDataSet(metaData,dataSetFormat)}};this.formatDataSet=function(metaData,dataSet){var initVar=initVars(metaData);var columns=initVar[0];var indexLastGroup=initVar[1];var columnsName=initVar[2];var rowValues=initVar[3];var formatedDataSet=initVar[4];var groups=initVar[5];dataSet.forEach(function(row){if(row.__group){if(isFormat2(metaData.formatXLS)){rowValues=setRowGroupFormat2(row,rowValues,groups,metaData,formatedDataSet,columnsName,columns,indexLastGroup)}else{rowValues=setRowGroup(row,rowValues,groups,metaData,formatedDataSet,columnsName,columns,indexLastGroup)}}else{setIndexGroups(groups,formatedDataSet);setRowNormal(columnsName,rowValues,row)}if(!row.__groupHeader){formatedDataSet.push(rowValues)}rowValues=[]});return[columnsName].concat(formatedDataSet)}}Configuration(function(ContextRegister){ContextRegister.register("ZhReportsXLS",ZhReportsXLS)});function ZhReports(templateManager,ZHPromise,ScreenService,restEngine,ZhUtil,eventAggregator,DecodeValueFieldService,ZhLogger,eventEngine,ZhReportsXLS){var reportConfig={PDF:{uri:"/generateReport",type:"PDF",action:"pdfAction"},XLS:{uri:"/generateXLS",type:"XLS",action:"xlsAction"},CSV:{uri:"/generateCSV",type:"CSV",action:"csvAction"}};var typeXLSLocal="XLSLocal";var maxVisibleColumns={LANDSCAPE:15,PORTRAIT:10};var reportNameToReportFunction={"=":"is equal to",IN:"is among",NOT_IN:"is not among","!=":"is different of",">":"is bigger than","<":"is lower than",">=":"is not lower than","<=":"is not bigger than",BETWEEN:["is between","and"],NOT_BETWEEN:["is lower than","and bigger than"],LIKE:"has",LIKE_I:"has",LIKE_ALL:"has any of",NOT_LIKE:"does not have",IS_NULL:"is not defined",IS_NOT_NULL:"is defined",ORDER_DESC:"ordered descending",ORDER_ASC:"ordered ascending",ORDER_BY:"ordered",GROUP_BY:"grouped"};eventEngine.registerEvent("BeforeGenerateReport","beforeGenerateReport");function triggerBeforeGenerateReport(widget,metaData){if(widget.beforeGenerateReport){return widget.beforeGenerateReport({metadata:metaData})}}function getFieldFilterValue(field,filter,widget){if(widget.appliedFilter&&widget.appliedFilter.ID==="EDITED"){return convertValueToDescriptionFilterInfo(field,filter,widget)}if(field.template==="field/select-native.html"){return convertValueToDescriptionNative(field,filter)}else if(field.template==="field/select-multiple.html"&&field.dataSource.checkedRows&&field.dataSource.checkedRows.length>0){return convertValueToDescriptionWithCheckedRows(field,filter)}else if(field.template==="field/select-multiple.html"&&field.outData&&field.widget.appliedFilter){return convertValueToDescriptionMultiple(field,filter)}else if(field.template==="field/select-multiple.html"&&field.dataSource.data&&field.widget.appliedFilter){return convertValueToDescriptionWithDate(field,filter)}else if(field.template==="field/select-multiple.html"&&field.isVisibleOnReport===true){return convertValueToDescriptionGrupdate(field,filter)}else if((field.template==="zh-interval-component#field/interval.html"||field.template==="field/datetime.html")&&field.isVisibleOnReport===true&&filter.operator==="BETWEEN"){return convertValueToDateInterval(field,filter)}else if(field.template==="field/checkbox.html"&&field.isVisibleOnReport===true&&field.valueToTrue&&field.valueToFalse){return convertValueToCheckBox(field,filter)}return getFieldFilterDefaultText(field,filter,filter.value,ScreenService.i18n(reportNameToReportFunction[filter.operator]))}function convertValueToDescriptionFilterInfo(field,filter,widget){var filterValue=filter.value;if((field.template==="zh-interval-component#field/interval.html"||field.template==="field/datetime.html"||field.template==="field/calendar.html")&&field.isVisibleOnReport&&filter.operator==="BETWEEN"){return convertValueToDateInterval(field,filter)}widget._filterInfo.forEach(function(item){if(item.label===field.label){filterValue=item.value}});return getFieldFilterDefaultText(field,filter,filterValue,ScreenService.i18n(reportNameToReportFunction[filter.operator]))}function convertValueToDescriptionNative(field,filter){var filterValue=filter.value;if(filterValue.length>1&&field.outData){return convertValueToDescriptionMultiple(field,filter)}else if(filterValue.length>1&&field.isVisibleOnReport===true){return convertValueToDescriptionWithDate(field,filter)}else{field.dataSource.data.forEach(function(row){if(row[field.valueField]==filterValue){filterValue=row[field.descriptionField]}})}return getFieldFilterDefaultText(field,filter,filterValue,ScreenService.i18n(reportNameToReportFunction[filter.operator]))}function convertValueToDescriptionWithCheckedRows(field,filter){var filterValue=filter.value;var descriptionField=field.descriptionField||field.filterProperties.descriptionField;var valueDescription=[];field.dataSource.checkedRows.forEach(function(row){valueDescription.push(row[descriptionField])});filterValue=valueDescription;return getFieldFilterDefaultText(field,filter,filterValue,ScreenService.i18n(reportNameToReportFunction[filter.operator]))}function convertValueToDescriptionMultiple(field,filter){var valueOutdata=field.outData;var filterValue=filter.value;var filterRow=field.widget.appliedFilter.FILTER_ROW;var fieldDescription=field.descriptionField;var keyFieldDescription=valueOutdata[fieldDescription];for(var key in valueOutdata){if(valueOutdata[key]===fieldDescription){filterValue=filterRow[fieldDescription]}else{for(var keyValue in valueOutdata){var valueKey=valueOutdata[keyValue];if(filter.name===valueKey&&field.valueField===keyValue){for(var row in filterRow){if(row==valueKey){filterValue=filterRow[keyFieldDescription]}}}}}}return getFieldFilterDefaultText(field,filter,filterValue,ScreenService.i18n(reportNameToReportFunction[filter.operator]))}function convertValueToDescriptionWithDate(field,filter){var filterValue=filter.value;var valueDescription=[];var realData=field.dataSource.data.length<filterValue.length?field.dataSource.checkedRows:field.dataSource.data;realData.forEach(function(row){if(filterValue.includes(row[field.valueField])){valueDescription.push(row[field.descriptionField])}});filterValue=valueDescription;return getFieldFilterDefaultText(field,filter,filterValue,ScreenService.i18n(reportNameToReportFunction[filter.operator]))}function convertValueToDescriptionGrupdate(field,filter){var filterValue=filter.value;var valoresUnicos=new Set;field.widget.groupedData.forEach(function(item){valoresUnicos.add(item[field.descriptionField])});if(valoresUnicos.size<1|valoresUnicos===undefined){return convertValueToDescriptionWithDate(field,filter)}filterValue=Array.from(valoresUnicos);return getFieldFilterDefaultText(field,filter,filterValue,ScreenService.i18n(reportNameToReportFunction[filter.operator]))}function convertValueToDateInterval(field,filter){var filterValue=filter.value;var startDate=filterValue[0];var endDate=filterValue[1];text="";filterValue=startDate+" - "+endDate;return filterValue}function convertValueToCheckBox(field,filter){var filterValue=filter.value.replace(/%/g,"");var fieldValueToTrue=field.valueToTrue||true;var fieldValueToFalse=field.valueToFalse||false;var fieldLabelToTrue=ScreenService.i18n(field.labelToTrue);var fieldLabelToFalse=ScreenService.i18n(field.labelToFalse);if(filterValue===fieldValueToTrue){filterValue=fieldLabelToTrue}else if(filterValue===fieldValueToFalse){filterValue=fieldLabelToFalse}else{return getFieldFilterDefaultText(field,filter,filter.value,ScreenService.i18n(reportNameToReportFunction[filter.operator]))}return getFieldFilterDefaultText(field,filter,filterValue,ScreenService.i18n(reportNameToReportFunction[filter.operator]))}function notUndefinedOrDefault(value,defaultValue){return value===undefined?defaultValue:value}function isPdfFormat(type){return type===reportConfig.PDF.type}function isPdfOrXlsLocalFormat(type){return type===reportConfig.PDF.type||type===typeXLSLocal}function isXlsLocalFormat(type){return type===typeXLSLocal}function checkZhReportActionDisplayMode(){if(!templateManager.project.zhReportActionDisplayMode){return"zh-reports#floating-report-card.html"}else if(templateManager.project.zhReportActionDisplayMode==="buttons"){return"zh-reports#floating-report.html"}}eventAggregator.subscribe("beforeProjectStartup",function(){templateManager.project.customFloatingActions.push({id:"#reportAction#",name:"reportAction",label:ScreenService.i18n("Export"),expandable:!templateManager.project.zhReportActionDisplayMode,order:10,icon:"file-export",template:checkZhReportActionDisplayMode(),isVisible:function(widget){var show=true;if(widget.floatingControl){var showPdfAction=notUndefinedOrDefault(widget.floatingControl.pdfAction,true);var showXlsAction=notUndefinedOrDefault(widget.floatingControl.xlsAction,true);var showCsvAction=notUndefinedOrDefault(widget.floatingControl.csvAction,true);show=showPdfAction||showXlsAction||showCsvAction}return show}})});var checkConfiguration=function(){if(!(templateManager.project&&templateManager.project.reportsUrl)){throw ScreenService.i18n('Need report configuration in "environment.json": "reportsUrl"!')}};var maskSeparatorOrLanguage=function(column){var separator=localStorage.getItem("LOGIN_SEPARATOR");if(separator){column.mask.params.thousands=column.mask.params.thousands||separator[0];column.mask.params.decimal=column.mask.params.decimal||separator[1]}else if($.currency.i18n[window.lang]){var thousands=$.currency.i18n[window.lang].thousands;var decimal=$.currency.i18n[window.lang].decimal;column.mask.params.thousands=column.mask.params.thousands||thousands;column.mask.params.decimal=column.mask.params.decimal||decimal}};var getFormatOfColumn=function(column){var format=column.format;if(!format){if(column.mask){column.mask.params=column.mask.params||{};format={};format.params=column.mask.params;format.type=column.mask.type;if(Util.isString(format.params.mask)&&Util.stringStartsWith(format.params.mask,"@")&&Util.stringEndsWith(format.params.mask,"@")){format.params.mask=ZhUtil.evaluate(format.params.mask)}}else if(column.template=="field/calendar.html"){format={type:"datetime"}}}return format};var buildColumn=function(column,size){if(Util.isUndefined(column.reportAlign)){column.reportAlign=column.align||"left"}return{align:column.reportAlign,description:ScreenService.i18n(column.labelOnReport||column.label),expression:column.expression,format:getFormatOfColumn(column),sequence:column.sequenceInList,size:size,xlsType:column.xlsType}};var filterVisibleColumns=function(widgetColumns,reportShowOnlyVisibleFields,reportType,groups){var showGroupedColumns=!isPdfFormat(reportType);var columns=widgetColumns.filter(function(column){var isGroupedColumn=groups?groups.indexOf(column.name)!=-1:column.grouped;var columnGroupVisibilitity=showGroupedColumns&&isGroupedColumn;var isVisibleOnReport=Util.isUndefinedOrNull(column.isVisibleOnReport)||column.isVisibleOnReport;var columnVisibility=isVisibleOnReport&&(!reportShowOnlyVisibleFields||column.isVisible&&column.showOnList);return column.aclIsVisible&&(columnGroupVisibilitity||columnVisibility)});if(showGroupedColumns&&groups)updateColumnsSequences(columns,groups);return columns};function updateColumnsSequences(columns,groups){var groupsName=Object.keys(groups);var columnsName=Object.keys(columns);var groupSequence=0;columnsName.forEach(function(colName){if(groupsName.indexOf(colName)!==-1){columns[colName].sequence+=groups.length}else{columns[colName].sequence+=groupSequence;groupSequence++}})}var getMaxVisibleColumns=function(widget,reportType){var maxColumns;if(reportType==reportConfig.PDF.type){maxColumns=widget.maxColumns}else{maxColumns=99999}return maxColumns};var _buildMetaDataColumns=function(widget,columnsToUse,reportType,groups){var newVersion=!!widget.getReportColumnsData;var columns={};var widgetColumns=newVersion?widget.getReportColumnsData():widget.fields;if(newVersion&&widget.groups.length){widget.groups.forEach(function(group){var groupField=Object.assign({},group);widgetColumns.unshift(groupField)})}var maxVisibleColCount=getMaxVisibleColumns(widget,reportType);if(widgetColumns){if(!newVersion){widgetColumns=filterVisibleColumns(widgetColumns,widget.reportShowOnlyVisibleFields,reportType,groups)}else{widgetColumns=widgetColumns.filter(function(widgetColumn){return!!widgetColumn.name})}if(maxVisibleColCount&&widgetColumns.length>maxVisibleColCount){ZhLogger.warning(ScreenService.i18n("Number of columns too big to render the report correctly. It was limited to __maxVisibleColCount__ columns.",{maxVisibleColCount:maxVisibleColCount}))}var remainingSize=100;var columnsWithoutColumnSize=0;widgetColumns.forEach(function(column){if(column.reportColumnSize){remainingSize-=parseInt(column.reportColumnSize)}else{columnsWithoutColumnSize++}});if(remainingSize<0){ZhLogger.warning(ScreenService.i18n("Sum of columns width is bigger than 100%."))}var size=Math.max(2,Math.floor(remainingSize/columnsWithoutColumnSize));var sum=0;widgetColumns.forEach(function(column,index){if(!columnsToUse||!columnsToUse[column.name]){var columnSize;if(column.reportColumnSize){columnSize=column.reportColumnSize}else{if(index===widgetColumns.length-1){columnSize=Math.max(2,remainingSize-sum)}else{columnSize=size;sum+=size}}if(!columnSizeHasUnity(columnSize)){columnSize+="%"}columns[column.valueFieldOnReport||column.name]=buildColumn(column,columnSize)}})}return columns};function getStaticPropertyValueFromObject(row){var toReturn={};toReturn[row[this.valueField]]=row[this.descriptionField];return toReturn}var _buildStaticDataColumns=function(widget,columns){var widgetColumns=widget.fields;var staticData={};if(widgetColumns){widgetColumns.forEach(function(column){if(columns[column.name]&&column.dataSource&&column.dataSource.data){staticData[column.name]=column.dataSource.data.map(getStaticPropertyValueFromObject,column)}else if(columns[column.valueFieldOnReport]&&column.dataSource&&column.dataSource.data){staticData[column.valueFieldOnReport]=column.dataSource.data.map(getStaticPropertyValueFromObject,column)}else if(column.template==="field/checkbox.html"){var valueToFalse={};valueToFalse[column.valueToFalse]=DecodeValueFieldService.model(column,column.valueToFalse);var valueToTrue={};valueToTrue[column.valueToTrue]=DecodeValueFieldService.model(column,column.valueToTrue);staticData[column.name]=[valueToFalse,valueToTrue]}});if(Object.keys(staticData).length){for(var data in staticData){staticData[data]=staticData[data].reduce(function(o1,o2){for(var key in o2){o1[key]=o2[key]}return o1},{})}}}return staticData};function columnSizeHasUnity(columnSize){return/[\%px]/g.test(columnSize.toString())}var buildGroup=function(column){return{name:column.name,field:column.name,isNumber:column.isNumber,descending:column.descending,format:getFormatOfColumn(column),internalSorts:column.internalSorts,header:{label:column.headerLabel||ScreenService.i18n(column.label),displayfield:column.name}}};var _buildMetaDataGroups=function(widget,customGroups){var buildedGroups=[];var groups=widget.groups;if(customGroups){groups=customGroups.map(function(name){return widget.getField(name)})}buildedGroups=groups.map(function(group){return buildGroup(group)});return buildedGroups};function getFieldFilterDefaultTextWithoutValue(text){return ScreenService.i18n(text)+"."}function likeIFieldText(value,text){return ScreenService.i18n(text)+' "'+value.replace(/%/g,"")+'"'}function valueFieldText(filter,value,text){if(value[0]==="%"&&value[value.length-1]==="%"){value=value.substring(1,value.length-1)}else{if(value[0]==="%"){if(filter.operator=="LIKE"){value=value.substring(1,value.length);text="ends with"}else if(filter.operator=="NOT_LIKE"){value=value.substring(1,value.length);text="does not ends with"}}if(value[value.length-1]==="%"){if(filter.operator=="LIKE"){value=value.substring(0,value.length-1);text="starts with"}else if(filter.operator=="NOT_LIKE"){value=value.substring(0,value.length-1);text="does not starts with"}}}return ScreenService.i18n(text)+" "+value+"."}function oneOrMoreValuesFieldText(value,text){if(Array.isArray(text)){return ScreenService.i18n(text[0])+" "+value[0]+" "+ScreenService.i18n(text[1])+" "+value[1]+"."}return ScreenService.i18n(text)+" "+value.join(", ")+"."}var getFieldFilterDefaultText=function(field,filter,value,text){if(field.isVisibleOnReport===true){text=""}if(Array.isArray(value)){return oneOrMoreValuesFieldText(value,text)}if(filter.operator==="LIKE_I"){return likeIFieldText(value,text,field)}if(!value){return getFieldFilterDefaultTextWithoutValue(text)}return valueFieldText(filter,value,text)};function filterIsVisibleOnHeader(field){return field&&field.isVisibleOnReport}var _buildMetaDataFilter=function(widget){var filterData=[];if(widget.dataSourceFilter){widget.dataSourceFilter.forEach(function(item){var field=widget.getField(item.name);if(filterIsVisibleOnHeader(field)){filterData.push({label:ScreenService.i18n(field.label),value:ZhUtil.evaluate(getFieldFilterValue(field,item,widget))})}})}return filterData};function convertImageToB64(url,callback){var xhr=new XMLHttpRequest;xhr.onload=function(){var reader=new FileReader;reader.onloadend=function(){callback(reader.result)};reader.readAsDataURL(xhr.response)};xhr.open("GET",url);xhr.responseType="blob";xhr.send()}function getAllImages(container,callback){var imgs={};var imgSrc=["reportClientLogo","reportProductLogo","reportEnterpriseLogo"];var index=0;if(!container[imgSrc[0]]&&!container[imgSrc[1]]&&!container[imgSrc[2]]){callback({});return}imgSrc.forEach(function(imgName){if(container[imgName]){index++;convertImageToB64(container[imgName],function(imageData){imgs[imgName]=imageData;index--;if(index===0){callback(imgs)}})}})}var buildMetaData=function(customData,sourceWidget,reportType,callback){var widget=sourceWidget;var columns=_buildMetaDataColumns(widget,customData.columns,reportType,customData.groups);var staticColumns=_buildStaticDataColumns(widget,columns);var concatenatedLabel=templateManager.container.label===widget.label?ScreenService.i18n(widget.label):ScreenService.i18n(templateManager.container.label)+" - "+ScreenService.i18n(widget.label);var widgetLabel=concatenatedLabel;var groups=_buildMetaDataGroups(widget,customData.groups);getAllImages(templateManager.project,function(images){var widgetMetaData={name:widget.name,title:customData.name||widgetLabel,reportName:customData.reportName||widget.name,reportClientLogo:images.reportClientLogo,reportProductLogo:images.reportProductLogo,reportEnterpriseLogo:images.reportEnterpriseLogo,widgetLabel:widgetLabel,version:"1.0",clientLogo:templateManager.project.reportClientLogo,productLogo:templateManager.project.reportProductLogo,enterpriseLogo:templateManager.project.reportEnterpriseLogo,columns:columns,staticData:staticColumns,groups:groups,filter:_buildMetaDataFilter(widget),xlsDefaultType:widget.xlsDefaultType,orientation:widget.reportOrientation||"PORTRAIT"};callback(widgetMetaData)})};var shouldUseDecodeValueField=function(field){var masksTypesToAvoid=["currency","hour","float","percent","fix"];return!field.mask||masksTypesToAvoid.indexOf(field.mask.type)==-1};var getGroupedColumns=function(groupsMetadata){var columns=[];groupsMetadata.forEach(function(group){columns.push(group.field)});return columns};var formatValuesForReport=function(dataSet,metaData,widget){var columns=Object.keys(metaData.columns);columns=columns.concat(getGroupedColumns(metaData.groups));return dataSet.map(function(row){if(row.__groupHeader||row.__groupFooter)return row;var formattedRow={};columns.forEach(function(column){var field=widget.getField(column);if(field&&shouldUseDecodeValueField(field)){formattedRow[column]=DecodeValueFieldService.model(field,row[column])}else{formattedRow[column]=row[column]}});return formattedRow})};var buildDataSet=function(metaData,widget,reportType){return loadAllData(widget,reportType).then(function(dataSet){return isPdfOrXlsLocalFormat(reportType)||reportType=="CSV"?formatValuesForReport(dataSet,metaData,widget):dataSet})};var buildDataSetXLS=function(metaData,widget,reportType,actionControl){return loadAllDataXLS(widget,reportType,metaData,actionControl).then(function(dataSet){return isPdfOrXlsLocalFormat(reportType)?formatValuesForReport(dataSet,metaData,widget):dataSet})};function getDataSourceName(dataSource){return dataSource.name.split("/").pop()}var confirmeErroBackend=function(result,dataToReturn,metaData){var variables={NAMEACTION:ScreenService.i18n(ZhReportsXLS.labelByFormat[metaData.formatXLS])};var message='Unable to generate the report in the format<BR>"__NAMEACTION__"<BR>Do you want to generate the report in the format<BR>"XLS (all columns - no group)",<BR> without grouping?';var callbackYes=function(){result.resolve(dataToReturn);metaData.formatXLS="F3"};var callbackYNo=function(){result.reject(dataToReturn)};ScreenService.confirmMessage(message,null,callbackYes,callbackYNo,null,variables)};var hasPagination=function(widget){var itemsPerPage=widget.itemsPerPage||widget.dataSource.itemsPerPage;return widget.hasPagination&&widget.dataSource.data.length>=itemsPerPage&&!widget.dataSource.loadedAllData};function loadAllData(widget,reportType){var dataSource=widget.dataSource;var result;if(dataSource.getStorageStrategy()&&!widget.useLocalDataOnReport&&hasPagination(widget)){var oldData=dataSource.data;var filters=widget.getDataSourceFilter();var additionalFilters=ZhUtil.getLikeAllFilter(widget,widget.searchCriteria||{});if(Array.isArray(additionalFilters)){filters=filters.concat(additionalFilters)}result=dataSource.load(filters,DataSource.LOAD_ALL,undefined,undefined,undefined,undefined,undefined,undefined,widget).then(function(dataSet){if(Util.isObject(dataSet)){var dataToReturn=dataSet.dataset[getDataSourceName(dataSource)]||dataSet.dataset[Object.keys(dataSet.dataset)[0]];return isPdfOrXlsLocalFormat(reportType)||reportType=="CSV"?widget.getUpdatedGroupData(dataToReturn):dataToReturn}else{dataSource.data=oldData;return dataSet}}).catch(function(){dataSource.data=oldData})}else{result=ZHPromise.when(widget.groupedData)}return result}var validateLoadAll=function(metaData,actionControl){return!(ZhReportsXLS.isFormat3(metaData.formatXLS)&&(actionControl.dataSourceName||actionControl.collectionName))};function loadAllDataXLS(widget,reportType,metaData,actionControl){var dataSource=widget.dataSource;var result=ZHPromise.defer();if(dataSource.getStorageStrategy()&&!widget.useLocalDataOnReport&&validateLoadAll(metaData,actionControl)&&hasPagination(widget)){var oldData=dataSource.data;var catchFunction=function(response){dataSource.data=oldData;if(isXlsLocalFormat(reportType)){confirmeErroBackend(result,widget.groupedData,metaData)}else{result.reject(response)}};var filters=widget.getDataSourceFilter();var additionalFilters=ZhUtil.getLikeAllFilter(widget,widget.searchCriteria||{});if(Array.isArray(additionalFilters)){filters=filters.concat(additionalFilters)}dataSource.load(filters,DataSource.LOAD_ALL,undefined,undefined,undefined,undefined,undefined,undefined,widget).then(function(dataSet){var dataToReturn=dataSet;if(Util.isObject(dataSet)){dataToReturn=dataSet.dataset[getDataSourceName(dataSource)];if(dataToReturn===undefined&&(actionControl.dataSourceName||actionControl.collectionName)){confirmeErroBackend(result,widget.groupedData,metaData)}else{dataToReturn=isPdfOrXlsLocalFormat(reportType)?widget.getUpdatedGroupData(dataToReturn):dataToReturn;result.resolve(dataToReturn)}}else{catchFunction(dataSet)}}).catch(catchFunction)}else{result.resolve(widget.groupedData)}return result}var buildFilePath=function(fileName){var reportsUrl=templateManager.project.reportsUrl;return{path:reportsUrl+"/reports/"+fileName}};var buildCallbackOfSuccess=function(callback){return function(data){if(callback){callback(buildFilePath(data.messages[0].message))}}};var buildFilePathForDataExporter=function(exporterUrl,fileName){return{path:exporterUrl+fileName}};var buildCallbackOfSuccessForDataExporter=function(exporterUrl,callback){return function(data){if(callback){callback(buildFilePathForDataExporter(exporterUrl,data.messages[0].message))}}};var getReportUri=function(reportType){return reportConfig[reportType].uri};var formatDataSetXLS=function(metaData,dataSetFormat,dataSet){var columns=metaData.columns;metaData.groups.forEach(function(column){if(columns[column.name]){columns[column.name].sequence-=1e3}});metaData.reportXLS=true;return ZhReportsXLS.getFormatDataSet(metaData,dataSetFormat,dataSet)};var formatDataSet=function(metaData,dataSet){var columns=metaData.columns;metaData.groups.forEach(function(column){if(columns[column.name]){columns[column.name].sequence-=1e3}});var columnsName=Object.keys(columns).sort(function(a,b){return columns[a].sequence-columns[b].sequence});var rowValues=[];var formatedDataSet=[];dataSet.forEach(function(row){columnsName.forEach(function(column){rowValues.push(row[column])});formatedDataSet.push(rowValues);rowValues=[]});return[columnsName].concat(formatedDataSet)};var buildDataSetToReportRow=function(reportType,metaData,dataSet){if(reportType==reportConfig.PDF.type){return dataSet.map(ZhUtil.clearRow)}else{return formatDataSet(metaData,dataSet)}};var buildReportRow=function(metaData,reportRowDataSet,widget){var reportRow={};reportRow.metaData=JSON.stringify(metaData);reportRow.dataSet=JSON.stringify(reportRowDataSet);reportRow.filter=JSON.stringify(widget.dataSourceFilter);return reportRow};var buildParamsToRequest=function(metaData,reportRowDataSet,widget){return{requestType:"Row",row:buildReportRow(metaData,reportRowDataSet,widget)}};var buildRequest=function(reportType,metaData,reportRowDataSet,callback,callbackError,widget){var uri=getReportUri(reportType);var params=buildParamsToRequest(metaData,reportRowDataSet,widget);var callbackSuccess=buildCallbackOfSuccess(callback);var requestType="post";var reportsUrl=templateManager.project.reportsUrl;return restEngine.request(uri,params,callbackSuccess,requestType,callbackError,reportsUrl)};var afterRequest=function(widget,response,deferred,reportType){if(response){var file=buildFilePath(response.messages[0].message);deferred.resolve(file);if(widget.afterOpenreport){widget.afterOpenreport()}}else{deferred.reject();publishErrorEvent()}};var _generateReport=function(widget,metaData,dataSet,callback,callbackError,reportType){var deferred=ZHPromise.defer();var reportRowDataSet=buildDataSetToReportRow(reportType,metaData,dataSet);buildRequest(reportType,metaData,reportRowDataSet,callback,callbackError,widget).then(function(response){afterRequest(widget,response,deferred,reportType)}).catch(function(response){deferred.reject(response);publishErrorEvent()});return deferred.promise};function clearFilter(filter){return filter.map(function(currentFilter){if(currentFilter.operator==="ORDER_BY"){currentFilter.name.map(function(currentOrderFilter){currentOrderFilter.name=currentOrderFilter.name.replace("__proxy_","");return currentOrderFilter})}currentFilter.value=ZhUtil.evaluate(currentFilter.value);return currentFilter})}var setDefaultParamReport=function(widget,reportType,metaData,params){var reportRow={};var dataSet=widget.dataSource.data;if(reportType===reportConfig.XLS.type){dataSet=formatDataSetXLS(metaData,widget.dataSetXLS,dataSet)}else if(reportType===reportConfig.CSV.type&&widget.dataSetCSV){dataSet=formatDataSet(metaData,widget.dataSetCSV)}reportRow.dataSet=JSON.stringify(dataSet.map(ZhUtil.clearRow));reportRow.metaData=JSON.stringify(metaData);reportRow.filter=JSON.stringify(widget.dataSourceFilter);params={requestType:"Row",row:reportRow};return params};function getParams(actionControl,widget,metaData,reportType){var params={requestType:"FilterData",filter:clearFilter(widget.dataSourceFilter),metaData:metaData};if(reportType===reportConfig.XLS.type&&metaData.formatXLS!=="F3"&&widget.dataSetXLS){params=setDefaultParamReport(widget,reportType,metaData,params)}else if(reportType==reportConfig.CSV.type&&widget.dataSetCSV||reportType==reportConfig.PDF.type&&widget.dataSetPDF){params=setDefaultParamReport(widget,reportType,metaData,params)}else{if(actionControl.dataSourceName){params.dataSourceName=actionControl.dataSourceName}else if(actionControl.collectionName){params.collectionName=actionControl.collectionName}else{params=setDefaultParamReport(widget,reportType,metaData,params)}}return params}var _generateServerSideReport=function(metaData,actionControl,widget,callback,callbackError,reportType){var exporterUrl=templateManager.project.exporterUrl;var deferred=ZHPromise.defer();var uri=getReportUri(reportType);var params=getParams(actionControl,widget,metaData,reportType);restEngine.request(uri,params,buildCallbackOfSuccessForDataExporter(exporterUrl,callback),"post",callbackError,exporterUrl).then(function(response){afterRequest(widget,response,deferred,reportType)}).catch(function(response){deferred.reject(response);publishErrorEvent()});return deferred.promise};var publishErrorEvent=function(){eventAggregator.publish("afterReportError")};var _i18nMetaData=function(metaData){var words={Page:ScreenService.i18n("Page"),Report:ScreenService.i18n("Report"),Version:ScreenService.i18n("Version")};metaData.words=words;metaData.lang=templateManager.lang;Object.keys(metaData.columns).forEach(function(key){var column=metaData.columns[key];column.description=ScreenService.i18n(column.description)});metaData.groups.forEach(function(group){Object.keys(group).forEach(function(key){var grp=group[key];if(grp){grp.label=ScreenService.i18n(grp.label)}})});return metaData};var getActionControl=function(widget,reportType){return Util.getNestedProperty(widget,["floatingControl",reportConfig[reportType].action])};this.generateReport=function generateReport(customData,sourceWidget,callback,callbackError,reportType,format){if(Util.getNestedProperty(sourceWidget,["dataSource","data","length"])){customData=customData||{};checkConfiguration();var widget=sourceWidget;var promise;buildMetaData(customData,widget,reportType,function(metaDataResolved){var metaDataInternationalized=_i18nMetaData(metaDataResolved);triggerBeforeGenerateReport(widget,metaDataInternationalized);var actionControl=getActionControl(widget,reportType);if(typeof actionControl!=="object"||actionControl.runAt!=="local"){if(reportType===reportConfig.XLS.type){metaDataInternationalized.formatXLS=format;promise=buildDataSetXLS(metaDataInternationalized,widget,typeXLSLocal,actionControl).then(function(dataSet){widget.dataSetXLS=dataSet;return _generateServerSideReport(metaDataInternationalized,actionControl,widget,callback,callbackError,reportType)})}else if(reportType===reportConfig.CSV.type||reportType===reportConfig.PDF.type){promise=buildDataSet(metaDataInternationalized,widget,reportType).then(function(dataSet){if(reportType===reportConfig.CSV.type){widget.dataSetCSV=dataSet}else{widget.dataSetPDF=dataSet}return _generateServerSideReport(metaDataInternationalized,actionControl,widget,callback,callbackError,reportType)})}else{promise=_generateServerSideReport(metaDataInternationalized,actionControl,widget,callback,callbackError,reportType)}}else{promise=buildDataSet(metaDataInternationalized,widget,reportType).then(function(dataSet){return _generateReport(widget,metaDataInternationalized,dataSet,callback,callbackError,reportType)})}});return promise}else{ScreenService.errorNotification("Can't create a report without data!")}};var _previewCallback=function(callback){return function(data){var popup_window=window.open(data.path,"_blank");if(!popup_window){ScreenService.showMessage(ScreenService.i18n("Pop-up Blocker is enabled! Please add this site to your exception list."))}if(callback){callback(data)}}};this.openReport=function openReport(customData,sourceWidget,callback,callbackError,reportType,format){return this.generateReport(customData,sourceWidget,_previewCallback(callback),callbackError,reportType,format)}}Configuration(function(ContextRegister){ContextRegister.register("ZhReports",ZhReports)});var ZeedhiDirectives=angular.module("ZeedhiDirectives");function ReportsDirective(ApplicationContext){return{priority:2,link:function($scope){$scope.generateReport=function(widget,type,format){ApplicationContext.ZhReports.openReport(widget.reportCustomData,widget,undefined,undefined,type,format)}}}}ZeedhiDirectives.directive("zhFloatingControl",["ApplicationContext",ReportsDirective]);window.templateUrls=window.templateUrls||[];var packageName="zh-select-autocomplete";var hasPackageRegistered=window.templateUrls.some(function(templateUrl){return templateUrl.package===packageName});if(!hasPackageRegistered){window.templateUrls.push({package:packageName,baseUrl:"./bower_components/"+packageName+"/dist/templates/"})}var ZhSelectAutoCompleteController=function($scope,$rootScope,templateManager,ScreenService,ZhUtil,SelectService,ZHPromise,EventChildPropagation,DecodeValueFieldService,$filter,metaDataFactory,$timeout,eventAggregator){var self=this;var propertyToSearch=[];var isMakingRequest=false;var parentReload=$scope.field.reload.bind($scope.field);$scope.field.lastSearch=$scope.field.lastSearch||"";$scope.field.dataInitialized=!!($scope.field.dataSource&&(!$scope.field.dataSource.lazyLoad||$scope.field.dataSource.data&&$scope.field.dataSource.data.length>0));$scope.field.searchUpdate=false;$scope.field.filteredData=$scope.field.dataSource.data;if(!$scope.field.dataSource.rest||!$scope.field.searchWithPagination)$scope.originalData=$scope.field.filteredData;if(!$scope.field.oldAfterLoadDataSource)$scope.field.oldAfterLoadDataSource=$scope.field.dataSource.afterLoadDataSource;$scope.field.dataSource.afterLoadDataSource=function(){if($scope.field.oldAfterLoadDataSource)$scope.field.oldAfterLoadDataSource.apply(null,arguments);$scope.field.filteredData=$scope.field.dataSource.data;if(!$scope.field.dataSource.rest||!$scope.field.searchWithPagination)$scope.originalData=$scope.field.filteredData;$scope.field.dataInitialized=!!($scope.field.searchUpdate||!$scope.field.dataSource.lazyLoad||$scope.field.dataSource.data&&$scope.field.dataSource.data.length>0);$scope.field.searchUpdate=false};$scope.$on("$destroy",function(event){event.currentScope.field.dataSource.afterLoadDataSource=event.currentScope.oldAfterLoadDataSource});$scope.field.lazyLoadEvent=$scope.field.lazyLoadEvent||templateManager.project.lazyLoadEvent;$scope.viewMore=ScreenService.i18n("View more...");$scope.showDropdown=true;$scope.itemSearch=$scope.field.lastSearch;function extendBehavior(){Util.extend(self,new ListTemplatable)}extendBehavior();$scope.isRequestBeingMade=function(){return isMakingRequest};var oldFieldToggleDropdown=$scope.field.toggleDropdown;$scope.field.toggleDropdown=function(){$scope.showDropdown=!$scope.showDropdown};var oldFieldInitializeField=$scope.field.initializeField;$scope.field.initializeField=function(){if(!$scope.field.dataInitialized){setDataInitialized();$scope.field.reload()}};function setDataInitialized(){$scope.field.dataInitialized=true}$scope.field.reload=function(additionalFilters){$scope.field.initializeField();return updateDatasource($scope.itemSearch,true,additionalFilters)};function getNewData(dataSets){var data;result=dataSets.dataset;var keys=Object.keys(result);if(keys&&keys.length>0&&keys[0]!=="0"){var dataSetName=$scope.field.dataSource.name.split("/").pop();if(result[dataSetName]){data=result[dataSetName]}}else{data=result}return data}function findNewValue(keys,field,value){var filter=[];keys.forEach(function(key){filter.push({name:key,operator:"=",value:value[key]})});var storageStrategy=field.dataSource.getStorageStrategy();return storageStrategy.getDataSource(field.dataSource.name,function(){},filter,1,2,undefined,0)}function prepareValue(valueFields,value){var valueBuilt={};if(valueFields.length===1&&typeof value!=="object"){valueBuilt[valueFields[0]]=value}else{valueBuilt=value}return valueBuilt}var oldFieldValue=$scope.field.value;$scope.field.value=function(value){if(value){var shouldMakeRequest=$scope.field.dataSource.rest&&$scope.field.hasPagination;currentRow=$scope.field.widget.currentRow;valueFields=$scope.field.valueFields;value=prepareValue(valueFields,value);if(shouldMakeRequest){findNewValue(valueFields,$scope.field,value).then(function(result){result=getNewData(result);if(result.length===1){self.addItemAsSelected(result[0],$scope.field)}else{currentRow[$scope.field.name]=""}})}else{var row=$scope.field.dataSource.data.filter(function(row){var result=true;valueFields.forEach(function(key){if(row[key]!==value[key]){result=false}});return result});if(row.length===1){self.addItemAsSelected(row[0],$scope.field)}else{currentRow[$scope.field.name]=""}}}else{return this.widget.currentRow[this.name]}};function getOnAddCode(){var onAddEventCode=$scope.field.events.filter(function(event){return event.name==="FieldOnAdd"});if(onAddEventCode.length>0){return onAddEventCode[0].code}else{return"args.owner.widget.onAdd()"}}var onAddCode=getOnAddCode();function buildActions(field){var actions=[{label:ScreenService.i18n("Cancel"),showAsAction:"back",isVisible:true,showOnForm:true,showOnList:true,hideIcon:true,events:[{name:"ActionEvent",code:"ScreenService.closePopup(); args.owner.widget.afterClosePopup(args.owner.widget.selectField);",id:9998}]}];if(field.showAddButtonAs=="action"){actions.push({icon:"plus",showAsAction:"always|edit|checked_rows|view",isVisible:true,showOnForm:true,showOnList:true,events:[{name:"ActionEvent",code:onAddCode,id:9999}]})}return actions}(function initialize(){initializeValuesOnCurrentRow();initializeFieldProperties()})();$scope.field.clearValue=function(){clearFieldValue(this)};function clearFieldValue(field){if(!field.isReadOnly()){field.clearByOutData();field.clearByName();field.clearByOutDescription();field.dataSource.clearCheckedRows();setChanged(field);if(field.change){field.change()}$scope.clearAutoCompleteListData();$scope.removeFocusOfInput()}}function configTemplate(field){var template;if(!field.showSelectAs){template="widget/list.html"}else if(field.showSelectAs==="tree"){template="widget/tree/grid.html"}else{template="widget/"+field.showSelectAs+".html"}return template}function buildFields(displayedField,key){this[key]={name:displayedField,showLabel:false,showOnList:true,mask:this.mask}}function insertLabels(label,key){this[key].label=label;this[key].showLabel=true}function buildSelectWidgetFields(field){var fields=[];if(field.fields&&field.fields.length){fields=field.fields}else{field.descriptionFields.forEach(buildFields,fields)}if(field.displayedFieldsLabels){field.displayedFieldsLabels.forEach(insertLabels,fields)}fields.forEach(function(currentElement){metaDataFactory.fieldFactory(currentElement,field.selectWidget,true)})}function buildEvents(){return[{name:"WidgetAfterMoveRow",code:"args.owner.setSelected(args);",id:9999},{name:"WidgetAfterLoadDataSource",code:"args.owner.setDataInitialized()",id:9999}]}function setSelected(args){if(!$scope.field.allowSelectOnlyLastChild||$scope.field.allowSelectOnlyLastChild&&this.isTree($scope.field.selectWidget)&&isLastChild(args.row)){ScreenService.closePopup();self.onAutoCompleteItemClick(args.row)}}function afterClosePopup(field){if(field.element){field.element.focus()}}function buildSelectWidget(field,widgetConfig){if(!field.selectWidget){field.selectWidget=metaDataFactory.widgetFactory({id:9e3,name:"Widget",label:field.label,template:widgetConfig.template,container:field.widget.container,isVisible:true,popupNoBlock:false,showDescriptionOrder:false,floatingControl:{openSearch:!Util.isMobile(),defaultSearchField:field.defaultSearchField,customizationAction:{layout:false,filter:false,view:false},xlsAction:false,pdfAction:false,csvAction:false},parentProperty:field.parentProperty,primaryProperty:field.primaryProperty,expandingProperty:field.expandingProperty,breadcrumbProperty:field.breadcrumbProperty,order:field.order,reverse:field.reverse,bringGroupsCollapsed:field.bringGroupsCollapsed,orderFromGroups:field.orderFromGroups,selectField:field,showCheckbox:false,onAdd:field.onAdd,showAddButtonAs:field.showAddButtonAs,addButtonText:field.addButtonText,noMatchText:field.noMatchText,searchNoMatchText:field.searchNoMatchText,fields:[],dataSource:field.dataSource,dataSourceFilter:field.dataSourceFilter,itemsPerPage:field.itemsPerPage||30,searchWithPagination:Util.isUndefinedOrNull(field.searchWithPagination)?true:field.searchWithPagination,hasPagination:Util.isUndefinedOrNull(field.hasPagination)?true:field.hasPagination,onDemand:field.onDemand,allowSelectOnlyLastChild:field.allowSelectOnlyLastChild,actions:widgetConfig.actions,events:EventChildPropagation.propagate(widgetConfig.widgetEvents,field),searchCriteria:field.searchCriteria});buildSelectWidgetFields(field)}var unregisterWatcher=$scope.$watchCollection(function(){return field.selectWidget.searchCriteria},function(current,old){if(!angular.equals(current||{},old||{})){$scope.field.searchUpdate=true}});$scope.$on("$destroy",function(){unregisterWatcher()});field.selectWidget.setSelected=setSelected;field.selectWidget.updateDatasource=updateDatasource;field.selectWidget.afterClosePopup=afterClosePopup}function processReload(isToReload,field){var defer=ZHPromise.defer();if(isToReload){field.selectWidget.searchCriteria={};field.reload().then(defer.resolve,defer.resolve)}else{defer.resolve()}return defer.promise}function innerSearch(selectListSearch,field){if(Util.isArray(field.filterDefinitions)&&field.filterDefinitions.length){var dataSource=field.dataSource;var filter=ZhUtil.buildFiltersInField(field,selectListSearch);dataSource.filter(filter,function(data){dataSource.data=data;templateManager.updateTemplate()})}}function cleanFieldSearch(field){innerSearch("",field)}function buildFieldWidget(field){cleanFieldSearch(field);var isToReload=!!(field.selectWidget&&Util.objectHasAnyValue(field.selectWidget.searchCriteria));if(!field.selectWidget){initializeSelectWidget(field);isToReload=!!(field.dataSource&&field.dataSource.lazyLoad)}return processReload(isToReload,field)}function buildWidgetConfig(field){var widgetConfig={};widgetConfig.template=configTemplate(field);widgetConfig.actions=buildActions(field);widgetConfig.widgetEvents=buildEvents();return widgetConfig}function initializeSelectWidget(field){buildSelectWidget(field,buildWidgetConfig(field));overrideReload(field)}var oldReload;function overrideReload(field){oldReload=field.selectWidget.reload;field.selectWidget.reload=function(){$scope.field.dataInitialized=true;return oldReload.call(field.selectWidget)}}$scope.processBeforeSelectOpenEvent=function(field){if(field.beforeSelectOpen){field.beforeSelectOpen()}};$scope.processAfterSelectOpenEvent=function(field){if(field.afterSelectOpen){field.afterSelectOpen()}};$scope.openField=function(field,$event){$event.stopPropagation();if(!field.isReadOnly()){$scope.inputWithEditableContent.blur();$scope.processBeforeSelectOpenEvent(field);buildFieldWidget(field).then(function(){field.initializeField();$scope.clearSearchFilter();ScreenService.openPopup(field.selectWidget);$scope.processAfterSelectOpenEvent(field)})}};var oldFieldOpenField=$scope.field.openField;$scope.field.openField=function(){$scope.openField($scope.field)};function configValueFields(){var field=$scope.field;if(!field.valueFields){field.valueFields=[field.valueField]}}function configDescriptionFields(){var field=$scope.field;field.descriptionFields=field.descriptionFields?field.descriptionFields:[field.descriptionField||field.name]}var oldFieldClearByOutData=$scope.field.clearByOutData;$scope.field.clearByOutData=function(){for(var prop in this.outData){this.widget.currentRow[this.outData[prop]]=""}}.bind($scope.field);var oldFieldClearByName=$scope.field.clearByName;$scope.field.clearByName=function(){this.widget.currentRow[this.name]=""}.bind($scope.field);var oldFieldClearByOutDescription=$scope.field.clearByOutDescription;$scope.field.clearByOutDescription=function(){this.widget.currentRow[this.outDescription]=""}.bind($scope.field);if($scope.selectField){var oldSelectFieldOpenField=$scope.selectField.openField;$scope.selectField.openField=function(){$scope.openField($scope.selectField)}}var setChanged=function(field){field.widget.currentRow.changed=true};$scope.clearField=function(field,$event){$event.stopPropagation();clearFieldValue(field)};$scope.hasValueSet=function(){var field=$scope.field;var currentRow=field.widget.currentRow;return!!currentRow[field.name]};$scope.$watch($scope.hasValueSet,function(newVal){$scope.showSpan=newVal});$rootScope.search=function(selectListSearch,field){var minLength=field.minimumInputLength||0;if(selectListSearch.length>minLength){innerSearch(selectListSearch,field)}};this.addItemAsSelected=function(item,field){(field.outData?changeByOut:changeByName)(field,item);if(field.outDescription){changeByDescription(field,item)}item.__isSelected=true;field.dataSource.checkedRows=[item];setChanged(field);if(field._afterSelected){field._afterSelected(item)}if(field.change)field.change();$scope.removeFocusOfInput()};$scope.getDescriptionFromSelectedValue=function(){var fieldName=$scope.field.name;var currentRow=$scope.field.widget.currentRow;return DecodeValueFieldService.model($scope.field,currentRow[fieldName])};this.getItemIdentifier=function(item){var identifier=[];var field=$scope.field;var valueFields=field.valueFields;for(var valueField in valueFields){identifier.push(item[valueFields[valueField]])}return identifier.join(" | ")};function orderDropdown(data,order){return $filter("orderBy")(data,order)}function insertFieldFilter(itemSearch){var name=$scope.field.searchableFields.join("|");if(!$scope.field.filterToAdd){$scope.field.filterToAdd={}}$scope.field.filterToAdd.name=name;$scope.field.filterToAdd.operator="LIKE_ALL";$scope.field.filterToAdd.value=buildSearchValue(itemSearch);var filterFound=($scope.field.dataSourceFilter||[]).some(function(item){return item.name===name});if(!filterFound){$scope.field.dataSourceFilter=$scope.field.dataSourceFilter||[];$scope.field.dataSourceFilter.push($scope.field.filterToAdd)}}function updateDatasourceRemote(itemSearch,isToReload,additionalFilters){if($scope.field.dataSource.rest){if(itemSearch!==undefined||isToReload){if($scope.field.searchableFields){isMakingRequest=true;if($scope.field.dataSource.disableLoader&&$scope.showLoader){$scope.showLoader()}var filters=$scope.field.dataSourceFilter.slice();if(additionalFilters)additionalFilters.forEach(function(filter){filters.push(filter)});return $scope.field.dataSource.load(filters,1,$scope.field.selectWidget.itemsPerPage).then(function(response){$scope.originalData=$scope.field.dataSource.data;if($scope.field.selectWidget.order){$scope.field.dataSource.data=orderDropdown($scope.field.dataSource.data,$scope.field.selectWidget.order);$scope.field.filteredData=$scope.field.dataSource.data}isMakingRequest=false;if($scope.field.dataSource.disableLoader&&$scope.hideLoader){$scope.hideLoader()}return response})}else{throw new Error("Field "+$scope.field.name+" must have searchableFields. ")}}}}function selectNextField(field){var form=field.getParent();var fields=form.fields.slice(form.fields.indexOf(field)+1).filter(function(item){return item.isVisible&&item.aclIsVisible&&!item.isReadOnly()&&item.element});if(fields.length){fields[0].element.find("input, button, textarea").focus()}}$scope.$on("$destroy",function(){if($scope.field.dataSourceFilter){$scope.field.dataSourceFilter.forEach(function(filter){if(angular.equals(filter,$scope.field.filterToAdd)){$scope.field.dataSourceFilter.splice($scope.field.dataSourceFilter.indexOf(filter),1);delete $scope.field.filterToAdd}})}if($scope.field.selectWidget){if(oldReload){$scope.field.selectWidget.reload=oldReload}}$scope.field.toggleDropdown=oldFieldToggleDropdown;$scope.field.initializeField=oldFieldInitializeField;$scope.field.value=oldFieldValue;$scope.field.openField=oldFieldOpenField;$scope.field.clearByOutData=oldFieldClearByOutData;$scope.field.clearByName=oldFieldClearByName;$scope.field.clearByOutDescription=oldFieldClearByOutDescription;$scope.field.reload=parentReload;if($scope.selectField){$scope.selectField.openField=oldSelectFieldOpenField}});function updateDatasourceLocal(itemSearch){var expression=function(row){var result=false;$scope.field.searchableFields.forEach(function(fieldName){var rowValue=String(row[fieldName]).toLowerCase();var localItemSearch=itemSearch.slice().toLowerCase();if(localItemSearch.charAt(0)==="%")localItemSearch=localItemSearch.slice(1);if(localItemSearch.charAt(localItemSearch.length-1)==="%")localItemSearch=localItemSearch.slice(-1);switch($scope.field.searchIn){case"beginning":result=rowValue.startsWith(localItemSearch)?true:result;break;case"end":result=rowValue.endsWith(localItemSearch)?true:result;break;default:result=rowValue.indexOf(localItemSearch)!==-1?true:result;break}});return result};$scope.field.dataSource.data=$filter("filter")($scope.originalData,expression);$scope.field.filteredData=$scope.field.dataSource.data;if($scope.field.selectWidget.order){$scope.field.filteredData=orderDropdown($scope.field.filteredData,$scope.field.selectWidget.order)}}function updateDatasource(itemSearch,isToReload,additionalFilters){var promise;itemSearch=itemSearch||$scope.itemSearch||"";if($scope.shouldMakeRequest(itemSearch,isToReload)){promise=ZHPromise.when(updateDatasourceRemote(itemSearch,isToReload,additionalFilters))}else{updateDatasourceLocal(itemSearch);promise=ZHPromise.when({})}resetDropdown();$scope.field.lastSearch=itemSearch;return promise}$scope.shouldMakeRequest=function(itemSearch,isToReload){if(isToReload)return true;if(!$scope.field.dataSource.rest)return false;if(!isMakingRequest&&$scope.field.dataInitialized&&itemSearch!==$scope.field.lastSearch){if($scope.field.searchWithPagination){var itemsPerPage=$scope.field.itemsPerPage||30;var pageSize=30<itemsPerPage?30:itemsPerPage;var data=self.getData()||[];return $scope.field.lastSearch===""||itemSearch.indexOf($scope.field.lastSearch)===-1||data.length>=pageSize}else{return $scope.field.lastSearch===""||itemSearch.indexOf($scope.field.lastSearch)===-1}}else{return false}};insertFieldFilter($scope.itemSearch);$scope.$watch(function(){return $scope.field.dataSourceFilter},onDatasourceUpdate,true);$scope.$watch(function(){return $scope.itemSearch},onItemSearchUpdate);var filterChanged=false;function onDatasourceUpdate(fieldDataSourceFilter){if(filterChanged){if($scope.field.selectWidget){$scope.field.selectWidget.dataSourceFilter=fieldDataSourceFilter}if(fieldDataSourceFilter===undefined||fieldDataSourceFilter&&fieldDataSourceFilter.length===0)return;update(true)}else{filterChanged=true}}var timeout=$timeout(function(){});function onItemSearchUpdate(){if(isMakingRequest)return;$timeout.cancel(timeout);timeout=$timeout(function(){if($scope.itemSearch==$scope.field.lastSearch||$scope.itemSearch===undefined)return;filterChanged=false;$scope.field.searchUpdate=true;insertFieldFilter($scope.itemSearch);$scope.field.dataInitialized=true;$scope.field.dataSource.setCurrentPage(1);updateDatasource($scope.itemSearch).then(function(){if($scope.itemSearch!==$scope.field.lastSearch){onItemSearchUpdate()}}).then(function(){if($scope.removeSelection)$scope.removeSelection();if($scope.selectFirstItem&&$scope.itemSearch){$timeout(function(){$scope.selectFirstItem()},0,false)}})},500)}function update(isToReload){updateDatasource($scope.itemSearch,isToReload)}function setOperator(){$scope.field.operator=$scope.field.operator||"="}function configHasPagination(){var field=$scope.field;if(field.hasPagination===undefined){field.hasPagination=true}}function initializeFieldProperties(){configValueFields();configDescriptionFields();configHasPagination();buildPropertiesToSearch();setOperator();initializeSelectWidget($scope.field)}$scope.searchFilter=function(row){return Util.isUndefinedOrNull($scope.itemSearch)||propertyToSearch.some(function(data){return~row[data].indexOfLatin($scope.itemSearch)})};function searchItem(itemIdentifier){var field=$scope.field;var data=field.dataSource.data;var valueFields=field.valueFields;var itemIdentifierArr=itemIdentifier.split(" | ");function findItem(item){var result=true;for(var valueField in valueFields){result&=item[valueFields[valueField]]==itemIdentifierArr[valueField]}return result}item=data.find(findItem);return item}$scope.onAutoCompleteItemSelect=function(selectedItemIdentifier){var item=searchItem(selectedItemIdentifier);if(!Util.isUndefinedOrNull(item))self.addItemAsSelected(item,$scope.field)};this.onAutoCompleteItemClick=function(clickedItem){self.addItemAsSelected(clickedItem,$scope.field)};var isLastChild=function(row){return row._childCount===0};function changeByName(field,row){var valueFields=field.valueFields;var currentRow=field.widget.currentRow;var fieldName=field.name;currentRow[fieldName]="";function buildCurrentRowValueFields(value,key){currentRow[value]=row[value]}valueFields.forEach(buildCurrentRowValueFields);currentRow[fieldName]=self.getItemDescription(row)}function changeByOut(field,row){if(field.widget.currentRow){var outData=field.outData||{};Object.keys(outData).forEach(function(key){if(Array.isArray(outData[key])){outData[key].forEach(function(valueKey){field.widget.currentRow[valueKey]=row[key]})}else{field.widget.currentRow[outData[key]]=row[key]}})}}function changeByDescription(field,row){field.widget.currentRow[field.outDescription]=self.getItemDescription(row)}this.getSelectionText=function getSelectionText(fieldRow){return fieldRow||ScreenService.i18n("Search")};$scope.maintainWindow=function(field){if(field.maintainWindow){var maintainWindowFilter=SelectService.buildMaintainFilter(field);ScreenService.openWindow(field.maintainWindow,maintainWindowFilter)}};function buildSearchValue(itemSearch){switch($scope.field.searchIn){case"beginning":return itemSearch+"%";case"end":return"%"+itemSearch;default:return"%"+itemSearch+"%"}}$scope.clearSearchFilter=function(){$scope.itemSearch=""};function addFieldNamesToPropertyToSearch(fields){fields.forEach(function(field){propertyToSearch.push(field)})}function buildPropertiesToSearch(){var field=$scope.field;$scope.field.searchWithPagination=Util.isUndefinedOrNull($scope.field.searchWithPagination)?true:$scope.field.searchWithPagination;var propertyToAdd=null;if(!Util.isUndefined(field.searchableFields)){propertyToAdd=field.searchableFields}else if(!Util.isUndefined(field.displayedFields)){propertyToAdd=field.displayedFields}else{propertyToAdd=field.descriptionFields}addFieldNamesToPropertyToSearch(propertyToAdd)}function initializeValuesOnCurrentRow(){var currentRow=$scope.field.widget.currentRow;var fieldName=$scope.field.name;currentRow[fieldName]=currentRow[fieldName]||""}function removeSelectedItemByIndex(index){var widgetParent=$scope.field.widget;var fieldName=$scope.field.name;widgetParent.currentRow[fieldName].splice(index,1)}this.getFieldLabel=function(){return $scope.field.label};this.getSelectedValues=function(){return $scope.field.widget.currentRow[$scope.field.name]};this.getSelectedItemDescription=function(item){return item[$scope.field.descriptionField]};this.getData=function(){return $scope.field.filteredData};$scope.$watchCollection(function(){return self.getData()},function(newValues,oldValues){if(newValues!==oldValues){$timeout(function(){if($scope.changeDropdownListPosition)$scope.changeDropdownListPosition()},0,false)}});$scope.dropDownLimit=10;$scope.loadMore=function($event){if($scope.dropDownLimit>29){resetDropdown();$scope.openField($scope.field,$event);return}else if($scope.dropDownLimit>19){$scope.viewMore=ScreenService.i18n("Open search widget")}$scope.dropDownLimit+=10;$event.preventDefault();$event.stopPropagation();$scope.focusOnInput()};function resetDropdown(){$scope.dropDownLimit=10;$scope.viewMore=ScreenService.i18n("View more...")}$scope.shouldShowLoadMore=function(){if($scope.field.hasPagination){return $scope.field.filteredData&&$scope.field.filteredData.length>=$scope.dropDownLimit}else{return false}};function translateText(field,item){if(!field.getTemplateSimpleName){Util.extend(field,new Templatable)}var text=item[field.name];return DecodeValueFieldService.model(field,text)}this.getItemText=function(item){var itemDescription=[];var descriptionFields=$scope.field.descriptionFields;var displayedFields=$scope.field.displayedFields;var textSpacer=$scope.field.textSpacer||" | ";var fields=$scope.field.fields;function buildTranslatedItemDescription(description,key){var field=fields.filter(function(field){return field.name===description})[0];itemDescription[key]=translateText(field,item)}function buildItemDescription(description,key){itemDescription[key]=item[description]}if(displayedFields){if(fields){displayedFields.forEach(buildTranslatedItemDescription)}else{displayedFields.forEach(buildItemDescription)}}else{if(fields){descriptionFields.forEach(buildTranslatedItemDescription)}else{descriptionFields.forEach(buildItemDescription)}}return itemDescription.join(textSpacer)};this.getItemDescription=function(item){var itemDescription=[];var descriptionFields=$scope.field.descriptionFields;var textSpacer=$scope.field.textSpacer||" | ";var fields=$scope.field.fields;function buildTranslatedItemDescription(description,key){var field=fields.filter(function(field){return field.name===description})[0];itemDescription[key]=translateText(field,item)}function buildItemDescription(description,key){itemDescription[key]=item[description]}if(fields){descriptionFields.forEach(buildTranslatedItemDescription)}else{descriptionFields.forEach(buildItemDescription)}itemDescription=itemDescription.join(textSpacer);return itemDescription};this.onRemoveSelectedItem=function(removedItemIndex){removeSelectedItemByIndex(removedItemIndex)};$scope.clearAutoCompleteListData=function(){$scope.itemSearch="";$scope.clearInputFieldText();$scope.autoCompleteListData=[];$scope.clearSelectedItem();$scope.showSpan=true};this.clearEditableInput=function(){$scope.inputWithEditableContent.val("")};this.shouldShowSpan=function(){var isReadOnly=$scope.field.isReadOnly();return isReadOnly||$scope.showSpan}};ZeedhiController.controller("ZhSelectAutoCompleteController",ZhSelectAutoCompleteController);jQuery.extend(jQuery.expr[":"],{focusable:function(el){return $(el).is("a, button, :input, [tabindex]")}});(function(){var ZeedhiDirectives=angular.module("ZeedhiDirectives");ZeedhiDirectives.directive("zhSelectAutocomplete",["$timeout","eventEngine",zhSelectAutocomplete]);function zhSelectAutocomplete($timeout,eventEngine){var ENTER=13;var DOWN=40;var ESC=27;var TAB=9;var UP=38;var linkFunction=function(theScope,theElement){var $scope=theScope;var element=theElement;var selectedList="";var loaderElement=$("img.autocomplete-loading-icon");var lazyLoadEventIndex;$scope.hideLoader=function(){loaderElement.hide()};$scope.showLoader=function(){loaderElement.css("display","initial")};$scope.selectFirstItem=function(){if(!selectedList||!selectedList[0]||!selectedList[0].parentElement){var spanList=$scope.selectAutoCompleteElement.find(".show-select span");selectedList=spanList.eq(0)}selectedList.addClass("selected")};$scope.removeSelection=function(){var spanList=$scope.selectAutoCompleteElement.find(".show-select span");spanList.removeClass("selected")};$scope.itemSearch=$scope.itemSearch||"";$scope.selectAutoCompleteElement=$(element);$scope.inputWithEditableContent=$(element).find(".editable");if($scope.field.lazyLoadEvent){lazyLoadEventIndex=eventEngine.bindEvent($scope.inputWithEditableContent,$scope.field.lazyLoadEvent,function(){$scope.field.initializeField()})}function createInputListeners(){$scope.inputWithEditableContent.change(function(evt){evt.stopPropagation()});$scope.inputWithEditableContent.blur(function(evt){var hasSelected=$(".show-select span:hover")[0];if(!hasSelected){$scope.removeFocusOfInput()}if($scope.field.blur)$scope.field.blur();$scope.showLoading=false});$scope.inputWithEditableContent.on("click",function(evt){evt.stopPropagation();if($scope.field.click)$scope.field.click();$scope.inputWithEditableContent.focus()});$scope.inputWithEditableContent.focus(function(evt){if($scope.field.isReadOnly())return;if($scope.selectAutoCompleteElement&&$scope.selectAutoCompleteElement.children(".show-select:visible").length)return;$scope.showLoading=true;$timeout(function(){$scope.inputWithEditableContent.val($scope.itemSearch);$scope.inputWithEditableContent.select();$scope.inputWithEditableContent.parent().scrollTop(0);$scope.showSpan=false;$scope.changeDropdownListPosition();$timeout(function(){$scope.$apply();$scope.processBeforeSelectOpenEvent($scope.field);$scope.field.initializeField();$scope.openList();$scope.processAfterSelectOpenEvent($scope.field);$scope.selectAutoCompleteElement.closest("[zh-scroller]").on("scroll."+$scope.$id,function(){$scope.hideList()})},0,false)})})}createInputListeners();keyPressNavegationListener();function keyPressNavegationListener(){var next;var navegationKeyPress=$scope.selectAutoCompleteElement;navegationKeyPress.on("keydown","input,select",function(event){var EVENTKEY=event;var spanList=$scope.selectAutoCompleteElement.find(".show-select span");if(EVENTKEY.which===DOWN||EVENTKEY.which===UP){EVENTKEY.preventDefault()}if(EVENTKEY.which===ENTER||EVENTKEY.which===TAB){EVENTKEY.preventDefault();var selected=$(event.target.parentNode.nextElementSibling).find(".selected");if(isShowMore(selected)){$scope.loadMore(event)}else{if(canSelect(selected)){$scope.selectItem(selected)}if(getFocusableItems().length>1){$scope.removeFocusOfInput();$scope.focusOnNextItem(EVENTKEY.which===TAB&&EVENTKEY.shiftKey)}}}else if(EVENTKEY.which===DOWN){if(selectedList){selectedList.removeClass("selected");next=selectedList.next();if(next.length>0){selectedList=next.addClass("selected")}else{selectedList=spanList.eq(0).addClass("selected")}}else{selectedList=spanList.eq(0).addClass("selected")}}else if(EVENTKEY.which===UP){if(selectedList){selectedList.removeClass("selected");next=selectedList.prev();if(next.length>0){selectedList=next.addClass("selected")}else{selectedList=spanList.last().addClass("selected")}}else{selectedList=spanList.last().addClass("selected")}}else if(EVENTKEY.which===ESC){$scope.hideList();selectedList="";return false}if(navegationKeyPress){var itemList=$scope.selectAutoCompleteElement.find(".list-items");var item=navegationKeyPress.find(".selected");var index;if(item.offset()!==undefined){if(EVENTKEY.which===ENTER){spanList=$scope.selectAutoCompleteElement.find(".show-select span");index=$scope.dropDownLimit-10;movimentation=(index+3.7)*32+item.outerHeight()-itemList.innerHeight();animateItemFocus(itemList,movimentation);selectedList=spanList.eq(index);selectedList.addClass("selected")}else{index=parseInt(item.attr("data-item-index"))||parseInt(item.prev().attr("data-item-index"))+1;var movimentation=0;if(item.position().top+item.outerHeight()>itemList.innerHeight()){movimentation=index*32+item.outerHeight()-itemList.innerHeight();animateItemFocus(itemList,movimentation)}else if(item.position().top<0){movimentation=index*32;animateItemFocus(itemList,movimentation)}}}}})}function animateItemFocus(itemList,movimentation){itemList.finish().animate({scrollTop:movimentation},500)}function getFocusableItems(){return $(":tabbable")}function canSelect(selectedList){return typeof selectedList==="string"&&selectedList!==""||typeof selectedList==="object"&&selectedList.text()!==""&&selectedList.attr("data-item-identifier")}function isShowMore(selectedItem){return selectedItem&&selectedItem.hasClass("view-more")}$scope.openList=function(){$scope.hideList();$scope.selectAutoCompleteElement.find(".show-select").css("display","block");$scope.selectAutoCompleteElement.find(".list-items").scrollTop(0);if($scope.selectFirstItem&&$scope.itemSearch)$scope.selectFirstItem()};$scope.changeDropdownListPosition=function(){var dropdown=$scope.selectAutoCompleteElement.find(".zh-select-autocomplete");var dropdownOffset=dropdown.offset().top;var listItemsElement=$scope.selectAutoCompleteElement.find(".list-items");updateListWidth(listItemsElement,dropdown);updateListPosition(listItemsElement,dropdownOffset,dropdown)};function updateListPosition(listItemsElement,dropdownOffset,dropdown){var popupModal=$(".popup-modal");var footerHeight=$("footer").height();if(popupModal.length){dropdownOffset-=popupModal.offset().top}listItemsElement.css("top",dropdownOffset+dropdown.outerHeight()-getParentFixedTop(dropdown));if(dropdown.offset().top+dropdown.outerHeight()+listItemsElement.outerHeight()+10>$(window).height()-footerHeight){listItemsElement.css("margin-top",-1*(dropdown.outerHeight()+listItemsElement.outerHeight()))}else{listItemsElement.css("margin-top",0)}}function updateListWidth(listItemsElement,dropdown){if(listItemsElement.width()!==dropdown.innerWidth()){listItemsElement.width(dropdown.innerWidth())}}function getParentFixedTop(el){var parents=el.parents();var top=0;parents.each(function(idx,item){item=$(item);if((item.css("position")==="fixed"||item.css("position")==="absolute")&&item.parent()&&(item.parent().css("position")==="fixed"||item.parent().css("position")==="absolute")){top=item.offset().top;return false}});return top}$scope.clearInputFieldText=function(){$scope.selectAutoCompleteElement.find("input:text").val("")};$scope.hideList=function(){$(".show-select").hide();$(".show-select span").removeClass("selected");$scope.selectAutoCompleteElement.closest("[zh-scroller]").off("scroll."+$scope.$id)};$scope.selectItem=function(selected){if(!selected)return;selectedItem=selected.text();var itemIdentifier=selected.attr("data-item-identifier");$scope.onAutoCompleteItemSelect(itemIdentifier)};$scope.focusOnNextItem=function(reverse){$scope.inputHasFocus=false;$canfocus=getFocusableItems();var index=$canfocus.index($scope.inputWithEditableContent)+(reverse?-1:1);if(!reverse&&index>=$canfocus.length)index=0;if(reverse&&index<0)index=$canfocus.length-1;$canfocus.eq(index).focus()};$scope.focusOnInput=function(){if($scope.field.isReadOnly())return;$scope.inputWithEditableContent.focus()};$scope.removeFocusOfInput=function(){$scope.showSpan=$scope.hasValueSet();$scope.hideList();$timeout(function(){$scope.$apply()},0,false)};$scope.clearSelectedItem=function(){var item=$scope.inputWithEditableContent.find(".selected");selectedList="";item.removeClass("selected")};function updateDropdownOnResize(){$scope.changeDropdownListPosition()}$(window).resize(updateDropdownOnResize);$scope.$on("$destroy",function(){$("div.zh-background-loading").off("mouseup");$(window).unbind("mouseup",updateDropdownOnResize);$scope.selectAutoCompleteElement.closest("[zh-scroller]").off("scroll."+$scope.$id);eventEngine.unbindEvent($scope.inputWithEditableContent,$scope.field.lazyLoadEvent,lazyLoadEventIndex)})};return{restrict:"A",link:linkFunction}}})();(function(){Configuration(registerSelectAutocomplete);function registerSelectAutocomplete(decodeTemplateFieldService){decodeTemplateFieldService.registerViewTemplate("zh-select-autocomplete#field/select-autocomplete.html","zh-select-autocomplete#field/select-autocomplete-view.html")}})();window.templateUrls=window.templateUrls||[];var packageName="zh-interval-component";var hasPackageRegistered=window.templateUrls.some(function(templateUrl){return templateUrl.package===packageName});if(!hasPackageRegistered){window.templateUrls.push({package:packageName,baseUrl:"./bower_components/"+packageName+"/dist/templates/"})}function IntervalRegister(DecodeValueFieldService,validateEngine,ScreenService){var self=this;var DEFAULT_DISPLAY_FORMAT="YYYY-MM-DD";var DEFAULT_DATE_FORMAT="YYYY-MM-DD";self.decodeValueField=function(field,fieldRow){var displayValue="";var dateFormat=field.dateFormat||DEFAULT_DATE_FORMAT;var formattedDate=field.displayFormat||DEFAULT_DISPLAY_FORMAT;if(fieldRow){if(fieldRow.end||fieldRow.start||fieldRow.period){var beginDate=fieldRow.start?moment(fieldRow.start,dateFormat).format(formattedDate):formattedDate.replace(/[a-z]/gi,"_");var endDate=fieldRow.end?moment(fieldRow.end,dateFormat).format(formattedDate):formattedDate.replace(/[a-z]/gi,"_");if(!fieldRow.period){displayValue=ScreenService.i18n("From ")+beginDate+ScreenService.i18n(" to ")+endDate;return displayValue}else{var periodLabel=fieldRow.period.label;displayValue=ScreenService.i18n("From ")+beginDate+ScreenService.i18n(" to ")+endDate+" ("+periodLabel+") ";return displayValue}}}return ScreenService.i18n("From ")+formattedDate.replace(/[a-z]/gi,"_")+ScreenService.i18n(" to ")+formattedDate.replace(/[a-z]/gi,"_")};DecodeValueFieldService.register("interval.html",self.decodeValueField);function required(value,validationAttrs){return{valid:requiredStart(value,validationAttrs).valid&&requiredEnd(value,validationAttrs).valid,message:ScreenService.i18n(validationAttrs.message)||ScreenService.i18n("Required field")}}function requiredStart(value,validationAttrs){return buildRequiredMessage(value,validationAttrs,"start")}function requiredEnd(value,validationAttrs){return buildRequiredMessage(value,validationAttrs,"end")}function buildRequiredMessage(value,validationAttrs,property){return{valid:value&&Util.isObject(value)&&!Util.isEmptyOrBlank(value[property]),message:ScreenService.i18n(validationAttrs.message)||ScreenService.i18n("Required field")}}function completeInterval(value,validationAttrs){var localValue=Util.isObject(value)?value:{};return{valid:Util.isEmptyOrBlank(localValue.start)?Util.isEmptyOrBlank(localValue.end):!Util.isEmptyOrBlank(localValue.end),message:ScreenService.i18n(validationAttrs.message)||ScreenService.i18n("Incomplete interval")}}function validInterval(value,validationAttrs){var localValue=Util.isObject(value)?value:{};var field=validationAttrs.field;var DEFAULT_DISPLAY_FORMAT=moment().locale(window.lang).localeData().longDateFormat("L");var displayFormat=field.displayFormat||DEFAULT_DISPLAY_FORMAT;return{valid:Util.isEmptyOrBlank(localValue.start)||Util.isEmptyOrBlank(localValue.end)||moment(localValue.formattedEnd,displayFormat)>=moment(localValue.formattedStart,displayFormat),message:ScreenService.i18n(validationAttrs.message)||ScreenService.i18n("Incomplete interval")}}var registeredValidations=validateEngine.getMappedValidations();var validationsToRegister={requiredInterval:required,requiredIntervalStart:requiredStart,requiredIntervalEnd:requiredEnd,completeInterval:completeInterval,validInterval:validInterval};for(var validationName in validationsToRegister){if(!registeredValidations.hasOwnProperty(validationName)){validateEngine.registerValidation(validationName,validationsToRegister[validationName])}}}Configuration(IntervalRegister);var IntervalController=function($scope,$rootScope,ZhUtil,ScreenService,metaDataFactory,eventEngine,templateManager){var self=this;self.field=$scope.field;self.widget=$scope.widget;$scope.$root=$rootScope;var DEFAULT_DISPLAY_FORMAT=moment().locale(window.lang).localeData().longDateFormat("L");var DEFAULT_DATE_FORMAT=moment().locale(window.lang).localeData().longDateFormat("L");var DEFAULT_START_LABEL="Begin on";var DEFAULT_END_LABEL="End on";var INCLUSIVE_SUFFIX="inclusive";var sourceElement=self.field||self.widget;$scope.dateFormat=sourceElement.dateFormat||DEFAULT_DATE_FORMAT;$scope.displayFormat=sourceElement.displayFormat||DEFAULT_DISPLAY_FORMAT;$scope.startLabel=ScreenService.i18n(sourceElement.startLabel||DEFAULT_START_LABEL);$scope.endLabel=ScreenService.i18n(sourceElement.endLabel||DEFAULT_END_LABEL);var emptyDefault=$scope.displayFormat.replace(/[Y,M,D]/gi,"_");if(!eventEngine.hasEvent("IntervalOnInvalidInput")){eventEngine.registerEvent("IntervalOnInvalidInput","intervalOnInvalidInput")}function isStartField(fieldId){var startId="_START";return fieldId.lastIndexOf(startId)+startId.length==fieldId.length}function isEndField(fieldId){var endId="_END";return fieldId.lastIndexOf(endId)+endId.length==fieldId.length}$scope.fillCurrentRow=function(element){var dateString=element.value;if(element.id===self.field.name+"_END"){$scope.fieldRow.end=getValueByDisplayValue(dateString)}else{$scope.fieldRow.start=getValueByDisplayValue(dateString)}if(moment($scope.fieldRow.start,$scope.dateFormat)._d.getTime()>moment($scope.fieldRow.end,$scope.dateFormat)._d.getTime()){if($scope.field.intervalOnInvalidInput){$scope.field.intervalOnInvalidInput()}}};function getDisplayValueByValue(value){var inDisplayFormat=moment(value,$scope.displayFormat,true).isValid();var displayValue=inDisplayFormat?value:moment(value,$scope.dateFormat).format($scope.displayFormat);return displayValue}function getValueByDisplayValue(displayValue){var inDateFormat=moment(displayValue,$scope.dateFormat,true).isValid();var value=inDateFormat?displayValue:moment(displayValue,$scope.displayFormat).format($scope.dateFormat);return value}function buildIntervals(){var fieldIntervals=self.field.intervals;var finalIntervals=[];if(fieldIntervals===undefined){fieldIntervals=[{label:"Today",period:"today"},{label:"Yesterday",period:"yesterday"},{label:"Tomorrow",period:"tomorrow"},{label:"This Week",period:"this-week"},{label:"Last Week",period:"last-week"},{label:"Next Week",period:"next-week"},{label:"This Quarter",period:"this-quarter"},{label:"Last Quarter",period:"last-quarter"},{label:"Next Quarter",period:"next-quarter"},{label:"This Month",period:"this-month"},{label:"Last Month",period:"last-month"},{label:"Next Month",period:"next-month"},{label:"This Year",period:"this-year"},{label:"Last Year",period:"last-year"},{label:"Next Year",period:"next-year"}]}if(Util.isArray(fieldIntervals)){fieldIntervals.forEach(function(interval){try{var row;if(isCustomPeriod(interval.period)){row=ZhUtil.evaluate(interval.period);row.customized=true}else{row=buildObjectWithPeriodDetails(interval.period)}finalIntervals.push({_period_label:interval.label,_period:row,_period_name:interval.period})}catch(e){}})}return finalIntervals}function isCustomPeriod(periodName){return periodName[0]==="@"}function buildObjectWithPeriodDetails(word){var decoded=decodeWordExpression(word);var buildIntervalMethod=decoded.suffix===INCLUSIVE_SUFFIX?buildIntervalInclusive:buildInterval;return buildIntervalMethod(decoded.prefix,decoded.amount,decoded.unit)}function decodeWordExpression(word){var exceptionWords={today:"this-day",yesterday:"last-day",tomorrow:"next-day"};if(word in exceptionWords){word=exceptionWords[word]}var prefix,amount,unit,suffix;var splitedString=word.split("-");if(splitedString.length===2){prefix=splitedString[0];unit=splitedString[1]}else if(splitedString.length>2){prefix=splitedString[0];amount=splitedString[1];unit=splitedString[2];suffix=splitedString[3]}else{throw"Used period has an incorrect format."}return{prefix:prefix,amount:amount||1,unit:unit,suffix:suffix}}function buildInterval(prefix,amount,unit){var start=moment().startOf(unit),end=moment();switch(prefix){case"last":end.subtract(1,unit);start.subtract(amount,unit);break;case"next":start.add(1,unit);end.add(amount,unit);break}end.endOf(unit);return factoryInterval(start,end)}function buildIntervalInclusive(prefix,amount,unit){var start=moment().startOf(unit),end=moment();switch(prefix){case"last":start.subtract(amount-1,unit);break;case"next":end.add(amount-1,unit);break}end.endOf(unit);return factoryInterval(start,end)}function factoryInterval(start,end){return{start:start.format($scope.dateFormat),end:end.format($scope.dateFormat),customized:false}}function clearInputValues(field,id){var parentElement=angular.element(field.element[0]);var element=parentElement.find("#"+id)[0];element.value=emptyDefault}function clearInternalValues(field,id){if(!self.field.isReadOnly()){var start="";var end="";var formattedStart=emptyDefault;var formattedEnd=emptyDefault;var intervalField=self.field;var parentWidget=intervalField.widget;if(id){if(isStartField(id)){end=$scope.fieldRow.end;formattedEnd=$scope.fieldRow.formattedEnd}else if(isEndField(id)){start=$scope.fieldRow.start;formattedStart=$scope.fieldRow.formattedStart}clearInputValues(field,id)}delete parentWidget.currentRow[intervalField.name];$scope.fieldRow={start:start,end:end,formattedStart:formattedStart,formattedEnd:formattedEnd};intervalField.validate(intervalField.value());if(self.field.change){self.field.change()}}}function createIntervalWidget(){var actions=[{label:ScreenService.i18n("Cancel"),showAsAction:"back",id:self.widget.id+"_cancel",closeIntervalWidget:self.closeIntervalWidget,isVisible:true,events:[{name:"ActionEvent",code:"args.owner.closeIntervalWidget()"}]},{label:ScreenService.i18n("OK"),showAsAction:"never",id:self.widget.id+"_ok",isVisible:true,applyIntervalToWidgetRow:self.applyIntervalToWidgetRow,closeIntervalWidget:self.closeIntervalWidget,events:[{name:"ActionEvent",code:"args.owner.closeIntervalWidget(); args.owner.applyIntervalToWidgetRow();"}]}];return metaDataFactory.widgetFactory({name:"Interval",label:self.field.label,template:"zh-interval-component#widget/interval.html",container:self.field.widget.container,isVisible:true,intervalField:self.field,startLabel:self.field.startLabel,endLabel:self.field.endLabel,dateFormat:$scope.dateFormat,actions:actions,parent:self.field,displayFormat:self.field.displayFormat||$scope.dateFormat,widgets:[{name:"Calendar",label:self.field.label,template:"widget/calendar.html",container:self.field.widget.container,actions:actions,dateFormat:$scope.dateFormat,displayFormat:self.field.displayFormat||$scope.dateFormat,isVisible:true,floatingControl:false,dataSource:{data:self.field.dataSource&&self.field.dataSource.data||[]},dateField:self.field.dateField,showDescriptionOrder:false,events:[{name:"WidgetAfterMoveRow",code:"args.owner.parent.selectIntervalDate(args)"},{name:"WidgetOnEnter",code:"args.owner.parent.selectDatesBasedOnCurrentRow()"}]},{name:"List",label:self.field.label,template:"widget/list.html",container:self.field.widget.container,isVisible:true,actions:actions,showDescriptionOrder:false,floatingControl:false,fields:[{label:"Period",name:"_period_label",translate:true,showOnList:true}],dataSource:{data:buildIntervals()},events:[{name:"WidgetAfterMoveRow",code:"args.owner.parent.selectIntervalPeriod(args.owner)"}]}],events:[]},self.field.widget.container)}this.inputOnClick=function($event){$event.stopPropagation()};this.openIntervalWidget=function(){if(!self.field.isReadOnly()){self.field.intervalWidget=createIntervalWidget();self.batata=$scope.$root;applyIntervalWidgetInitialValues();resetIntervalValuesOnCurrentRow();createIntervalWidgetMethods();ScreenService.openPopup(self.field.intervalWidget).then(function(){if(self.field.intervalWidget===$scope.$root._currentPopup){$scope.$root._currentPopup=self.field.intervalWidget.widgets[0];$scope.$root._currentPopup.lastActiveWidget=self.field.intervalWidget.parent.widget}})}};function applyIntervalWidgetInitialValues(){var intervalWidget=self.field.intervalWidget;intervalWidget.isIntervalEmpty=true;intervalWidget.beingSelected="start";intervalWidget.setBeingSelected=setBeingSelected;intervalWidget.carouselWidget="calendar";intervalWidget.intervalData={};intervalWidget.intervalData.start=getInitialstartDate();intervalWidget.intervalData.end=getInitialEndDate();intervalWidget.widgets[0].currentDate=intervalWidget.intervalData.start;intervalWidget.formattedData={};intervalWidget.formattedData.start=getDisplayValueByValue(getInitialstartDate());intervalWidget.formattedData.end=getDisplayValueByValue(getInitialEndDate())}function getInitialstartDate(){return getInitialDate("start")}function getInitialEndDate(){return getInitialDate("end")}function getInitialDate(property){var field=self.field;var parentWidget=field.widget;var currentRowProperty=parentWidget.currentRow[field.name];return currentRowProperty?currentRowProperty[property]:moment().format($scope.dateFormat)}function resetIntervalValuesOnCurrentRow(){var intervalField=self.field;var parentWidget=intervalField.widget;if(!parentWidget.currentRow[intervalField.name]){parentWidget.currentRow[intervalField.name]={start:null,end:null,period:null}}}function setBeingSelected(value){self.field.intervalWidget.beingSelected=value}this.applyIntervalToWidgetRow=function(){var intervalField=self.field;var parentWidget=intervalField.widget;var intervalData=intervalField.intervalWidget.intervalData;var formattedData=intervalField.intervalWidget.formattedData;$scope.fieldRow={start:intervalData.start,end:intervalData.end,period:intervalData.period,formattedStart:formattedData.start,formattedEnd:formattedData.end};parentWidget.currentRow[intervalField.name]=$scope.fieldRow;intervalField.validate(intervalField.value());if(intervalField.change){intervalField.change()}};this.closeIntervalWidget=function(){ScreenService.closePopup();setLastActivatedWidget(self.field.widget)};function createIntervalWidgetMethods(){self.field.intervalWidget.selectDatesBasedOnCurrentRow=function(){var field=self.field;var currentRow=field.widget.currentRow;var intervalWidget=field.intervalWidget;var intervalData=intervalWidget.intervalData;var formattedData=intervalWidget.formattedData;var startDate=currentRow[field.name]?currentRow[field.name].start:null;var endDate=currentRow[field.name]?currentRow[field.name].end:null;if(Util.isValidDate(startDate,$scope.dateFormat)&&Util.isValidDate(endDate,$scope.dateFormat)){intervalData.start=startDate;intervalData.end=endDate;formattedData.start=getDisplayValueByValue(startDate);formattedData.end=getDisplayValueByValue(endDate);selectIntervalOnCalendar()}else{intervalData.start=moment().format($scope.dateFormat);intervalData.end=moment().format($scope.dateFormat);formattedData.start=moment().format($scope.displayFormat);formattedData.end=moment().format($scope.displayFormat);selectIntervalOnCalendar()}};self.field.intervalWidget.selectIntervalDate=function(args){var intervalWidget=self.field.intervalWidget;var intervalData=intervalWidget.intervalData;var formattedData=intervalWidget.formattedData;var selectedDate=args.row;var momentSelectedDate=moment(args.row,$scope.dateFormat);var momentstartDate=moment(intervalData.start,$scope.dateFormat);var momentEndDate=moment(intervalData.end,$scope.dateFormat);if(intervalWidget.beingSelected!=="start"&&intervalWidget.beingSelected!=="end"){intervalWidget.beingSelected="start"}intervalData[intervalWidget.beingSelected]=selectedDate;formattedData[intervalWidget.beingSelected]=getDisplayValueByValue(selectedDate);var shouldToggleBeingSelected=true;if(intervalWidget.beingSelected==="start"&&momentSelectedDate.isAfter(momentEndDate)){intervalData.end=selectedDate;formattedData.end=getDisplayValueByValue(selectedDate)}else if(intervalWidget.beingSelected==="end"&&momentSelectedDate.isBefore(momentstartDate)){shouldToggleBeingSelected=false;intervalData.start=selectedDate;formattedData.start=getDisplayValueByValue(selectedDate)}if(shouldToggleBeingSelected){toggleBeingSelected()}clearOldInterval();selectIntervalOnCalendar();intervalWidget.isIntervalEmpty=false};self.field.intervalWidget.selectIntervalPeriod=function(listWidget){var intervalWidget=self.field.intervalWidget;var intervalData=intervalWidget.intervalData;intervalData.start=listWidget.currentRow._period.start;intervalData.end=listWidget.currentRow._period.end;intervalData.period={name:listWidget.currentRow._period_name,label:listWidget.currentRow._period_label,customized:listWidget.currentRow._period.customized};intervalWidget.formattedData.start=getDisplayValueByValue(intervalData.start);intervalWidget.formattedData.end=getDisplayValueByValue(intervalData.end);clearOldInterval();selectIntervalOnCalendar();ScreenService.closePopup();self.field.widget.activate();self.applyIntervalToWidgetRow()};self.field.intervalWidget.isCalendarCurrentWidget=function(){return self.field.intervalWidget.carouselWidget==="calendar"};self.field.intervalWidget.isPeriodSelectorCurrentWidget=function(){return self.field.intervalWidget.carouselWidget==="periodSelector"};self.field.intervalWidget.toggleCurrentWidget=function(){var intervalWidget=self.field.intervalWidget;if(intervalWidget.isPeriodSelectorCurrentWidget()){intervalWidget.carouselWidget="calendar";intervalWidget.beingSelected="start"}else{intervalWidget.carouselWidget="periodSelector";intervalWidget.beingSelected="none"}setLastActivatedWidget(self.field.widget);intervalWidget.nextWidget();intervalWidget.container.prepareActions()}}function setLastActivatedWidget(toBecomeActiveWidget){toBecomeActiveWidget.activate();toBecomeActiveWidget.lastActiveWidget=self.field.widget.parent}function toggleBeingSelected(){var intervalWidget=self.field.intervalWidget;intervalWidget.beingSelected=intervalWidget.beingSelected==="start"?"end":"start"}function clearOldInterval(){var calendarWidget=self.field.intervalWidget.widgets[0];calendarWidget.selectedDates=[]}function selectIntervalOnCalendar(){var intervalWidget=self.field.intervalWidget||self.widget;var calendarWidget=intervalWidget.widgets[0];var dateFormat=self.field.dateFormat;var startDate=intervalWidget.intervalData.start;var endDate=intervalWidget.intervalData.end;var momentstartDate=moment(startDate,dateFormat);var momentEndDate=moment(endDate,dateFormat);var momentCurrentDate=momentstartDate;while(momentCurrentDate.isBefore(momentEndDate)||momentCurrentDate.isSame(momentEndDate)){calendarWidget.setDateAsSelected(momentCurrentDate.format(dateFormat),dateFormat);momentCurrentDate.add(1,"day")}}this.getPeriodLabel=function(){var label="";var property=self.field.widget.currentRow[self.field.name];if(property&&property.period&&property.period.label){label="("+property.period.label+")"}return label};if(self.field){var field=self.field;var fieldName=field.name;var parentWidget=field.widget;field.value(self.field.value()||self.field.defaultValue);field.isRowSet=function(){var fieldName=this.name;var currentRow=this.widget.currentRow;var hasValue=currentRow[fieldName]&&currentRow[fieldName].formattedStart;var startSet=hasValue&&currentRow[fieldName].formattedStart.indexOf("_")===-1;var endSet=hasValue&&currentRow[fieldName].formattedEnd.indexOf("_")===-1;return startSet&&endSet};field.clearValue=clearInternalValues;field.getDatesByPeriodName=function(periodName,periodLabel){periodLabel=periodLabel||"";var date=isCustomPeriod(periodName)?ZhUtil.evaluate(periodName):buildObjectWithPeriodDetails(periodName);return{start:date.start,end:date.end,formattedStart:getDisplayValueByValue(date.start),formattedEnd:getDisplayValueByValue(date.end),period:{name:periodName,label:periodLabel||"",customized:date.customized}}};if(parentWidget.currentRow[fieldName]&&parentWidget.currentRow[fieldName].period&&parentWidget.currentRow[fieldName].period.name){var date=field.getDatesByPeriodName(parentWidget.currentRow[fieldName].period.name);parentWidget.currentRow[fieldName].start=date.start;parentWidget.currentRow[fieldName].end=date.end}$scope.$watch("fieldRow.start",function(newValue){if(!parentWidget.currentRow[fieldName].keepFormatted){parentWidget.currentRow[fieldName].formattedStart=newValue?getDisplayValueByValue(newValue):emptyDefault}else{delete parentWidget.currentRow[fieldName].keepFormatted}});$scope.$watch("fieldRow.end",function(newValue){if(!parentWidget.currentRow[fieldName].keepFormatted){parentWidget.currentRow[fieldName].formattedEnd=newValue?getDisplayValueByValue(newValue):emptyDefault}else{delete parentWidget.currentRow[fieldName].keepFormatted}})}$scope.isRequired=function(field){return field.validations&&(field.validations.requiredInterval||field.validations.requiredIntervalStart||field.validations.requiredIntervalEnd)}};ZeedhiController.controller("IntervalController",IntervalController);var ZeedhiDiretiveDate=angular.module("ZeedhiDiretiveDate");ZeedhiDiretiveDate.directive("zhIntervalInput",function(templateManager,ScreenService){return{restrict:"A",link:function($scope,$element,$attrs){var type=$attrs.zhIntervalInput||"start";var field=$scope.field;var fieldName=field.name;var widget=field.widget;var arrowUpKey=38;var arrowDownKey=40;var homeKey=36;var endKey=35;var arrowLeftKey=37;var arrowRightKey=39;var backspaceKey=8;var deleteKey=46;var inputProperties={};if(type!=="start"){inputProperties={scopeVariable:"formattedEnd",searchVale:"_END",newValue:"_START",cursorIndex:$scope.displayFormat.length,toggleKeys:[arrowUpKey,homeKey,arrowLeftKey,backspaceKey],selectionPosition:0,extraToggleCondition:function(){return false}}}else{inputProperties={scopeVariable:"formattedStart",searchVale:"_START",newValue:"_END",cursorIndex:0,toggleKeys:[arrowDownKey,endKey,arrowRightKey],selectionPosition:$scope.displayFormat.length,extraToggleCondition:function(keyCode,selectionStart){return isNumberKeyCode(keyCode)&&selectionStart>=$scope.displayFormat.length-1}}}widget.currentRow.$error=widget.currentRow.$error||{};widget.currentRow.$error[fieldName]=widget.currentRow.$error[fieldName]||[];function isNumberKeyCode(keyCode){return keyCode>=96&&keyCode<=105||keyCode>=48&&keyCode<=57}function isToPreventDefault(evt){var toPrevent=[backspaceKey,deleteKey];return evt.keyCode&&(evt.key.length<2||toPrevent.indexOf(evt.keyCode)!==-1)}function setCursorPosition(element,position){element.setSelectionRange(position,position)}function getToggleCondition(selectionStart,keyCode){return inputProperties.toggleKeys.indexOf(keyCode)!==-1&&selectionStart==inputProperties.selectionPosition||inputProperties.extraToggleCondition(keyCode,selectionStart)}function toggleInput(evt){evt.preventDefault();var fieldName=$element[0].id.replace(inputProperties.searchVale,inputProperties.newValue);var fieldElement=$element.parent().find("#"+fieldName);fieldElement.focus();setCursorPosition(fieldElement[0],inputProperties.cursorIndex)}function updateNextNumber(selectionStart,key){if(selectionStart<$scope.displayFormat.length){var value=$scope.fieldRow[inputProperties.scopeVariable];while(value[selectionStart]&&value[selectionStart]!=="_"&&isNaN(value[selectionStart])){selectionStart++}$scope.fieldRow[inputProperties.scopeVariable]=value.substr(0,selectionStart)+key+value.substr(selectionStart+1);templateManager.updateTemplate()}else{selectionStart++}selectionStart++;setCursorPosition($element[0],selectionStart)}function clearPreviousNumber(selectionStart){if(selectionStart!==0){var value=$scope.fieldRow[inputProperties.scopeVariable];selectionStart--;while(value[selectionStart]&&value[selectionStart]!=="_"&&isNaN(value[selectionStart])){selectionStart--}$scope.fieldRow[inputProperties.scopeVariable]=value.substr(0,selectionStart)+"_"+value.substr(selectionStart+1);templateManager.updateTemplate();setCursorPosition($element[0],selectionStart)}}$element.on("keydown",function(evt){if(isToPreventDefault(evt)){evt.preventDefault()}var key=evt.key;var keyCode=evt.keyCode;var selectionStart=$element[0].selectionStart;if(isNumberKeyCode(keyCode)){updateNextNumber(selectionStart,key)}if(getToggleCondition(selectionStart,keyCode)){toggleInput(evt)}else if(keyCode==backspaceKey){clearPreviousNumber(selectionStart)}});function valueIsFullfilled(value){return value.indexOf("_")===-1}function showIntervalValidationsErrors(field){var value=field.value();var validStart=!valueIsFullfilled(value.formattedStart)||moment(value.formattedStart,$scope.displayFormat).isValid();var fieldName=field.name;var validateResult={valid:true};if(!validStart){field.widget.currentRow[fieldName].keepFormatted=true;field.widget.currentRow[fieldName].start="";validateResult={valid:false,message:ScreenService.i18n("Invalid start date")}}else{var validEnd=!valueIsFullfilled(value.formattedEnd)||moment(value.formattedEnd,$scope.displayFormat).isValid();if(!validEnd){field.widget.currentRow[fieldName].keepFormatted=true;field.widget.currentRow[fieldName].end="";validateResult={valid:false,message:ScreenService.i18n("Invalid end date")}}else{if(moment(value.formattedEnd,$scope.displayFormat)<moment(value.formattedStart,$scope.displayFormat)){validateResult={valid:false,message:ScreenService.i18n("Invalid interval")}}}}if(!validateResult.valid){field.widget.currentRow.$error[fieldName]=[];field.widget.currentRow.$error[fieldName].push(validateResult)}return validateResult.valid}$element.on("blur",function(){var inputElement=$element[0];if(valueIsFullfilled(inputElement.value)){if(moment(inputElement.value,$scope.displayFormat).isValid()){$scope.fillCurrentRow(inputElement);templateManager.updateTemplate();if($scope.field.validate($scope.field.value())&&$scope.field.change){$scope.field.change()}}else if($scope.field.intervalOnInvalidInput){$scope.field.intervalOnInvalidInput()}}$scope.field.validate($scope.field.value());showIntervalValidationsErrors(field)})}}});function GridNavigationLibrary(ZhKeyboardService,templateManager,ScreenService){var rowHeight=35;function isTree(widget){return widget.template=="/widget/tree/grid.html"||widget.template=="widget/tree/grid.html"}function _getFocusedElement(){var element=$(":focus");if(element.is(".zh-label-with-icon")||element.parent().is(".zh-radio-label")||element.parent().is(".zh-box-label")||element.is("textarea")||element.is("input")){return element}else{return undefined}}function getActiveWidget(){var enabledWidget=true;var widget;if(!ScreenService.isSideMenuOpen()&&Util.isUndefined(_getFocusedElement())&&!ScreenService.isAlertShown()){widget=templateManager.container.getActiveWidget();enabledWidget=!widget.disableGridNavigation&&!widget.inEditMode()}return enabledWidget&&widget}function filterVisibleRowsOnTree(widget){return widget.plainTreeData.filter(function(row){return Util.isUndefinedOrNull(row._parent)||row._parent._opened})}function filterSearchVisibleRows(widget,data){var fieldsArray=[];widget.fields.forEach(function(field){if(field.isVisible&&field.aclIsVisible){fieldsArray.push(field.name)}});return data.filter(function(row){var toReturn=false;fieldsArray.forEach(function(property){if(row[property]&&row[property].toString().toLowerCase().indexOf(widget.searchList.toString().toLowerCase())!=-1){toReturn=true}});return toReturn})}function getDataSource(widget){var dataSource;if(isTree(widget)&&!!widget.searchList){dataSource=filterSearchVisibleRows(widget,widget.plainTreeData)}else if(isTree(widget)&&!widget.searchList){dataSource=filterVisibleRowsOnTree(widget)}else if(!isTree(widget)&&!!widget.searchList){dataSource=filterSearchVisibleRows(widget,widget.groupedData||widget.dataSource.data)}else if(!isTree(widget)&&!widget.searchList){dataSource=widget.groupedData||widget.dataSource.data}return dataSource}function getElementScope(element){var scope=element.scope();if(!scope){element=element.parents("[zh-new-grid]");scope=element[0]?element[0].__scope:null}return scope}templateManager.projectPromise.then(function(){var shortcutKeys=templateManager.project.shortcutKeys;var keys={toogleRow:shortcutKeys.toogleRow||"space",openSwipe:shortcutKeys.openSwipe||"enter",openInlineEdit:shortcutKeys.openInlineEdit||"ctrl+space"};ZhKeyboardService.bind(keys.toogleRow,function(){var widget=getActiveWidget();if(widget){if(widget.showCheckbox){widget.toggle(widget.currentRow)}templateManager.updateTemplate()}});ZhKeyboardService.bind(keys.openSwipe,function(){var widget=getActiveWidget();if(widget){if(widget.name=="select_multiple_widget"){widget.setSelected(widget.dataSource.getCheckedRows(),widget.selectField);widget.afterClosePopup(widget.selectField)}else if(widget.afterMoveRow){widget.afterMoveRow()}}});ZhKeyboardService.bind(keys.openInlineEdit,function(event){var widget=getActiveWidget();if(widget){var elem=$($(".currentRow").find(".inline-editable")[0]);event.preventDefault();if(widget.template.indexOf("grid")>=0&&elem.attr("class")&&elem.attr("class").indexOf("inline-editable")>=0){elem.click()}}});ZhKeyboardService.bind("right",function(){var widget=getActiveWidget();if(widget){if(isTree(widget)&&!Util.isEmptyObject(widget.currentRow)){var closedTreeParent=$(".currentRow").find(".tree-expand-icon.closed")[0];if(closedTreeParent){closedTreeParent.click()}}else if(widget.currentRow.__group&&widget.currentRow.__groupHeader){widget.currentRow.__groupOpened=true;templateManager.updateTemplate()}}});ZhKeyboardService.bind("left",function(){var widget=getActiveWidget();if(widget){if(isTree(widget)&&!Util.isEmptyObject(widget.currentRow)){widget.currentRow._opened=false;templateManager.updateTemplate()}else if(widget.currentRow.__group&&widget.currentRow.__groupHeader){widget.currentRow.__groupOpened=false;templateManager.updateTemplate()}}});ZhKeyboardService.bind("pageup",function(event){var widget=getActiveWidget();if(widget){event.preventDefault();var parent=$(".body").last();var widgetHeight=parent.height();var leftover=parent.height()%rowHeight;if(parent.siblings(".grid-vertical-scroll-control").length>0){parent.siblings(".grid-vertical-scroll-control").scrollTop(parent.siblings(".grid-vertical-scroll-control").scrollTop()-widgetHeight+leftover)}else{parent.scrollTop(parent.scrollTop()-widgetHeight+leftover)}}});ZhKeyboardService.bind("pagedown",function(event){var widget=getActiveWidget();if(widget){event.preventDefault();var parent=$(".body").last();var widgetHeight=parent.height();var leftover=parent.height()%rowHeight;if(parent.siblings(".grid-vertical-scroll-control").length>0){parent.siblings(".grid-vertical-scroll-control").scrollTop(parent.siblings(".grid-vertical-scroll-control").scrollTop()+widgetHeight-leftover)}else{parent.scrollTop(parent.scrollTop()+widgetHeight-leftover)}}});ZhKeyboardService.bind("up",function(event){var widget=getActiveWidget();if(widget){event.preventDefault();var activeGrid=angular.element($(".zh-new-grid-"+widget.name));var parent=activeGrid.find(".body");var scope=getElementScope(parent);if(scope){var dataSource=getDataSource(widget);pressUpKey(widget,dataSource,scope);templateManager.updateTemplate();scrollUp(parent)}}});ZhKeyboardService.bind("down",function(event){var widget=getActiveWidget();if(widget){event.preventDefault();var activeGrid=angular.element($(".zh-new-grid-"+widget.name));var parent=activeGrid.find(".body");var scope=getElementScope(parent);if(scope){var dataSource=getDataSource(widget);pressDownKey(widget,dataSource,scope);templateManager.updateTemplate();scrollDown(parent)}}})});var isAnyMasterDetailTemplate=function(widget){var isMasterDetailGrid=widget.template&&~widget.template.indexOf("master_detail/grid.html");var isMasterDetailList=widget.template&&~widget.template.indexOf("master_detail/list.html");var isMasterDetailTreeGrid=widget.template&&~widget.template.indexOf("master_detail/tree/grid.html");return isMasterDetailGrid||isMasterDetailList||isMasterDetailTreeGrid};var callAfterMoveRow=Util.buildDebounceMethod(function callAfterMoveRow(widget){if(widget.afterMoveRow&&(!isAnyMasterDetailTemplate(widget)||ScreenService.isSwipeOpen())){widget.afterMoveRow()}},300);function scrollUp(parent){var scrollControl=parent.siblings(".grid-vertical-scroll-control")[0];var row=parent.find(".currentRow:last");if(scrollControl){if(row.length===0||row[0]==parent.find(".tr").first()[0]){scrollControl.scrollTop-=rowHeight}}else if(row.length>0&&row.offset().top<parent.offset().top){parent[0].scrollTop-=rowHeight}}function pressUpKey(widget,dataSource,scope){var rowChanged=false;var previousCurrentRow=widget.currentRow;var index=dataSource.indexOf(widget.currentRow);if(Util.isEmptyObject(widget.currentRow)||index==-1){widget.currentRow=dataSource[0]||{};rowChanged=true}else if(index>0){var isClosed,row,found=false;do{index-=1;row=dataSource[index];isClosed=row.__groupHeaders&&row.__groupHeaders.some(function(header){return header.__groupOpened===false});found=!isClosed}while(!found&&index>0);if(found){widget.currentRow=dataSource[index];rowChanged=true}}if(scope&&scope.controller&&scope.controller._rows){if(scope.controller._rows.length>0&&!~scope.controller._rows.indexOf(widget.currentRow)&&!~scope.controller._rows.indexOf(previousCurrentRow)){widget.currentRow=scope.controller._rows[0];rowChanged=true}}if(widget.computeDescriptionOrder)widget.computeDescriptionOrder();if(rowChanged)callAfterMoveRow(widget)}function scrollDown(parent){var scrollControl=parent.siblings(".grid-vertical-scroll-control")[0];var row=parent.find(".currentRow:last");if(scrollControl){if(row.length===0||row[0]==parent.find(".tr").last()[0]){scrollControl.scrollTop+=rowHeight}}else if(row.length>0&&row.offset().top+rowHeight>parent.offset().top+parent.innerHeight()){parent[0].scrollTop+=rowHeight}}function pressDownKey(widget,dataSource,scope){var rowChanged=false;var previousCurrentRow=widget.currentRow;var index=dataSource.indexOf(widget.currentRow);if(Util.isEmptyObject(widget.currentRow)||index==-1){widget.currentRow=dataSource[0]||{};rowChanged=true}else if(index!=dataSource.length-1){var isClosed,row,found=false;do{index+=1;row=dataSource[index];isClosed=row.__groupHeaders&&row.__groupHeaders.some(function(header){return header.__groupOpened===false});found=!isClosed}while(!found&&index<dataSource.length-1);if(found){widget.currentRow=dataSource[index];rowChanged=true}}if(scope&&scope.controller&&scope.controller._rows){if(scope.controller._rows.length>0&&!~scope.controller._rows.indexOf(widget.currentRow)&&!~scope.controller._rows.indexOf(previousCurrentRow)){widget.currentRow=scope.controller._rows[scope.controller._rows.length-1];rowChanged=true}}if(widget.computeDescriptionOrder)widget.computeDescriptionOrder();if(rowChanged)callAfterMoveRow(widget)}}Configuration(function(ContextRegister){ContextRegister.register("GridNavigationLibrary",GridNavigationLibrary)});(function(){angular.module("ZeedhiApp").config(function($httpProvider){if(Boolean(window.applicationVersion)){$httpProvider.interceptors.push(function(){return{request:function cacheBypass(config){if(config&&config.url&&shouldApplyBypass(config.url)){if(config.url.indexOf("?")!==-1){config.url+="&"}else{config.url+="?"}config.url+="v="+window.applicationVersion}return config}}})}else{console.warn('Missing "applicationVersion" global property for CacheBypass.')}});function shouldApplyBypass(url){const urlWithoutParams=url.split("?")[0];return Util.stringEndsWith(urlWithoutParams,".json")||Util.stringEndsWith(urlWithoutParams,".html")||Util.stringEndsWith(urlWithoutParams,".svg")}})();function ZhuAclConfig(){var self=this;this.RULE_ALLOW="A";this.RULE_READONLY="R";this.RULE_INVISIBLE="I";this.exportRulesModal="exportRulesModal";this.menuElementsListWidgetName="elementsListWidget";this.containerElementsListWidgetName="containerElementsModal";this.containerElementsTreeWidgetName="containerElementsTree";this.containerType="container";this.getDefaultDataSourceFilter=function(groupIds,projectId,organizationId){var dataFilter=[];var groupFilter={name:"GROUP_ID",operator:"=",value:groupIds};var projectFilter={name:"PROJECT_ID",operator:"=",value:projectId};if(organizationId!==undefined){var organizationFilter={name:"ORGANIZATION_ID",operator:"=",value:organizationId};dataFilter.push(organizationFilter)}dataFilter.push(groupFilter);dataFilter.push(projectFilter);return dataFilter};this.getAclMap=function(type){var aclMap={container:{aclTypeCod:"C",childs:["widgets"]},widgets:{aclTypeCod:"W",childs:["widgets","fields","actions"]},fields:{aclTypeCod:"F",childs:[]},actions:{aclTypeCod:"A",childs:[]}};return aclMap[type]||{}};this.getRuleType=function(isVisible,isEditable){var ruleType;if(!isVisible){ruleType=self.RULE_INVISIBLE}else if(!isEditable){ruleType=self.RULE_READONLY}else{ruleType=self.RULE_ALLOW}return ruleType};this.getRuleConfiguration=function(ruleType){var ruleConfig={isVisible:ruleType!=self.RULE_INVISIBLE,isEditable:ruleType==self.RULE_ALLOW};return ruleConfig}}Configuration(function(ContextRegister){ContextRegister.register("ZhuAclConfig",ZhuAclConfig)});var ZhuAclMessages={CANCEL:"Cancelar",YES:"Sim",NO:"Não",VISIBLE:"visíveis",EDITABLE:"editáveis",INVISIBLE:"invisíveis"};(function(){var mappedMessages=["ACCESS_DENIED","RULE_NOT_SAVED","SUC_RULE_INSERTED","ERR_RULE_INSERTED","SUC_RULES_EXPORTED","ERR_RULES_EXPORTED","CANNOT_LOAD_RULES","CONFIRMATION_MESSAGE","CONFIRM_CHILDS_QUESTION","CONFIRM_EXPORT","NSHOW_WITHOUT_ID","NSHOW_WITHOUT_CONTAINER_CONFIG","NSHOW_WITHOUT_ID_AND_CONTAINER_CONFIG"];mappedMessages.forEach(function addMappedMessages(code){ZhuAclMessages[code]="zhuacl#"+code})})();function ZhuAccessButtonService(){this.insertButtonInProject=function(project){var notification={label:"Access Control",name:"accessControl",icon:"block",isVisible:false,tooltip:"Access Control",isAclNotification:true,events:[{name:"NotificationEvent",code:"ZhuAclController.openAclModalWidget();"}]};try{notification=Util.extend(new _Notification,notification);project.notifications=project.notifications||[];project.notifications.push(notification)}catch(e){console.error("O Controle de acesso à elementos só funciona em versões acima da 1.40.x do Zeedhi Framework")}};this.disableButtonInProject=function(project){if(project.notifications){project.notifications=project.notifications.filter(function(notification){return!notification.isAclNotification})}};this.enableButtonInProject=function(project){if(project.notifications){project.notifications.forEach(function(notification){if(notification.isAclNotification){notification.isVisible=true}})}}}ZeedhiServices.service("ZhuAccessButtonService",function(ApplicationContext){var instance=new ZhuAccessButtonService;ApplicationContext.registerInstance("ZhuAccessButtonService",instance);return instance});function ZhuAclService(requestDataSourceEngine,restEngine,ZhuAclConfig){this.getZhuAclRules=function(projectId,groupIds){return requestDataSourceEngine.getDataSource("zhuacl#/acl_zhu_acl_rules",ZhuAclConfig.getDefaultDataSourceFilter(groupIds,projectId),1,undefined,undefined,undefined,12e4).then(function(response){var dataset=response.dataset||{};var rules=dataset.zhu_access_control_rule_login;if(Util.isArray(rules)){var objToReturn={aclRules:rules,defaultRule:dataset.zhu_access_control_default_rule.defaultRule};return objToReturn}else{throw{code:ZhuAclMessages.CANNOT_LOAD_RULES}}})};this.getWidgetMetadata=function(widgetName){var widgetUrl="zhuacl#json/"+widgetName+".json";return restEngine.requestMetaData(widgetUrl).then(function(metadata){return metadata.data})};this.exportRules=function(profileFrom,profilesTo){var rows=[{changed:true,profileFrom:profileFrom,profilesTo:profilesTo}];return requestDataSourceEngine.setDataSource("zhuacl#/acl_zhu_acl_element_exportRules",rows)}}Configuration(function(ContextRegister){ContextRegister.register("ZhuAclService",ZhuAclService)});function ZhuAclController(ScreenService,templateManager,metaDataFactory,ZHPromise,ZhuAclService,ZhuAccessButtonService,ZhuAclConfig,MessageService,ApplicationContext,eventAggregator){var self=this;var user;var validProperties=["widgets","fields","actions"];var loadedContainers={};function User(userId,projectId,organizationId,defaultRule){var currentGroupId;var userDefaultRule=defaultRule||ZhuAclConfig.RULE_INVISIBLE;this.setCurrentGroupId=function(id){currentGroupId=id};this.getDefaultRule=function(){return userDefaultRule};this.getCurrentGroupId=function(){return currentGroupId};this.getProjectId=function(){return projectId};this.getUserId=function(){return userId};this.getOrganizationId=function(){return organizationId}}this.getDefaultRule=function(){return user.getDefaultRule()};this.getCurrentGroupId=function(){return user.getCurrentGroupId()};this.getProjectId=function(){return user.getProjectId()};var prepareLabelToName=function(label){var name=label.toLowerCase();name=name.replace(/\ /g,"_");return name.replace(/[^\w\s]/gi,"")};var translateLabel=function(label){return ScreenService.i18n(label)};this.getRulesFromDatasource=function(rulesData){var userId=user.getUserId();var rules={};rulesData.forEach(function(row){var obj={ruleRow:row,userGroups:{}};obj.userGroups[userId]={rule:row.RULE};rules[row.ELEMENT_UNIQUE_ID]=obj});return rules};this.getElementRule=function(rules,itemId){var itemRule={};if(rules[itemId]){itemRule=rules[itemId].ruleRow}return itemRule};this.getPlannedItemToInsertInDataSet=function(rules,item,itemType,parentId){var uniqueId=item.id;var itemRule=self.getElementRule(rules,uniqueId);var itemToInsert={UNIQUE_ID:uniqueId,NAME:item.name||prepareLabelToName(item.label),LABEL:translateLabel(item.label||item.name),TYPE:itemType,RULE:itemRule.RULE||this.getDefaultRule(),RULE_ID:itemRule.ID,PARENT_ID:parentId,USER_ID:user.getUserId(),PROJECT_ID:user.getProjectId(),ORGANIZATION_ID:user.getOrganizationId()};itemToInsert.isVisible=item.aclIsVisible?item.aclIsVisible:checkChildrenVisible(item,true);itemToInsert.isEditable=!item.aclReadOnly&&item.aclIsVisible?true:checkChildrenVisible(item);return itemToInsert};var checkChildrenVisible=function(component,isVisibleHandle){var control=false;var childrenTypes=["widgets","fields","notifications"];if(!(component instanceof Container)){childrenTypes.push("actions")}childrenTypes.forEach(function(type){if(component[type]){component[type].forEach(function(children){if(children&&children.aclIsVisible&&isVisibleHandle){control=true}if(children&&children.aclIsVisible&&!children.aclReadOnly){control=true}})}});return control};var insertContainerElementsListWidget=function(container){return getFactoredWidget(container,ZhuAclConfig.containerElementsListWidgetName,true).then(function(factoredWidget){container.actions=container.actions||[];return factoredWidget})};this.openAclModalWidget=function(){insertContainerElementsListWidget(templateManager.container).then(function(widget){ScreenService.openPopup(widget)})};var redirectToMainWindow=function(){var dashboardMenu=templateManager.project.getMenu("dashboard");var openLinkByMenu=ApplicationContext.LibUtilities&&ApplicationContext.LibUtilities.openLinkByMenu;if(dashboardMenu&&openLinkByMenu){openLinkByMenu(dashboardMenu)}else{openWindow(templateManager.project.mainWindow)}};var verifyContainerRule=function(rule){var containerIsRestrict=rule===ZhuAclConfig.RULE_INVISIBLE;if(containerIsRestrict){var actions=[{label:ScreenService.i18n("Ok"),code:redirectToMainWindow}];var dialogConfig={type:"ALERT",icon:"exclamation",actions:actions};MessageService.showCustomDialogByCode(ZhuAclMessages.ACCESS_DENIED,{},dialogConfig)}return!containerIsRestrict};var mergeUndefinedRules=function(groupIds,itemRule,parentRules){parentRules=parentRules||{};var definedRule=itemRule.rule;var groupRules=parentRules.groupRules||{};if(!definedRule){definedRule=parentRules.rule||templateManager.project.aclDefaultRule}else{var undefinedGroups=itemRule.undefinedGroups||[];groupIds.forEach(function(groupId){var parentRule=groupRules[groupId]||templateManager.project.aclDefaultRule;var isUndefinedGroup=undefinedGroups.indexOf(groupId)!==-1;var groupRule=isUndefinedGroup?parentRule:definedRule;groupRules[groupId]=groupRule;if(definedRule!==ZhuAclConfig.RULE_ALLOW&&groupRule!==ZhuAclConfig.RULE_INVISIBLE){definedRule=groupRule}});itemRule.rule=definedRule}return{rule:definedRule,groupRules:groupRules}};var getUserRule=function(rules,userId,elementId){return Util.getNestedProperty(rules,[elementId,"userGroups",userId])};var initObject=function(obj,objKeys,lastKeyValue){var objKeysLength=objKeys.length;objKeys.reduce(function(prev,next,index){if(index==objKeysLength-1){prev[next]=lastKeyValue}else{prev[next]=prev[next]||{}}return prev[next]},obj)};var updateContainerAcl=function(rules,groupIds,userId){var applyRule=function(item,parentRules){var id=item.id;var userRule=getUserRule(rules,userId,id)||{};var mergedItem=mergeUndefinedRules(groupIds,userRule,parentRules);var itemRule=mergedItem.rule;item.aclIsVisible=itemRule!=ZhuAclConfig.RULE_INVISIBLE;item.aclReadOnly=itemRule!=ZhuAclConfig.RULE_ALLOW;return mergedItem};var updateItemAcl=function(item,type,parentRules){var mergedItem=applyRule(item,parentRules);ZhuAclConfig.getAclMap(type).childs.forEach(function(type){if(Util.isArray(item[type])){item[type].forEach(function(child){updateItemAcl(child,type,mergedItem)})}})};var changeNotificationVisibility=function(isVisible){templateManager.project.notifications.some(function(notification){var isAclNotification=notification.name==="accessControl";if(isAclNotification){notification.isVisible=isVisible}return isAclNotification})};var updateUserRules=function(container){var containerId=container.id;var parentMenuId=container.parentMenuId;var userRule=getUserRule(rules,userId,containerId);if(!userRule&&parentMenuId){userRule=getUserRule(rules,userId,parentMenuId);if(userRule){initObject(rules,[containerId,"userGroups",userId],userRule)}}};var container=templateManager.container;var aclEnable=container.aclEnable;aclEnable=aclEnable!==undefined?aclEnable:true;changeNotificationVisibility(aclEnable);if(aclEnable){updateUserRules(container);var containerRule=applyRule(container);if(verifyContainerRule(containerRule.rule)){updateItemAcl(container,ZhuAclConfig.containerType)}loadedContainers[container.id]=true}};var convertObjectRulesToArray=function(userId,objRules){var arrayRules=[];Object.keys(objRules).forEach(function(ruleId){var objRule=objRules[ruleId];var userRule=objRule.userGroups[userId];if(userRule){var rule={UNIQUE_ID:ruleId,NAME:objRule.itemName,RULE:userRule.rule};arrayRules.push(rule)}});return arrayRules};var convertArrayRulesToObject=function(userId,arrayRules){var objRules={};arrayRules.forEach(function(rule){var profileObjects={};profileObjects[userId]={rule:rule.RULE,undefinedGroups:rule.GROUP_ID||[]};objRules[rule.UNIQUE_ID]={itemName:rule.NAME,userGroups:profileObjects}});return objRules};var subscribeContainerEvent=function(rules,groupIds,userId){eventAggregator.subscribe(EventAggregator.ON_CONTAINER_OPEN,function applyACL(){var containerId=templateManager.container.id;if(!loadedContainers[containerId]){updateContainerAcl(rules,groupIds,userId)}})};var updateProjectAcl=function(loginRules,defaultRule,groupIds){var rules={};var userId=user.getUserId();if(Util.isObject(loginRules)){rules=loginRules;loginRules=convertObjectRulesToArray(userId,rules)}else if(Util.isArray(loginRules)){rules=convertArrayRulesToObject(userId,loginRules)}templateManager.project.aclDefaultRule=defaultRule||ZhuAclConfig.RULE_INVISIBLE;templateManager.userId=userId;templateManager.aclRules=rules;updateContainerAcl(rules,groupIds,userId);subscribeContainerEvent(rules,groupIds,userId)};var createUser=function createUser(userId,projectId,organizationId,defaultRule){user=new User(userId,projectId,organizationId,defaultRule)};this.setUserRules=function(groupIds,projectId,userId,organizationId,options){var returnPromise;loadedContainers={};options=options||{};if(options.canConfigureAcl){ZhuAccessButtonService.enableButtonInProject(templateManager.project);templateManager.updateTemplate()}else{ZhuAccessButtonService.disableButtonInProject(templateManager.project);templateManager.updateTemplate()}if(options.rules){createUser(userId,projectId,organizationId,options.defaultRule);updateProjectAcl(options.rules,options.defaultRule,groupIds);returnPromise=ZHPromise.when(templateManager.aclRules)}else{returnPromise=ZhuAclService.getZhuAclRules(projectId,groupIds).then(function(response){createUser(userId,projectId,organizationId,response.defaultRule);updateProjectAcl(response.aclRules,response.defaultRule,groupIds);return templateManager.aclRules}).catch(function(err){MessageService.showMessageByCode(err.code)})}return returnPromise};this.setElementsListFilter=function(container,groupId,widgetName){widgetName=widgetName||ZhuAclConfig.menuElementsListWidgetName;var elementsWidget=container.getWidget(widgetName);elementsWidget.dataSourceFilter=ZhuAclConfig.getDefaultDataSourceFilter(groupId,user.getProjectId(),user.getOrganizationId());user.setCurrentGroupId(groupId)};var getFactoredWidget=function(container,widgetName,pushInContainer){var widget=container.getWidget(widgetName);if(widget){return ZHPromise.when(widget)}else{return ZhuAclService.getWidgetMetadata(widgetName).then(function(metadata){var factoredWidget=metaDataFactory.widgetFactory(metadata,container);if(pushInContainer){container.widgets.push(factoredWidget)}return factoredWidget})}};this.getFactoredWidget=getFactoredWidget;this.insertElementsListWidget=function(container,parentWidget,extraElementsPath){getFactoredWidget(container,ZhuAclConfig.menuElementsListWidgetName).then(function(factoredWidget){if(parentWidget&&!factoredWidget.parent){factoredWidget.parent=parentWidget;parentWidget.widgets=parentWidget.widgets||[];parentWidget.widgets.push(factoredWidget);factoredWidget.extraElementsPath=extraElementsPath}})}}Configuration(function(ContextRegister){ContextRegister.register("ZhuAclController",ZhuAclController)});function ZhuAclCRUDController(ScreenService,ZHPromise,ZhuAclConfig,ZhuAclController,MessageService){function defineQuestionToUse(rule,messageConfig){var question=ZhuAclMessages.VISIBLE;if(rule==ZhuAclConfig.RULE_INVISIBLE){question=ZhuAclMessages.INVISIBLE}else if(rule==ZhuAclConfig.RULE_ALLOW){question=ZhuAclMessages.EDITABLE}messageConfig.newVisibility=ScreenService.i18n(question);return messageConfig}function deleteChildrensRules(elementsWidget,parentRow,groupId,parentRule){if(parentRow._childCount){elementsWidget.dataSource.data.forEach(function(row){if(row._parent==parentRow){if(row.extraElement){row.RULE=parentRule}else{row.__isDeleted=true;row.RULE_SAVE_CONTAINER=parentRule}row.changed=true;row.GROUP_ID=groupId;deleteChildrensRules(elementsWidget,row,groupId,parentRule)}})}}function confirmChildsVisibility(elementsWidget,ruleType,messageConfig){var returnPromise=ZHPromise.when();if(elementsWidget.currentRow._childCount){var currentRow=elementsWidget.currentRow;var defer=ZHPromise.defer();var actions=[{label:ScreenService.i18n(ZhuAclMessages.YES),code:function(){currentRow.changed=true;deleteChildrensRules(elementsWidget,currentRow,currentRow.GROUP_ID,currentRow.RULE);defer.resolve()}},{label:ScreenService.i18n(ZhuAclMessages.NO),code:function(){var messageConfig={type:"confirmation",icon:"question"};MessageService.showMessageByCode(ZhuAclMessages.CONFIRMATION_MESSAGE,{},messageConfig);defer.reject()}}];var message=ZhuAclMessages.CONFIRM_CHILDS_QUESTION;var dialogConfig={type:"confirmation",icon:"question",actions:actions};MessageService.showCustomDialogByCode(message,defineQuestionToUse(ruleType,messageConfig),dialogConfig);returnPromise=defer.promise}return returnPromise}function reloadChildrensRules(elementsWidget,parentRow,updatedRules,deletedRules){if(parentRow._childCount){elementsWidget.dataSource.data.forEach(function(row){if(row._parent==parentRow){var rowId=row.UNIQUE_ID;row.isVisible=parentRow.isVisible;row.isEditable=parentRow.isEditable;if(deletedRules.indexOf(rowId)!=-1){delete row.RULE_ID}if(updatedRules[rowId]&&updatedRules[rowId].containerId){row.CONTAINER_RULE_ID=updatedRules[rowId].containerId}reloadChildrensRules(elementsWidget,row,updatedRules,deletedRules)}delete row.__isDeleted;delete row.changed})}}function fixZeedhiBehavior(widget){widget.dataSource.data.forEach(function(data){data.isEditable=data._childCount&&data.isVisible||data.isEditable})}function isFatherVisible(parentRow,widget){return widget.dataSource.data.some(function(row){return row.PARENT_ID==parentRow.UNIQUE_ID&&(row.isVisible||row.isEditable)})}function reloadParentsRules(row,widget){var parentRow=row._parent;if(parentRow){if(row.isVisible){parentRow.isEditable=parentRow.isEditable||row.isEditable||row.isVisible;parentRow.isVisible=true}else{var updateFather=isFatherVisible(parentRow,widget);parentRow.isEditable=updateFather;parentRow.isVisible=updateFather}reloadParentsRules(row._parent,widget)}}function clearRowState(row){row.changed=false;row.__isDeleted=false}function reloadDataSourceAfterSave(elementsWidget,newRules){var currentRow=elementsWidget.currentRow;var currentRowId=currentRow.UNIQUE_ID;var updatedRule=newRules.updated[currentRowId];var deletedRules=newRules.deleted||[];if(updatedRule){if(Util.isObject(updatedRule)){currentRow.RULE_ID=updatedRule.menuId;currentRow.CONTAINER_RULE_ID=updatedRule.containerId}else{currentRow.RULE_ID=updatedRule}reloadChildrensRules(elementsWidget,currentRow,newRules.updated,deletedRules);if(!currentRow.extraElement){reloadParentsRules(currentRow,elementsWidget);fixZeedhiBehavior(elementsWidget)}}var updatedRules=Object.keys(newRules.updated);if(updatedRules.length){elementsWidget.dataSource.data.forEach(function(row){var ruleId=newRules.updated[row.UNIQUE_ID];if(ruleId&&row.extraElement){row.RULE_ID=ruleId;row.RULE=currentRow.RULE;row.isVisible=currentRow.isVisible;row.isEditable=currentRow.isEditable}clearRowState(row)})}else{elementsWidget.dataSource.data.forEach(clearRowState)}}function cancelSave(widget){widget.reload()}function changeElementRule(currentRow,isVisible,isEditable){currentRow.RULE=ZhuAclConfig.getRuleType(isVisible,isEditable);currentRow.isVisible=isVisible;currentRow.isEditable=isEditable;currentRow.GROUP_ID=currentRow.GROUP_ID||ZhuAclController.getCurrentGroupId()}function clearInlineChangedStatus(row){delete row.changed_isEditable;delete row.changed_isVisible}function saveRule(widget,isEditable,isVisible,messageConfig){var currentRow=widget.currentRow;var ruleType=ZhuAclConfig.getRuleType(isVisible,isEditable);clearInlineChangedStatus(currentRow);changeElementRule(currentRow,isVisible,isEditable);confirmChildsVisibility(widget,ruleType,messageConfig).then(function(){widget.saveRow().then(function(response){widget.reload();MessageService.successNotificationByCode(ZhuAclMessages.SUC_RULE_INSERTED)}).catch(function(){cancelSave(widget);MessageService.notificationMessageByCode(ZhuAclMessages.ERR_RULE_INSERTED,{},{type:"alert"})})}).catch(function(){cancelSave(widget);MessageService.notificationMessageByCode(ZhuAclMessages.RULE_NOT_SAVED,{},{type:"alert"})})}this.changeIsEditable=function changeIsEditable(widget,row,messageConfig){var isEditable=row.isEditable;var isVisible=isEditable||row.isVisible;saveRule(widget,isEditable,isVisible,messageConfig)};this.changeIsVisible=function changeIsVisible(widget,row,messageConfig){var isVisible=row.isVisible;var isEditable=isVisible&&row.isEditable;saveRule(widget,isEditable,isVisible,messageConfig)}}Configuration(function(ContextRegister){ContextRegister.register("ZhuAclCRUDController",ZhuAclCRUDController)});function ZhuAclExportRulesController(templateManager,MessageService,ScreenService,ZhuAclConfig,ZhuAclController,ZhuAclService){var self=this;var requestToExportRules=function(profileFrom,profilesToExport){ZhuAclService.exportRules(profileFrom,profilesToExport).then(self.closeExportRulesPopup).catch(function(response){var errorCode=response&&(response.errorCode||response.error)||ZhuAclMessages.ERR_RULES_EXPORTED;MessageService.errorNotificationByCode(errorCode)})};this.exportRules=function(){var exportRulesWidget=templateManager.container.getWidget(ZhuAclConfig.exportRulesModal);if(exportRulesWidget.isValid()){var currentRow=exportRulesWidget.currentRow;var dialogConfig={type:"CONFIRMATION",actions:[{label:ScreenService.i18n(ZhuAclMessages.YES),code:function(){requestToExportRules(currentRow.profileFrom,currentRow.profilesToExport)}},{label:ScreenService.i18n(ZhuAclMessages.NO)}]};MessageService.showCustomDialogByCode(ZhuAclMessages.CONFIRM_EXPORT,{},dialogConfig)}};this.profileActionEventExportRules=function(groupId){var container=templateManager.container;return ZhuAclController.getFactoredWidget(container,ZhuAclConfig.exportRulesModal,true).then(function(exportRulesWidget){ScreenService.openPopup(exportRulesWidget);exportRulesWidget.isVisible=true;exportRulesWidget.currentRow={profileFrom:groupId};exportRulesWidget.fields[0].dataSourceFilter=[{name:"ID",operator:"<>",value:groupId}]})};this.closeExportRulesPopup=function(){ScreenService.closePopup()}}Configuration(function(ContextRegister){ContextRegister.register("ZhuAclExportRulesController",ZhuAclExportRulesController)});function ZhuContainerElementsController(templateManager,ZhuAclController,ZhuAclConfig,aclEngine,ZhuAclCRUDController,MessageService){var self=this;var idErrorMessages="";var getContainerElementsTreeWidget=function(){return templateManager.container.getWidget(ZhuAclConfig.containerElementsTreeWidgetName)};var getContainerElementsListWidget=function(){return templateManager.container.getWidget(ZhuAclConfig.containerElementsListWidgetName)};var clearIdErrorsMessage=function(){idErrorMessages=""};var showIdErrorsMessage=function(){if(idErrorMessages){var messageConfig={type:"alert",icon:"exclamation"};MessageService.showMessageByCode(ZhuAclMessages.NSHOW_WITHOUT_ID,{elementsIds:idErrorMessages},messageConfig)}};var addParentMenuProperties=function(rules,item,itemToInsert){var parentMenuId=item.parentMenuId;var parentMenuLabel=item.parentMenuLabel||item.parentMenuName;if(parentMenuId&&parentMenuLabel){var parentMenuRule=ZhuAclController.getElementRule(rules,parentMenuId);itemToInsert.PARENT_MENU_ID=parentMenuId;itemToInsert.PARENT_MENU_NAME=item.parentMenuName||ZhuAclController.prepareLabelToName(parentMenuLabel);itemToInsert.PARENT_MENU_LABEL=parentMenuLabel;itemToInsert.PARENT_MENU_RULE_ID=parentMenuRule.ID}};var getPlannedContainer=function(rules,item,itemType,parentId){var plannedItems=[];itemType=itemType||ZhuAclConfig.containerType;if(item&&!item.isZhuAclElement&&(!!item.label||["container","widgets"].includes(itemType))){var uniqueId=item.id;if(uniqueId){var aclType=ZhuAclConfig.getAclMap(itemType);var itemToInsert=ZhuAclController.getPlannedItemToInsertInDataSet(rules,item,aclType.aclTypeCod,parentId);addParentMenuProperties(rules,item,itemToInsert);plannedItems.push(itemToInsert);aclType.childs.forEach(function(type){if(Util.isArray(item[type])){item[type].forEach(function(child){plannedItems=plannedItems.concat(getPlannedContainer(rules,child,type,uniqueId))})}})}else{var nameToShow=item.label||item.name;idErrorMessages+="<br> "+nameToShow+";"}}return plannedItems};this.reloadContainerElementsModal=function(){getContainerElementsListWidget().reload()};this.reloadContainerElementsTree=function(){getContainerElementsTreeWidget().reload()};this.selectAccessOnChange=function(selectedRow){if(selectedRow&&selectedRow.SELECT_ACCESS){ZhuAclController.setElementsListFilter(templateManager.container,selectedRow.ID,ZhuAclConfig.containerElementsTreeWidgetName)}self.reloadContainerElementsTree()};var copyItem=function(itemToCopy,itemType,parentId){var item;if(itemToCopy&&!itemToCopy.isZhuAclElement&&!itemToCopy.ignoreAclElementsConfig){var uniqueId=itemToCopy.id;item={id:uniqueId,name:itemToCopy.name,label:itemToCopy.label,parentMenuId:itemToCopy.parentMenuId,parentMenuName:itemToCopy.parentMenuName,parentMenuLabel:itemToCopy.parentMenuLabel};itemType=itemType||ZhuAclConfig.containerType;var aclType=ZhuAclConfig.getAclMap(itemType);aclType.childs.forEach(function(type){if(Util.isArray(itemToCopy[type])){item[type]=itemToCopy[type].map(function(child){return copyItem(child,type,uniqueId)}).filter(function(copiedChild){return copiedChild})}})}return item};this.containerElementsTreeAfterLoadDataSource=function(){clearIdErrorsMessage();var widget=getContainerElementsTreeWidget();var elementsListWidget=getContainerElementsListWidget();var elementsListRow=elementsListWidget&&elementsListWidget.currentRow;var rulesData=Util.clone(widget.dataSource.data);widget.dataSource.data=[];elementsListWidget.getField("disableDescription").isVisible=false;if(elementsListRow&&elementsListRow.SELECT_ACCESS){var rules=ZhuAclController.getRulesFromDatasource(rulesData);var container=copyItem(templateManager.container);if(container){aclEngine.processAcl(container,rules,templateManager.userId,templateManager.project.elementListDefaultRule||ZhuAclController.getDefaultRule(),true);widget.dataSource.data=getPlannedContainer(rules,container);showIdErrorsMessage();checkEditContainerRules(container,rules,widget,elementsListWidget)}}};checkEditContainerRules=function(container,rules,widget,elementsListWidget){var isVisibleField=widget.getField("isVisible");var isEditableField=widget.getField("isEditable");var disableDescField=elementsListWidget.getField("disableDescription");if(rules.hasOwnProperty(container.id)&&rules[container.id].ruleRow&&["A","R"].includes(rules[container.id].ruleRow.RULE)){isVisibleField.readOnly=false;isEditableField.readOnly=false;disableDescField.isVisible=false}else{isVisibleField.readOnly=true;isEditableField.readOnly=true;disableDescField.isVisible=true}};this.isEditableOnChange=function(currentRow){var widget=getContainerElementsTreeWidget();var messageConfig={type:"container",subType:"elementos filhos"};ZhuAclCRUDController.changeIsEditable(widget,currentRow,messageConfig)};this.isVisibleOnChange=function(currentRow){var widget=getContainerElementsTreeWidget();var messageConfig={type:"container",subType:"elementos filhos"};ZhuAclCRUDController.changeIsVisible(widget,currentRow,messageConfig)}}Configuration(function(ContextRegister){ContextRegister.register("ZhuContainerElementsController",ZhuContainerElementsController)});function ZhuMenuElementsController(ScreenService,templateManager,ZhuAclController,ZhuAclConfig,aclEngine,ZhuAclCRUDController,MessageService,restEngine,ZHPromise){var MENU="M";var GROUP_MENU="G";var IGNORED_MENUS=["zhHistory"];var idErrorMessages={errorMenus:"",errorContainers:""};var getWidgetElements=function(){return templateManager.container.getWidget(ZhuAclConfig.menuElementsListWidgetName)};var clearIdErrorsMessage=function(){idErrorMessages={errorMenus:"",errorContainers:""}};var showIdErrorsMessage=function(){var messageCode;var errorMenus=idErrorMessages.errorMenus;var errorContainers=idErrorMessages.errorContainers;var messageParameters={elementsIds:errorMenus,elementsWithoutContainer:errorContainers};if(errorMenus&&errorContainers){messageCode=ZhuAclMessages.NSHOW_WITHOUT_ID_AND_CONTAINER_CONFIG}else if(errorMenus){messageCode=ZhuAclMessages.NSHOW_WITHOUT_ID}else if(errorContainers){messageCode=ZhuAclMessages.NSHOW_WITHOUT_CONTAINER_CONFIG}if(messageCode){MessageService.showMessageByCode(messageCode,messageParameters,{type:"alert"})}};var addErrorMenuId=function(item){var nameToShow=item.label||item.name;idErrorMessages.errorMenus+="<br> "+nameToShow+";"};var addErrorContainerId=function(item){var nameToShow=item.label||item.name;idErrorMessages.errorContainers+="<br> "+nameToShow+";"};this.elementsActionEventEdit=function(currentRow){if(!currentRow.buildedMenu){var elementsWidget=getWidgetElements();var messageConfig={type:"menu",subType:"submenus"};currentRow.isEditable=!currentRow.isEditable;ZhuAclCRUDController.changeIsEditable(elementsWidget,currentRow,messageConfig)}};this.elementsActionEventView=function(currentRow){if(!currentRow.buildedMenu){var elementsWidget=getWidgetElements();var messageConfig={type:"menu",subType:"submenus"};currentRow.isVisible=!currentRow.isVisible;currentRow.isEditable=currentRow.isVisible;ZhuAclCRUDController.changeIsVisible(elementsWidget,currentRow,messageConfig)}};this.elementsActionEventBack=function(){var elementsWidgetParent=getWidgetElements().parent;return ScreenService.closeSwipe().then(function(){elementsWidgetParent.list();elementsWidgetParent.activate()})};var addContainerProperties=function(item,menuItem,rules){var containerId=menuItem.containerId;var containerLabel=menuItem.containerLabel||menuItem.containerName;if(containerId&&containerLabel){var containerRule=ZhuAclController.getElementRule(rules,containerId);item.CONTAINER_ID=containerId;item.CONTAINER_NAME=menuItem.containerName||ZhuAclController.prepareLabelToName(containerLabel);item.CONTAINER_LABEL=containerLabel;item.CONTAINER_RULE_ID=containerRule.RULE_ID}else if(menuItem.windowName&&!menuItem.buildedMenu){addErrorContainerId(menuItem)}};var planningMenuItem=function(menuItem,parentMenuItem,rules){var item;var uniqueId=menuItem.id;if(uniqueId){var parentId=parentMenuItem&&parentMenuItem.id;var itemType=!parentId?GROUP_MENU:MENU;item=ZhuAclController.getPlannedItemToInsertInDataSet(rules,menuItem,itemType,parentId);item.buildedMenu=menuItem.buildedMenu;addContainerProperties(item,menuItem,rules)}else{addErrorMenuId(menuItem)}return item};var addMenusInDataSource=function(widget,rules,menus,parentMenu){menus.forEach(function(menu,index){var item=planningMenuItem(menu,parentMenu,rules);if(item){widget.dataSource.data.push(item);if(menu.menus&&menu.menus.length>0){addMenusInDataSource(widget,rules,menu.menus,menu)}}})};var getProjectMenu=function(){var projectMenu=Util.clone(templateManager.project.groupMenu);return projectMenu.filter(function(menu){return IGNORED_MENUS.indexOf(menu.name)==-1})};var extraRulesPromise;var loadExtraRules=function(extraElementsPath){if(!extraRulesPromise){if(extraElementsPath){extraRulesPromise=restEngine.requestMetaData(Util.getRightPath(extraElementsPath),{})}else{extraRulesPromise=ZHPromise.when()}}};var addExtraElements=function(widget,projectRules,defaultRule){var getRule=function(id){return projectRules[id]&&projectRules[id].ruleRow||{}};var getVisibility=function(rule){return(rule||defaultRule)!=="I"};extraRulesPromise.then(function(response){if(response&&response.data){response.data.forEach(function(row){var rule=getRule(row.UNIQUE_ID);row.RULE=rule.RULE;row.RULE_ID=rule.ID;row.isVisible=getVisibility(rule.RULE);row.extraElement=true});widget.dataSource.data=widget.dataSource.data.concat(response.data)}})};this.loadPlanningTree=function(){var elementsWidget=getWidgetElements();var userId=templateManager.userId;var defautRule=templateManager.project.elementListDefaultRule||ZhuAclController.getDefaultRule();var rules=ZhuAclController.getRulesFromDatasource(elementsWidget.dataSource.data);var newMenu=getProjectMenu();clearIdErrorsMessage();loadExtraRules(elementsWidget.extraElementsPath);aclEngine.processMenuAcl(newMenu,rules,templateManager.containers,userId,defautRule);elementsWidget.dataSource.data=[];addMenusInDataSource(elementsWidget,rules,newMenu);addExtraElements(elementsWidget,rules,defautRule);showIdErrorsMessage()};this.reloadElementsWidget=function(){getWidgetElements().reload()}}Configuration(function(ContextRegister){ContextRegister.register("ZhuMenuElementsController",ZhuMenuElementsController)});ZeedhiApp.run(function(templateManager,ZhuAccessButtonService){templateManager.projectPromise.then(function(project){if(templateManager.project.aclEnable){ZhuAccessButtonService.insertButtonInProject(templateManager.project)}})});function ZhuLogService(){this.getPlainContentRows=function(value){var data=[];var objValue=JSON.parse(value);createRows(data,objValue);return data};function createRows(data,value,parent){Object.keys(value).forEach(function(key){createRow(data,key,value[key],parent)})}function createRow(data,key,value,parent){var method;if(Util.isObject(value)){method=factoryCreateObjectRowsMethod()}else if(Array.isArray(value)){method=factoryCreateArrayRowsMethod()}else{method=createSimpleRow}method(data,key,value,parent)}function factoryCreateObjectRowsMethod(){return factoryCreateObjectRows(": {}")}function factoryCreateArrayRowsMethod(){return factoryCreateObjectRows(": []")}function createSimpleRow(data,key,value,parent){if(typeof value==="string"){value='"'+value+'"'}value=key+": "+value;addData(key,value,parent,data)}function addData(key,value,parent,data){var id=parent+"#"+key;data.push({ID:id,VALUE:value,PARENT:parent});return id}function factoryCreateObjectRows(emptySufix){return function createObjectRows(data,key,rowContent,parent){var rowValue=key;if(Object.keys(rowContent).length===0){rowValue+=emptySufix}var id=addData(key,rowValue,parent,data);createRows(data,rowContent,id)}}}Configuration(function(ContextRegister){ContextRegister.register("ZhuLogService",ZhuLogService)});function ZhuLogController(ZhuLogService,ScreenService,templateManager,metaDataFactory,ZhPreferences,ZhFilterPreferences,$timeout,requestEngine,requestFactory){var self=this;var LOG_WIDGET_NAME="zhuLog";var CONTENT_WIDGET="content";var CONTENT_FORM_WIDGET="contentForm";var CONTENT_GRID_WIDGET="contentGrid";var CONTENT_FILTER_WIDGET="select";var USER_ID_FIELD="USER_ID";var LOG_CONFIGURATION_WIDGET="logConfigurationWidget";var REMOVE="remove";var ALLOW="allow";var ALL="all";function uniqid(){return Math.random().toString(10).substring(2,15)+Math.random().toString(10).substring(2,15)}this.closeSwipe=function(widget){ScreenService.closeSwipe();widget.container.getWidget(LOG_WIDGET_NAME).activate()};this.showActiveAll=function(widget){requestEngine.doRequest(requestFactory.factory({serviceName:"zhulog#/logConfiguration/areAllActive",requestType:"filterData"})).then(function(response){var status=response.dataset.status[0];widget.getAction("allowAll").isVisible=!status;widget.noMatchText=status?"All users allowed!":"No user allowed!";widget.activate()})};this.openPopUp=function(widget){var popUpDefaults={id:uniqid(),name:"controlPopUp",showDescriptionOrder:false,label:"Allow User's Log",template:"widget/grid.html",showCheckbox:true,isVisible:true,itemsPerPage:30,events:[{name:"WidgetAfterSelectRow",code:"ZhuLogController.setPopUpAllowActionVisiblity(args.owner, true)"},{name:"WidgetAfterUnselectRow",code:"ZhuLogController.setPopUpAllowActionVisiblity(args.owner, false)"}],parent:widget,floatingControl:{searchAction:true,customizationAction:{filter:true,layout:false,view:false},xlsAction:false,pdfAction:false,csvAction:false},dataSource:{rest:true,localStorage:false,data:[],name:"/operador",itemsPerPage:30},dataSourceFilter:[{name:"IDATIVO",operator:"=",value:"S"}],fields:[{id:uniqid(),name:"CDOPERADOR",label:"ID",operator:"NOT IN",template:"field/text.html",isVisible:true,showOnList:true},{id:uniqid(),name:"NMOPERADOR",label:"Name",template:"field/text.html",isVisible:true,showOnList:true},{id:uniqid(),name:"DSEMAILOPER",label:"Email",template:"field/text.html",isVisible:true,showOnList:true},{id:uniqid(),name:"NRORG",label:"Organization",template:"field/select.html",dataSource:{name:"/organization",rest:true,localStorage:false,data:[]},dataSourceFilter:[],valueField:"ID",descriptionField:"NAME",isVisible:true,showOnList:true}],actions:[{id:uniqid(),name:"allow",label:"Allow",isVisible:false,showAsAction:"never",events:[{name:"ActionEvent",code:"ZhuLogController.setZhuLogConfiguration(args.owner.widget,"+ALLOW+")"}]},{id:uniqid(),name:"back",label:"Cancel",isVisible:true,showAsAction:"back",events:[{name:"ActionEvent",code:"ScreenService.closePopup()"}]}]};if(widget.dataSource.data.length){popUpDefaults.dataSourceFilter.push({name:"CDOPERADOR",operator:"NOT_IN",value:widget.dataSource.data.map(function(user){return user[USER_ID_FIELD]})})}var popUp=metaDataFactory.widgetFactory(popUpDefaults,widget.container);ScreenService.openPopup(popUp)};this.setPopUpAllowActionVisiblity=function(widget,isVisible){var action=widget.getAction(ALLOW);action.isVisible=isVisible;widget.activate()};this.switchLogStatus=function(widget){var params={};requestEngine.doRequest(requestFactory.factory({serviceName:"zhulog#/logConfiguration/switch",requestType:"dataSource",dataSource:params})).then(function(response){widget.container.label=response.dataset.status[0]?"Log - Active":"Log - Inactive";widget.activate()})};this.setZhuLogConfiguration=function(widget,method){var checkedUsers=widget.getCheckedRows();var params={all:false,deny:false,allow:false};switch(method){case REMOVE:params.deny=true;break;case ALL:params.all=true}params.users=!params.all?checkedUsers:[];requestEngine.doRequest(requestFactory.factory({serviceName:"zhulog#/logConfiguration/update",requestType:"dataSource",dataSource:params})).then(function(){ScreenService.closePopup(true);parentWidget=widget.container.getWidget(LOG_CONFIGURATION_WIDGET);self.showActiveAll(parentWidget);parentWidget.reload()})};function getContentWidget(){return templateManager.container.getWidget(CONTENT_WIDGET)}function getContentFormWidget(){return templateManager.container.getWidget(CONTENT_FORM_WIDGET)}function getContentGridWidget(){return templateManager.container.getWidget(CONTENT_GRID_WIDGET)}function getFilterWidget(){return templateManager.container.getWidget(CONTENT_FILTER_WIDGET)}function getZhuLogWidget(){return templateManager.container.getWidget(LOG_WIDGET_NAME)}this.openContent=function(widget){var contentFormWidget=getContentFormWidget();contentFormWidget.currentRow=widget.currentRow;var rows=ZhuLogService.getPlainContentRows(widget.currentRow.CONTENT);getContentGridWidget().dataSource.data=rows;ScreenService.openSwipe(getContentWidget())};var startFilter=function(widget,currentRow){ZhPreferences.getDefaultWidgetPreferences(widget.id).then(function(result){if(result){ZhFilterPreferences.openFilterWidget(widget,currentRow)}})};var isAppliedFilter=function(widget){return!!widget.zhuLogAppliedFilter};function setStatusToContainersLabel(widget){requestEngine.doRequest(requestFactory.factory({serviceName:"zhulog#/logConfiguration/status",requestType:"filterData"})).then(function(response){widget.container.label=response.dataset.status[0]?"Log - Active":"Log - Inactive";widget.activate()})}this.zhuLogWidgetOnEnter=function(){var widget=getZhuLogWidget();$timeout(function(){if(widget.inListMode()){if(isAppliedFilter(widget)){widget.reload()}else{var currentRow=widget.currentRowDefaultFilter||widget.currentRow;ZhFilterPreferences.setOriginalFilter(widget.id,currentRow);startFilter(widget,currentRow)}}setStatusToContainersLabel(widget)},500,false)};this.zhuLogFilterAfterApply=function(){getZhuLogWidget().zhuLogAppliedFilter=true};this.openFilterPopUp=function(){ScreenService.openPopup(getFilterWidget())};this.setSelectValues=function(){var selectWidget=templateManager.container.getWidget("select");var select2=templateManager.container.getWidget("select").fields[1];if(selectWidget.currentRow.SNATIVE==="REQUEST"){select2.label="Resquest type";select2.readOnly=false;select2.dataSource.data=[];select2.dataSource.data.push({value:"Dataset"},{value:"Row"},{value:"Empty"},{value:"Filter"})}else{if(selectWidget.currentRow.SNATIVE==="RESPONSE"){select2.label="Response type";select2.readOnly=false;select2.dataSource.data=[];select2.dataSource.data.push({value:"Dataset"},{value:"Message"})}else{select2.dataSource.data=[];this.clearFieldsValue(1);select2.readOnly=true}}};this.setTextEdit=function(){var selectWidget=templateManager.container.getWidget("select");selectWidget.actions[2].isVisible=true;selectWidget.actions[3].isVisible=true;if(selectWidget.currentRow.SNATIVE==="REQUEST"){if(selectWidget.currentRow.SNATIVE2==="Dataset"||selectWidget.currentRow.SNATIVE2==="Row"){selectWidget.fields[2].label="Column name";selectWidget.fields[3].label="Operator";selectWidget.fields[3].template="field/select-native.html";selectWidget.fields[4].label="Value";this.addFields()}if(selectWidget.currentRow.SNATIVE2==="Empty"){selectWidget.fields[2].label="Parameter";selectWidget.fields[3].label="Operator";selectWidget.fields[3].template="field/select-native.html";selectWidget.fields[4].label="Value";this.addFields()}if(selectWidget.currentRow.SNATIVE2==="Filter"){selectWidget.fields[2].label="Column name";selectWidget.fields[3].label="Column value";selectWidget.fields[3].template="field/text-edit.html";selectWidget.fields[4].label="Value";this.addFields()}if(selectWidget.currentRow.SNATIVE2===null){this.removeExtraFields()}}else{if(selectWidget.currentRow.SNATIVE==="RESPONSE"){if(selectWidget.currentRow.SNATIVE2==="Dataset"){selectWidget.fields[2].label="Column name";selectWidget.fields[3].label="Operator";selectWidget.fields[3].template="field/select-native.html";selectWidget.fields[4].label="Value";this.addFields()}if(selectWidget.currentRow.SNATIVE2=="Message"){selectWidget.fields[2].label="Column name";selectWidget.fields[3].label="Operator";selectWidget.fields[3].template="field/select-native.html";selectWidget.fields[4].label="Value";this.addFields()}if(selectWidget.currentRow.SNATIVE2===null){this.removeExtraFields()}}}};this.removeExtraFields=function(){var selectWidget=templateManager.container.getWidget("select");var fields=selectWidget.fields;for(var i=fields.length-1;i>6;i--){if(!Util.isUndefined(fields[i])){delete selectWidget.currentRow[fields[i].name];delete fields[i]}}};this.addFields=function(){var selectWidget=templateManager.container.getWidget("select");var fields=templateManager.container.getWidget("select").fields;var field;var dataSource;for(var i=2;i<=6;i++){if(i!==5){var data;if(!Util.isUndefined(fields[i].dataSource)){data=fields[i].dataSource.data;dataSource={data:data}}field={label:fields[i].label,template:fields[i].template,name:"extraField"+fields.length,class:fields[i].class,events:fields[i].events,dataSource:dataSource,valueField:fields[i].valueField,descriptionField:fields[i].descriptionField,isVisible:true,breakline:fields[i].breakline};metaDataFactory.fieldFactory(field,selectWidget,selectWidget)}else{field={label:fields[i].label,template:fields[i].template,name:"extraField"+fields.length,class:fields[i].class,events:fields[i].events,dataSource:dataSource,valueField:fields[i].valueField,descriptionField:fields[i].descriptionField,isVisible:false,breakline:fields[i].breakline};metaDataFactory.fieldFactory(field,selectWidget,selectWidget)}}};this.clearAllFields=function(){this.removeExtraFields();this.clearFieldsValue(0)};this.clearFieldsValue=function(startingValue){var selectWidget=templateManager.container.getWidget("select");for(var i=startingValue;i<selectWidget.fields.length;i++){if(!Util.isUndefined(selectWidget.fields[i])){if(selectWidget.fields[i].value!==""){selectWidget.fields[i].value("")}}}selectWidget.fields[1].readOnly=true};this.clearFields=function(args){var fieldIndex=args.owner.field.sequenceInList;fieldIndex--;var selectWidget=templateManager.container.getWidget("select");var fields=selectWidget.fields;for(var i=fieldIndex;i>=fieldIndex-4;i--){delete selectWidget.currentRow[fields[i].name];delete fields[i]}templateManager.updateTemplate()};this.manageFields=function(args){var operatorIndex=args.owner.field.sequenceInList;operatorIndex--;var selectWidget=templateManager.container.getWidget("select");var selectedfield=selectWidget.fields[operatorIndex];var selectedValue=selectedfield.value();if(selectedValue==="IS_NULL"||selectedValue==="IS_NOT_NULL"){selectWidget.fields[operatorIndex+1].readOnly=false;selectWidget.fields[operatorIndex+1].class=4;selectWidget.fields[operatorIndex+2].isVisible=false;selectWidget.fields[operatorIndex+1].readOnly=true}else if(selectedValue==="BETWEEN"||selectedValue==="NOT_BETWEEN"){selectWidget.fields[operatorIndex+1].class=2;selectWidget.fields[operatorIndex+1].label="Begin";selectWidget.fields[operatorIndex+2].isVisible=true}else{selectWidget.fields[operatorIndex+1].readOnly=false;selectWidget.fields[operatorIndex+1].class=4;selectWidget.fields[operatorIndex+1].label="Value";selectWidget.fields[operatorIndex+2].isVisible=false}};this.startFiltering=function(){var selectWidget=templateManager.container.getWidget("select");var fields=selectWidget.fields;var i=9;var j=0;var params=[];while(i<fields.length){if(!Util.isUndefined(fields[i])){var name=fields[i].value();i++;var operator=fields[i].value();i++;var value;if(operator==="IS_NULL"||operator==="IS_NOT_NULL"){value="";i+=3}else if(operator==="BETWEEN"||operator==="NOT_BETWEEN"){value=[];value[0]=fields[i].value();i++;value[1]=fields[i].value();i+=2}else{value=fields[i].value();i+=3}params[j]={name:name,operator:operator,value:value};j++}else{i+=5}}}}Configuration(function(ContextRegister){ContextRegister.register("ZhuLogController",ZhuLogController)});function ZhuLogDecorator(ApplicationContext,templateManager){var LOG_CONTAINER_NAME="zhulog#log";var GRID_WIDGET_INDEX=0;var logDecorator;function getLogDecorator(){if(logDecorator===undefined){logDecorator=templateManager.projectPromise.then(function(){var decoratorServiceName=templateManager.project.zhuLogDecoratorService;var logDecorator=ApplicationContext[decoratorServiceName];return logDecorator})}return logDecorator}this.afterLoadDataSource=function(args){getLogDecorator().then(function(logDecorator){if(logDecorator){var dataSource=args.owner.dataSource;dataSource.data=logDecorator.normalizeRows(dataSource.data)}})};this.beforeGridFilterApply=function(args){getLogDecorator().then(function(logDecorator){if(logDecorator){var _event=args.e;_event.filters=logDecorator.normalizeFilters(_event.preference.FILTER_ROW)}})};this.apply=function(containerName,container){return getLogDecorator().then(function(logDecorator){if(logDecorator&&containerName===LOG_CONTAINER_NAME){var logWidget=container.widgets[GRID_WIDGET_INDEX];logWidget.events.push({name:"WidgetAfterLoadDataSource",code:"ZhuLogDecorator.afterLoadDataSource(args);"});logWidget.events.push({name:"FilterBeforeApply",code:"ZhuLogDecorator.beforeGridFilterApply(args);"});logDecorator.decorateWidget(logWidget)}return container})}}Configuration(function(ContainerDecoratorProvider,ContextRegister,ApplicationContext,templateManager){ContextRegister.register("ZhuLogDecorator",ZhuLogDecorator);ContainerDecoratorProvider.registerProvider(new ZhuLogDecorator(ApplicationContext,templateManager))});function ZhuLogHelper(){this.moveField=function(widget,fieldName,position){var index=-1;widget.fields.find(function(field){index++;return field.name===fieldName});widget.fields.splice(position-1,0,widget.fields.splice(index,1)[0])};this.getField=function(widget,fieldName){var field=widget.fields.find(function(field){return field.name===fieldName});if(field===null){throw'Field "'+fieldName+'" not found'}return field};this.addField=function(widget,field,position){position=(position||widget.fields.length)-1;widget.fields.splice(position,0,field)};this.removeField=function(widget,fieldName){widget.fields=widget.fields.filter(function(field){return field.name!==fieldName})};this.editField=function(widget,fieldName,editings){var field=this.getField(widget,fieldName);Util.extend(field,editings)};this.getFilters=function(filters,filterName){return filters.filter(function(filter){return filter.name===filterName})};this.addFilter=function(filters,filter){filters.push(filter)};this.removeFilter=function(filters,filterName){filters=filters.filter(function(filter){return filter.name!==filterName})}}Configuration(function(ContextRegister){ContextRegister.register("ZhuLogHelper",ZhuLogHelper)});function Colors(){this.TColorToHex=function(TColor){var rgb=this.TColorToRGB(TColor);return this.rgbToHex(rgb)};this.TColorToRGB=function(TColor){var r=TColor&255;var g=TColor>>8&255;var b=TColor>>16&255;return[r,g,b]};this.rgbToHex=function(rgb){return"#"+((1<<24)+(rgb[0]<<16)+(rgb[1]<<8)+rgb[2]).toString(16).slice(1)};this.RGBToTColor=function(r,g,b){var Tcolor=r|g<<8|b<<16;return Tcolor}}Configuration(function(ContextRegister){ContextRegister.register("Colors",Colors)});var Endereco=function(restEngine,ScreenService,MessageService,ZHPromise){var self=this;self.buscarCep=function(CEP){CEP=CEP.replace(/[\D]+/g,"");if(CEP.length==8){return restEngine.post("/lib_findAddress",{requestType:"Row",row:{CEP:CEP}})}else{ScreenService.showMessage("CEP Inválido.")}};self.validarCep=function(widget,CEP){self.buscarCep(CEP).then(function(response){var endereco=response.dataset.ENDERECO;if(endereco){widget.currentRow.CEP=CEP;widget.currentRow.CDPAIS=endereco.CDPAIS?endereco.CDPAIS:"";widget.currentRow.NMPAIS=endereco.NMPAIS?endereco.NMPAIS:"";widget.currentRow.SGESTADO=endereco.SGESTADO?endereco.SGESTADO:"";widget.currentRow.NMESTADO=endereco.NMESTADO?endereco.NMESTADO:"";widget.currentRow.CDMUNICIPIO=endereco.CDMUNICIPIO?endereco.CDMUNICIPIO:"";widget.currentRow.NMMUNICIPIO=endereco.NMMUNICIPIO?endereco.NMMUNICIPIO:"";widget.currentRow.CDBAIRRO=endereco.CDBAIRRO?endereco.CDBAIRRO:"";widget.currentRow.NMBAIRRO=endereco.NMBAIRRO?endereco.NMBAIRRO:"";widget.currentRow.CDLOGRADOURO=endereco.CDLOGRADOURO?endereco.CDLOGRADOURO:"";widget.currentRow.DSLOGRADOURO=endereco.DSLOGRADOURO?endereco.DSLOGRADOURO:"";widget.currentRow.DSENDERECO=endereco.DSENDERECO?endereco.DSENDERECO:""}else{widget.currentRow.CEP=""}},function(error){MessageService.getMessageByCode("PROXY_CONNECTION_FAIL").then(function(errorMessage){var row={CEP:CEP,errorMessage:errorMessage};widget.currentRow.CEP="";if(error.data)errorMessage=error.data.error;ScreenService.showMessageByCode("REQUEST_CEP_ERROR",row,Constants.errorMessage)})})}};Configuration(function(ContextRegister){ContextRegister.register("Endereco",Endereco)});var General=function(ScreenService,templateManager,localStorageEngine,restEngine,maskEngine,ZhUtil,ZHPromise,ValidationEngine,metaDataFactory,MessageService){var searchListDeleted;var parent=this;var cacheLoaded=false;this.onClickDependentField=function(dependentField,parameters){var dataSourceFilterNew=this.buildDataSourceFilter(angular.copy(dependentField.dataSourceFilter),parameters);var changedDataSourceFilter=compareDataSourceFilters(dependentField.selectWidget,dataSourceFilterNew,parameters);if(changedDataSourceFilter){changeDependetFieldFilter(dependentField,dataSourceFilterNew)}if(dependentField.selectWidget&&changedDataSourceFilter||(!dependentField.dataSource.data||!dependentField.dataSource.data.length)||searchListDeleted){dependentField.reload()}};this.buildDataSourceFilter=function(dataSourceFilter,parameters){if(!dataSourceFilter){throw"DataSourceFilter is not defined!"}for(var position in dataSourceFilter){if(parameters.hasOwnProperty(dataSourceFilter[position].name)){dataSourceFilter[position].value=parameters[dataSourceFilter[position].name]}}return dataSourceFilter};var changeDependetFieldFilter=function(dependentField,dataSourceFilterNew){dependentField.dataSourceFilter=dataSourceFilterNew;dependentField.dataSource.lazyLoad=false;if(dependentField.selectWidget){dependentField.selectWidget.dataSourceFilter=dataSourceFilterNew}if(dependentField.selectWidget&&dependentField.selectWidget.searchList){searchListDeleted=true;delete dependentField.selectWidget.searchList}else if(dependentField.selectWidget){searchListDeleted=false}};var compareDataSourceFilters=function(selectWidget,dataSourceFilterNew,parameters){var changedDataSourceFilter=false;if(selectWidget){var selectWidgetDataSourceFilter=selectWidget.dataSourceFilter;for(var position=0;position<dataSourceFilterNew.length;position++){if(parameters.hasOwnProperty(dataSourceFilterNew[position].name)){if(selectWidgetDataSourceFilter[position].value!=dataSourceFilterNew[position].value){changedDataSourceFilter=true}}}}else{changedDataSourceFilter=true}return changedDataSourceFilter};this.getLevelByMask=function(maskName,firstLevel){firstLevel=toNumber(firstLevel);var mask=getLocalVar(maskName);var splitMask=mask.split(".");var biggestLevel=splitMask.length;var level=[];var objLevel={};for(var i=0;i<biggestLevel;i++){objLevel={nivel:i+firstLevel,caracteres:i>0?parseInt(level[i-1].caracteres)+parseInt(splitMask[i].length):parseInt(splitMask[i].length)};objLevel.nivel=objLevel.nivel.toString();objLevel.caracteres=objLevel.caracteres.toString();level.push(objLevel)}return level};var toNumber=function(value){if(!value&&value!==0){throw"firstLevel is not defined"}else if(typeof value!=="number"&&value){value=parseInt(value);if(isNaN(parseInt(value))){throw"Invalid firstLevel"}else{return value}}return value};this.toggleReadOnlySelect=function(checkboxField,selectField){if(checkboxField.checked){selectField.readOnly=true;selectField.validations={};selectField.setValue("")}else{selectField.readOnly=false;selectField.validations={required:true}}templateManager.updateTemplate()};this.setLoggedUnit=function(widget){widget.currentRow.CDFILIAL=getLocalVar("CDFILIAL");widget.currentRow.NMFILIAL=getLocalVar("NMFILIAL")};var currentIdgrupoper;var currentCallback;var currentParameters;var gruposDeOperador={LCMR:"A liberação de cardápio fora da meta dependente de autorização"};var fields=[{name:"email",label:"E-mail",class:12,isVisible:true,readOnly:false,template:"field/text-edit.html",events:[],fieldGroup:"AUTH",validations:{required:true,mail:true}},{name:"senha",label:"Senha",class:12,isVisible:true,readOnly:false,fieldGroup:"AUTH",template:"field/password-edit.html",events:[],validations:{required:true}}];var actions=[{name:"cancelar",label:"Cancelar",idVisible:true,hideIcon:true,showAsAction:"back",events:[{name:"ActionEvent",code:"ScreenService.closePopup();"}]},{name:"confirmar",label:"Confirmar",idVisible:true,hideIcon:true,showAsAction:"never",events:[{name:"ActionEvent",code:"General.validateUser(args.owner.widget);"}]}];this.openAuthPopup=function(idgrupoper,message,callback,parameters){if(!idgrupoper){throw"idgrupoper is not defined"}initAuthVariables(idgrupoper,callback,parameters);if(!message){message=gruposDeOperador[currentIdgrupoper]||""}var widgetAuth=metaDataFactory.widgetFactory({id:0,name:"authWidget",label:"Autenticação",template:"widget/form.html",container:templateManager.container,isVisible:true,popupNoBlock:false,fieldGroups:[{id:1e5,name:"AUTH",opened:true,collapsible:false,label:message}],fields:fields,actions:actions,events:[]});ScreenService.openPopup(widgetAuth)};var initAuthVariables=function(idgrupoper,callback,parameters){currentIdgrupoper=idgrupoper;currentCallback=callback||null;currentParameters=parameters||[]};this.validateUser=function(widget){var self=this;if(widget.isValid()){var email=widget.currentRow.email;var senha=widget.currentRow.senha;autenticar(email,senha).then(function(callback){getPermission(callback.dataset.user.cdoperador).then(function(permission){if(permission){if(typeof currentCallback=="function"){ScreenService.closePopup();currentCallback.apply(null,currentParameters)}else{throw"callback is not a function"}}else{MessageService.showMessageByCode("lib#GEN_INVALID_OPERGROUP",null,{type:"ERROR"})}},function(callback){this.callbackError(callback)}.bind(self))},function(callback){this.callbackError(callback)}.bind(self))}};var autenticar=function(email,senha){return restEngine.request("/Autenticar",{requestType:"FilterData",filter:[{name:"email",operator:"=",value:email},{name:"senha",operator:"=",value:senha}]})};var getPermission=function(cdoperador){return restEngine.request("/validateUserGroup",{requestType:"Row",row:{idgrupoper:currentIdgrupoper,cdoperador:cdoperador}}).then(function(callback){return callback.dataset.permission.isValid})};this.callbackError=function(callback){if(callback.data){ScreenService.showMessage(ScreenService.i18n(callback.data.error))}else{MessageService.showMessageByCode("lib#GEN_TIMEOUT",null,{type:"ERROR"})}};this.comparaPratoProduto=function(pinicial,pfinal,mascara){var mask={type:"fix",params:{mask:mascara}};pinicial=Util.applyMask(pinicial,mask,maskEngine,ZhUtil).split(".");pfinal=Util.applyMask(pfinal,mask,maskEngine,ZhUtil).split(".");var nvinicial=pinicial.length;var nvfinal=pfinal.length;var menornv;if(nvinicial>nvfinal){menornv=nvfinal}else{menornv=nvinicial}var resultado=true;var i=0;while(pinicial[i]==pfinal[i]&&i<menornv){i++}if(pinicial.hasOwnProperty(i)&&!pfinal.hasOwnProperty(i)||pinicial[i]>pfinal[i]){resultado=false}else{resultado=true}return resultado};var reportWidget={id:0,name:"reportWidget",label:"Tipo de Relatório",template:"widget/form.html",container:{},isVisible:true,popupNoBlock:false,fields:[],actions:[],events:[]};var reportFields=[{id:99999999,name:"QR2TYPE",label:"",class:12,readOnly:false,isVisible:true,isVisibleForm:true,isVisibleGrid:false,template:"field/radio-group.html",events:[],valueField:"value",descriptionField:"name",defaultOption:0,dataSource:{data:[{name:"pdf",value:"PDF"},{name:"xls",value:"XLS"},{name:"rtf",value:"RTF"},{name:"txt",value:"TXT"}]}}];var reportActions=[{name:"cancelar",label:"Cancelar",idVisible:true,hideIcon:true,showAsAction:"back",events:[{name:"ActionEvent",code:"ScreenService.closePopup();"}]},{name:"confirmar",label:"Confirmar",idVisible:true,hideIcon:true,showAsAction:"never",events:[{name:"ActionEvent",code:"General.generateReport(args.owner.widget, args);"}]}];var reportCallback;var reportParameters;var reportWidgetParentName;this.openReportPopup=function(widget,callback,parameters,reportFormats){reportCallback=callback;reportParameters=parameters||[];reportWidgetParentName=widget.name;reportWidget.container=widget.container;reportWidget.fields=reportFields;reportWidget.actions=reportActions;var reportWidgetInitialized=metaDataFactory.widgetFactory(reportWidget);updateReportWidgetFormats(reportWidgetInitialized,reportFormats);ScreenService.openPopup(reportWidgetInitialized)};var updateReportWidgetFormats=function(reportWidget,reportFormats){if(Array.isArray(reportFormats)&&reportFormats.length){var formatField=reportWidget.getField("QR2TYPE");formatField.dataSource.data=reportFormats}};this.generateReport=function(widget,args){var reportWidgetParentCurrentRow=widget.container.getWidget(reportWidgetParentName).currentRow;reportWidgetParentCurrentRow.QR2TYPE=widget.currentRow.QR2TYPE;args.row=reportWidgetParentCurrentRow;if(typeof reportCallback=="function"){reportCallback.apply(null,reportParameters)}ScreenService.closePopup()};this.saveRow=function(args,closeSwipe){args.owner.widget.saveRow().then(function(){var currentRow=args.owner.widget.currentRow;currentRow.__is_new=false;currentRow.changed=false;args.owner.widget.reload();if(closeSwipe){ScreenService.closeSwipe()}})};this.openSelectionOnce=function(name){var filterWidget=templateManager.container.getWidget(name+"_FILTER");if(!filterWidget.wasOpened){filterWidget.edit();ScreenService.openPopup(filterWidget);filterWidget.wasOpened=true}};this.openSelection=function(name){var filterWidget=templateManager.container.getWidget(name+"_FILTER");filterWidget.edit();ScreenService.openPopup(filterWidget)};this.getContainerName=function(){return templateManager.container.name};this.backOrCancel=function(args){var deferred=ZHPromise.defer();if(args.row.__is_new){args.owner.widget.list(true);args.owner.widget.dataSource.data.pop();args.owner.widget.currentRow={};deferred.resolve()}else if(args.owner.widget.mode==="edit"){args.owner.widget.view();for(var i in args.owner.widget.backupRow){args.owner.widget.currentRow[i]=args.owner.widget.backupRow[i]}deferred.resolve();return deferred.promise}ScreenService.goBack();return deferred.promise};this.edit=function(widget){widget.backupRow=Object.assign({},widget.currentRow);widget.edit()};this.modEdit=function(widget){parent.edit(widget);var widgetParent=widget.widgets;if(widgetParent.length)parent.setVisibleforTabbed(widgetParent,false,widget)};this.cancelModEdit=function(args,widgetParent){parent.backOrCancel(args).then(function(success){var widget=args.owner.widget;var widgetParent=widget.widgets;if(widgetParent.length)parent.setVisibleforTabbed(widgetParent,true)})};this.setVisibleforTabbed=function(widgets,isVisible,exception){widgets.forEach(function(widget){if(exception){if(exception.name!=widget.name)widget.isVisible=isVisible}else{widget.isVisible=isVisible}})};this.setContextVar=function(name,containerName,value){localStorageEngine.setLocalVar(containerName+"_"+name,value)};this.getContextVar=function(name,containerName){return localStorageEngine.getLocalVar(containerName+"_"+name)};var _getWidget=function(widgetName){var isPopup=arguments[1]||null;if(!!templateManager.container){var widget;if(!isPopup){widget=templateManager.container.getWidget(widgetName)}else{widget=templateManager.container.getWidget(widgetName);if(widget)if(widget.hasOwnProperty("__filterPopup"))widget=widget.__filterPopup;else{widget=widget.appliedFilter}}if(widget){return widget}}return null};var _getField=function(name,widgetName){var widget=_getWidget(widgetName);var field=widget.getField(name);if(field){return field}return null};var _getAction=function(name,widgetName){var widget=_getWidget(widgetName);var action=widget.getAction(name);if(action){return action}return null};this.getFieldValue=function(name,widgetName){var isPopup=arguments[2]||null;var widget=_getWidget(widgetName,isPopup);if(widget&&widget.currentRow){return widget.currentRow[name]}else{return""}};this.setEnableField=function(name,widgetName){_getField(name,widgetName).readOnly=false};this.setDisableField=function(name,widgetName){_getField(name,widgetName).readOnly=true};this.setVisibleField=function(name,widgetName){_getField(name,widgetName).isVisible=true};this.setInvisibleField=function(name,widgetName){_getField(name,widgetName).isVisible=false};this.setEnableAction=function(name,widgetName){_getAction(name,widgetName).readOnly=false};this.setDisableAction=function(name,widgetName){_getAction(name,widgetName).readOnly=true};this.setVisibleAction=function(name,widgetName){_getAction(name,widgetName).isVisible=true};this.setInvisibleAction=function(name,widgetName){_getAction(name,widgetName).isVisible=false};this.now=function(){return moment(new Date).format("DD/MM/YYYY HH:mm:ss")};this.today=function(){return moment(new Date).format("DD/MM/YYYY")};var getCurrentModule=function(){var currentModule=window.location.hash.split("/").filter(function(_){return _.length}).pop();if(currentModule&&currentModule.length>0){currentModule=currentModule.split(/_|#/)[0]}return currentModule};this.openReport=function(route,reportName,params,isUrl){isUrl=isUrl?true:false;params.__report_name=reportName;var lastActiveWidget=templateManager.container.getActiveWidget().lastActiveWidget;if(lastActiveWidget&&lastActiveWidget.beforeOpenReport){lastActiveWidget.beforeOpenReport({reportParams:params})}return restEngine.post(route,{requestType:"Row",row:params},null,null,null,null,3e6).then(function(response){if(response&&response.messages){var report=response.messages.pop();var isLibOpenReport=report.message.includes("lib_openReport");if(isUrl||isLibOpenReport){var url=report.message;if(isLibOpenReport){var serviceUrl=window.serviceUrls.find(function(item){return item.package==getCurrentModule()}).baseUrl;if(!serviceUrl.includes("http")){serviceUrl=window.location.origin+window.location.pathname.replace("//","/")+serviceUrl}var url=serviceUrl+url}var reportOpened=window.open(url);if(!reportOpened){MessageService.showMessageByCode("lib#GEN_POPUP_BLOCKER",null,{type:"ERROR"})}}else{if(params.QR2TYPE){params.__FORMAT=params.QR2TYPE}var format=params.__FORMAT?params.__FORMAT:"pdf";var data=report.message;if(data.includes("&format=")){var splitedData=data.split("&format=");data=splitedData[0];format=splitedData[1]}var a=document.createElement("a");document.body.appendChild(a);a.style="display: none";a.href="data:application/octet-stream;base64,"+data;a.download=reportName+"."+format;a.click()}}}).catch(function(response){if(response.data&&response.data.error){ScreenService.showMessage(ScreenService.i18n(response.data.error),"E")}})};this.saveCrud=function(widget,afterValid){var deferred=ZHPromise.defer();if(widget.isValid()){if(afterValid&&angular.isObject(afterValid)){if(angular.isFunction(afterValid.callback))afterValid.callback.apply(null,afterValid.params)}var paramsNewCode=widget.paramsNewCode;if(paramsNewCode&&paramsNewCode.__is_new_code){widget.currentRow.__using_unit=paramsNewCode.__using_unit||false;widget.currentRow.__new_code_pk=paramsNewCode.__new_code_pk;widget.currentRow.__table_pk=paramsNewCode.__table_pk;widget.currentRow.__new_code_interval=paramsNewCode.__new_code_interval||1;widget.currentRow.__new_code_length=paramsNewCode.__new_code_length||5;widget.currentRow.__new_code_column_size=paramsNewCode.__new_code_column_size||10;widget.currentRow.__cast_number=paramsNewCode.__cast_number||false}var fieldsToValidateDuplication=widget.fieldsToValidateDuplication;if(fieldsToValidateDuplication&&fieldsToValidateDuplication.length){setDuplicationValidateParamsToCurrentRow(widget)}widget.saveRow().then(function(success){widget.activate();if(widget.currentRow.__is_new){widget.list(true);ScreenService.goBack();widget.reload().then(function(){deferred.resolve(success)})}else{widget.computeDescriptionOrder();widget.view();deferred.resolve(success)}},function(error){var errorMessage="Timeout";if(error.data){errorMessage=error.data.error}ScreenService.showMessage(errorMessage);deferred.reject(errorMessage)})}else{deferred.reject("Preencha todos os campos corretamente!")}return deferred.promise};var setDuplicationValidateParamsToCurrentRow=function(widget){try{var fieldsToValidate=widget.fieldsToValidateDuplication;var validationArray=[];checkValidateFieldsArray(fieldsToValidate);for(var index in fieldsToValidate){var field=fieldsToValidate[index];if(!field.description){field.description=field.name;var warningMsg="Missing description for "+field.name+" field in 'fieldsToValidateDuplication' of "+widget.name;console.warn(warningMsg)}field.description=field.description.toLowerCase();validationArray.push(field)}if(validationArray.length){widget.currentRow.__fieldsToValidateDuplication=validationArray}}catch(e){ScreenService.showMessage(e)}};var checkValidateFieldsArray=function(arrayToCheck){for(var index in arrayToCheck){var objectToCheck=arrayToCheck[index];if(typeof objectToCheck=="object"){if(!objectToCheck.name){throw"Error in data save. Property 'fieldsToValidateDuplication' of widget has elements without name."}}else{throw"Error in data save. Property 'fieldsToValidateDuplication' of widget has non-object elements."}}};this.deleteCrud=function(widget){var deferred=ZHPromise.defer();MessageService.confirmMessageByCode("lib#GEN_DELETE_REG").then(function(success){widget.removeRow().then(function(){ScreenService.closeSwipe().then(function(){widget.activate();deferred.resolve()})},function(error){if(error.data&&error.data.error.indexOf("ORA-02292")!==-1){MessageService.showMessageByCode("lib#GEN_DELETE_BLOCK",null,{type:"ERROR"})}else{ScreenService.showMessage(error.data.error)}deferred.reject()})});return deferred.promise};this.deleteCrudCheckedRows=function(widget){var deferred=ZHPromise.defer();MessageService.confirmMessageByCode("lib#GEN_DELETE_REG").then(function(success){widget.removeCheckedRows().then(function(){widget.reload();widget.unSelectAll();deferred.resolve()},function(error){if(error.data&&error.data.error.indexOf("ORA-02292")!==-1){MessageService.showMessageByCode("lib#GEN_DELETE_BLOCK",null,{type:"ERROR"})}else{ScreenService.showMessage(error.data.error)}deferred.reject()})});return deferred.promise};this.justInteger=function(selector,retryCount){if(!retryCount||retryCount>5)retryCount=5;if(!selector){throw{message:"Selector is not defined!"}}setTimeout(function(){var elem=$(selector);if(elem[0]){var length=selector.split(",").length;for(var i=0;i<length;i++){if(elem.hasOwnProperty(i)){elem[i].onkeypress=avoidNonInteger;elem[i].onpaste=preventEvent}}}else{if(!retryCount){console.error("Selector not found!")}else{retryCount--;this.justInteger(selector,retryCount)}}}.bind(this),500)};function avoidNonInteger(e){var integerNumbers=[48,49,50,51,52,53,54,55,56,57];var numberCode=e.which;if(integerNumbers.indexOf(numberCode)<0){preventEvent(e)}}function preventEvent(e){e.preventDefault()}function padLeft(value,length){return value.toString().length<length?padLeft("0"+value,length):value}function padRight(value,length){return value.toString().length<length?padRight(value+"0",length):value}this.getCurrentDate=function(format){return moment().format(format)};this.setDateAttrToVarcharOnCurrentRow=function(currentRow,attrName){this.setAttrOnCurrentRow(currentRow,attrName,currentRow[attrName].replace(":",""))};this.setAttrOnCurrentRow=function(currentRow,attrName,value){currentRow[attrName]=value};this.setFloatAttrOnCurrentRow=function(currentRow,attrName){this.setAttrOnCurrentRow(currentRow,attrName,this.valueToFloat(currentRow[attrName]))};this.valueToFloat=function(value){if(typeof value=="string"&&!Util.isEmptyOrBlank(value)){if(value.indexOf(",")==-1&&value.indexOf(".")==-1){return parseFloat(value)}else if(value.indexOf(",")>value.indexOf(".")){return parseFloat(value.replace(/\./g,"").replace(/\,/g,"."))}else if(value.indexOf(",")<value.indexOf(".")){return parseFloat(value.replace(/\,/g,""))}}else{return value}};this.toLocalDate=function(element,viewValue,params,callBack){var value=viewValue||"";element.val(value);params.callback=callBack;$.currency.setMask(params,element)};this.toLocalDateFormat=function(value,params){if(value){var valueDate=moment(value,params.format);value=valueDate.format(params.toFormat)}return value};maskEngine.registerMask("dateFormat",this.toLocalDate,this.toLocalDateFormat);var maskFunction=function(element,viewValue,params,callBack){};var maskFormatFunction=function(value,params){if(value){var length=value.length;if(length===11)value=value.replace(/^(\d{3})(\d{3})(\d{3})(\d{2})/,"$1.$2.$3-$4");else if(length===14)value=value.replace(/^(\d{2})(\d{3})(\d{3})(\d{4})(\d{2})/,"$1.$2.$3/$4-$5");return value}};maskEngine.registerMask("CPFCNPJ",maskFunction,maskFormatFunction);var constAllWidgets;this.setVisibilityByProjectID=function(widgets){if(widgets.length>1){widgets.forEach(function(childWidget){parent.setVisibilityByProjectID(childWidget.widgets);if(childWidget.projects){childWidget.projects.forEach(function(proj){childWidget.isVisible=proj.projectID==templateManager.project.id||proj.projectID=="allProjects"?true:false})}})}};this.validateFilterPopup=function(args){if(args.owner.hasOwnProperty("__filterPopup")){var filterPopup=args.owner.__filterPopup;if(!filterPopup.isValid())args.e.preventDefault()}};var timeFormats={hh:isValidHour,mm:isValidMinutesOrSeconds,ss:isValidMinutesOrSeconds,"hh:mm":isValidHourAndMinutes,"mm:ss":isValidMinutesAndSeconds,"hh:mm:ss":isValidTime};function isValidHour(hour){if(parseInt(hour)>23||parseInt(hour)<0)return false;else return true}function isValidMinutesOrSeconds(minuteOrSecond){if(parseInt(minuteOrSecond)>59||parseInt(minuteOrSecond)<0)return false;else return true}function isValidHourAndMinutes(hourAndMinute){if(hourAndMinute){var timeArray=hourAndMinute.split(":");return isValidHour(timeArray[0])&&isValidMinutesOrSeconds(timeArray[1])}return true}function isValidMinutesAndSeconds(minutesAndSeconds){if(minutesAndSeconds){var timeArray=minutesAndSeconds.split(":");return isValidMinutesOrSeconds(timeArray[0])&&isValidMinutesOrSeconds(timeArray[1])}return true}function isValidTime(time){if(time){var timeArray=time.split(":");return isValidHour(timeArray[0])&&isValidMinutesOrSeconds(timeArray[1])&&isValidMinutesOrSeconds(timeArray[2])}return true}var validTime=function(value,format){var validFunction;if(!format)throw"format is not defined";if(typeof format=="string"&&timeFormats.hasOwnProperty(format.toLowerCase()))validFunction=timeFormats[format.toLowerCase()];else throw"time format is not registered";return{valid:validFunction(value),message:ScreenService.i18n("Não é um tempo válido.")}};this.registerTimeFormat=function(format,formatFunction){if(typeof format!=="string")throw"time format must be an string";if(timeFormats.hasOwnProperty(format.toLowerCase()))throw"time format already registered";timeFormats[format]=formatFunction};ValidationEngine.registerValidation("isValidTime",validTime);this.fill=function(value,length,toRight,filler){if(value){value=value.toString();if(filler){filler=filler.toString()[0]}else filler="0";if(toRight)while(value.length+filler.length<=length)value=value+filler;else while(value.length+filler.length<=length)value=filler+value}return value};function validCNPJ(CNPJ){if(CNPJ===undefined||CNPJ===null)return false;CNPJ=CNPJ.toString().replace(/[\D]+/g,"");if(CNPJ.length!=14)return false;if(CNPJ=="00000000000000"||CNPJ=="11111111111111"||CNPJ=="22222222222222"||CNPJ=="33333333333333"||CNPJ=="44444444444444"||CNPJ=="55555555555555"||CNPJ=="66666666666666"||CNPJ=="77777777777777"||CNPJ=="88888888888888"||CNPJ=="99999999999999")return false;var tamanho=CNPJ.length-2;var numeros=CNPJ.substring(0,tamanho);var digitos=CNPJ.substring(tamanho);var soma=0;var pos=tamanho-7;for(var i=tamanho;i>=1;i--){soma+=numeros.charAt(tamanho-i)*pos--;if(pos<2)pos=9}var resultado=soma%11<2?0:11-soma%11;if(resultado!=digitos.charAt(0))return false;tamanho=tamanho+1;numeros=CNPJ.substring(0,tamanho);soma=0;pos=tamanho-7;for(i=tamanho;i>=1;i--){soma+=numeros.charAt(tamanho-i)*pos--;if(pos<2)pos=9}resultado=soma%11<2?0:11-soma%11;if(resultado!=digitos.charAt(1))return false;return true}this.validateCNPJ=validCNPJ;function validCPF(CPF){if(CPF===undefined||CPF===null)return false;CPF=CPF.toString().replace(/[\D]+/g,"");if(CPF.length!=11)return false;if(CPF=="00000000000"||CPF=="11111111111"||CPF=="22222222222"||CPF=="33333333333"||CPF=="44444444444"||CPF=="55555555555"||CPF=="66666666666"||CPF=="77777777777"||CPF=="88888888888"||CPF=="99999999999")return false;var soma=0;var resto;for(var i=1;i<=9;i++)soma=soma+parseInt(CPF.substring(i-1,i))*(11-i);resto=soma*10%11;if(resto==10||resto==11)resto=0;if(resto!=parseInt(CPF.substring(9,10)))return false;soma=0;for(i=1;i<=10;i++)soma=soma+parseInt(CPF.substring(i-1,i))*(12-i);resto=soma*10%11;if(resto==10||resto==11)resto=0;if(resto!=parseInt(CPF.substring(10,11)))return false;return true}this.validateCPF=validCPF;this.inscricaoFormat=function(inscricao,force){if(inscricao===undefined||inscricao===null||inscricao==="")return{parameter:"",value:"",tipo:{cod:null,desc:null},valid:false};if(force===undefined||force===null)force=false;inscricao=inscricao.toString().replace(/[\D]+/g,"");var obj={};obj.tipo={};if(inscricao.length<=5){obj.tipo.cod="O";obj.tipo.desc="Código Genérico";obj.valid=true;obj.value=this.fill(inscricao,5)}else{if(inscricao.length==11){obj.tipo.cod="F";obj.tipo.desc="Pessoa Física";obj.valid=this.validateCPF(inscricao);obj.value=inscricao.substr(0,3)+"."+inscricao.substr(3,3)+"."+inscricao.substr(6,3)+"-"+inscricao.substr(9,2)}else if(inscricao.length==14){obj.tipo.cod="J";obj.tipo.desc="Pessoa Jurídica";obj.valid=this.validateCNPJ(inscricao);obj.value=inscricao.substr(0,2)+"."+inscricao.substr(2,3)+"."+inscricao.substr(5,3)+"/"+inscricao.substr(8,4)+"-"+inscricao.substr(12,2)}else force=true;if(force&&obj.valid!==true){obj.tipo.cod="I";obj.tipo.desc="Inscrição Internacional";if(inscricao.length<=20){obj.valid=true;obj.value=this.fill(inscricao,20)}else{obj.valid=false;obj.value=inscricao.substr(0,20)}}}obj.parameter=inscricao;return obj};var CPFValidation=function(value,validationAttrs){return{valid:validCPF(value),message:ScreenService.i18n("CPF Inválido")}};ValidationEngine.registerValidation("CPF",CPFValidation);var CNPJValidation=function(value,validationAttrs){return{valid:validCNPJ(value),message:ScreenService.i18n("CNPJ Inválido")}};ValidationEngine.registerValidation("CNPJ",CNPJValidation);this.callRestEngine=function(dataSource,requestType,requestValue,disableLoader){var defer=ZHPromise.defer();var params={};switch(requestType){case"Row":params={requestType:"Row",row:requestValue,disableLoader:disableLoader};break;case"DataSet":params={requestType:"DataSet",dataset:requestValue,disableLoader:disableLoader};break;case"FilterData":params={requestType:"FilterData",filter:requestValue,disableLoader:disableLoader};break;default:return defer.reject("Erro na passagem de parâmetros para a requisição. O valor para requestType deve ser 'Row', 'DataSet' ou 'FilterData'.")}return restEngine.request(dataSource,params)};this.changeWidgetAcessibility=function(widgets,enabled){widgets.forEach(function(widget){widget.enabled=enabled});templateManager.updateTemplate()};this.formWidgetSwitchTemplate=function(widget){if(widget.template!="widget/form.html"&&widget.template!="widget/form-view.html")return false;if(!widget.templateToForm)widget.templateToForm="widget/form.html";if(!widget.templateToView)widget.templateToView="widget/form-view.html";if(widget.template==widget.templateToForm)widget.template=widget.templateToView;else if(widget.template==widget.templateToView)widget.template=widget.templateToForm;templateManager.updateTemplate();return true};this.widgetEdit=function(widget){if(!widget.editing){if(this.formWidgetSwitchTemplate(widget)&&widget.parent){var widgetsToDeactivate=widget.parent.widgets;this.changeWidgetAcessibility(widgetsToDeactivate.filter(function(subwidget){return subwidget.name!=widget.name}).concat(widget.parent),false)}else this.changeWidgetAcessibility(widget.widgets,false);var ignoredKeys=["__rightActions","__leftActions","_children","_parent","__groupHeaders","__index","__isSelected","__notSelectable","$$hashKey"];widget.backupRow=Util.clone(widget.currentRow,ignoredKeys);widget.edit();return true}else return false};this.widgetCancelForm=function(widget){if(this.formWidgetSwitchTemplate(widget)&&widget.parent){var widgets=widget.parent.widgets;this.changeWidgetAcessibility(widgets.concat(widget.parent),true)}else this.changeWidgetAcessibility(widget.widgets,true);if(widget.currentRow.__is_new){var indexOfCurrentRow=widget.dataSource.data.indexOf(widget.currentRow);if(indexOfCurrentRow!==-1){widget.dataSource.data.pop()}widget.list();ScreenService.closeSwipe()}else{Object.keys(widget.backupRow).forEach(function(key){widget.currentRow[key]=widget.backupRow[key]});widget.view()}};this.widgetGoBackToList=function(widget){ScreenService.closeSwipe();widget.list()};this.widgetGoBackToParent=function(widget){ScreenService.closeSwipe().then(function(){widget.parent.list();widget.parent.activate()})};this.widgetNewRow=function(widget){this.changeWidgetAcessibility(widget.widgets,false);widget.newRow()};this.widgetSave=function(widget){var deferred=ZHPromise.defer();if(widget.isValid()){widget.currentRow.changed=true;if(!widget.currentRow.__is_new)widget.currentRow.__is_new=false;else if(widget.paramsNewCode&&widget.paramsNewCode.__is_new_code){widget.currentRow.__using_unit=widget.paramsNewCode.__using_unit||false;widget.currentRow.__new_code_pk=widget.paramsNewCode.__new_code_pk;widget.currentRow.__table_pk=widget.paramsNewCode.__table_pk;widget.currentRow.__new_code_interval=widget.paramsNewCode.__new_code_interval||1;widget.currentRow.__new_code_length=widget.paramsNewCode.__new_code_length||5;widget.currentRow.__new_code_column_size=widget.paramsNewCode.__new_code_column_size||10;widget.currentRow.__cast_number=widget.paramsNewCode.__cast_number||false;if(!widget.currentRow.__columns_to_return&&widget.paramsNewCode&&widget.paramsNewCode.__columns_to_return)widget.currentRow.__columns_to_return=widget.paramsNewCode.__columns_to_return}widget.saveRow().then(function(response){widget.currentRow.changed=false;delete widget.backupRow;if(this.formWidgetSwitchTemplate(widget)&&widget.parent){widget.view();var widgets=widget.parent.widgets;this.changeWidgetAcessibility(widgets.concat(widget.parent),true)}else{if(widget.currentRow.__is_new){ScreenService.closeSwipe();widget.list()}else widget.view();this.changeWidgetAcessibility(widget.widgets,true)}if(widget.currentRow.__is_new)widget.currentRow.__is_new=false;else widget.reload();deferred.resolve(response)}.bind(this),function(error){var errorMessage="Timeout";if(error.data)errorMessage=error.data.error;ScreenService.showMessage(errorMessage);deferred.reject(errorMessage)})}else deferred.reject("Preencha todos os campos corretamente!");return deferred};this.checkParentContainer=function(containerProperties){containers=templateManager.containers;if(!containers.hasOwnProperty(containerProperties.parentContainerName)){if(angular.isFunction(containerProperties.callback)){containerProperties.callback.apply(containerProperties.scope,containerProperties.params)}else{ScreenService.openWindow(containerProperties.parentContainerName)}}};var messagesWidget={id:0,name:"messagesWidget",label:"Mensagens",messagesDataset:"",template:"widget/form.html",floatingControl:{customizationAction:{filter:false,view:false,layout:false}},container:{},isVisible:true,popupNoBlock:false,fields:[],actions:[],events:[]};var messagesFields=[{label:"",name:"CONTENT",readOnly:true,template:"field/textarea.html",textRows:14,isVisible:true,class:12,descriptionOrder:true,showOnView:true,showOnForm:true,showOnList:true}];var messagesActions=[{name:"cancelar",label:"Cancelar",idVisible:true,hideIcon:true,showAsAction:"back",events:[{name:"ActionEvent",code:"ScreenService.closePopup();"}]},{name:"exportar",label:"Exportar",idVisible:true,icon:"export",showAsAction:"always",events:[{name:"ActionEvent",code:"General.generateFileByDataSet(args.owner.widget.messagesDataset);"}]}];this.showErrorMessages=function(widget,dataset,popupName){messagesWidget.container=widget.container;messagesWidget.fields=messagesFields;messagesWidget.actions=messagesActions;var messagesWidgetInitialized=metaDataFactory.widgetFactory(messagesWidget);var content="";if(popupName!==undefined)messagesWidgetInitialized.label=popupName;messagesWidgetInitialized.messagesDataset=dataset;dataset.forEach(function(message){content+=message+"\n"});messagesWidgetInitialized.getField("CONTENT").setValue(content);ScreenService.openPopup(messagesWidgetInitialized)};this.generateFileByDataSet=function(dataset,fileProperties){var content="";var name="content";var extension="text/plain";if(fileProperties!==undefined){if(fileProperties.fileName!==undefined)name=fileProperties.fileName}dataset.forEach(function(line){content+=line+"\r\n"});var element=document.createElement("a");element.setAttribute("href","data:"+extension+";charset=utf-8,"+encodeURIComponent(content));element.setAttribute("download",name);element.style.display="none";document.body.appendChild(element);element.click();document.body.removeChild(element)};this.isWidgetFiltered=function(widget){var isFiltered=true;var currentFilter;if(widget.hasOwnProperty("__filterPopup"))currentFilter=widget.__filterPopup.currentFilter;else currentFilter=widget.appliedFilter.FILTER_ROW;var requiredFields=widget.fields.filter(function(field){return isRequiredFieldInFilter(field)||isRequiredFieldWithoutFilterProperties(field)});if(requiredFields.length&&Array.isArray(currentFilter)){isFiltered=false}return isFiltered};function isRequiredFieldInFilter(field){return field.filterProperties&&field.filterProperties.validations&&field.filterProperties.validations.required}function isRequiredFieldWithoutFilterProperties(field){return field.isVisible&&field.validations&&field.validations.required&&!field.filterProperties}this.newRow=function(widget){if(this.isWidgetFiltered(widget)){widget.newRow()}else{MessageService.showMessageByCode("lib#GEN_NOT_FILTER",null,{type:"ERROR"})}};this.saveWithParent=function(widget,parents){if(Array.isArray(parents)){parents.forEach(function(parent){widget.currentRow[parent]=widget.parent.currentRow[parent]});return this.widgetSave(widget)}else throw"'Parents' property should be an array, "+typeof parents+" given."};this.justDigits=function(selector,retryCount){if(!retryCount||retryCount>5)retryCount=5;if(!selector){throw{message:"Selector is not defined!"}}setTimeout(function(){var elem=$(selector);if(elem[0]){var length=selector.split(",").length;for(var i=0;i<length;i++){if(elem.hasOwnProperty(i)){elem[i].onkeypress=avoidNonDigits;elem[i].onpaste=preventEvent}}}else{if(!retryCount){console.error("Selector not found!")}else{retryCount--;this.justDigits(selector,retryCount)}}}.bind(this),500)};function avoidNonDigits(e){var digits=[44,45,46,48,49,50,51,52,53,54,55,56,57];var digitCode=e.which;if(digits.indexOf(digitCode)<0){preventEvent(e)}}this.callMaskCurrency=function(field,decimal,thousands,precision){precision=precision||2;var value=field.value();var params={decimal:decimal,thousands:thousands,precision:precision};field.value(this.maskCurrency(value,params))};var maskFunction=function(element,viewValue,params,callBack){};this.maskCurrency=function(value,params){var thousands=Util.isEmptyOrBlank(params.thousands)?params.thousand:params.thousands;if(!Util.isEmptyOrBlank(value)){if(value[0]==="."||value[0]===",")value="0"+value;if(params.decimal===",")value=numberFormatBr(value);var newValue="";value=value.split(".").join("");var dec=value.split(",")[1];var mil=[];var int=value.split(",")[0];if(dec===undefined){dec="";dec=dec.padEnd(params.precision,"0");int=value}else if(dec.length<params.precision){dec=dec.padEnd(params.precision,"0")}else if(dec.length>params.precision){dec=parseFloat("1."+dec).toFixed(params.precision).toString().split(".")[1]}var counter=angular.copy(int.length/3);for(var i=1;i<=counter;i++){if(i!=counter)mil.push(thousands+int.substr(-3));else mil.push(int.substr(-3));int=int.substr(0,int.length-3)}if(int!="")mil.push(int);mil=mil.reverse().join("");newValue=mil+params.decimal+dec;var regex="^(^([0-9]{1,3}\\"+thousands+")((\\d{3}\\"+thousands+"{1})|(\\d{3}\\"+params.decimal+"\\d{2,}))*$)|^(\\d{0,3}\\"+params.decimal+"\\d{2,})*$";regex=new RegExp(regex,"g");if(regex.test(newValue))return newValue;else return 0}};maskEngine.registerMask("maskCurrency",maskFunction,this.maskCurrency);this.parseFloat=function(value){if(/^(.*)(\.+).*(,+)(.*)$/gm.test(value)){var loop=value.toString().split(".");for(var i=0;i<loop.length-1;i++){value=value.toString().replace(".","")}}if(/\,/g.test(value))value=value.toString().replace(",",".");return parseFloat(value)};var numberFormatBr=function(value){if(/^(.*)(\,+).*(\.+)(.*)$/gm.test(value)){var loop=value.toString().split(",");for(var i=0;i<loop.length-1;i++){value=value.toString().replace(",","")}}if(/^\d{1,}\.{1}\d*$/g.test(value))value=value.toString().replace(".",",");else if(/^(\d*)([\.]*)((\d|\.)*)$/.test(value)){value=value.split(".");value[value.length-1]=","+value[value.length-1];value=value.join("")}return value.toString()};this.lengthCurrency=function(args,field){var value;var fieldValue;if(field.inlineEditable&&(field.widget.mode==="list"||field.widget.mode==="inline_edit")){fieldValue=field.widget.currentRow[field.name+"_inline"];value=Util.isEmptyOrBlank(fieldValue)?"":fieldValue.toString()}else{fieldValue=field.value();value=Util.isEmptyOrBlank(fieldValue)?"":fieldValue.toString()}var realLength=value.split("-").join("").split(".").join("").split(",")[0].length;if(realLength>=field.maxLengthCurrency&&!/^(\d+)(\,){1}(\d*)$/gm.test(value)){var allowedKeys=[8,37,38,39,40,46,110,188,190,194];if(!allowedKeys.includes(args.e.keyCode))args.e.preventDefault()}};var treatResponse=function(response,Authenticator){var url=response.responseURL;var responseURL=null;var responseData=response.response;if(url.indexOf("index.php/")>-1){responseURL=url.slice(url.indexOf("index.php/")+9)}if(responseURL){var responseObj=JSON.parse(responseData);var errorCode=responseObj.error;if(Authenticator){Authenticator.run(responseURL,responseObj,errorCode)}else if(errorCode&&errorCode.indexOf("AUTH_")>-1){var cleanError=parent.getCleanError(errorCode);MessageService.showMessageByCode(cleanError)}}};this.getCleanError=function(msg){return msg.match(/AUTH_[^\s]+/g)[0]};this.initRoutesListener=function(Authenticator){(function(open){XMLHttpRequest.prototype.open=function(method,url,async,user,pass){this.addEventListener("readystatechange",function(){try{treatResponse(this,Authenticator)}catch(e){return false}},false);open.call(this,method,url,async,user,pass)}})(XMLHttpRequest.prototype.open)};this.isValidFiliaisValuesCP=function(values){var arrFilialValida=getLocalVar("CPFILIALVALIDA");if(arrFilialValida&&cacheLoaded){var arrValues=[];Array.isArray(values)?arrValues=values:arrValues.push(values);var isInvalid=arrValues.some(function(value){return!arrFilialValida.includes(value)}.bind(this));return!isInvalid}else{this.callRestEngine("lib#/lib_getValidOrganizationAndBranches","FilterData",[]).then(function(result){cacheLoaded=true;if(result.dataset){var arrayToPush=[];result.dataset.validBranches.forEach(function(row){arrayToPush.push(row.FILIAL)}.bind(this));setLocalVar("CPFILIALVALIDA",arrayToPush);this.isValidFiliaisValuesCP(values)}}.bind(this)).catch(function(error){if(error.data&&error.data.error){ScreenService.showMessage(error.data.error)}else{console.log(error)}})}};this.validateFieldFiliaisCP=function(field){var arrFilialValida=getLocalVar("CPFILIALVALIDA");var filialValues;if(arrFilialValida&&cacheLoaded){if(field.name=="CDFILIAL")filialValues=field.value();else{if(field.outData.CDFILIAL){filialValues=field.widget.currentRow[field.outData.CDFILIAL]}else{return console.log("Não existe o campo CDFILIAL neste FIELD, usar a função validateFieldFiliaisCP(field)")}if(filialValues&&filialValues.length>0){var arrValues=[];Array.isArray(filialValues)?arrValues=filialValues:arrValues.push(filialValues);var filtered=arrValues.filter(function(filial){return arrFilialValida.includes(filial)}.bind(this));var invalids=arrValues.filter(function(filial){return!arrFilialValida.includes(filial)}.bind(this));if(filtered.length==0||!this.isValidFiliaisValuesCP(arrValues)){MessageService.showMessageByCode("lib#CP_BRANCH_NOT_ALLOWED",null,{type:"ERROR"});var payload={CDFILIAL:invalids};this.callRestEngine("lib#/lib_saveOrgFilial","DataSet",[payload])}}}}else{this.callRestEngine("lib#/lib_getValidOrganizationAndBranches","FilterData",[]).then(function(result){cacheLoaded=true;if(result.dataset){var arrayToPush=[];result.dataset.validBranches.forEach(function(row){arrayToPush.push(row.FILIAL)}.bind(this));setLocalVar("CPFILIALVALIDA",arrayToPush);this.validateFieldFiliaisCP(field)}}.bind(this)).catch(function(error){if(error.data&&error.data.error){ScreenService.showMessage(error.data.error)}else{console.log(error)}})}};this.setCurrentRowWithOutData=function(currentRow,valuesToSetOnCurrentRow,outDataValue){for(var key in outDataValue){if(Array.isArray(outDataValue[key])){var newArray=[];outDataValue[key].forEach(function(value){newArray[value]=value}.bind(this));this.setCurrentRowWithOutData(currentRow,valuesToSetOnCurrentRow,newArray)}else currentRow[outDataValue[key]]=valuesToSetOnCurrentRow[key]}}};Configuration(function(ContextRegister){ContextRegister.register("General",General)});function LogDecorator(ZhuLogHelper){var getContentWidget=function(gridWidget){return gridWidget.widgets[0].widgets[0]};const ROUTE_FIELD_NAME="ROUTE";const ROUTE_LABEL_FIELD_NAME="ROUTE_LABEL";const TIME_FIELD_NAME="TIMESTAMP";const USER_ID_FIELD_NAME="USER_ID";const USER_NAME_FIELD_NAME="USER_NAME";const PRODUCT_ID_FIELD_NAME="PRODUCT_ID";const CONTENT_FIELD_NAME="CONTENT";const HTTP_RESPONSE_CODE_FIELD_NAME="HTTP_RESPONSE_CODE";const REQUEST_TYPE_FIELD_NAME="REQUEST_TYPE";const REQUEST_ID_FIELD_NAME="REQ_ID";const TYPE_FIELD_NAME="TYPE";const CONTAINER_FIELD_NAME_NAME="CONTAINER_NAME";const WIDGET_NAME_FIELD_NAME="WIDGET_NAME";const ORGANIZATION_ID_FIELD_NAME="ORGANIZATION_ID";const USER_NAME_FIELD_LABEL="User Name";const ROUTE_LABEL_FIELD_LABEL="Action";const TEXT_EDIT_TEMPLATE="field/text-edit.html";const SELECT_NATIVE_TEMPLATE="field/select-native.html";const SELECT_MULTIPLE_TEMPLATE="field/select-multiple.html";const DATE_INTERVAL_TEMPLATE="zh-interval-component#field/interval.html";const DATETIME_TEMPLATE="field/datetime.html";var filterFieldsInAdvancedFieldGroup=[REQUEST_ID_FIELD_NAME,TYPE_FIELD_NAME,HTTP_RESPONSE_CODE_FIELD_NAME,CONTENT_FIELD_NAME];var fieldsNotUpdateTemplate=[ROUTE_LABEL_FIELD_NAME];var updateWidgetFields=function(widget){var routeField=ZhuLogHelper.getField(widget,ROUTE_FIELD_NAME);var userNameField=Util.clone(routeField);var routeLabelField=Util.clone(routeField);userNameField.name=USER_NAME_FIELD_NAME;userNameField.label=USER_NAME_FIELD_LABEL;routeLabelField.name=ROUTE_LABEL_FIELD_NAME;routeLabelField.label=ROUTE_LABEL_FIELD_LABEL;ZhuLogHelper.moveField(widget,USER_ID_FIELD_NAME,1);ZhuLogHelper.addField(widget,userNameField,2);ZhuLogHelper.moveField(widget,TIME_FIELD_NAME,3);ZhuLogHelper.moveField(widget,CONTAINER_FIELD_NAME_NAME,4);ZhuLogHelper.moveField(widget,WIDGET_NAME_FIELD_NAME,5);ZhuLogHelper.moveField(widget,ROUTE_FIELD_NAME,6);ZhuLogHelper.addField(widget,routeLabelField,7);ZhuLogHelper.editField(widget,ROUTE_LABEL_FIELD_NAME,{valueField:ROUTE_FIELD_NAME,descriptionField:ROUTE_LABEL_FIELD_NAME,template:SELECT_NATIVE_TEMPLATE,dataSource:{data:window.routesTranslate||[]},filterProperties:{template:SELECT_MULTIPLE_TEMPLATE,operator:"IN"},showOnList:true,maxWidth:"12%",class:3});ZhuLogHelper.editField(widget,USER_ID_FIELD_NAME,{showOnList:true,maxWidth:"10%",class:4});ZhuLogHelper.editField(widget,USER_NAME_FIELD_NAME,{showOnList:true,maxWidth:"15%",class:4});ZhuLogHelper.editField(widget,CONTAINER_FIELD_NAME_NAME,{showOnList:true,maxWidth:"15%",class:3});ZhuLogHelper.editField(widget,WIDGET_NAME_FIELD_NAME,{showOnList:true,maxWidth:"15%",class:3});ZhuLogHelper.editField(widget,TIME_FIELD_NAME,{showOnList:true,maxWidth:"10%",class:4});ZhuLogHelper.editField(widget,ROUTE_FIELD_NAME,{showOnList:true,maxWidth:"15%",class:3});ZhuLogHelper.editField(widget,TYPE_FIELD_NAME,{showOnList:true,maxWidth:"8%",class:3});ZhuLogHelper.removeField(widget,PRODUCT_ID_FIELD_NAME);ZhuLogHelper.removeField(widget,ORGANIZATION_ID_FIELD_NAME)};var updateWidgetFieldsGridOnly=function(gridWidget){gridWidget.fields.forEach(function(field){if(field.name&&!(filterFieldsInAdvancedFieldGroup.indexOf(field.name)!=-1)){field.fieldGroup=null}if(field.filterProperties){if(fieldsNotUpdateTemplate.indexOf(field.name)==-1){field.template=field.filterProperties.template}if(field.filterProperties.template==TEXT_EDIT_TEMPLATE){field.filterProperties.operator="LIKE"}}});ZhuLogHelper.editField(gridWidget,TIME_FIELD_NAME,{template:DATETIME_TEMPLATE,dateFormat:"DD/MM/YYYY",timeFormat:"HH:mm:ss",displayFormat:"DD/MM/YYYY HH:mm:ss","datetime-dateFormat":"dd/mm/yy","datetime-timeFormat":"HH:ii:ss",filterProperties:{isVisible:true,showOnForm:true,label:"Date",template:DATE_INTERVAL_TEMPLATE,dateFormat:"DD/MM/YYYY",displayFormat:"DD/MM/YYYY",intervals:[{label:"Última semana",period:"last-week"},{label:"Último mês",period:"last-month"}]}});ZhuLogHelper.editField(gridWidget,TYPE_FIELD_NAME,{class:4});ZhuLogHelper.editField(gridWidget,HTTP_RESPONSE_CODE_FIELD_NAME,{class:4,isVisible:false,filterProperties:{isVisible:true,operator:"LIKE"}});ZhuLogHelper.editField(gridWidget,REQUEST_ID_FIELD_NAME,{class:4,isVisible:false,filterProperties:{isVisible:true,operator:"LIKE"}});ZhuLogHelper.editField(gridWidget,CONTENT_FIELD_NAME,{isVisible:false,fieldGroup:"advancedFilter",template:TEXT_EDIT_TEMPLATE,filterProperties:{isVisible:true,operator:"LIKE",class:12}})};var updateWidgetFieldsFormOnly=function(formWidget){ZhuLogHelper.editField(formWidget,HTTP_RESPONSE_CODE_FIELD_NAME,{class:2});ZhuLogHelper.editField(formWidget,REQUEST_TYPE_FIELD_NAME,{class:3})};this.decorateWidget=function(gridWidget){updateWidgetFields(gridWidget);updateWidgetFieldsGridOnly(gridWidget);var formWidget=getContentWidget(gridWidget);updateWidgetFields(formWidget);updateWidgetFieldsFormOnly(formWidget);gridWidget.currentRowDefaultFilter={TIMESTAMP:{start:moment().add(-1,"days").format("DD/MM/YYYY"),end:moment().format("DD/MM/YYYY"),period:undefined}}};this.normalizeRows=function(rows){return rows};this.normalizeFilters=function(filters){}}Configuration(function(ContextRegister){ContextRegister.register("LogDecorator",LogDecorator)});var MenuBuilder=function(restEngine,MessageService,templateManager,metaDataFactory,eventAggregator,$window,requestDataSourceEngine,ApplicationContext,ScreenService){var localProductMenu;var attrToReplace=["label","showMenu","showHeader","showDescriptionOrder","onRequestIdleTimeout","mainWindow","logLevel","aclEnable","showMenuSearch","userDataActions","reportServiceUrl","reportsPath","inDeveloperMode","showDevtoolsInSameWindow","shouldBackToMainWindowOnReload","shortcutKeys"];var requestProductMenu=function(){var modulesPackage=$window.modulesPackage||"modules";return restEngine.requestMetaData(modulesPackage+"#json/containers.json").then(function(response){var productObjMenu=response.data;var keys=Object.keys(productObjMenu);return productObjMenu[keys[0]]})};var removeEmptyMenuGroups=function(groupMenus){return groupMenus.filter(function(group){return group.menus&&group.menus.length!=0||group.name=="zhHistory"})};var orderMenus=function(menus){menus.map(function(menu){if(menu.menus){menu.menus=orderMenus(menu.menus)}return menu});return sortMenus(menus)};var sortMenus=function(menus){return menus.sort(function(menuA,menuB){if(menuA.order&&menuB.order){if(menuA.order<menuB.order){return-1}if(menuA.order>menuB.order){return 1}}if(!menuA.order&&menuB.order){return-1}if(menuA.order&&menuB.order){return 1}return 0})};var prepareMenus=function(response){var groupMenus=response.dataset.menu;window.routesTranslate=response.dataset.routesTranslate;var zhuLogWidget=templateManager.container?templateManager.container.getWidget("zhuLog"):false;if(zhuLogWidget){zhuLogWidget.getField("ROUTE_LABEL").dataSource.data=window.routesTranslate;$(window).trigger("resize.grid")}groupMenus=orderMenus(removeEmptyMenuGroups(groupMenus));var groupMenuHistory=[templateManager.project.getMenu("zhHistory")];templateManager.project.groupMenu=metaDataFactory.groupMenuFactory(groupMenus.concat(groupMenuHistory));var aux={};Object.keys(templateManager.aclRules).forEach(function(ruleKey){aux[ruleKey]=templateManager.aclRules[ruleKey]});templateManager.aclRules=aux;eventAggregator.publish("menuBuilded");if(!localStorage.getItem("IS_LOGGED")){MessageService.successNotificationByCode("lib#SUC_AUTHENTICATION");setTimeout(function(){if(!JSON.parse(localStorage.getItem("IS_SUPPORT_OPERATOR"))){var hasVisibleMenu=templateManager.project.groupMenu.find(function(menu){return menu.name!="zhHistory"&&(typeof menu.aclIsVisible===undefined||menu.aclIsVisible===true)});if(hasVisibleMenu){saveLoginData();localStorage.setItem("IS_LOGGED",true)}else{MessageService.showCustomDialogByCode("lib#EMPTY_ACCESS_RULE_LIB",null,{type:"INFORMATION",actions:[{label:ScreenService.i18n("Ok"),code:function(){ApplicationContext.LibLoginController.logout()}}]})}var notices=JSON.parse(localStorage.getItem("NOTICES"));if(notices&&notices.length){ApplicationContext.LibLoginController.openPopupNotices()}}else{localStorage.setItem("IS_LOGGED",true)}},1500)}};var replaceProductAttrOnMenu=function(productMenu){attrToReplace.forEach(function(attr){templateManager.project[attr]=productMenu[attr]})};var setLocalProductMenu=function(){if(!$window.modulesPackage){requestProductMenu().then(function(productMenu){localProductMenu=productMenu})}};var getCurrentModule=function(){var currentModule=window.location.hash.split("/").filter(function(_){return _.length}).pop();if(currentModule&&currentModule.length>0){currentModule=currentModule.split(/_|#/)[0]}return currentModule};if(!window.notUseMicroservice){eventAggregator.subscribe("loginSuccess",function(loginResponse){if(!JSON.parse(localStorage.getItem("IS_LOGGED"))){ApplicationContext.LibUtilities.menuFavoritos(true)}eventAggregator.publish("AboutOnClick");if(!$window.modulesPackage&&!$window.keepTitle){replaceProductAttrOnMenu(localProductMenu);templateManager.updateTitle(templateManager.project.label)}var filter=[{name:"CONCATENATE_GROUP_MENU",operator:"=",value:true},{name:"VISIBLE_ELEMENTS",operator:"=",value:loginResponse.VISIBLE_ELEMENTS||[]},{name:"EXPIRED_ELEMENTS",operator:"=",value:loginResponse.EXPIRED_ELEMENTS||[]},{name:"URL_ORIGIN",operator:"=",value:window.location.origin},{name:"CURRENT_MODULE",operator:"=",value:getCurrentModule()},{name:"CURRENT_LANGUAGE",operator:"=",value:window.lang}];requestDataSourceEngine.getDataSource("lib#/lib_buildMenu",filter).then(prepareMenus).catch(ApplicationContext.LibUtilities.showErrorMessage)});setLocalProductMenu()}var saveLoginData=function(){ApplicationContext.LibUtilities.saveCollectedData(localStorage.getItem("LOGIN_USER_ID"),"LOGIN");ApplicationContext.LibUtilities.saveCollectedData(localStorage.getItem("LOGIN_PHP_VERSION_ID"),"PHPVERSION");ApplicationContext.LibLoginService.setLogAccess();var licenseInfo=localStorage.getItem("LICENSE_INFO");if(licenseInfo){ApplicationContext.LibLoginService.saveProductsPermission(licenseInfo);ApplicationContext.LibLoginService.saveVariableMeasure(licenseInfo)}}};Configuration(function(ContextRegister){ContextRegister.register("MenuBuilder",MenuBuilder)});function LibMessages(){this.ALE_EXPIRED_SESSION="Sua sessão expirou.<br/>Você será redirecionado para efetuar login novamente.";this.ALE_MIGRATION_IS_PENDENT="ATENÇÃO!<br/><br/>Esse produto foi atualizado recentemente, com necessidade de alterações na estrutura do banco de dados, sem que essas alterações tenham sido aplicadas.<br/>A utilização do produto nessa situação poderá acarretar erros.<br/><br/>Solicite ao administrador do sistema a regularização da alteração na estrutura do bando de dados.","INFORMATION";this.ERR_ATTEMPT_END="Tentativas esgotadas. Redirecionando...";this.ERR_ATTEMPT_PARTIAL="Senha incorreta.<br/>Tentativa %1/3";this.ERR_EXPIRED_SESSION_LOGIN="Sessão expirada. Redirecionando..."}Configuration(function(ContextRegister){ContextRegister.register("LibMessages",LibMessages)});function ReportDecorator(eventAggregator,restEngine,templateManager,ZhLogger,ScreenService,eventEngine){this.onContainerOpen=function(){try{var container=templateManager.container;validContainer(container);if(container.customReportsConfig){var customReportsConfig=container.customReportsConfig;validCustomReportsConfig(customReportsConfig);var widget=selectWidget(container,customReportsConfig.widgetName);var containerName=container.customReportsConfig?container.customReportsConfig.reportCodeName:container.name;var fieldToChangeData=selectField(widget,customReportsConfig.fieldName);if(customReportsConfig.reportIsTheMainFunction===undefined||customReportsConfig.reportIsTheMainFunction===true){buildData(containerName,fieldToChangeData)}else{const separator="', '";const eventCode="ReportDecorator.triggerBuildData('"+containerName+separator+customReportsConfig.widgetName+separator+customReportsConfig.fieldName+"')";addEvent({entity:widget,event:{name:"WidgetOnEnterOnce",code:eventCode,bind:true}})}widget.beforeOpenReport=beforeOpenReport}}catch(e){ZhLogger.warning(e)}};eventAggregator.subscribe("onContainerOpen",this.onContainerOpen);this.triggerBuildData=function(containerName,widgetName,fieldName){const container=templateManager.container;validContainer(container);const widget=selectWidget(container,widgetName);const fieldToChangeData=selectField(widget,fieldName);try{buildData(containerName,fieldToChangeData)}catch(e){ZhLogger.warning(e)}};function buildData(containerName,fieldToChangeData){const route=getServiceUrlBasedOnTriggerPackage()+"#/lib_getDataReportField";restEngine.post(route,{requestType:"Row",row:[containerName.substr(0,6)]}).then(function(callback){try{var data=callback.dataset.dataReport;handleErrors(data);const formattedData=getFormattedData(fieldToChangeData,data);formattedData.forEach(function(row){row.description=ScreenService.i18n(row.description)});setDataSource(fieldToChangeData,formattedData);applyDefaultValue(fieldToChangeData);setTimeout(function(){clickOnSelectedOption(fieldToChangeData.name)},500);addEvent({entity:fieldToChangeData.getParent(),event:{name:"WidgetOnEnter",code:"ReportDecorator.onEnterReportWidget('"+fieldToChangeData.name+"')",bind:true}})}catch(e){ZhLogger.warning(e)}}.bind(this),function(error){if(error.data&&error.data.error){throw error.data.error}else{throw ScreenService.i18n("Ocorreu um erro ao buscar a lista de relátorios da tela.")}})}function getServiceUrlBasedOnTriggerPackage(){const fileName=templateManager.container.fileName;const aliasSplited=fileName.split("#").shift().split("_");if(aliasSplited.length){const packageName=aliasSplited.shift();if(packageName)return packageName}return"lib"}function getFormattedData(fieldToChangeData,data){return data.filter(function(reportElement){return!Array.isArray(reportElement)}).map(function(reportElement){if(Array.isArray(reportElement))return;const newElement={};newElement[fieldToChangeData.valueField]=reportElement.value;newElement[fieldToChangeData.descriptionField]=reportElement.description;newElement[fieldToChangeData.strategyField]=reportElement.strategy;return newElement})}function handleErrors(data){const errorIndex=data.findIndex(function(reportElement){return Array.isArray(reportElement)});if(errorIndex===-1)return;if(data.length===1){const message=ScreenService.i18n("Ocorreu um erro ao buscar a lista de relatórios da tela.");ScreenService.errorNotification(message);throw message+ScreenService.i18n("Consulte a requisição correspondente para mais detalhes.")}else{const isQr2Parametrized=data[errorIndex].findIndex(function(error){return error===ScreenService.i18n("Servidor de relatórios QR2 não está parametrizado.")})===-1;const isBirtParametrized=data[errorIndex].findIndex(function(error){return error===ScreenService.i18n("Servidor de relatórios BIRT não está parametrizado.")})===-1;if(isQr2Parametrized||isBirtParametrized){ScreenService.errorNotification(ScreenService.i18n("Alguns relatórios podem não estar disponíveis."))}ZhLogger.warning(ScreenService.i18n("Alguns relatórios podem não estar disponíveis. Consulte a requisição correspondente para mais detalhes."))}}function setDataSource(fieldToChangeData,data){if(!fieldToChangeData.dataSource.data||fieldToChangeData.dataSource.data.length==0){fieldToChangeData.dataSource.data=data}else{const valueField=fieldToChangeData.valueField;const descriptionField=fieldToChangeData.descriptionField;const strategyField=fieldToChangeData.strategyField;const removingDuplicatedReports=function(report,index,reports){return index===reports.findIndex(function(r){return r[valueField]===report[valueField]&&r[descriptionField]===report[descriptionField]&&r[strategyField]===report[strategyField]})};const newData=fieldToChangeData.dataSource.data.concat(data);fieldToChangeData.dataSource.data=newData.filter(removingDuplicatedReports)}}function applyDefaultValue(fieldToChangeData){if(!fieldToChangeData.defaultValue||fieldToChangeData.defaultValue==="firstRow"){const firstRow=fieldToChangeData.dataSource.getFirstRow();fieldToChangeData.defaultValue=firstRow[fieldToChangeData.valueField]}fieldToChangeData.applyDefaultValue()}function clickOnSelectedOption(fieldName){const baseSelector="#"+fieldName+" + div";const baseElement=document.querySelector(baseSelector);if(!baseElement){return setTimeout(function recursiveCallClickOnSelectedOption(){clickOnSelectedOption(fieldName)},500)}document.querySelector(baseSelector).click();const selectedElementSelector=baseSelector+' li[class*="selected"]';document.querySelector(selectedElementSelector).click()}function selectWidget(container,widgetName){var widget=container.getWidget(widgetName);if(widget){return widget}else{throw ScreenService.i18n("A widget informada não existe dentro desse container.")}}function selectField(widget,fieldName){var field=widget.getField(fieldName);if(field){if(field.dataSource){return field}else{throw ScreenService.i18n("O field informado não contém a propriedade dataSource.")}}else{throw ScreenService.i18n("O field informado não existe na widget informada.")}}function validContainer(container){if(!container){throw ScreenService.i18n("Container não existe.")}}function validCustomReportsConfig(config){if(!config.widgetName){throw ScreenService.i18n("A propriedade widgetName não existe dentro de customReportsConfig.")}if(!config.fieldName){throw ScreenService.i18n("A propriedade fieldName não existe dentro de customReportsConfig.")}}function eventExistsByCode(events,searchedCode){return events.filter(function(event){return event.code.indexOf(searchedCode)!=-1}).length>0}function eventExistsByName(events,searchedName){return events.findIndex(function(event){return event.name===searchedName})!==-1}function addCodeOnEvent(events,eventName,eventCode,placeOn){if(!placeOn)placeOn="right";const eventIndex=events.findIndex(function(event){return event.name===eventName});const event=events[eventIndex];const endSemicolonIndex=event.code.lastIndexOf(";");const codeHasEndSemicolon=endSemicolonIndex!==-1&&endSemicolonIndex===event.code.length-1;if(!codeHasEndSemicolon){event.code+=";"}if(placeOn==="right"){events[eventIndex].code+=eventCode}else{const newCode=eventCode+";"+events[eventIndex].code;events[eventIndex].code=newCode}}function addEvent(params){const entity=params.entity;const event=params.event;const name=event.name;const code=event.code;const events=entity.events;if(eventExistsByName(events,name)){if(!eventExistsByCode(events,code)){addCodeOnEvent(events,name,code,event.placeOn)}}else{events.push({name:name,code:code});if(event.bind){eventEngine.bindEvent(entity,name,code)}}}function getSelectedOption(fieldName){const selector="#"+fieldName+' + div li[class*="selected"]';return document.querySelector(selector)}function getCurrent(fieldName){const selector="#"+fieldName+" + div > span";return document.querySelector(selector).textContent}this.onEnterReportWidget=function(fieldName){const field=templateManager.container.getActiveWidget().getField(fieldName);if(!field.value()){applyDefaultValue(field)}if(!getSelectedOption(fieldName)){setTimeout(function runClickOnSelectedOption(){const selectedOption=getSelectedOption(fieldName);if(!selectedOption){return setTimeout(runClickOnSelectedOption,500)}const current=getCurrent(fieldName);if(!current){return clickOnSelectedOption(fieldName)}},500)}};function beforeOpenReport(params){const reportParams=params.reportParams;const reportNameSplitted=reportParams.__report_name.split(".");const reportName=reportNameSplitted[0];const strategy=reportNameSplitted[1];reportParams.__report_name=reportName;reportParams.STRATEGY=strategy}}Configuration(function(ContextRegister){ContextRegister.register("ReportDecorator",ReportDecorator)});function ShortcutDecorator(ApplicationContext,templateManager){const defaultCRUDShortcutKeys={add:"mod+a",edit:"mod+e",delete:"mod+d"};function getTooltipModKey(){var platform=window.navigator.platform,commandPlatforms=["Macintosh","MacIntel","MacPPC","Mac68K"],ctrlPlatforms=["Win32","Win64","Windows","WinCE"],mod=false;if(commandPlatforms.indexOf(platform)!==-1){mod="Command + "}else if(ctrlPlatforms.indexOf(platform)!==-1||/Linux/.test(platform)){mod="Ctrl + "}return mod}function getShortcutKey(widget,shortcut){return Util.getNestedProperty(widget,["shortcutKeys",shortcut])||Util.getNestedProperty(templateManager,["project","shortcutKeys",shortcut])||defaultCRUDShortcutKeys[shortcut]}function applyShortcutOnAction(widgets){var modTooltip=getTooltipModKey();widgets.forEach(function(widget){if(widget.actions){widget.actions.forEach(function(action){if(action.icon==="plus"&&!action.skipShortcut&&!action.shortcutKey){action.shortcutKey=getShortcutKey(widget,"add")}else if(action.icon==="pencil"&&!action.skipShortcut&&!action.shortcutKey){action.shortcutKey=getShortcutKey(widget,"edit")}else if(action.icon==="trash"&&!action.skipShortcut&&!action.shortcutKey){action.shortcutKey=getShortcutKey(widget,"delete")}else if(!action.skipShortcut&&!action.shortcutKey){action.shortcutKey=getShortcutKey(widget,action.icon)}if(modTooltip&&action.shortcutKey&&!action.tooltip&&templateManager.project.showShortcutKeyAsTooltip!==false){action.tooltip=action.shortcutKey.toUpperCase().replace("MOD+",modTooltip)}})}if(widget.widgets&&widget.widgets.length){applyShortcutOnAction(widget.widgets)}})}this.apply=function(containerName,container){if(templateManager.project.enableCRUDShortcutKeys==true){applyShortcutOnAction(container.widgets)}return container}}Configuration(function(ContainerDecoratorProvider,ContextRegister,ApplicationContext,templateManager){ContextRegister.register("ShortcutDecorator",ShortcutDecorator);ContainerDecoratorProvider.registerProvider(new ShortcutDecorator(ApplicationContext,templateManager))});function LibUtilities(ScreenService,eventAggregator,templateManager,requestDataSourceEngine,restEngine,MessageService,ZhuAclConfig,General,ZHPromise){var self=this;this.authenticationContainer="login#authentication";this.expiredSessionMethod=null;var STYLESHEET_TYPE="stylesheet";var addLinkTagInHead=function(href,type){var lnk=document.createElement("link");lnk.setAttribute("rel",type);if(type==STYLESHEET_TYPE){lnk.setAttribute("type","text/css")}lnk.setAttribute("href",href);document.getElementsByTagName("head").item(0).appendChild(lnk)};var href="bower_components/tek-libraries/css/favorites.min.css";addLinkTagInHead(href,STYLESHEET_TYPE);this.showErrorMessage=function(response){return MessageService.getMessageByCode("lib#UNEXPECTED_ERROR").then(function(defaultMessage){if(response&&response.data&&response.data.error){var error=response.data.error;if(self.isJson(error)){error=JSON.parse(error);var params=error.PARAMS||null;var messageCode=error.CODE||"UNEXPECTED_ERROR";return MessageService.getMessageByCode("lib#"+messageCode).then(function(message){return ScreenService.showMessage(message,"ERROR",null,params)}).catch(function(){return ScreenService.showMessage(messageCode,"ERROR",null,params)})}else{var message=Util.isEmptyOrBlank(error)?defaultMessage:error.split("Exception:").pop();if(!message.includes("ALE_SESSION_WILL_BE_ENDED")){return ScreenService.showMessage(message,"ERROR")}}}else{return ScreenService.showMessage(defaultMessage,"ERROR")}})};this.redirectToLogin=function(){if(window.openLoginContainerWithoutRedirect){ScreenService.openWindow(self.authenticationContainer)}else{self.openWindow(self.authenticationContainer)}};eventAggregator.subscribe("EventOnRequestStart",function(eventData){var validateExpiredSessionRoute="lib_validateExpiredSession";var logoutRoute="lib_logout";var loginRoute="login";var validateUserRoute="validateUser";var requestConfig=eventData.requestConfig;if(requestConfig&&requestConfig.url&&shouldAddRequestInfo(requestConfig.url)&&templateManager.container){requestConfig.data.origin=requestConfig.data.origin||{};var widget;var container=templateManager.loadingContainerJson;if(container){widget=getFirstWidgetWithDataSourceRest(container.widgets);if(!widget){widget=container.widgets[0]}}else{container=templateManager.container;widget=container.getActiveWidget()}requestConfig.data.origin.containerLabel=container.label||container.name;requestConfig.data.origin.widgetLabel=widget.label||widget.name}var route=requestConfig.url.split("/").pop();if(route!=validateExpiredSessionRoute){factoryExpiredSessionMethods()}if(route!=logoutRoute&&route!=loginRoute){var token=localStorage.getItem("LOGIN_TOKEN");var hash=localStorage.getItem("LOGIN_HASH");var keepConnected=localStorage.getItem("LOGIN_KEEP_CONNECTED");if(window.externalTokens){window.externalTokens.some(function(externalToken){if(eventData.requestConfig.url.includes(externalToken.url)){token=externalToken.token;keepConnected=externalToken.keepConnected||keepConnected;return true}return false})}if(token){requestConfig.headers["OAuth-Token"]=token}if(hash){requestConfig.headers["OAuth-Hash"]=hash;requestConfig.headers["OAuth-Project"]=window.tekLoginProjectId}if(route==validateUserRoute){keepConnected="Yes"}requestConfig.headers["OAuth-KeepConnected"]=keepConnected}});var shouldAddRequestInfo=function(url){return!url.match(/.json/i)&&!url.match(/.html/i)&&!url.match(/.svg/i)};var getFirstWidgetWithDataSourceRest=function(widgets){for(var i=0;i<widgets.length;i++){if(widgets[i].dataSource&&widgets[i].dataSource.rest==true){return widgets[i]}else{return getFirstWidgetWithDataSourceRest(widgets[i])}}};var factoryExpiredSessionMethods=function(){if(templateManager.project&&templateManager.project.onRequestIdleTimeout){if(self.expiredSessionMethod){clearTimeout(self.expiredSessionMethod)}self.expiredSessionMethod=Util.doAsync(validateExpiredSession,templateManager.project.onRequestIdleTimeout)}};var validateExpiredSession=function(){var timeout=templateManager.project.onRequestIdleTimeout;var filter=[{name:"TIMEOUT",value:timeout,operator:"="}];requestDataSourceEngine.getDataSource("lib#/lib_validateExpiredSession",filter).then(function(response){if(response&&response.dataset&&response.dataset.expiredSessionInfo){var expiredSessionInfo=response.dataset.expiredSessionInfo;if(expiredSessionInfo.IS_EXPIRED){eventAggregator.publish("LibExpiredSession")}else{if(self.expiredSessionMethod){clearTimeout(self.expiredSessionMethod)}Util.doAsync(validateExpiredSession,expiredSessionInfo.TIMEOUT)}}else{self.showErrorMessage(response)}}).catch(self.showErrorMessage)};this.changeLoginResponseToOldParams=function(loginResponse){if(loginResponse){return{cdoperador:loginResponse.USER_ID,nmoperador:loginResponse.USER_NAME,dsemailoper:loginResponse.EMAIL,nrorg:loginResponse.ORGANIZATION_ID,nmorg:loginResponse.TRADING_NAME,nmrazsocialorg:loginResponse.COMPANY_NAME,perfilDeAcesso:loginResponse.ACCESS_PROFILE,cdempresa:loginResponse.CDEMPRESA||null,cdfilialselecionada:loginResponse.CDFILIAL||null,cdpictprat:loginResponse.CDPICTPRAT||null,cdpictprod:loginResponse.CDPICTPROD||null,ididioma:loginResponse.IDIDIOMA||null,nmacesso:loginResponse.NMACESSO||null,nmcomploper:loginResponse.NMCOMPLOPER||null,nmfilialselecionada:loginResponse.NMFILIAL||null,nrestruttrab:loginResponse.NRESTRUTTRAB||null,nrorgtrab:loginResponse.NRORGTRAB||null,nrparcnegocio:loginResponse.NRPARCNEGOCIO||null,logged:loginResponse.LOGGED,senhaExpirada:loginResponse.EXPIRED_PASSWORD,version:loginResponse.VERSION}}};var getCurrentModule=function(){var currentModule=window.location.hash.split("/").filter(function(_){return _.length}).pop();if(currentModule&&currentModule.length>0){currentModule=currentModule.split(/_|#/)[0]}return currentModule};this.openMicroServiceUrl=function(args){var containerName=args.owner.msContainerName;var currentModule,module;if(containerName.indexOf("#")==-1){currentModule=module=""}else{var subModule=containerName.split("#")[0];module=subModule.split("_")[0];currentModule=getCurrentModule()}if(module&&currentModule&&module!=currentModule){var filter=[{name:"USER",value:localStorage.getItem("LOGIN_USER"),operator:"="},{name:"IS_LOGGED",value:localStorage.getItem("IS_LOGGED")||false,operator:"="},{name:"KEEP_CONNECTED",value:localStorage.getItem("LOGIN_KEEP_CONNECTED")||"No",operator:"="},{name:"LOGIN_LANGUAGE",value:localStorage.getItem("LOGIN_LANGUAGE")||window.lang,operator:"="},{name:"LOGIN_SEPARATOR",value:localStorage.getItem("LOGIN_SEPARATOR"),operator:"="}];ScreenService.showLoader();requestDataSourceEngine.getDataSource(module+"#/lib_startSession",filter).then(function(){ScreenService.hideLoader();ScreenService.openLink(args.owner.url)}).catch(function(error){ScreenService.hideLoader();self.showErrorMessage(error)})}};this.openLinkByMenu=function(menu){if(typeof menu==="string"){menu=templateManager.project.getMenu(menu)}var args={owner:{msContainerName:menu.msContainerName,url:menu.url}};self.openMicroServiceUrl(args)};this.openWindow=function(windowName,newWindow){return requestModulesMetadata().then(function(modules){var subModule=windowName.split("#")[0];var module=subModule.split("_")[0];var url=window.location.origin+"/"+modules[module].baseUrl+"/#/"+windowName;if(ScreenService.openLink){ScreenService.openLink(url,newWindow)}else{ScreenService.openWindow(windowName)}})};var requestModulesMetadata=function(){var modulesPackage=window.modulesPackage||"modules";return restEngine.requestMetaData(modulesPackage+"#json/modules.json").then(function(response){return response.data})};eventAggregator.subscribe("AboutOnClick",function(){if(!templateManager.versionData){templateManager.versionData=true;var filter=[{name:"CURRENT_MODULE",operator:"=",value:getCurrentModule()}];ScreenService.showLoader();requestDataSourceEngine.getDataSource("lib#/lib_getVersionInfo",filter).then(function(response){ScreenService.hideLoader();templateManager.versionData=response.dataset.versionInfo;templateManager.versionData.dependencies.current=templateManager.versionData.dependencies.frontend;templateManager.versionData.dependencies.changeCurrentVersion=function(newVersion){templateManager.versionData.dependencies.current=templateManager.versionData.dependencies[newVersion]};if(!!templateManager.versionData.dependencies){localStorage.setItem("versionData",JSON.stringify(templateManager.versionData))}else{localStorage.setItem("versionData",JSON.stringify(false))}}).catch(function(error){ScreenService.hideLoader();self.showErrorMessage(error)})}});eventAggregator.subscribe("onContainerOpen",function(args){var versionData=JSON.parse(localStorage.getItem("versionData"));if(!args.container.isNext&&versionData&&versionData.dependencies&&templateManager.versionData&&templateManager.versionData.dependencies){templateManager.versionData.name=versionData.name;templateManager.versionData.version=versionData.version;templateManager.versionData.dependencies.backend=versionData.dependencies.backend;templateManager.versionData.dependencies.frontend=versionData.dependencies.frontend;templateManager.versionData.dependencies.modules=versionData.dependencies.modules;templateManager.versionData.dependencies.changeCurrentVersion("frontend");templateManager.updateTemplate()}self.menuFavoritos(false)});this.menuFavoritos=function(forceExec){setTimeout(function(){var groupId=localStorage.getItem("ACCESS_PROFILE");var projectId=window.projectId;var favoritesData=localStorage.getItem("LIB_FAVORITES_DATA");if(favoritesData!==null){eventAggregator.publish("ZhFavoritesOnLoad",favoritesData)}else if(projectId&&groupId&&(localStorage.getItem("IS_LOGGED")||forceExec)){var zhuAclFilter=ZhuAclConfig.getDefaultDataSourceFilter([groupId],projectId);requestDataSourceEngine.getDataSource("zhuacl#/acl_zhu_acl_rules",zhuAclFilter,1,undefined,undefined,undefined,12e4,12e4,undefined,true).then(function(response){var dataset=response.dataset||{};if(dataset){requestDataSourceEngine.getDataSource("lib#/lib_findFavorites",[],1,undefined,undefined,undefined,12e4,12e4,undefined,true).then(function(result){var favorites=formatFavoritesData(result);if(favorites){verificaAcessoFavoritos(dataset,favorites).then(function(favorites){favorites=JSON.stringify(favorites);localStorage.setItem("LIB_FAVORITES_DATA",favorites);eventAggregator.publish("ZhFavoritesOnLoad",favorites)}.bind(this))}},function(){})}})}else if(localStorage.getItem("IS_LOGGED")||forceExec){requestDataSourceEngine.getDataSource("lib#/lib_findFavorites",[],1,undefined,undefined,undefined,12e4,12e4,undefined,true).then(function(result){var favorites=formatFavoritesData(result);if(favorites){favorites=JSON.stringify(favorites);localStorage.setItem("LIB_FAVORITES_DATA",favorites);eventAggregator.publish("ZhFavoritesOnLoad",favorites)}},function(){})}},2e3)};function formatFavoritesData(result){var favorites=result.dataset.favorites;return favorites[0].map(function(item){return{id:item.ID,name:item.NAME,label:ScreenService.i18n(item.LABEL)}})}function verificaAcessoFavoritos(dataset,favorites){var deferred=ZHPromise.defer();var pos=null;var menuFavoritesIds=favorites.map(function(a){return a.id});var defaultRule=dataset.zhu_access_control_default_rule.defaultRule;favorites.forEach(function(favorite){favorite.rule=defaultRule});dataset.zhu_access_control_rule_login.forEach(function(acl){if(menuFavoritesIds.includes(acl.UNIQUE_ID)){pos=menuFavoritesIds.indexOf(acl.UNIQUE_ID);favorites[pos].rule=acl.RULE}});favorites=favorites.filter(function(favorite){return favorite.rule=="A"||favorite.rule=="R"||localStorage.getItem("ACL_ADMINISTRATOR")});deferred.resolve(favorites);return deferred.promise}eventAggregator.subscribe("ZhFavoritesOnChange",function(args){localStorage.setItem("LIB_FAVORITES_DATA",JSON.stringify(args.fullList));args.changed.changed=true;requestDataSourceEngine.setDataSource("lib#/lib_changeFavorites",[args.changed],undefined,undefined,undefined,undefined,true)});eventAggregator.subscribe("EventOnRequestError",function(eventData){if(eventData.e&&eventData.e.e&&eventData.e.e.data&&eventData.e.e.data.data){var error=eventData.e.e.data.data;var config=eventData.e.e.data.config;if(error.errorCode==101||error.errorCode==100){eventAggregator.publish("LibInvalidToken",error.errorCode)}else if(error.errorCode==102){eventAggregator.publish("LibInvalidTokenSupportOperator")}else if(error.errorCode==20){eventAggregator.publish("LibConcurrentAccess")}else if(error.errorCode==21||error.errorCode==22){eventAggregator.publish("LibAccessBlocked")}}});this.isJson=function(str){var result=null;try{result=JSON.parse(str)}catch(e){}return result};this.saveCollectedData=function(collectionIds,operationId,productId,operatorCode,operatorName,organizationId){var row={COLLECTION_IDS:collectionIds,OPERATION_ID:operationId,PRODUCT_ID:productId||null,OPERATOR_CODE:operatorCode||null,OPERATOR_NAME:operatorName||null,ORGANIZATION_ID:organizationId||null,changed:true};return requestDataSourceEngine.setDataSource("lib#/lib_saveCollectedData",[row],undefined,undefined,undefined,undefined,true)};this.addTranslateButton=function(){templateManager.projectPromise.then(function(){if(!window.hideTranslateButton){var notification={label:ScreenService.i18n("Atualizar Tradução"),tooltip:ScreenService.i18n("Atualizar Tradução"),name:"libTranslate",icon:"information",isVisible:true,events:[{name:"NotificationEvent",code:"LibLoginController.updateTranslation();"}]};notification=Util.extend(new _Notification,notification);templateManager.project.notifications=templateManager.project.notifications||[];templateManager.project.notifications.push(notification)}})};this.addPHPErrorLogButton=function(){templateManager.projectPromise.then(function(){var action={label:ScreenService.i18n("Baixar log do PHP"),icon:"download",isVisible:true,events:[{name:"ActionEvent",code:"LibLoginController.getPHPErrorLogFiles();"}]};templateManager.project.userDataActions=templateManager.project.userDataActions||[];templateManager.project.userDataActions.push(action)})}}Configuration(function(ContextRegister){ContextRegister.register("LibUtilities",LibUtilities)});var ViewFloatMask=function(maskEngine){var keypressHandler=function(e,element,params){var opt=Util.extend(Util.clone($.currency.i18n[$.currency.lang]),params||{},true);var thousandsCode=opt.thousands.charCodeAt();var isThousands=thousandsCode===e.which;var is_number=e.which>=48&&e.which<=57;var is_dot=e.which==46;var is_comma=e.which==44;var is_minus=e.which==45;var hasSeparator=element.val().indexOf(opt.decimal)!=-1||element.val().indexOf(opt.thousands)!=-1;var hasNegative=element.val().length>0||!opt.allowNegative;if(hasSeparator&&(is_dot||is_comma)||hasNegative&&is_minus||isThousands)e.preventDefault();if(is_dot||is_comma||is_number||is_minus)element.data("maskOptions",opt);else e.preventDefault()};var keyupHandler=function(e,element,params){if(params.precision){var value=element[0].value;var decimals=value.substring(value.indexOf(params.decimal||",")+1,value.length);if(value!=decimals){if(decimals.length>params.precision){element[0].value=value.substring(0,value.indexOf(params.decimal||",")+(params.precision+1))}}}};var viewFloat=function(element,viewValue,params,callBack){var value=viewValue||"";element.val(value);params.callback=callBack;params.showRound=!("showRound"in params)?true:params.showRound;params.showSymbol=false;element.on("keypress",function(event){keypressHandler(event,element,params)});element.on("keyup",function(event){keyupHandler(event,element,params)});element.on("blur",function(){element.text(unMaskViewFloat(element.val(),params));element.val(viewFloatFormat(element.val(),params));params.callback(element.text())});if(!!params.showRound){element.on("focus",function(){var value=element.text();var viewValue=viewFloatFormat(element.val(),params);var currentValue=viewFloatFormat(element.text(),params);if(currentValue!==viewValue)value=element.val();element.val(viewFloatFormat(value,params));element.select()})}};var viewFloatFormat=function(value,params){var defaultOptions=Util.clone($.currency.i18n[$.currency.lang]);var valueFormated="";try{var options=Util.extend(defaultOptions,params||{},true);valueFormated=$.currency.string(value,options)}catch(e){valueFormated=value}return valueFormated};var unMaskViewFloat=function(value,params){var opt=Util.extend(Util.clone($.currency.i18n[$.currency.lang]),params||{},true);var fltValue=opt.allowZero&&!opt.allowEmpty?0:"";var valueFormated=value;if(!Util.isEmptyOrBlank(valueFormated)){var decimal=opt.decimal;var thousands=opt.thousands;if(typeof valueFormated==="string"){if(opt.showSymbol)valueFormated=valueFormated.replace(opt.symbol,"");if(thousands)valueFormated=valueFormated.replace(new RegExp("\\"+thousands,"g"),"");valueFormated=valueFormated.replace(new RegExp("\\"+decimal,"g"),".");valueFormated=removeInvalidChar(valueFormated)}fltValue=parseFloat(valueFormated);if(!opt.allowZero&&fltValue===0||$.currency.isInvalidValue(fltValue,opt))valueFormated=""}return valueFormated};var removeInvalidChar=function(value){var index=value.indexOf(".");return index+1===value.length?value.slice(0,index):value};var maskViewFloat=function(value,params){var opt=Util.extend(Util.clone($.currency.i18n[$.currency.lang]),params||{},true);if(value)value=value.replace(new RegExp("\\"+".","g"),opt.decimal);return value};this.register=maskEngine.registerMask("viewFloat",viewFloat,viewFloatFormat)};Configuration(function(ContextRegister){ContextRegister.register("ViewFloatMask",ViewFloatMask)});function WidgetsMetaData(){this.getExpiredSession=function(){return{name:"EXPIRED_SESSION",label:"Sessão Expirada",isVisible:true,showDescriptionOrder:false,showAsModal:true,template:"widget/form.html",tekLibExpiredSession:true,actions:[{name:"CONFIRM",label:"Confirmar",showAsAction:"never",events:[{name:"ActionEvent",code:"LibLoginController.expiredSessionActionEventConfirm(args)"}]},{name:"CANCEL",label:"Sair",showAsAction:"back",events:[{name:"ActionEvent",code:"LibLoginController.expiredSessionActionEventCancel()"}]}],events:[],dataSource:[],fields:[{name:"OPERATOR",label:"Usuário",template:"field/text-edit.html",class:12,readOnly:true,isVisible:true,showOnList:true,showOnForm:true},{name:"PASSWORD",label:"Senha",template:"field/password.html",class:12,focused:true,validations:{required:true},isVisible:true,showOnList:true,showOnForm:true,events:[{name:"FieldOnKeyup",code:"LibLoginController.expiredSessionFieldOnKeyupPassword(args)"}]}]}};this.getPageViewNotice=function(){return{name:"PAGEVIEWNOTICE",label:"",template:"widget/form.html",showDescriptionOrder:false,showAsModal:true,isVisible:true,width:"85%",height:"90%",actions:[{name:"close",label:"Fechar",isVisible:true,hideIcon:true,showAsAction:"back",events:[{id:"363705655463155833317",name:"ActionEvent",code:"LibLoginController.pageViewNoticeActionEventCancel()"}]}],events:[],dataSource:{},fields:[{id:"13464068121582746262789",name:"PDF",label:"",class:12,template:"field/textarea.html",readOnly:true,isVisible:true,showOnList:false,showOnView:true,showOnForm:true,toolbar:{undo:false,redo:false,bold:false,italic:false,underline:false,superscript:false,subscript:false,strikethrough:false,clear:false,fontname:false,fontsize:false,color:false,ul:false,ol:false,paragraph:false,lineheight:false,table:false,picture:false,codeview:false}}]}};this.getPHPErrorLogFiles=function(){return{id:"363705655463451456155833317",name:"PHP_ERROR_LOG_FILES",label:"Arquivos de log do PHP",template:"widget/grid.html",showDescriptionOrder:false,showAsModal:true,hasPagination:false,searchWithPagination:false,isVisible:true,width:"70%",height:"85%",floatingControl:{searchAction:true,reportAction:true,refreshAction:false,customizationAction:{layout:false,filter:false,view:false}},actions:[{name:"close",label:"Cancelar",isVisible:true,hideIcon:true,showAsAction:"back",events:[{name:"ActionEvent",code:"LibLoginController.phpErrorLogFilesActionEventCancel()"}]},{icon:"download",name:"download",tooltip:"Baixar arquivo",isVisible:true,showAsAction:"grid-right",events:[{name:"ActionEvent",code:"LibLoginController.downloadPHPErrorLog(args)"}]}],events:[],dataSource:{rest:false,data:[]},fields:[{id:"134640648714121582746262789",name:"NAME",label:"Arquivo",template:"field/text-edit.html",isVisible:true,showOnList:true},{id:"1346406845105478158274626278",name:"SIZE",label:"Tamanho",template:"field/text-edit.html",isVisible:true,showOnList:true},{id:"134640687485721582746262789",name:"LAST_MODIFIED",label:"Última Modificação",template:"field/text-edit.html",isVisible:true,showOnList:true}]}}}Configuration(function(ContextRegister){ContextRegister.register("WidgetsMetaData",WidgetsMetaData)});function LibLoginService(requestDataSourceEngine){this.startSession=function(user){var filter=[{name:"USER",value:user,operator:"="},{name:"IS_LOGGED",value:localStorage.getItem("IS_LOGGED")||false,operator:"="},{name:"LOGIN_TOKEN",value:localStorage.getItem("LOGIN_TOKEN"),operator:"="},{name:"LOGIN_LANGUAGE",value:localStorage.getItem("LOGIN_LANGUAGE")||window.lang,operator:"="},{name:"LOGIN_SEPARATOR",value:localStorage.getItem("LOGIN_SEPARATOR"),operator:"="}];return requestDataSourceEngine.getDataSource("lib#/lib_startSession",filter,1,undefined,undefined,undefined,12e4).then(function(data){if(typeof data=="string"){return{isError:true,message:data}}return data&&data.dataset?data.dataset.system:false})};this.validateUser=function(cdOperator,password,isSupportOperator){var filter=[{name:"USER",value:cdOperator,operator:"="},{name:"PASSWORD",value:password,operator:"="},{name:"IS_SUPPORT_OPERATOR",value:isSupportOperator,operator:"="}];return requestDataSourceEngine.getDataSource("login#/validateUser",filter)};this.logout=function(){var filter=[{name:"PROJECT",value:window.tekLoginProjectId,operator:"="},{name:"ERASE_HASH",value:localStorage.getItem("LOGIN_ERASE_HASH"),operator:"="},{name:"HASH",value:localStorage.getItem("LOGIN_HASH"),operator:"="}];return requestDataSourceEngine.getDataSource("lib#/lib_logout",filter,1,undefined,undefined,undefined,12e4)};this.getModulesVersion=function(){return requestDataSourceEngine.getDataSource("lib#/lib_getModulesVersion",[])};this.generateModulesVersionFile=function(){return requestDataSourceEngine.setDataSource("lib#/lib_generateModulesVersionFile",[{changed:true}])};this.downloadModulesVersionFile=function(fileName){var serviceUrl=window.serviceUrl;window.open(serviceUrl+"/lib_downloadModulesVersionFile?requestType=DataSet&dataset[0][FILE_NAME]="+fileName)};this.updateSession=function(user,accessProfile,otherSessionValues){var filter=[{name:"USER",value:user,operator:"="},{name:"ACCESS_PROFILE",value:accessProfile,operator:"="},{name:"OTHER_SESSION_VALUES",value:otherSessionValues,operator:"="},{name:"LOGIN_USER",value:localStorage.getItem("LOGIN_USER"),operator:"="}];return requestDataSourceEngine.getDataSource("lib#/lib_updateSession",filter)};this.updateTranslation=function(){return requestDataSourceEngine.getDataSource("lib#/lib_updateTranslation",[],1,undefined,undefined,undefined,3e5)};this.saveProductsPermission=function(licenseInfo){var row={LICENSE_INFO:licenseInfo,changed:true};return requestDataSourceEngine.setDataSource("lib#/lib_saveProductsPermission",[row],undefined,undefined,undefined,undefined,true)};this.saveVariableMeasure=function(licenseInfo){var row={LICENSE_INFO:licenseInfo,changed:true};return requestDataSourceEngine.setDataSource("lib#/lib_saveVariableMeasure",[row],undefined,undefined,undefined,undefined,true)};this.setLogAccess=function(){var row={changed:true};return requestDataSourceEngine.setDataSource("lib#/lib_setLogAccess",[row],undefined,undefined,undefined,undefined,true)};this.getPHPErrorLogFiles=function(){return requestDataSourceEngine.getDataSource("lib#/lib_getPHPErrorLogFiles",[])}}Configuration(function(ContextRegister){ContextRegister.register("LibLoginService",LibLoginService)});function LibCustomizationController(templateManager,LibUtilities,ScreenService,MessageService){var getCustomizationContainer=function(){return templateManager.container};var getCustomizationWidget=function(){return getCustomizationContainer().getWidget("customizationWidget")};this.customizationContainerAfterinit=function(){var route=localStorage.getItem("LIB_CUSTOMIZATION_ROUTE");var label=localStorage.getItem("LIB_CUSTOMIZATION_LABEL");var token=localStorage.getItem("LOGIN_TOKEN");var hash=localStorage.getItem("LOGIN_HASH")||"0";var user=localStorage.getItem("LOGIN_USER");var languange=localStorage.getItem("LOGIN_LANGUAGE");var customURL=localStorage.getItem("LOGIN_CUSTOMIZATION_URL");clearTimeout(LibUtilities.expiredSessionMethod);var url=customURL+route+"?header=0&menu=0"+"&token="+token+"&hash="+hash+"&user="+user+"&languange="+languange+"&productId="+window.projectId+"&isZhAngular=1";getCustomizationWidget().sourceUrl=url;getCustomizationContainer().label=label+" "+ScreenService.i18n("(Customização)")};this.customizationMenuOnClick=function(menu){if(!menu.route){MessageService.showMessageByCode("lib#ERR_NOT_FOUND_CUSTOM_ROUTE",null,{type:"ERROR"})}else{localStorage.setItem("LIB_CUSTOMIZATION_ROUTE",menu.route);localStorage.setItem("LIB_CUSTOMIZATION_LABEL",menu.label);ScreenService.openWindow("lib#customizationWindow");if(ScreenService.isSideMenuOpen()){ScreenService.toggleSideMenu()}}}}Configuration(function(ContextRegister){ContextRegister.register("LibCustomizationController",LibCustomizationController)});function LibLoginController(LibLoginService,LibUtilities,localStorageEngine,templateManager,eventAggregator,ScreenService,metaDataFactory,WidgetsMetaData,ZhuAclController,ZhKeyboardService,ZHPromise,MessageService){var self=this;var loginUserId,loginUserName,loginIsSupOper,loginSupOperId;window.tekLoginProjectId=angular.copy(window.projectId);var factoryExpiredSessionWidget=function(){return metaDataFactory.widgetFactory(WidgetsMetaData.getExpiredSession(),templateManager.container)};var factoryPageViewNoticeWidget=function(){return metaDataFactory.widgetFactory(WidgetsMetaData.getPageViewNotice(),templateManager.container)};var factoryPHPErrorLogFilesWidget=function(){return metaDataFactory.widgetFactory(WidgetsMetaData.getPHPErrorLogFiles(),templateManager.container)};var updateLanguage=function(){var langParam=Util.getUrlParameter("lang");var language=langParam||localStorage.getItem("LOGIN_LANGUAGE")||window.lang;window.lang=language;ScreenService.setLanguage(language);localStorageEngine.setLocalVar("language",language)};var updateToken=function(){var authToken=Util.getUrlParameter("authToken");if(authToken){localStorage.setItem("LOGIN_TOKEN",authToken)}return authToken};var updateHashAndKeepConn=function(){var hash=Util.getUrlParameter("hash");if(hash){localStorage.setItem("LOGIN_HASH",hash)}var keepConn=Util.getUrlParameter("keepConn");if(keepConn){localStorage.setItem("LOGIN_KEEP_CONNECTED",keepConn)}};var updateSeparator=function(){var separator=Util.getUrlParameter("sep")||localStorage.getItem("LOGIN_SEPARATOR");if(separator){localStorage.setItem("LOGIN_SEPARATOR",separator);if($.currency.i18n[window.lang]){$.currency.i18n[window.lang].thousands=separator[0];$.currency.i18n[window.lang].inputThousands=separator[0];$.currency.i18n[window.lang].decimal=separator[1];$.currency.i18n[window.lang].inputDecimal=separator[1]}}};this.authenticate=function(forceAuthenticate){templateManager.project.elementListDefaultRule=templateManager.project.elementListDefaultRule||"I";updateLanguage();updateSeparator();updateHashAndKeepConn();var defer=ZHPromise.defer();forceAuthenticate=forceAuthenticate===true;if(window.location.hash.replace("#/","")!=LibUtilities.authenticationContainer||forceAuthenticate){var setAclEventId;var user=localStorage.getItem("LOGIN_USER");var useRedirect=localStorage.getItem("LOGIN_USE_REDIRECT");var authToken=updateToken();if(!user&&!authToken||useRedirect=="S"){LibUtilities.redirectToLogin();defer.resolve({})}else{var setAclFunction=function(){setAcl(defer.promise,setAclEventId)};setAclEventId=eventAggregator.subscribe("onContainerOpen",setAclFunction);ScreenService.showLoader();LibLoginService.startSession(user).then(function(response){ScreenService.hideLoader();startSessionResponse(response,defer)}).catch(function(error){ScreenService.hideLoader();if(error.data&&(error.data.errorCode==101||error.data.errorCode==100)){self.logout()}else if(error.data.errorCode==20){localStorage.setItem("LOGIN_ERASE_HASH","Y");MessageService.showCustomDialogByCode("lib#ALE_SESSION_WILL_BE_ENDED",null,{type:"INFORMATION",actions:[{label:ScreenService.i18n("Ok"),code:function(){self.logout()}}]})}else{defer.reject(error);LibUtilities.showErrorMessage(error)}})}}return defer.promise};var startSessionResponse=function(response,defer){if(response.isError){defer.reject(response.message)}else{if(!response.USER_ID){self.logout()}else if(response.SESSION_EXPIRED){logoutExpiredSession(true)}else{if(response.LICENSE_INFO){localStorage.setItem("LICENSE_INFO",response.LICENSE_INFO)}if(response.LOGIN_USER&&response.LOGIN_TOKEN){localStorage.setItem("LOGIN_USER",response.LOGIN_USER);localStorage.setItem("LOGIN_TOKEN",response.LOGIN_TOKEN)}localStorage.setItem("LOGIN_USER_NEXT",response.LOGIN_USER_NEXT||response.LOGIN_USER);localStorage.setItem("IS_SUPPORT_OPERATOR",response.IS_SUPPORT_OPERATOR);localStorage.setItem("LOGIN_USER_ID",response.USER_ID);localStorage.setItem("LOGIN_PHP_VERSION_ID",response.PHP_VERSION_ID);localStorage.setItem("ACL_ADMINISTRATOR",response.ACL_ADMINISTRATOR);localStorage.setItem("ACCESS_PROFILE",response.ACCESS_PROFILE);localStorage.setItem("LOGIN_CUSTOMIZATION_URL",response.CUSTOMIZATION_URL);localStorage.setItem("NOTICES",JSON.stringify(response.NOTICES));localStorage.setItem("TIMEOUTNOTICES",JSON.stringify(response.TIMEOUTNOTICES));if(response.IS_SUPPORT_OPERATOR){loginIsSupOper=response.IS_SUPPORT_OPERATOR;loginSupOperId=response.SUPPORT_OPERATOR_ID}if(response.IS_SUPPORT_OPERATOR||response.IS_TEKNISA_USER){LibUtilities.addPHPErrorLogButton();ZhKeyboardService.bind("ctrl+alt+shift+l",self.getPHPErrorLogFiles)}loginUserId=response.USER_ID;loginUserName=response.USER_NAME;if(response.IS_PENDENT_MIGRATION){MessageService.showMessageByCode("lib#ALE_MIGRATION_IS_PENDENT",null,{type:"INFORMATION"})}if(response.VISIBLE_ELEMENTS){localStorage.setItem("LOGIN_VISIBLE_ELEMENTS",JSON.stringify(response.VISIBLE_ELEMENTS))}if(response.ACL_ADMINISTRATOR){LibUtilities.addTranslateButton()}defer.resolve(response)}}};this.pageViewNoticeActionEventCancel=function(){ScreenService.closePopup(true)};this.openPopupNotices=function(){var divider=window.nextUrl.slice(-1)=="/"?"":"/";var route=divider+"modules/login/pageViewNotice";var token=localStorage.getItem("LOGIN_TOKEN");var hash=localStorage.getItem("LOGIN_HASH")||"0";var user=localStorage.getItem("LOGIN_USER_NEXT");var languange=localStorage.getItem("LOGIN_LANGUAGE");clearTimeout(LibUtilities.expiredSessionMethod);var url=window.nextUrl+route+"?header=0&menu=0"+"&token="+token+"&hash="+hash+"&user="+user+"&languange="+languange+"&productId="+window.projectId+"&isZhAngular=1";var pageViewNoticeWidget=factoryPageViewNoticeWidget();ScreenService.openPopup(pageViewNoticeWidget).then(function(){Util.doAsync(function(){var element=$(".zh-PAGEVIEWNOTICE").parent();if(element[0]&&element[0].style){element[0].style.padding="0px"}var popupElement=element.parent().parent().children();if(popupElement[0]){popupElement[0].remove()}element[0].style.height="100%";element[0].style.maxHeight="100%";element.parent()[0].style.height="100%";var bodyHeight=element.height()-$(".zh-footer-center").parent().height();var heightPDF=String(bodyHeight+"px");var htmlPDF="<iframe id='pageViewNotice' src = "+url+"#page=1&zoom=109' width='100%' height='100%' type='application/pdf' style='height:"+heightPDF+"; padding-bottom: 40px'></iframe>";var fieldSelector=$("#PDF");divField=fieldSelector.parent()[0];fieldSelector.parent()[0].innerHTML=htmlPDF;pageViewNoticeWidget.edit();templateManager.updateTemplate()},2e3)})};this.logout=function(){ScreenService.showLoader();LibLoginService.logout().then(function(){ScreenService.hideLoader();localStorage.removeItem("ACL_ADMINISTRATOR");localStorage.removeItem("ACCESS_PROFILE");localStorage.removeItem("IS_LOGGED");localStorage.removeItem("LOGIN_USER");localStorage.removeItem("LOGIN_USER_NEXT");localStorage.removeItem("LOGIN_TOKEN");localStorage.removeItem("LICENSE_INFO");localStorage.removeItem("LOGIN_ERASE_HASH");localStorage.removeItem("IS_SUPPORT_OPERATOR");localStorage.removeItem("LOGIN_USER_ID");localStorage.removeItem("LOGIN_PHP_VERSION_ID");localStorage.removeItem("LIB_FAVORITES_DATA");localStorage.removeItem("NOTICES");localStorage.removeItem("TIMEOUTNOTICES");LibUtilities.redirectToLogin()}).catch(function(error){ScreenService.hideLoader();LibUtilities.showErrorMessage(error)})};var setAcl=function(loginPromise,setAclEventId){loginPromise.then(function(response){if(!window.productApplyAcl){ZhuAclController.setUserRules(response.ACCESS_PROFILE,window.projectId,response.USER_ID,response.ORGANIZATION_ID,{canConfigureAcl:response.ACL_ADMINISTRATOR,rules:response.ACL_ADMINISTRATOR?[]:false,defaultRule:response.ACL_ADMINISTRATOR?"A":false});templateManager.project.aclDefaultRule="A"}eventAggregator.unSubscribe("onContainerOpen",setAclEventId)}).catch(LibUtilities.showErrorMessage)};eventAggregator.subscribe("LibExpiredSession",function(){if(!templateManager.container.getActiveWidget().tekLibExpiredSession){var expiredSessionWidget=factoryExpiredSessionWidget();expiredSessionWidget.attempts=0;expiredSessionWidget.dataSource.data=[];expiredSessionWidget.newRow();expiredSessionWidget.currentRow.OPERATOR=loginUserId+" - "+loginUserName;ScreenService.openPopup(expiredSessionWidget);localStorageEngine.setLocalVar("LOGIN_EXPIRED_SESSION",true)}});eventAggregator.subscribe("LibInvalidToken",function(errorCode){if(errorCode==101){MessageService.showCustomDialogByCode("lib#ALE_EXPIRED_SESSION",null,{type:"INFORMATION",actions:[{label:ScreenService.i18n("Ok"),code:self.logout}]})}else if(errorCode==100){self.logout()}});eventAggregator.subscribe("LibInvalidTokenSupportOperator",function(errorCode){MessageService.showCustomDialogByCode("lib#ALE_EXPIRED_SESSION_SUPPORT_OPERATOR",null,{type:"INFORMATION",actions:[{label:ScreenService.i18n("Ok"),code:self.logout}]})});eventAggregator.subscribe("LibConcurrentAccess",function(){localStorage.setItem("LOGIN_ERASE_HASH","Y");MessageService.showCustomDialogByCode("lib#ALE_SESSION_WILL_BE_ENDED",null,{type:"INFORMATION",actions:[{label:ScreenService.i18n("Ok"),code:function(){self.logout()}}]})});eventAggregator.subscribe("LibAccessBlocked",function(errorCode){MessageService.showCustomDialogByCode("lib#ACCESS_BLOCKED_BY_TIME_OR_DAY",null,{type:"INFORMATION",actions:[{label:ScreenService.i18n("Ok"),code:function(){self.logout()}}]})});var logoutExpiredSession=function(afterLogin){localStorageEngine.setLocalVar("LOGIN_EXPIRED_SESSION",false);var message=afterLogin?"ERR_EXPIRED_SESSION_LOGIN":"ERR_ATTEMPT_END";MessageService.getMessageByCode("lib#"+message).then(function(loadingMessage){ScreenService.changeLoadingMessage(ScreenService.i18n(loadingMessage));ScreenService.showLoader();Util.doAsync(self.logout,5e3)})};this.expiredSessionActionEventConfirm=function(args){var expiredSessionWidget=args.owner.widget?args.owner.widget:args.owner.field.widget;if(expiredSessionWidget.isValid()){var password=expiredSessionWidget.currentRow.PASSWORD;var userId=loginSupOperId||loginUserId;ScreenService.showLoader();LibLoginService.validateUser(userId,password,loginIsSupOper).then(function(){LibLoginService.getModulesVersion();ScreenService.hideLoader();localStorageEngine.setLocalVar("LOGIN_EXPIRED_SESSION",false);ScreenService.closePopup()}).catch(function(error){ScreenService.hideLoader();if(error.data&&error.data.errorCode&&error.data.errorCode==20){localStorageEngine.setLocalVar("LOGIN_EXPIRED_SESSION",false);eventAggregator.publish("LibConcurrentAccess")}else if(error.data&&error.data.errorCode&&error.data.errorCode==102){localStorageEngine.setLocalVar("LOGIN_EXPIRED_SESSION",false);eventAggregator.publish("LibInvalidTokenSupportOperator")}else if(error.data&&error.data.errorCode&&(error.data.errorCode==21||error.data.errorCode==22)){localStorageEngine.setLocalVar("LOGIN_EXPIRED_SESSION",false);eventAggregator.publish("LibAccessBlocked")}else{var params={attempts:++expiredSessionWidget.attempts};MessageService.showMessageByCode("lib#ERR_ATTEMPT_PARTIAL",params,{type:"ERROR"});if(expiredSessionWidget.attempts>=3){logoutExpiredSession()}}})}};this.expiredSessionActionEventCancel=function(){localStorageEngine.setLocalVar("LOGIN_EXPIRED_SESSION",false);self.logout()};this.expiredSessionFieldOnKeyupPassword=function(args){var key=window.event.keyCode;if(key==13){this.expiredSessionActionEventConfirm(args)}};this.downloadModulesVersionFile=function(){return LibLoginService.generateModulesVersionFile().then(function(response){if(response&&response.dataset){var fileName=response.dataset.generatedFile[0];LibLoginService.downloadModulesVersionFile(fileName);return true}else{LibUtilities.showErrorMessage(response);return false}}).catch(LibUtilities.showErrorMessage)};this.updateSession=function(user,accessProfile,otherSessionValues){var defer=ZHPromise.defer();ScreenService.showLoader();LibLoginService.updateSession(user,accessProfile,otherSessionValues).then(function(response){ScreenService.hideLoader();if(response&&response.dataset&&response.dataset.sessionUpdated){var sessionUpdated=response.dataset.sessionUpdated[0];localStorage.setItem("LOGIN_USER",sessionUpdated);defer.resolve()}else{defer.reject(response)}}).catch(function(error){ScreenService.hideLoader();defer.reject(error)});return defer.promise};this.expiredMenuOnClick=function(){MessageService.showMessageByCode("lib#ALE_EXPIRED_MENU",null,{type:"ERROR"})};this.updateTranslation=function(){MessageService.confirmMessageByCode("lib#ALE_UPDATE_TRANSLATION",null,{type:"CONFIRMATION",success:function(){ScreenService.showLoader();LibLoginService.updateTranslation().then(function(){var widget=templateManager.container.getActiveWidget();if(self.checkContainerIsZhNext()&&$("iframe").length&&widget.sourceUrl){window.libTranslateDefer=ZHPromise.defer();var frameUrl=widget.sourceUrl.split("?")[0];$("iframe")[0].contentWindow.postMessage({type:"updateTranslation"},frameUrl);window.libTranslateDefer.then(function(){reloadUpdateTranslation()}).catch(function(error){ScreenService.hideLoader();LibUtilities.showErrorMessage(error)})}else{reloadUpdateTranslation()}}).catch(function(error){ScreenService.hideLoader();LibUtilities.showErrorMessage(error)})},fail:function(){}})};var reloadUpdateTranslation=function(){MessageService.showMessageByCode("lib#SUC_UPDATE_TRANSLATION");setTimeout(function(){window.location.reload(true)},7e3)};this.checkContainerIsZhNext=function(){if(templateManager.container.widgets&&templateManager.container.widgets.length){return templateManager.container.widgets[0].template=="widget/iframe.html"}return false};this.downloadPHPErrorLog=function(args){var url=window.serviceUrl+"/lib_downloadPHPErrorLog"+"?token="+localStorage.getItem("LOGIN_TOKEN")+"&filename="+args.row.NAME;window.open(url)};this.getPHPErrorLogFiles=function(){ScreenService.showLoader();LibLoginService.getPHPErrorLogFiles().then(function(response){var widget=factoryPHPErrorLogFilesWidget();widget.dataSource.data=response.dataset.getPHPErrorLogFiles;ScreenService.hideLoader();ScreenService.openPopup(widget);if(ScreenService.isSideMenuOpen()){ScreenService.toggleSideMenu()}}).catch(function(error){ScreenService.hideLoader();LibUtilities.showErrorMessage(error)})};this.phpErrorLogFilesActionEventCancel=function(){ScreenService.closePopup(true)}}Configuration(function(ContextRegister){ContextRegister.register("LibLoginController",LibLoginController)});var ZeedhiFields=angular.module("ZeedhiFields");ZeedhiFields.directive("zhNavbarDefaultHeader",function(templateManager,ScreenService,eventAggregator,$compile,ApplicationContext){return{restrict:"C",link:function($scope,element){$scope.favoritesList=[];$scope.lastDeletedItem=undefined;var favoritesText=ScreenService.i18n("Favoritos");var favoritesAddText=ScreenService.i18n("Adicionar aos Favoritos");var favoritesRemoveText=ScreenService.i18n("Remover dos Favoritos");var favoritesUndoText=ScreenService.i18n("Desfazer");var favoritesContainer;var startHollowCode='<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 30 30" style="enable-background:new 0 0 30 30;" xml:space="preserve">'+'\t<style type="text/css">'+"\t\t.st0{fill:#FFFFFF;}"+"\t</style>"+"\t<g>"+'\t\t<path class="st0" d="M15,4.21l3.51,7.1l7.84,1.14l-5.67,5.53l1.34,7.81L15,22.1l-7.01,3.69l1.34-7.81l-5.67-5.53l7.84-1.14L15,4.21'+"\t\t\t M15,2.21c-0.76,0-1.46,0.43-1.79,1.11l-3.04,6.16l-6.8,0.99c-0.75,0.11-1.38,0.64-1.61,1.36c-0.24,0.72-0.04,1.52,0.51,2.05"+"\t\t\tl4.92,4.8l-1.16,6.77c-0.13,0.75,0.18,1.51,0.8,1.96c0.35,0.25,0.76,0.38,1.18,0.38c0.32,0,0.64-0.08,0.93-0.23l6.08-3.2l6.08,3.2"+"\t\t\tc0.29,0.15,0.61,0.23,0.93,0.23c0.41,0,0.83-0.13,1.18-0.38c0.62-0.45,0.92-1.21,0.8-1.96l-1.16-6.77l4.92-4.8"+'\t\t\tc0.55-0.53,0.74-1.33,0.51-2.05c-0.24-0.72-0.86-1.25-1.61-1.36l-6.8-0.99l-3.04-6.16C16.46,2.64,15.76,2.21,15,2.21L15,2.21z"/>'+"\t</g>"+"</svg>";var startFilledCode='<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 30 30" style="enable-background:new 0 0 30 30;" xml:space="preserve">'+'\t<style type="text/css">'+"\t\t.st0{fill:#FFFFFF;}"+"\t</style>"+"\t<g>"+'\t\t<path class="st0" d="M28.25,11.83c-0.24-0.72-0.86-1.25-1.61-1.36l-6.8-0.99l-3.04-6.16C16.46,2.64,15.76,2.21,15,2.21'+"\t\t\ts-1.46,0.43-1.79,1.11l-3.04,6.16l-6.8,0.99c-0.75,0.11-1.38,0.64-1.61,1.36c-0.24,0.72-0.04,1.52,0.51,2.05l4.92,4.8l-1.16,6.77"+"\t\t\tc-0.13,0.75,0.18,1.51,0.8,1.96c0.35,0.25,0.76,0.38,1.18,0.38c0.32,0,0.64-0.08,0.93-0.23l6.08-3.2l6.08,3.2"+"\t\t\tc0.29,0.15,0.61,0.23,0.93,0.23c0.41,0,0.83-0.13,1.18-0.38c0.62-0.45,0.92-1.21,0.8-1.96l-1.16-6.77l4.92-4.8"+'\t\t\tC28.29,13.35,28.48,12.56,28.25,11.83z"/>'+"\t</g>"+"</svg>";function createVisualElements(){var headerContainer=$(element).children()[0];headerContainer.style.width="calc(100% - 50px)";favoritesContainer=$('<div class="zh-favorites"></div>').appendTo(element);var favoritesButtonElement=$compile('<div class="zh-favorites-button" ng-click="toggleList()">'+'  <div class="zh-favorites-button-star" ng-if="!isFavorited">'+"    "+startHollowCode+"  </div>"+'  <div class="zh-favorites-button-star" ng-if="isFavorited">'+"    "+startFilledCode+"  </div>"+'  <div class="zh-favorites-button-text">'+favoritesText+"</div>"+"</div>")($scope);var favoritesButton=$(favoritesButtonElement).appendTo(favoritesContainer);var favoritesListElement=$compile('<div class="zh-favorites-list" ng-class="{\'opened\': opened}">'+'  <div class="zh-favorites-list-button" ng-if="!isFavorited" ng-click="addToFavorites()">'+favoritesAddText+"</div>"+'  <div class="zh-favorites-list-button" ng-if="isFavorited" ng-click="removeFromFavorites()">'+favoritesRemoveText+"</div>"+'  <div class="zh-favorites-list-undo" ng-show="false" ng-click="undo()">'+favoritesUndoText+"</div>"+'  <div class="zh-favorites-list-items" ng-show="favoritesList.length > 0">'+'\t <div class="zh-favorites-list-item" ng-repeat="item in favoritesList track by item.id" ng-click="openItem(item)">'+"      {{ item.label }}"+'      <span class="zh-favorites-list-item-delete" data-zh-icon="trash icon-white no-border" ng-click="deleteItem(item, $index, $event)"></span>'+"    </div>"+"  </div>"+"</div>")($scope);var favoritesList=$(favoritesListElement).appendTo(favoritesContainer)}function checkIsFavorited(containerId){var oldIsFavorited=$scope.isFavorited;$scope.isFavorited=$scope.favoritesList.findIndex(function(item){return item.id===containerId})!==-1;if(oldIsFavorited!==$scope.isFavorited){templateManager.updateTemplate()}}$scope.addToFavorites=function(){var item={id:templateManager.container.id,name:templateManager.container.fileName.split(".json")[0],label:ScreenService.i18n(templateManager.container.label)};$scope.favoritesList.push(item);$scope.isFavorited=true;eventAggregator.publish("ZhFavoritesOnChange",{fullList:$scope.favoritesList,changed:{item:item,status:"add"}})};$scope.removeFromFavorites=function(){var index=$scope.favoritesList.findIndex(function(item){return item.id===templateManager.container.id});if(index>-1){var item=$scope.favoritesList.splice(index,1);$scope.isFavorited=false;eventAggregator.publish("ZhFavoritesOnChange",{fullList:$scope.favoritesList,changed:{item:item,status:"delete"}})}};$scope.openItem=function(item){ApplicationContext.LibUtilities.openWindow(item.name);$scope.opened=false};var undoTimeout;$scope.deleteItem=function(item,index,event){$scope.favoritesList.splice(index,1);$scope.lastDeletedItem={item:item,index:index};clearTimeout(undoTimeout);undoTimeout=setTimeout(function(){$scope.lastDeletedItem=undefined;templateManager.updateTemplate()},1e4);eventAggregator.publish("ZhFavoritesOnChange",{fullList:$scope.favoritesList,changed:{item:item,status:"delete"}});if(item.id===templateManager.container.id){$scope.isFavorited=false}event.stopImmediatePropagation()};$scope.undo=function(){if($scope.lastDeletedItem){$scope.favoritesList.splice($scope.lastDeletedItem.index,0,$scope.lastDeletedItem.item)}$scope.lastDeletedItem=undefined};$scope.toggleList=function(){$scope.opened=!$scope.opened};document.addEventListener("mousedown",function(evt){if($(favoritesContainer).find(evt.target).length===0&&$scope.opened){$scope.opened=false;templateManager.updateTemplate()}});eventAggregator.subscribe(eventAggregator.ON_CONTAINER_OPEN,function(args){checkIsFavorited(args.container.id)});eventAggregator.subscribe("ZhFavoritesOnLoad",function(favorites){favorites=JSON.parse(favorites);$scope.favoritesList=favorites;if(templateManager.container){checkIsFavorited(templateManager.container.id)}});createVisualElements()}}});function LibZdNextListener(ScreenService,LibLoginService,LibUtilities,templateManager){window.addEventListener("message",handleMessageEvent);function handleMessageEvent(event){if(event.data.type==="logoutByZdNext"){logoutByZdNext()}else if(event.data.type==="versionInfo"){var versionInfo=event.data.data.versionInfo;if(versionInfo&&templateManager.versionData&&templateManager.versionData.dependencies){templateManager.versionData.name=versionInfo.name;templateManager.versionData.version=versionInfo.version;templateManager.versionData.dependencies.backend=versionInfo.backend;templateManager.versionData.dependencies.frontend=versionInfo.frontend;templateManager.versionData.dependencies.modules=versionInfo.modules;templateManager.versionData.dependencies.changeCurrentVersion("frontend");templateManager.updateTemplate()}}else if(event.data.type==="updateTranslationNext"){if(event.data.data.isError){window.libTranslateDefer.reject(event.data.data.message)}else{window.libTranslateDefer.resolve()}}}var logoutByZdNext=function(){ScreenService.showLoader();LibLoginService.logout().then(function(){ScreenService.hideLoader();localStorage.removeItem("IS_LOGGED");localStorage.removeItem("LOGIN_USER");localStorage.removeItem("LOGIN_TOKEN");localStorage.removeItem("LOGIN_ERASE_HASH");LibUtilities.redirectToLogin()}).catch(function(error){ScreenService.hideLoader();LibUtilities.showErrorMessage(error)})}}Configuration(function(ContextRegister){ContextRegister.register("LibZdNextListener",LibZdNextListener)});